#ifndef Node_included
	#include "Node.h"
#endif

class Array: public Node	// is an array of Nodes with a length and an origin.
{
	int _length, _origin, _circcounter;
	NodePP _data;

	public:
		union {ObjectType flag; ObjectBits bit; int tint;};

		static int maxStringLength;
		static const Array aArray;

		operator_new;
		Array(): Node(ARRAY), _length(0), _origin(0), _data(0) {}
		Array(int length_, int origin_=1);
		Array(ArrayP array_);
		void free();

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();

		void setPtrs(IntToPtr_ &intToPtr);
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);

		StringP string();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		void printBin(FILEP strm);
		NodeP contentsTree(	wxArrayString &namearr, 
									wxArrayString &valarr, 
									wxArrayPtrVoid &objarr, 
									ObjectType want, 
									ObjectType dont, 
									ObjectType must, 
									int &count, int level);
		bool expanded() {return bit.table_expand;}
		bool expandable() {return true;}
		void setExpanded(bool state) {bit.table_expand=state;}

		OPERATORS_DECL
		int compare(NodeP nd);
		int count();
		int _sizeof();
		StringP _typeof();
		bool equalP(NodeP b);
		NodeP deepCopy();
		NodeP first_();
		NodeP butFirst();
		NodeP firsts();
		NodeP butFirsts();
		NodeP last();
		NodeP butLast();
		NodeP fPut(NodeP nd);
		NodeP lPut(NodeP nd);
		double _min(double d);
		double _max(double d);
		NodeP Norm();
		NodeP maxNorm();
		NodeP resize(int newsize);
		NodeP saturateAbove(double limit);
		NodeP saturateBelow(double limit);
		NodeP item(int index);
		NodeP item(NodeP index, NodeP result);
		NodeP items(NodeP start, NodeP end);
		NodeP mdItem(NodeP index);
		NodeP setitem(int index, NodeP newitem);
		NodeP setitem(NodeP index, NodeP newitem, bool safe);
		NodeP setitems(NodeP start, NodeP newitems);
		NodeP memberP(NodeP subobj, bool notp=false, bool substr=false);
		NodeP reverse();
		NodeP rotate(int places);
		NodeP shuffle();
		NodeP upper();
		NodeP lower();
		PairP list();
		ArrayP array(int origin=1);
		IntArrayP intarray(int origin=1);
		Int16ArrayP int16array(int origin=1);
		FloatArrayP floatarray(int origin=1);
		BitmapP bitmap(int width);
		void combSortInPlace();
		NodeP combSort();
		int circcounter() {return _circcounter;}
		void setcirccounter(int ccnt) {_circcounter=ccnt;}
		bool circular2();
		GRAPHIC_DECL

		 int length() {return _length;}
		 int origin() {return _origin;}
		NodePP data() {return _data;}
		void setorigin(int origin_) {_origin=origin_;}
};

#define Array_included
