//___________________________________________________________________
//
//                         Button Header
//___________________________________________________________________

#ifndef WINDOWNODE
	#include "Window.h"
#endif

extern Function 
	lButton, 
	lButtonDestroy, 
	lButtonEnable, 
	lButtonGetLabel, 
	lButtonOnClick, 
	lButtonSetLabel;

class Button: public wxButton
{
	public:
		enum Data
		{	WINDOW_DATA,
			onClick, uonClick, tonClick,
			dataCount
		};
		NodeP data[dataCount];

		static int vmt;

		virtual NodePP d(int i) {return &data[i];}

		Button(wxWindow *parent);
		Button(ButtonNodeP buttonNode_);
		Button(ButtonNodeP buttonNode_,
			wxWindow* parent, wxWindowID id, 
			const wxString &label,
			PairP onClick_=PairP(0),
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = 0, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = _("Button"));
		~Button();

		void 
			OnClose(wxCloseEvent &event),
			OnClick(wxCommandEvent &event);

		wxString wxstring();
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		DECLARE_EVENT_TABLE()
};
typedef Button *ButtonP;

class ButtonNode: public WindowNode
{
	public:
		ButtonP &button;
		static const ButtonNode aButtonNode;

		operator_new;
		PairP onClick();
		void setonClick(NodeP function);

		ButtonNode();
		ButtonNode(WindowNodeP parent_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();
		
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs(IntToPtr_ &intToPtr);
		void recreate();

		StringP string();
		wxString wxstring();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);

		StringP _typeof();
};
