//___________________________________________________________________
//
//                         CheckBox Header
//___________________________________________________________________

#ifndef WINDOWNODE
	#include "Window.h"
#endif

extern Function 
	lCheckBox, lCheckBoxDestroy, lCheckBoxOnClick,
	lCheckBoxValue, lCheckBoxSet, lCheckBoxEnable;

class CheckBox: public wxCheckBox
{
	public:
		enum Data
		{	WINDOW_DATA,
			onClick, uonClick, tonClick,
			dataCount
		};
		NodeP data[dataCount];

		static int vmt;

		virtual NodePP d(int i) {return &data[i];}

		CheckBox(wxWindow *parent);
		CheckBox(CheckBoxNodeP checkBoxNode_);
		CheckBox(CheckBoxNodeP checkBoxNode_,
			wxWindow* parent, wxWindowID id, 
			const wxString &label,
			PairP onClick_=PairP(0),
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = 0, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = _("CheckBox"));
		~CheckBox();

		void 
			OnClose(wxCloseEvent &event),
			OnClick(wxCommandEvent &event);

		wxString wxstring();
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		DECLARE_EVENT_TABLE()
};
typedef CheckBox *CheckBoxP;

class CheckBoxNode: public WindowNode
{
	public:
		CheckBoxP &checkBox;

		static const CheckBoxNode aCheckBoxNode;

		operator_new;
		PairP onClick();
		void setonClick(NodeP function);

		CheckBoxNode();
		CheckBoxNode(WindowNodeP parent_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();
		
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs(IntToPtr_ &intToPtr);
		void recreate();

		StringP string();
		wxString wxstring();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		StringP _typeof();
};
