
#include "stdafx.h"
#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <wx/debug.h>

#include "Main.h"
#include "File.h"
#include "String.h"
#include "Object.h"
#include "Line.h"
#include "Int.h"
#include "Colon.h"
#include "Thread.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
#endif

Colon::Colon() 
{	type=COLON;
}

Colon::Colon(NodeP node): 
Line(node, 0, COLON) 
{	wxASSERT(node);
}

Colon::Colon(NodeP node, NodeType type_):
Line(node, 0, type_) 
{	wxASSERT(node);
}

StringP Colon::string()
{
	StringP str = colon()->string();
	if throwing return StringP(Unbound);
	str = new String(str->ptr(), 0, str->length()+1, str->type, String::copy_colon);
	return str;
}

void Colon::print(FILEP strm, int &width, int depth, int noBrackets, int noSpacers)
{
	if (type==COLON)
	{	::print(strm, width, ':'); 
		colon()->print(strm, width, depth);
	}
	else if (type==VARPARAM)
	{	::print(strm, width, '&'); 
		colon()->print(strm, width, depth);
	}
}

void Colon::printBin(FILEP strm)
{
	int width=Int::max;
	if (type==COLON)
		::print(strm, width, ':'); 
	else if (type==VARPARAM)
		::print(strm, width, '&'); 
	colon()->printBin(strm);
}
