//___________________________________________________________________
//
//                         Compiler Header
//___________________________________________________________________

#ifndef Node_included
	#include "Node.h"
#endif

//#define PROC_EVAL

class __single_inheritance Compiler;

#ifdef _DEBUG
	#undef new
#endif

class NodePStack;
class IntStack;
class FloatStack;
class ToDoCStack;
class VarStack;
class VarPStack;
class PairPPStack;
class ErrorStack;

class Compiler
{
	bool tracing;  // are we tracing the current procedure? 
	int old_ift_iff;
	TailCall oldtailcall;  // in case of reentrant use of Evaluator 

	CompiledP code;
	NodeP		// Registers 
		val,     // the value of the last expression 
		catch_tag;

	PairP
		nodeList,    // flat list of expressions to evaluate
		unev,       // list of unevaluated expressions
		exp;       // the current expression 

	NodeP proc; // the procedure definition

	PairP
		formals,  // list of formal parameters 
		parm,    // the current formal 
		arg;    // the current actual 

	int asp;		// argStack pointer
	int vsp;	  // varStack pointer

	public:
		Compiler() {}
		Compiler(PairP nodeList_, ToDo where, ThreadP th);
		NodeP compile(PairP nodeList_, ToDo where, ThreadP th);


#ifdef PROC_EVAL
	#define create_function(x)	_##x(),

		int Eval_Labels(create_function)		dummy;
#endif

		ThreadP th;

		static const char commandName[][end+1];

	friend class Pair;
};

extern NodeP lcompile(PairPP arg);

