#ifndef Node_included
	#include "Node.h"
#endif

#ifndef Complex_included

#include <complex>

typedef std::complex<double> complexd;	
typedef complexd* complexdP;

class Complexd: public Node 
{
	public: 
		complexd complex_;

		static const int digits;
		static const Complexd aComplexd;

		operator_new;
		Complexd():         Node(COMPLEX), complex_(0) {}
		Complexd(complexd c): Node(COMPLEX), complex_(c) {}
		Complexd(double re): Node(COMPLEX), complex_(re) {}
		Complexd(double re, double im): Node(COMPLEX), complex_(re,im) {}

		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);
		int _sizeof();
		StringP string();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		void printBin(FILEP strm);
		StringP _typeof();

		int   numberP() {return 1;}
		double getnumber(); 
		 NodeP    number() {return this;}

		OPERATORS_DECL
		int compare(NodeP nd);
		double _min(double d);
		double _max(double d);
		NodeP Norm();
		NodeP maxNorm(); 
		NodeP item(NodeP index, NodeP result);
		NodeP bititem(NodeP index);
		NodeP memberP(NodeP subobj, bool notp=false, bool substr=false);
		NodeP readbin(FileP file);
		PairP list();

		static void init();
		static void reset_FPU();
		static double abs(complexd x);
		static complexd rnd();
		static complexd sqr(complexd x);
		static complexd Remainder(complexd x, double d);
		static complexd Remainder(double x, complexd d);
		static complexd Remainder(complexd x, complexd d);
		static complexd mod(complexd x, double d);
		static complexd mod(double x, complexd d);
		static complexd mod(complexd x, complexd d);
};

extern void
	print(FILEP strm, int &width, complexd c),
	printBin(FILEP strm, complexd c);

#define Complex_included
#endif
