#include "stdafx.h"
#ifdef _DEBUG
	#include <crtdbg.h>
#endif

#include <wx/object.h>
#include <wx/dynlib.h>
#include <wx/datstrm.h>
#include <wx/thread.h>

#include "Main.h"
#include "Pair.h"
#include "String.h"
#include "DL.h"
#include "Error.h"
#include "File.h"

#include "IntToPtr_.h"
#include "PtrToInt_.h"
#include "Security.h"
#include "Thread.h"
#include "LogoApp.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
#endif

DynamicLibrary::DynamicLibrary(StringP name_, wxDynamicLibrary *module_):
	Node(DYNAMIC_LIB), module(module_) 
{
	setname(name_);
}

void DynamicLibrary::free()
{
	if (module)
		delete module;
}

void DynamicLibrary::setname(StringP nd) {_name=nd;  check_oldyoung(nd);}

void DynamicLibrary::inc_gc() {fifo << name();}

int  DynamicLibrary::youngs() {return gmark(name());}
int  DynamicLibrary::youngsPtr(PtrToInt_ &ptrToInt) 
{	return gmarkPtr(name(), ptrToInt);
}
void DynamicLibrary::check_oldyoungs() {check_oldyoung(name());}

void DynamicLibrary::setPtrs(IntToPtr_ &intToPtr)
{
	setname(StringP((String*)intToPtr.find(int(_name))));
	wxDynamicLibrary *dl=new wxDynamicLibrary;
	if (!dl)
	{	error(OUT_OF_MEM); return;
	}
	if (!dl->Load(_name->ptr()))
	{	error(FILE_ERROR, new String(
			wxString(_("Dynamic Library"))+" "+_name->ptr()+" "+_("not found")));
		return;
	}
	module=dl;
}
DataInputStream &DynamicLibrary::read(DataInputStream &istr) 
{
	istr >> (int&)_name;
	return istr;
}
wxDataOutputStream &DynamicLibrary::write(wxDataOutputStream &ostr) 
{
	ostr << type << GC_::ptrToInt->find(name());
	return ostr;
}

StringP DynamicLibrary::string()
{
	wxString s;
	return new String(wxString(_("DynamicLibrary"))+" "+name()->ptr());
}

void DynamicLibrary::print(FILEP strm, int &width, int depth, int noBrackets, int noSpacers)
{
	::print(strm, width, _("DynamicLibrary "));
	name()->print(strm, width, depth);
}

NodeP lDynamicLibrary(PairPP arg)
{
	ThreadP th=Thread::This();
	if (!th->security->dlcall)
	{	error(SECURITY_ERROR, new String(_("to use DynamicLibrary"))); return Unbound;
	}
	StringP name=arg[1]->a_string(1);
	if throwing return Unbound;
//	char pathbuffer[_MAX_PATH];
//	int err = _searchenv_s(name->ptr(), "PATH", pathbuffer, _MAX_PATH);
	wxPathList pl;
	pl.Add(theApp->runDirectory);
	pl.AddEnvList(wxT("PATH"));
	wxString path=pl.FindValidPath(name->ptr());
	if (path==wxEmptyString)
	{	StringP nameext=new String(name, new String(".dll"));
		if throwing return Unbound;
		if (nameext)
			path=pl.FindValidPath(nameext->ptr());
//			err = _searchenv_s(nameext->ptr(), "PATH", pathbuffer, _MAX_PATH);
//		if (err != 0)
		if (path==wxEmptyString)
		{	error(FILE_ERROR, 
				new Pair(new String(_("Dynamic Library ")), 
				new Pair(name,
				new Pair(new String(_(" not found")), 0))));
			return Unbound;
		}
	}
	wxDynamicLibrary *dl=new wxDynamicLibrary;
	if (!dl)
	{	error(OUT_OF_MEM); return Unbound;
	}
	if (!dl->Load(name->ptr()))
	{	error(FILE_ERROR, 
			new Pair(new String(_("Dynamic Library ")), 
			new Pair(name,
			new Pair(new String(_(" could not be loaded")), 0))));
		return Unbound;
	}else
		return new DynamicLibrary(name, dl);
}

