
#include "stdafx.h"

#include <wx/wfstream.h>
#include <wx/datstrm.h>
#include <wx/zipstrm.h>

#include "Color.h"
#include "DataInputStream.h"

DataInputStream::DataInputStream(wxFileInputStream &s):
wxDataInputStream(s)
{
}

DataInputStream::DataInputStream(wxFFileInputStream &s):
wxDataInputStream(s)
{
}

DataInputStream::DataInputStream(wxZipInputStream &s):
wxDataInputStream(s)
{
}

DataInputStream &DataInputStream::operator>>(wxString& word)
{
	word = ReadString();
	return *this;
}

DataInputStream &DataInputStream::operator>>(bool &b)
{
	b = (Read8()!=0);
	return *this;
}

DataInputStream &DataInputStream::operator>>(char &c)
{
    c = Read8();
    return *this;
}

DataInputStream &DataInputStream::operator>>(unsigned char &c)
{
    c = Read8();
    return *this;
}

DataInputStream &DataInputStream::operator>>(wxInt16& i)
{
	i = (wxInt16)Read16();
	return *this;
}

DataInputStream &DataInputStream::operator>>(wxInt32& i)
{
	i = (wxInt32)Read32();
	return *this;
}

DataInputStream &DataInputStream::operator>>(wxUint16& i)
{
	i = Read16();
	return *this;
}

DataInputStream &DataInputStream::operator>>(wxUint32& i)
{
	i = Read32();
	return *this;
}

DataInputStream &DataInputStream::operator>>(Color &c)
{
	return *this >> c.i;
}

DataInputStream &DataInputStream::operator>>(double& i)
{
	i = ReadDouble();
	return *this;
}

DataInputStream &DataInputStream::operator>>(float& f)
{
	f = (float)ReadDouble();
	return *this;
}

bool DataInputStream::Eof()
{
	return m_input->Eof();
}
