//////////////////////////////////////////////////////////////////////////////
// File:        prefs.cpp
// Purpose:     STC test Preferences initialization
// Maintainer:  Wyo
// Created:     2003-09-01
// RCS-ID:      $Id: prefs.cpp,v 1.3 2004/05/25 11:14:03 JS Exp $
// Copyright:   (c) wxGuide
// Licence:     wxWindows licence
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#include "EdDefsExt.h"     // Additional definitions
#include "EdPrefs.h"       // Preferences

#include "Main.h"
#include "Node.h"
#include "String.h"
#include "Object.h"
#include "Table.h"
#include "Pair.h"
#include "File.h"
#include "Workspace.h"
#include "Thread.h"

//----------------------------------------------------------------------------
//! language types
const CommonInfo g_CommonPrefs = {
    // editor functionality prefs
    true,  // syntaxEnable
    true,  // foldEnable
    true,  // indentEnable
    // display defaults prefs
    false, // overTypeInitial
    false, // readOnlyInitial
    false,  // wrapModeInitial
    false, // displayEOLEnable
    false, // IndentGuideEnable
    false, // lineNumberEnable
    false, // longLineOnEnable
    false, // whiteSpaceEnable
};

//----------------------------------------------------------------------------
// keywordlists


// aUCBLogo

wxString 
	aUCBLogoWordlist1,
	aUCBLogoWordlist2,
	aUCBLogoWordlist3,
	aUCBLogoWordlist4,
	aUCBLogoWordlist5;

wxString aUCBLogoWordlist;

wxString
	aUCBLogoWordlistLow1,
	aUCBLogoWordlistLow2,
	aUCBLogoWordlistLow3,
	aUCBLogoWordlistLow4,
	aUCBLogoWordlistLow5,

	aUCBLogoWordlistBoth1,
	aUCBLogoWordlistBoth2,
	aUCBLogoWordlistBoth3,
	aUCBLogoWordlistBoth4,
	aUCBLogoWordlistBoth5;

// C++

wxChar* CppWordlist1 =
    _T("asm auto bool break case catch char class const const_cast \
       continue default delete do double dynamic_cast else enum explicit \
       export extern false float for friend goto if inline int long \
       mutable namespace new operator private protected public register \
       reinterpret_cast return short signed sizeof static static_cast \
       struct switch template this throw true try typedef typeid \
       typename union unsigned using virtual void volatile wchar_t \
       while");
wxChar* CppWordlist2 =
    _T("file");
wxChar* CppWordlist3 =
    _T("a addindex addtogroup anchor arg attention author b brief bug c \
       class code date def defgroup deprecated dontinclude e em endcode \
       endhtmlonly endif endlatexonly endlink endverbatim enum example \
       exception f$ f[ f] file fn hideinitializer htmlinclude \
       htmlonly if image include ingroup internal invariant interface \
       latexonly li line link mainpage name namespace nosubgrouping note \
       overload p page par param post pre ref relates remarks return \
       retval sa section see showinitializer since skip skipline struct \
       subsection test throw todo typedef union until var verbatim \
       verbinclude version warning weakgroup $ @ "" & < > # { }");


// Python

wxChar* PythonWordlist1 =
    _T("and assert break class continue def del elif else except exec \
       finally for from global if import in is lambda None not or pass \
       print raise return try while yield");
wxChar* PythonWordlist2 =
    _T("ACCELERATORS ALT AUTO3STATE AUTOCHECKBOX AUTORADIOBUTTON BEGIN \
       BITMAP BLOCK BUTTON CAPTION CHARACTERISTICS CHECKBOX CLASS \
       COMBOBOX CONTROL CTEXT CURSOR DEFPUSHBUTTON DIALOG DIALOGEX \
       DISCARDABLE EDITTEXT END EXSTYLE FONT GROUPBOX ICON LANGUAGE \
       LISTBOX LTEXT MENU MENUEX MENUITEM MESSAGETABLE POPUP PUSHBUTTON \
       RADIOBUTTON RCDATA RTEXT SCROLLBAR SEPARATOR SHIFT STATE3 \
       STRINGTABLE STYLE TEXTINCLUDE VALUE VERSION VERSIONINFO VIRTKEY");

LanguageInfo g_LanguagePrefs[5];
int g_LanguagePrefsSize=0;

void init_aUCBLogoWordLists()
{
	aUCBLogoWordlist1 =
		wxString(_T("_defMacro "))
		+_T("_Macro ")
		+_T("apply ")
		+_T("be ")
		+_T("break ")
		+_T("case ")
		+_T("catch ")
		+_T("continue ")
		+_T("continueLoop ")
		+_T("define ")
		+_T("defineBe ")
		+_T("do_until ")
		+_T("do_while ")
		+_T("doubleBuffer ")
		+_T("end ")
		+_T("false ")
		+_T("for ")
		+_T("foreach ")
		+_T("forever ")
		+_T("goTo ")
		+_T("Graphic ")
		+_T("GraphicEnd ")
		+_T("GraphicStart ")
		+_T("identityMatrix ")
		+_T("IDM ")
		+_T("if ")
		+_T("ifElse ")
		+_T("ifF ")
		+_T("ifFalse ")
		+_T("ifT ")
		+_T("ifTrue ")
		+_T("ignore ")
		+_T("inherit ")
		+_T("make ")
		+_T("Matrix ")
		+_T("output ")
		+_T("pause ")
		+_T("PolyEnd ")
		+_T("Polygon ")
		+_T("PolyStart ")
		+_T("redraw ")
		+_T("repeat ")
		+_T("repCount ")
		+_T("repeatCount ")
		+_T("run ")
		+_T("runParse ")
		+_T("runSecure ")
		+_T("runResult ")
		+_T("setIdentityMatrix ")
		+_T("setIDM ")
		+_T("setNamespace ")
		+_T("setTurtleMatrix ")
		+_T("Shell ")
		+_T("ShellSpawn ")
		+_T("singleBuffer ")
		+_T("step ")
		+_T("stop ")
		+_T("Surface ")
		+_T("SurfaceColumn ")
		+_T("SurfaceEnd ")
		+_T("SurfaceStart ")
		+_T("test ")
		+_T("Tag ")
		+_T("TessContour ")
		+_T("Tesselation ")
		+_T("TessEnd ")
		+_T("TessStart ")
		+_T("Thing ")
		+_T("this ")
		+_T("Thread ")
		+_T("ThreadJoinable ")
		+_T("throw ")
		+_T("TurtleMatrix ")
		+_T("to ")
		+_T("trace ")
		+_T("true ")
		+_T("unstep ")
		+_T("until ")
		+_T("untrace ")
		+_T("VideoEnd ")
		+_T("VideoFrame ")
		+_T("VideoStart ")
		+_T("wait ")
		+_T("while ");

/*	aUCBLogoWordlist2 =
		wxString(_T("_eq "))
		+_T("_maybeOutput ")
		+_T("_setBF ")
		+_T("_setButFirst ")
		+_T("_setFirst ")
		+_T("_setItem ")
		+_T("_setPos ")
		+_T("abs ")
		+_T("addColors ")
		+_T("addColorsMod ")
		+_T("allFullScreen ")
		+_T("allOpen ")
		+_T("AlNumP ")
		+_T("AlNum? ")
		+_T("AlphaP ")
		+_T("Alpha? ")
		+_T("and ")
		+_T("and2 ")
		+_T("Arc ")
		+_T("ArcCos ")
		+_T("ArcSin ")
		+_T("ArcTan ")
		+_T("Arity ")
		+_T("Array ")
		+_T("ArrayP ")
		+_T("Array? ")
		+_T("ASCII ")
		+_T("ASCIIP ")
		+_T("ASCII? ")
		+_T("aShift ")
		+_T("back ")
		+_T("backslashedP ")
		+_T("backslashed? ")
		+_T("BackslashEncode ")
		+_T("beforeP ")
		+_T("before? ")
		+_T("beginBusyCursor ")
		+_T("BigFloat ")
		+_T("BigFloatSetPrecision ")
		+_T("BitAnd ")
		+_T("BitCopy ")
		+_T("BitFill ")
		+_T("BitItem ")
		+_T("BitMakeTransparent ")
		+_T("BitMaxX ")
		+_T("BitMaxY ")
		+_T("BitNot ")
		+_T("BitOr ")
		+_T("BitPaste ")
		+_T("BitPasteFast ")
		+_T("BitPasteTo ")
		+_T("BitPasteToScaled ")
		+_T("BitPixel ")
		+_T("BitSetPixel ")
		+_T("BitXOr ")
		+_T("boldTextMode ") 
		+_T("BoxSizer ")
		+_T("BoxSizerAdd ")
		+_T("BoxSizerDestroy ")
		+_T("buried ")
		+_T("bury ")
		+_T("BusyCursorP ")
		+_T("BusyCursor? ")
		+_T("butFirst ")
		+_T("butFirsts ")
		+_T("butLast ")
		+_T("Button ")
		+_T("ButtonDestroy ")
		+_T("ButtonEnable ")
		+_T("ButtonOnClick ")
		+_T("bye ")
		+_T("Calls ")
		+_T("CaseIgnoredP ")
		+_T("CaseIgnored? ")
		+_T("castShadows ")
		+_T("changeDir ")
		+_T("Char ")
		+_T("CharP ")
		+_T("Char? ")
		+_T("CharUnderCursor ")
		+_T("CheckBox ")
		+_T("CheckBoxDestroy ")
		+_T("CheckBoxEnable ")
		+_T("CheckBoxOnClick ")
		+_T("CheckBoxSet ")
		+_T("CheckBoxValue ")
		+_T("ChoiceBox ")
		+_T("ChoiceBoxAppend ")
		+_T("ChoiceBoxCount ")
		+_T("ChoiceBoxDestroy ")
		+_T("ChoiceBoxEnable ")
		+_T("ChoiceBoxOnChar ")
		+_T("ChoiceBoxOnKeyDown ")
		+_T("ChoiceBoxOnKeyUp ")
		+_T("ChoiceBoxOnSelect ")
		+_T("ChoiceBoxRemoveItem ")
		+_T("ChoiceBoxSelection ")
		+_T("ChoiceBoxSetBackgroundColor ")
		+_T("ChoiceBoxSetChoices ")
		+_T("ChoiceBoxSetColor ")
		+_T("ChoiceBoxSetFontName ")
		+_T("ChoiceBoxSetFontSize ")
		+_T("ChoiceBoxSetFontStyle ")
		+_T("ChoiceBoxSetFontWeight ")
		+_T("ChoiceBoxSetItem ")
		+_T("ChoiceBoxSetSelection ")
		+_T("circle ")
		+_T("circularP ")
		+_T("circular? ")
		+_T("clean ")
		+_T("clearPortBit ")
		+_T("clearScreen ")
		+_T("clearShadows ")
		+_T("clearText ")
		+_T("close ")
		+_T("CntrlP ")
		+_T("Cntrl? ")
		+_T("combine ")
		+_T("ComboBox ")
		+_T("ComboBoxAppend ")
		+_T("ComboBoxCount ")
		+_T("ComboBoxDestroy ")
		+_T("ComboBoxEnable ")
		+_T("ComboBoxOnChange ")
		+_T("ComboBoxOnChar ")
		+_T("ComboBoxOnEnter ")
		+_T("ComboBoxOnKeyDown ")
		+_T("ComboBoxOnKeyUp ")
		+_T("ComboBoxOnSelect ")
		+_T("ComboBoxRemoveItem ")
		+_T("ComboBoxSelection ")
		+_T("ComboBoxSetBackgroundColor ")
		+_T("ComboBoxSetChoices ")
		+_T("ComboBoxSetColor ")
		+_T("ComboBoxSetFontName ")
		+_T("ComboBoxSetFontSize ")
		+_T("ComboBoxSetFontStyle ")
		+_T("ComboBoxSetFontWeight ")
		+_T("ComboBoxSetItem ")
		+_T("ComboBoxSetSelection ")
		+_T("ComboBoxSetValue ")
		+_T("ComboBoxValue ")
		+_T("Comment ")
		+_T("complexP ")
		+_T("complex? ")
		+_T("conjugate ")
		+_T("ConsoleSetFocus ")
		+_T("Contents ")
		+_T("copyDef ")
		+_T("Cos ")
		+_T("count ")
		+_T("cross ")
		+_T("CSymP ")
		+_T("CSym? ")
		+_T("Cursor ")
		+_T("Cylinder ")
		+_T("deepCopy ")
		+_T("deleteTextures ")
		+_T("dequeue ")
		+_T("Difference ")
		+_T("DigitP ")
		+_T("Digit? ")
		+_T("DirectoryP ")
		+_T("Directory? ")
		+_T("DirSelector ")
		+_T("disableCylinderLines ")
		+_T("disableDepthTest ")
		+_T("disableDither ")
		+_T("disableFog ")
		+_T("disableLineSmooth ")
		+_T("disableLighting ")
		+_T("disablePolySmooth ")
		+_T("disablePointSmooth ")
		+_T("disableRoundLineEnds ")
		+_T("disableShadows ")
		+_T("disableTextMouseEvents ")
		+_T("disableTexture ")
		+_T("disableTextureFont ")
		+_T("dispatchMessages ")
		+_T("Distance ")
		+_T("DistanceXYZ ")
		+_T("DLCall ")
		+_T("drawGraphic ")
		+_T("dribble ")
		+_T("DynamicLibrary ")
		+_T("DynamicLibraryCall ")
		+_T("edit ")
		+_T("editFile ")
		+_T("Ellipse ")
		+_T("EllipseArc ")
		+_T("Ellipsoid ")
		+_T("emptyP ")
		+_T("empty? ")
		+_T("enableCylinderLines ")
		+_T("enableDepthTest ")
		+_T("enableDither ")
		+_T("enableFog ")
		+_T("enableLineSmooth ")
		+_T("enableLighting ")
		+_T("enablePointSmooth ")
		+_T("enablePolySmooth ")
		+_T("enableRoundLineEnds ")
		+_T("enableShadows ")
		+_T("enableTextMouseEvents ")
		+_T("enableTexture ")
		+_T("enableTextureFont ")
		+_T("endBusyCursor ")
		+_T("EofP ")
		+_T("Eof? ")
		+_T("equalP ")
		+_T("equal? ")
		+_T("erAll ")
		+_T("erase ")
		+_T("eraseAll ")
		+_T("eraseDirectory ")
		+_T("eraseFile ")
		+_T("eraseNames ")
		+_T("eraseProcedures ")
		+_T("error ")
		+_T("exp ")
		+_T("Faculty ")
		+_T("factorize ")
		+_T("Fence ")
		+_T("FileP ")
		+_T("File? ")
		+_T("Files ")
		+_T("FileSelector ")
		+_T("FileSize ")
		+_T("FileTime ")
		+_T("fill ")
		+_T("fillCircle ")
		+_T("fillEllipse ")
		+_T("fillPie ")
		+_T("fillRect ")
		+_T("first ")
		+_T("firsts ")
		+_T("Float ")
		+_T("FloatArray ")
		+_T("FloatArrayP ")
		+_T("FloatArray? ")
		+_T("FloatControl ")
		+_T("FloatControlDestroy ")
		+_T("FloatControlEnable ")
		+_T("FloatControlOnChange ")
		+_T("FloatControlSetRange ")
		+_T("FloatControlSetValue ")
		+_T("FloatControlValue ")
		+_T("floatP ")
		+_T("float? ")
		+_T("FloodColor ")
		+_T("Form ")
		+_T("forward ")
		+_T("fPut ")
		+_T("Frame ")
		+_T("FrameDestroy ")
		+_T("FrameEnable ")
		+_T("FrameFullScreen ")
		+_T("FrameIconize ")
		+_T("FrameMaximize ")
		+_T("FrameOnChar ")
		+_T("FrameOnClose ")
		+_T("FrameOnKeyDown ")
		+_T("FrameOnKeyUp ")
		+_T("FrameSetBackgroundColor ")
		+_T("FrameSetClientSize ")
		+_T("FrameSetColor ")
		+_T("FrameSetFocus ")
		+_T("FrameSetFontName ")
		+_T("FrameSetFontSize ")
		+_T("FrameSetFontStyle ")
		+_T("FrameSetFontWeight ")
		+_T("FrameSetShape ")
		+_T("FrameSetSizer ")
		+_T("fullScreen ")
		+_T("fullText ")
		+_T("Gauge ")
		+_T("GaugeDestroy ")
		+_T("GaugeSetBackgroundColor ")
		+_T("GaugeSetColor ")
		+_T("GaugeSetRange ")
		+_T("GaugeSetValue ")
		+_T("GaugeValue ")
		+_T("gcd ")
		+_T("genSym ")
		+_T("getColorDatabase ")
		+_T("getColorFromUser ")
		+_T("getEnv ")
		+_T("getEnvTable ")
		+_T("getFontFromUser ")
		+_T("getMultipleChoices ")
		+_T("getNumberFromUser ")
		+_T("getPasswordFromUser ")
		+_T("getProcessId ")
		+_T("getSingleChoice ")
		+_T("getSingleChoiceIndex ")
		+_T("getTextFromUser ")
		+_T("getThreadId ")
		+_T("getPortBit ")
		+_T("getWorkingDirectory ")
		+_T("Graph ")
		+_T("GraphCurrent ")
		+_T("GraphDestroy ")
		+_T("GraphEnter ")
		+_T("GraphLeave ")
		+_T("GraphOnChar ")
		+_T("GraphOnKeyDown ")
		+_T("GraphOnKeyUp ")
		+_T("GraphOnMouseLeftDClick ")
		+_T("GraphOnMouseLeftDown ")
		+_T("GraphOnMouseLeftUp ")
		+_T("GraphOnMouseMiddleDClick ")
		+_T("GraphOnMouseMiddleDown ")
		+_T("GraphOnMouseMiddleUp ")
		+_T("GraphOnMouseMotion ")
		+_T("GraphOnMouseRightDClick ")
		+_T("GraphOnMouseRightDown ")
		+_T("GraphOnMouseRightUp ")
		+_T("GraphP ")
		+_T("Graph? ")
		+_T("GraphSetCurrent ")
		+_T("greater ")
		+_T("greaterEqual ")
		+_T("greaterEqualP ")
		+_T("greaterEqual? ")
		+_T("greaterP ")
		+_T("greater? ")
		+_T("Heading ")
		+_T("help ")
		+_T("hideTurtle ")
		+_T("Home ")
		+_T("HSB ")
		+_T("HSBA ")
		+_T("IdentityMatrix ")
		+_T("imag ")
		+_T("insertMode ")
		+_T("Int ")
		+_T("Int8 ")
		+_T("Int8P ")
		+_T("Int8? ")
		+_T("Int16 ")
		+_T("Int16P ")
		+_T("Int16? ")
		+_T("IntControl ")
		+_T("IntControlDestroy ")
		+_T("IntControlEnable ")
		+_T("IntControlOnChange ")
		+_T("IntControlSetRange ")
		+_T("IntControlSetValue ")
		+_T("IntControlValue ")
		+_T("intForm ")
		+_T("IntP ")
		+_T("Int? ")
		+_T("IntArray ")
		+_T("IntArrayP ")
		+_T("IntArray? ")
		+_T("Int16Array ")
		+_T("Int16ArrayP ")
		+_T("Int16Array? ")
		+_T("invertMatrix ")
		+_T("iSeq ")
		+_T("iSeqIA ")
		+_T("iSeqIntArray ")
		+_T("Item ")
		+_T("Items ")
		+_T("Key ")
		+_T("KeyboardValue ")
		+_T("KeyP ")
		+_T("Key? ")
		+_T("Label ")
		+_T("LabelAlign ")
		+_T("LabelFont ")
		+_T("LabelSize ")
		+_T("LabelWeight ")
		+_T("last ")
		+_T("left ")
		+_T("leftPortShift ")
		+_T("leftRoll ")
		+_T("less ")
		+_T("lessEqual ")
		+_T("lessEqualP ")
		+_T("lessEqual? ")
		+_T("lessP ")
		+_T("less? ")
		+_T("LineColumn ")
		+_T("LineTColumn ")
		+_T("LineRow ")
		+_T("List ")
		+_T("ListBox ")
		+_T("ListBoxAppend ")
		+_T("ListBoxCount ")
		+_T("ListBoxDestroy ")
		+_T("ListBoxEnable ")
		+_T("ListBoxOnChar ")
		+_T("ListBoxOnDClick ")
		+_T("ListBoxOnKeyDown ")
		+_T("ListBoxOnKeyUp ")
		+_T("ListBoxOnSelect ")
		+_T("ListBoxRemoveItem ")
		+_T("ListBoxSelections ")
		+_T("ListBoxSetBackgroundColor ")
		+_T("ListBoxSetChoices ")
		+_T("ListBoxSetColor ")
		+_T("ListBoxSetFontName ")
		+_T("ListBoxSetFontSize ")
		+_T("ListBoxSetFontStyle ")
		+_T("ListBoxSetFontWeight ")
		+_T("ListBoxSetItem ")
		+_T("ListBoxSetSelections ")
		+_T("ListControl ")
		+_T("ListControlColumn ")
		+_T("ListControlColumnCount ")
		+_T("ListControlDeleteItem ")
		+_T("ListControlDestroy ")
		+_T("ListControlEnable ")
		+_T("ListControlGet ")
		+_T("ListControlGetColumn ")
		+_T("ListControlGetItem ")
		+_T("ListControlGetRow ")
		+_T("ListControlInsertColumn ")
		+_T("ListControlInsertItem ")
		+_T("ListControlItemCount ")
		+_T("ListControlOnChar ")
		+_T("ListControlOnColClick ")
		+_T("ListControlOnColEndDrag ")
		+_T("ListControlOnItemActivated ")
		+_T("ListControlOnItemSelected ")
		+_T("ListControlOnKeyDown ")
		+_T("ListControlOnKeyUp ")
		+_T("ListControlRow ")
		+_T("ListControlSet ")
		+_T("ListControlSetBackgroundColor ")
		+_T("ListControlSetColor ")
		+_T("ListControlSetColumn ")
		+_T("ListControlSetFontName ")
		+_T("ListControlSetFontSize ")
		+_T("ListControlSetFontStyle ")
		+_T("ListControlSetFontWeight ")
		+_T("ListControlSetItem ")
		+_T("ListControlSetRow ")
		+_T("ListControlSort ")
		+_T("ListControlText ")
		+_T("ListP ")
		+_T("List? ")
		+_T("LN ")
		+_T("load ")
		+_T("loadImage ")
		+_T("loadPicture ")
		+_T("loadPictureText ")
		+_T("local ")
		+_T("Log10 ")
		+_T("LogoComspec ")
		+_T("LogoEditor ")
		+_T("LogoFontsDir ")
		+_T("LogoHelpDir ")
		+_T("LogoInstance ")
		+_T("LogoLibDir ")
		+_T("LogoTempDir ")
		+_T("LogoVersion ")
		+_T("lowerCase ")
		+_T("LowerP ")
		+_T("Lower? ")
		+_T("lowPassFilter ")
		+_T("lPut ")
		+_T("lShift ")
		+_T("MacroP ")
		+_T("Macro? ")
		+_T("makeDirectory ")
		+_T("makeTree ")
		+_T("makeTreeFromBody ")
		+_T("MandelIterate ")
		+_T("max ")
		+_T("maxNorm ")
		+_T("mdItem ")
		+_T("mdSetItem ")
		+_T("Member ")
		+_T("MemberP ")
		+_T("Member? ")
		+_T("merge ")
		+_T("mergePairs ")
		+_T("mergeSort ")
		+_T("MessageBox ")
		+_T("MidiAllSoundsOff ")
		+_T("MidiClose ")
		+_T("MidiCountDevices ")
		+_T("MidiDeviceInfo ")
		+_T("MidiMessage ")
		+_T("MidiNoteOn ")
		+_T("MidiNoteOff ")
		+_T("MidiOpen ")
		+_T("MidiOutStream ")
		+_T("MidiOutStreamsFinished ")
		+_T("MidiOutStreamsStart ")
		+_T("MidiOutStreamsStop ")
		+_T("MidiProgramChange ")
		+_T("min ")
		+_T("Minus ")
		+_T("MIPS ")
		+_T("Mod ")
		+_T("Modulo ")
		+_T("MouseButtons ")
		+_T("MousePos ")
		+_T("MouseX ")
		+_T("MouseY ")
		+_T("movePixel ")
		+_T("moveLine ")
		+_T("NameInTableP ")
		+_T("NameInTable? ")
		+_T("NameP ")
		+_T("Name? ")
		+_T("Names ")
		+_T("Namespace ")
		+_T("newTurtle ")
		+_T("Nodes ")
		+_T("noDribble ")
		+_T("noRefresh ")
		+_T("Norm ")
		+_T("not ")
		+_T("notPortBit ")
		+_T("notFullScreen ")
		+_T("NumberP ")
		+_T("Number? ")
		+_T("OnChar ")
		+_T("OnKeyDown ")
		+_T("OnKeyUp ")
		+_T("OnMouseLeftDClick ")
		+_T("OnMouseLeftDown ")
		+_T("OnMouseLeftUp ")
		+_T("OnMouseMiddleDClick ")
		+_T("OnMouseMiddleDown ")
		+_T("OnMouseMiddleUp ")
		+_T("OnMouseMotion ")
		+_T("OnMouseRightDClick ")
		+_T("OnMouseRightDown ")
		+_T("OnMouseRightUp ")
		+_T("OnTextMouseLeftDClick ")
		+_T("OnTextMouseLeftDown ")
		+_T("OnTextMouseLeftUp ")
		+_T("OnTextMouseMiddleDClick ")
		+_T("OnTextMouseMiddleDown ")
		+_T("OnTextMouseMiddleUp ")
		+_T("OnTextMouseMotion ")
		+_T("OnTextMouseRightDClick ")
		+_T("OnTextMouseRightDown ")
		+_T("OnTextMouseRightUp ")
		+_T("openAppend ")
		+_T("openRead ")
		+_T("openReadBin ")
		+_T("openUpdate ")
		+_T("openUpdateBin ")
		+_T("openWrite ")
		+_T("openWriteBin ")
		+_T("or ")
		+_T("or2 ")
		+_T("Orientation ")
		+_T("orthographic ")
		+_T("OSScreenSize ")
		+_T("overwriteMode ")
		+_T("Palette ")
		+_T("partialEllipsoid ")
		+_T("PenColor ")
		+_T("PenDown ")
		+_T("PenDownP ")
		+_T("PenDown? ")
		+_T("PenErase ")
		+_T("PenMode ")
		+_T("PenPaint ")
		+_T("PenReverse ")
		+_T("PenSize ")
		+_T("PenUp ")
		+_T("perspective ")
		+_T("pick ")
		+_T("Pitch ")
		+_T("Pixel ")
		+_T("plainTextMode ")
		+_T("playWave ")
		+_T("playWaveFast ")
		+_T("PortIn ")
		+_T("PortOut ")
		+_T("pop ")
		+_T("popMatrix ")
		+_T("Pos ")
		+_T("PosXYZ ")
		+_T("Power ")
		+_T("primeP ")
		+_T("prime? ")
		+_T("Primitive? ")
		+_T("PrimitiveP ")
		+_T("Primitives ")
		+_T("print ")
		+_T("printOut ")
		+_T("printOutTitles ")
		+_T("PrintP ")
		+_T("Print? ")
		+_T("ProcedureP ")
		+_T("Procedure? ")
		+_T("Procedures ")
		+_T("Product ")
		+_T("PunctP ")
		+_T("Punct? ")
		+_T("push ")
		+_T("pushMatrix ")
		+_T("queue ")
		+_T("Quotient ")
		+_T("radArcCos ")
		+_T("radArcSin ")
		+_T("radArcTan ")
		+_T("radCos ")
		+_T("RadioButton ")
		+_T("RadioButtonDestroy ")
		+_T("RadioButtonEnable ")
		+_T("RadioButtonOnClick ")
		+_T("RadioButtonSet ")
		+_T("RadioButtonValue ")
		+_T("radTan")
		+_T("random ")
		+_T("rawASCII ")
		+_T("readChar ")
		+_T("readCharExt ")
		+_T("readComplexBin ")
		+_T("Reader ")
		+_T("ReaderPos ")
		+_T("readFloatArray ")
		+_T("readFloatArrayBin ")
		+_T("readFloatBin ")
		+_T("readIntBin ")
		+_T("readIntArrayBin ")
		+_T("readInt16Bin ")
		+_T("readInt16ArrayBin ")
		+_T("readInt8Bin ")
		+_T("readList ")
		+_T("readRawLine ")
		+_T("readStructBin ")
		+_T("readUInt8Bin ")
		+_T("readWord ")
		+_T("real ")
		+_T("refresh ")
		+_T("reHSB ")
		+_T("reHSBA ")
		+_T("Remainder ")
		+_T("remDup ")
		+_T("remove ")
		+_T("removeItem ")
		+_T("renameFile ")
		+_T("replace ")
		+_T("reRandom ")
		+_T("reRGB ")
		+_T("reRGBA ")
		+_T("resize ")
		+_T("reverse ")
		+_T("rightPortShift ")
		+_T("rightRoll ")
		+_T("rnd ")
		+_T("RGB ")
		+_T("RGBA ")
		+_T("right ")
		+_T("Roll ")
		+_T("rotate ")
		+_T("round ")
		+_T("rSeq ")
		+_T("rSeqFloatArray ")
		+_T("saturateAbove ")
		+_T("saturateBelow ")
		+_T("save ")
		+_T("saveImage ")
		+_T("savePicture ")
		+_T("savePictureText ")
		+_T("savePostScript ")
		+_T("savePS ")
		+_T("saveScreen ")
		+_T("saveScreenVector ")
		+_T("saveSize ")
		+_T("ScreenColor ")
		+_T("scroll ")
		+_T("scrollCal ")
		+_T("scrollCalibrate ")
		+_T("Scrunch ")
		+_T("Se ")
		+_T("Sentence ")
		+_T("setCallsSplitter ")
		+_T("setCaseIgnored ")
		+_T("setCursor ")
		+_T("setCylinderPos ")
		+_T("setDepthFunc ")
		+_T("setErallOnRun ")
		+_T("setEye ")
		+_T("setFloodColor ")
		+_T("setFocusOnRun ")
		+_T("setFogColor ")
		+_T("setFogDensity ")
		+_T("setFogMode ")
		+_T("setFogRange ")
		+_T("setFPUStatusFlags ")
		+_T("setGenSym ")
		+_T("setHeading ")
		+_T("setItem ")
		+_T("setItems ")
		+_T("setLabelAlign ")
		+_T("setLabelFont ")
		+_T("setLabelSize ")
		+_T("setLabelWeight ")
		+_T("setLightAmbient ")
		+_T("setLightDiffuse ")
		+_T("setLightSpecular ")
		+_T("setLightPos ")
		+_T("setLogoComspec ")
		+_T("setLogoEditor ")
		+_T("setLogoFontsDir ")
		+_T("setLogoHelpDir ")
		+_T("setLogoLibDir ")
		+_T("setLogoTempDir ")
		+_T("setMargins ")
		+_T("setMaterialAmbient ")
		+_T("setMaterialDiffuse ")
		+_T("setMaterialSpecular ")
		+_T("setMaterialEmission ")
		+_T("setMaterialShininess ")
		+_T("setOrientation ")
		+_T("setPalette ")
		+_T("setPenColor ")
		+_T("setPenPattern ")
		+_T("setPenSize ")
		+_T("setPitch ")
		+_T("setPixel ")
		+_T("setPixelXY ")
		+_T("setPixelXYZ ")
		+_T("setPlayOnSwap ")
		+_T("setPointSize ")
		+_T("setPolyonMode ")
		+_T("setPos ")
		+_T("setPosXYZ ")
		+_T("setPortBit ")
		+_T("setPrintPrecision ")
		+_T("setReader ")
		+_T("setReaderPos ")
		+_T("setRoll ")
		+_T("setSaveSize ")
		+_T("setScreenColor ")
		+_T("setScreenRange ")
		+_T("setScrunch ")
		+_T("setShadowColor ")
		+_T("setSpherePos ")
		+_T("setTessWindingRule ")
		+_T("setTexPos ")
		+_T("setTextColor ")
		+_T("setTextFont ")
		+_T("setTextSize ")
		+_T("setTextSelection ")
		+_T("setTexXY ")
		+_T("setTexPos ")
		+_T("setTurtle ")
		+_T("setUpdateGraph ")
		+_T("setVarsSplitter ")
		+_T("setWriter ")
		+_T("setWriterPos ")
		+_T("setXY ")
		+_T("setXYZ ")
		+_T("setX ")
		+_T("setY ")
		+_T("setZ ")
		+_T("ShadowColor ")
		+_T("show ")
		+_T("shownP ")
		+_T("shown? ")
		+_T("showTurtle ")
		+_T("shrinkStacks ")
		+_T("shuffle ")
		+_T("Signum ")
		+_T("Sin ")
		+_T("SizeOf ")
		+_T("Slider ")
		+_T("SliderDestroy ")
		+_T("SliderEnable ")
		+_T("SliderOnScroll ")
		+_T("SliderSetRange ")
		+_T("SliderSetValue ")
		+_T("SliderValue ")
		+_T("Sound ")
		+_T("Sounds ")
		+_T("SoundsFinished ")
		+_T("SoundsStop ")
		+_T("SpaceP ")
		+_T("Space? ")
		+_T("Sphere ")
		+_T("spinX ")
		+_T("spinY ")
		+_T("spinZ ")
		+_T("splitScreen ")
		+_T("Sqr ")
		+_T("Sqrt ")
		+_T("standout ")
		+_T("StaticText ")
		+_T("StaticTextDestroy ")
		+_T("StaticTextLabel ")
		+_T("StaticTextSetBackgroundColor ")
		+_T("StaticTextSetColor ")
		+_T("StaticTextSetFontName ")
		+_T("StaticTextSetFontSize ")
		+_T("StaticTextSetFontStyle ")
		+_T("StaticTextSetFontWeight ")
		+_T("StaticTextSetLabel ")
		+_T("StringBuffer ")
		+_T("StringBufferToWord ")
		+_T("Struct ")
		+_T("subStringP ")
		+_T("subString? ")
		+_T("Sum ")
		+_T("Table ")
		+_T("Tables ")
		+_T("Text ")
		+_T("TextControl ")
		+_T("TextControlAppend ")
		+_T("TextControlCursor ")
		+_T("TextControlDestroy ")
		+_T("TextControlEnable ")
		+_T("TextControlInsertMode ")
		+_T("TextControlOnChange ")
		+_T("TextControlOnChar ")
		+_T("TextControlOnEnter ")
		+_T("TextControlOnKeyDown ")
		+_T("TextControlOnKeyUp ")
		+_T("TextControlOverwriteMode ")
		+_T("TextControlSetBackgroundColor ")
		+_T("TextControlSetColor ")
		+_T("TextControlSetCursor ")
		+_T("TextControlSetFontName ")
		+_T("TextControlSetFontSize ")
		+_T("TextControlSetFontStyle ")
		+_T("TextControlSetFontWeight ")
		+_T("TextControlSetInsertionPointEnd ")
		+_T("TextControlSetValue ")
		+_T("TextControlValue ")
		+_T("TextControlWrite ")
		+_T("TextMousePos ")
		+_T("TextMouseX ")
		+_T("TextMouseY ")
		+_T("TextScreen ")
		+_T("Texture ")
		+_T("Time ")
		+_T("TimeFine ")
		+_T("TimeMilli ")
		+_T("TimerFreq ")
		+_T("TimeURes ")
		+_T("ToggleButton ")
		+_T("ToggleButtonDestroy ")
		+_T("ToggleButtonEnable ")
		+_T("ToggleButtonOnClick ")
		+_T("ToggleButtonSetValue ")
		+_T("ToggleButtonValue ")
		+_T("toInt ")
		+_T("toList ")
		+_T("toListList ")
		+_T("Tone ")
		+_T("Tones ")
		+_T("TonesFinished ")
		+_T("TonesStop ")
		+_T("towards ")
		+_T("towardsXYZ ")
		+_T("traced ")
		+_T("trunc ")
		+_T("Turtle ")
		+_T("type ")
		+_T("typeBin ")
		+_T("TypeOf ")
		+_T("UInt8 ")
		+_T("UInt8P ")
		+_T("UInt8? ")
		+_T("unbury ")
		+_T("unperspective ")
		+_T("updateCalls ")
		+_T("updateGraph ")
		+_T("updateVars ")
		+_T("upperCase ")
		+_T("UpperP ")
		+_T("Upper? ")
		+_T("upPitch ")
		+_T("waitMS ")
		+_T("waituS ")
		+_T("Window ")
		+_T("Word ")
		+_T("WordP ")
		+_T("Word? ")
		+_T("WordUnderCursor ")
		+_T("WriterPos ")
		+_T("Writer ")
		+_T("xAdd ")
		+_T("xCopy ")
		+_T("xCor ")
		+_T("xDigitP ")
		+_T("xDigit? ")
		+_T("xDiv ")
		+_T("xMod ")
		+_T("xMul ")
		+_T("xSub ")
		+_T("yCor ")
		+_T("zCor ");
*/
	aUCBLogoWordlist3=
		wxString(_T("` "))
		+_T("arc2 ")
		+_T("axes ")
		+_T("buryall ")
		+_T("buryname ")
		+_T("cascade ")
		+_T("cascade2 ")
		+_T("check ")
		+_T("closeall ")
		+_T("cngon ")
		+_T("cond ")
		+_T("crbox ")
		+_T("crossmap ")
		+_T("dir ")
		+_T("dirlg ")
		+_T("displaymatrix ")
		+_T("edall ")
		+_T("edn ")
		+_T("edns ")
		+_T("edpl ")
		+_T("edpls ")
		+_T("edps ")
		+_T("emacs_debug ")
		+_T("ern ")
		+_T("erns ")
		+_T("erpl ")
		+_T("filep ")
		+_T("filter ")
		+_T("find ")
		+_T("float2ratio ")
		+_T("h ")
		+_T("hex ")
		+_T("invoke ")
		+_T("isprime ")
		+_T("lcm ")
		+_T("loadpalette ")
		+_T("localmake ")
		+_T("macroexpand ")
		+_T("map ")
		+_T("map_se ")
		+_T("mdarray ")
		+_T("name ")
		+_T("namelist ")
		+_T("pen ")
		+_T("pllist ")
		+_T("poall ")
		+_T("pon ")
		+_T("pons ")
		+_T("popl ")
		+_T("popls ")
		+_T("pops ")
		+_T("pots ")
		+_T("profile ")
		+_T("qrest ")
		+_T("quoted ")
		+_T("radd ")
		+_T("ratio ")
		+_T("ratio2float ")
		+_T("rdiv ")
		+_T("reduce ")
		+_T("reset ")
		+_T("rmul ")
		+_T("rotatescene ")
		+_T("rsub ")
		+_T("savel ")
		+_T("setpen ")
		+_T("smul ")
		+_T("stepall ")
		+_T("traceall ")
		+_T("transfer ")
		+_T("transpose ")
		+_T("transposematrix ")
		+_T("unburyall ")
		+_T("unburyname ")
		+_T("vowelp ");

	aUCBLogoWordlist4=wxEmptyString;
/*		wxString(_T("bk "))
		+_T("bFs ")
		+_T("bF ")
		+_T("BitTrans ")
		+_T("bL ")
		+_T("cd ")
		+_T("cS ")
		+_T("cT ")
		+_T("co ")
		+_T("disCL ")
		+_T("disLS ")
		+_T("disPS ")
		+_T("disRLE ")
		+_T("disTex ")
		+_T("down ")
		+_T("ed ")
		+_T("enCL ")
		+_T("enLS ")
		+_T("enPS ")
		+_T("enRLE ")
		+_T("enTex ")
		+_T("er ")
		+_T("erF ")
		+_T("erNS ")
		+_T("erPLs ")
		+_T("erPs ")
		+_T("fd ")
		+_T("fS ")
		+_T("GC ")
		+_T("hT ")
		+_T("loadPic ")
		+_T("lr ")
		+_T("lt ")
		+_T("op ")
		+_T("PC ")
		+_T("PD ")
		+_T("PE ")
		+_T("pO ")
		+_T("poT ")
		+_T("PPt ")
		+_T("PX ")
		+_T("PU ")
		+_T("pr ")
		+_T("rC ")
		+_T("rCE ")
		+_T("rCs ")
		+_T("rL ")
		+_T("rSeqFA ")
		+_T("rW ")
		+_T("rr ")
		+_T("rt ")
		+_T("savePic ")
		+_T("SC ")
		+_T("Se ")
		+_T("setFC ")
		+_T("setH ")
		+_T("setM ")
		+_T("setPC ")
		+_T("setPS ")
		+_T("setSC ")
		+_T("setTC ")
		+_T("setTM ")
		+_T("sT ")
		+_T("sS ")
		+_T("TM ")
		+_T("TS ")
		+_T("uP ");
*/

	aUCBLogoWordlist5=
		wxString(_T("IntMax "))
		+_T("Int16Max ")
		+_T("UInt8Max ");

	if (GC_::initialized)
	{	PairP prims=PairP(lLogoConstants(0));
		if (!throwing)
			prims=PairP(prims->sentence(PairP(lPrimitives(0))));
//		if (!throwing)
//			prims=PairP(prims->combSort());
		if (!throwing)
		{	aUCBLogoWordlist2=wxEmptyString;
			while (prims)
			{	StringP str=prims->first()->string();
				if (str->length() >= 2)
					aUCBLogoWordlist2+=wxString(prims->first()->string()->ptr())+_T(" ");
				next(prims);
			}
//c_out << aUCBLogoWordlist2 << endL;
		}
	}

	aUCBLogoWordlist=aUCBLogoWordlist1
						+ aUCBLogoWordlist2
						+ aUCBLogoWordlist3
						+ aUCBLogoWordlist4
						+ aUCBLogoWordlist5;

	aUCBLogoWordlistLow1=aUCBLogoWordlist1.Lower();
	aUCBLogoWordlistLow2=aUCBLogoWordlist2.Lower();
	aUCBLogoWordlistLow3=aUCBLogoWordlist3.Lower();
	aUCBLogoWordlistLow4=aUCBLogoWordlist4.Lower();
	aUCBLogoWordlistLow5=aUCBLogoWordlist5.Lower();

	aUCBLogoWordlistBoth1=aUCBLogoWordlistLow1+aUCBLogoWordlist1;
	aUCBLogoWordlistBoth2=aUCBLogoWordlistLow2+aUCBLogoWordlist2;
	aUCBLogoWordlistBoth3=aUCBLogoWordlistLow3+aUCBLogoWordlist3;
	aUCBLogoWordlistBoth4=aUCBLogoWordlistLow4+aUCBLogoWordlist4;
	aUCBLogoWordlistBoth5=aUCBLogoWordlistLow5+aUCBLogoWordlist5;


	LanguageInfo languagePrefs[] = 
	{	// aUCBLogo case insensitive
		{	_T("aUCBLogo case insensitive"),
			_T("*.lg;*."),
			wxSTC_LEX_AUCBLOGONOCASE,
			{	{mySTC_TYPE_DEFAULT, _T("")},
				{mySTC_TYPE_COMMENT, _T("")},
				{mySTC_TYPE_COMMENT_LINE, _T("")},
				{mySTC_TYPE_COMMENT_DOC, _T("")},
				{mySTC_TYPE_NUMBER, _T("")},
				{mySTC_TYPE_WORD1, aUCBLogoWordlistLow1}, // KEYWORDS
				{mySTC_TYPE_WORD2, aUCBLogoWordlistLow2},
				{mySTC_TYPE_WORD3, aUCBLogoWordlistLow3},
				{mySTC_TYPE_WORD4, aUCBLogoWordlistLow4},
				{mySTC_TYPE_WORD5, aUCBLogoWordlistLow5},
				{mySTC_TYPE_WORD6, _T("")},
				{mySTC_TYPE_STRING, _T("")},
				{mySTC_TYPE_CHARACTER, _T("")},
				{mySTC_TYPE_UUID, _T("")},
				{mySTC_TYPE_PREPROCESSOR, _T("")},
				{mySTC_TYPE_OPERATOR, _T("")},
				{mySTC_TYPE_IDENTIFIER, _T("")},
				{mySTC_TYPE_STRING_EOL, _T("")},
				{mySTC_TYPE_STRING, _T("")}, // VERBATIM
				{mySTC_TYPE_REGEX, _T("")},
				{mySTC_TYPE_COMMENT_SPECIAL, _T("")}, // DOXY
				{mySTC_TYPE_ERROR, _T("")}, // KEYWORDS ERROR
				{-1, _T("")},
				{-1, _T("")},
				{24, _T("to")},
				{25, _T("end")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")}
			},
			mySTC_FOLD_COMMENT | mySTC_FOLD_COMPACT | mySTC_FOLD_PREPROC
		},
		// aUCBLogo case sensitive
		{	_T("aUCBLogo case sensitive"),
			_T("*.lg"),
			wxSTC_LEX_AUCBLOGO,
			{	{mySTC_TYPE_DEFAULT, _T("")},
				{mySTC_TYPE_COMMENT, _T("")},
				{mySTC_TYPE_COMMENT_LINE, _T("")},
				{mySTC_TYPE_COMMENT_DOC, _T("")},
				{mySTC_TYPE_NUMBER, _T("")},
				{mySTC_TYPE_WORD1, aUCBLogoWordlistBoth1}, // KEYWORDS
				{mySTC_TYPE_WORD2, aUCBLogoWordlistBoth2},
				{mySTC_TYPE_WORD3, aUCBLogoWordlistBoth3},
				{mySTC_TYPE_WORD4, aUCBLogoWordlistBoth4},
				{mySTC_TYPE_WORD5, aUCBLogoWordlistBoth5},
				{mySTC_TYPE_WORD6, _T("")},
				{mySTC_TYPE_STRING, _T("")},
				{mySTC_TYPE_CHARACTER, _T("")},
				{mySTC_TYPE_UUID, _T("")},
				{mySTC_TYPE_PREPROCESSOR, _T("")},
				{mySTC_TYPE_OPERATOR, _T("")},
				{mySTC_TYPE_IDENTIFIER, _T("")},
				{mySTC_TYPE_STRING_EOL, _T("")},
				{mySTC_TYPE_STRING, _T("")}, // VERBATIM
				{mySTC_TYPE_REGEX, _T("")},
				{mySTC_TYPE_COMMENT_SPECIAL, _T("")}, // DOXY
				{mySTC_TYPE_ERROR, _T("")}, // KEYWORDS ERROR
				{-1, _T("")},
				{-1, _T("")},
				{24, _T("to")},
				{25, _T("end")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")}
			},
			mySTC_FOLD_COMMENT | mySTC_FOLD_COMPACT | mySTC_FOLD_PREPROC
		},
		// C++
		{	_T("C++"),
			_T("*.c;*.cc;*.cpp;*.cxx;*.cs;*.h;*.hh;*.hpp;*.hxx;*.sma"),
			wxSTC_LEX_CPP,
			{	{mySTC_TYPE_DEFAULT, _T("")},
				{mySTC_TYPE_COMMENT, _T("")},
				{mySTC_TYPE_COMMENT_LINE, _T("")},
				{mySTC_TYPE_COMMENT_DOC, _T("")},
				{mySTC_TYPE_NUMBER, _T("")},
				{mySTC_TYPE_WORD1, CppWordlist1}, // KEYWORDS
				{mySTC_TYPE_STRING, _T("")},
				{mySTC_TYPE_CHARACTER, _T("")},
				{mySTC_TYPE_UUID, _T("")},
				{mySTC_TYPE_PREPROCESSOR, _T("")},
				{mySTC_TYPE_OPERATOR, _T("")},
				{mySTC_TYPE_IDENTIFIER, _T("")},
				{mySTC_TYPE_STRING_EOL, _T("")},
				{mySTC_TYPE_DEFAULT, _T("")}, // VERBATIM
				{mySTC_TYPE_REGEX, _T("")},
				{mySTC_TYPE_COMMENT_SPECIAL, _T("")}, // DOXY
				{mySTC_TYPE_WORD2, CppWordlist2}, // EXTRA WORDS
				{mySTC_TYPE_WORD3, CppWordlist3}, // DOXY KEYWORDS
				{mySTC_TYPE_ERROR, _T("")}, // KEYWORDS ERROR
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")}
			},
			mySTC_FOLD_COMMENT | mySTC_FOLD_COMPACT | mySTC_FOLD_PREPROC
		},
		// Python
		{	_T("Python"),
			_T("*.py;*.pyw"),
			wxSTC_LEX_PYTHON,
			{	{mySTC_TYPE_DEFAULT, _T("")},
				{mySTC_TYPE_COMMENT_LINE, _T("")},
				{mySTC_TYPE_NUMBER, _T("")},
				{mySTC_TYPE_STRING, _T("")},
				{mySTC_TYPE_CHARACTER, _T("")},
				{mySTC_TYPE_WORD1, PythonWordlist1}, // KEYWORDS
				{mySTC_TYPE_DEFAULT, _T("")}, // TRIPLE
				{mySTC_TYPE_DEFAULT, _T("")}, // TRIPLEDOUBLE
				{mySTC_TYPE_DEFAULT, _T("")}, // CLASSNAME
				{mySTC_TYPE_DEFAULT, PythonWordlist2}, // DEFNAME
				{mySTC_TYPE_OPERATOR, _T("")},
				{mySTC_TYPE_IDENTIFIER, _T("")},
				{mySTC_TYPE_DEFAULT, _T("")}, // COMMENT_BLOCK
				{mySTC_TYPE_STRING_EOL, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")}
			},
			mySTC_FOLD_COMMENTPY | mySTC_FOLD_QUOTESPY
		},
		// * (any)
		{	(wxChar *)DEFAULT_LANGUAGE,
			_T("*.*"),
			wxSTC_LEX_PROPERTIES,
			{	{mySTC_TYPE_DEFAULT, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")},
				{-1, _T("")}
			},
			0
		},
	};

	int size = WXSIZEOF(languagePrefs);
	g_LanguagePrefsSize = WXSIZEOF(languagePrefs);
	for (int i=0; i<size; i++)
		g_LanguagePrefs[i]=languagePrefs[i];
}


//----------------------------------------------------------------------------
//! languages

#ifdef WIN32
const int g_StyleSize=10;
#else
const int g_StyleSize=14;
#endif
//----------------------------------------------------------------------------
//! style types
const StyleInfo g_StylePrefs [] = {
    // mySTC_TYPE_DEFAULT
    {_T("Default"),
     _T("BLACK"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_WORD1
    {_T("Keyword1"),
     _T("BLUE"), _T("WHITE"),
     _T(""), g_StyleSize, mySTC_STYLE_BOLD, 0},

    // mySTC_TYPE_WORD2
    {_T("Keyword2"),
     _T("BLUE"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_WORD3
    {_T("Keyword3"),
     _T("PURPLE"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_WORD4
    {_T("Keyword4"),
     _T("BLUE"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_WORD5
    {_T("Keyword5"),
     _T("BLUE"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_WORD6
    {_T("Keyword6"),
     _T("FIREBRICK"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_COMMENT
    {_T("Comment"),
     _T("FOREST GREEN"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_COMMENT_DOC
    {_T("Comment (Doc)"),
     _T("FOREST GREEN"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_COMMENT_LINE
    {_T("Comment line"),
     _T("FOREST GREEN"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_COMMENT_SPECIAL
    {_T("Special comment"),
     _T("FOREST GREEN"), _T("WHITE"),
     _T(""), g_StyleSize, mySTC_STYLE_ITALIC, 0},

    // mySTC_TYPE_CHARACTER
    {_T("Character"),
     _T("BLACK"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_CHARACTER_EOL
    {_T("Character (EOL)"),
     _T("KHAKI"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_STRING
    {_T("String"),
     _T("RED"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_STRING_EOL
    {_T("String (EOL)"),
     _T("RED"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_DELIMITER
    {_T("Delimiter"),
     _T("ORANGE"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_PUNCTUATION
    {_T("Punctuation"),
     _T("ORANGE"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_OPERATOR
    {_T("Operator"),
     _T("BLACK"), _T("WHITE"),
     _T(""), g_StyleSize, mySTC_STYLE_BOLD, 0},

    // mySTC_TYPE_BRACE
    {_T("Label"),
     _T("VIOLET"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_COMMAND
    {_T("Command"),
     _T("BLUE"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_IDENTIFIER
    {_T("Identifier"),
     _T("BLACK"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_LABEL
    {_T("Label"),
     _T("VIOLET"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_NUMBER
    {_T("Number"),
     _T("RED"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_PARAMETER
    {_T("Parameter"),
     _T("VIOLET"), _T("WHITE"),
     _T(""), g_StyleSize, mySTC_STYLE_ITALIC, 0},

    // mySTC_TYPE_REGEX
    {_T("TO or Regular expression"),
     _T("BLUE"), _T("WHITE"),
     _T(""), g_StyleSize, mySTC_STYLE_BOLD, 0},

    // mySTC_TYPE_UUID
    {_T("END or UUID"),
     _T("BLUE"), _T("WHITE"),
     _T(""), g_StyleSize, mySTC_STYLE_BOLD, 0},

    // mySTC_TYPE_VALUE
    {_T("Value"),
     _T("ORCHID"), _T("WHITE"),
     _T(""), g_StyleSize, mySTC_STYLE_ITALIC, 0},

    // mySTC_TYPE_PREPROCESSOR
    {_T("Preprocessor"),
     _T("GREY"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_SCRIPT
    {_T("Script"),
     _T("DARK GREY"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_ERROR
    {_T("Error"),
     _T("RED"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0},

    // mySTC_TYPE_UNDEFINED
    {_T("Undefined"),
     _T("ORANGE"), _T("WHITE"),
     _T(""), g_StyleSize, 0, 0}

    };

const int g_StylePrefsSize = WXSIZEOF(g_StylePrefs);
