
#include "stdafx.h"
#include <wx/string.h>
#include <wx/filename.h>

#include "Environment.h"

Environment environment;

Environment::Environment()
{
	  logolib=getenv("ALOGOLIB" ); 
	if (!logolib)
#ifdef WIN32
		logolib="lib";
#else
		logolib="/usr/share/aucblogo/lib";
#endif
	helpfiles=getenv("ALOGOHELP"); if (!helpfiles) helpfiles="help";
	   editor=getenv("AEDITOR"  ); 
	  tempdir=getenv("ATEMP"    ); if (!tempdir)     tempdir="temp";
	 fontsdir=getenv("AFONTS"   );
	  comspec=getenv("COMSPEC" );  
	if (!comspec)     
#ifdef WIN32
		comspec=wxGetOSDirectory()+wxFileName::GetPathSeparator()+wxT("command.com");
#else
		comspec="sh";
#endif

	if (!fontsdir)     
#ifdef WIN32
		fontsdir=wxGetOSDirectory()+
			wxFileName::GetPathSeparator()+wxT("fonts")+
			wxFileName::GetPathSeparator();
#else
		fontsdir="/usr/share/fonts/truetype/";
#endif

	if (editor)
		editorname = editor.AfterLast(wxFileName::GetPathSeparator());
	else
		editorname=wxEmptyString;
}

Environment::~Environment()
{
}
