#include "stdafx.h"

#include <math.h>

#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <wx/app.h>
#include <wx/frame.h>
#include <wx/dialog.h>
#include <wx/listctrl.h>
#include <wx/thread.h>
#include <wx/treectrl.h>
#include <wx/listimpl.cpp>
#include <wx/timer.h>
#include <wx/notebook.h>

#include <stdio.h>

#include "Main.h"

#include "File.h"
#include "Pair.h"
#include "Procedure.h"
#include "Primitive.h"
#include "Compiled.h"
#include "Object.h"
#include "Table.h"
#include "PtrTable.h"
#include "LogoObject.h"
#include "Quote.h"
#include "Colon.h"
#include "Tree.h"
#include "Int.h"
#include "Float.h"
#include "String.h"

#include "Environment.h"
#include "Error.h"
#include "Eval.h"
#include "NodePStack.h"
#include "Stack.h"
#include "ToDoStack.h"
#include "Init.h"

#include "Calls.h"
#include "Vars.h"
#include "UInt8.h"
#include "Color.h"
#include "Console.h"
#include "LogoApp.h"
#include "Graphics.h"

#include "EdFrame.h"
#include "Mem.h"
#include "Point.h"
#include "Graph.h"
#include "Pen.h"
#include "Font.h"
#include "Turtle.h"
#include "Event.h"
#include "Security.h"
#include "Thread.h"
#include "DebugState.h"

extern Function llocal;

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
#endif

#ifdef WIN32
	#pragma inline_depth(12)
	#pragma inline_recursion(on)
#endif

LineP findLine(int col, int row, LineP l)
{
/*	int i=0;
	while (l && l->is.line && (l->row<row || l->col<col) && i<2000) 
	{	LineP t=LineP(l->tail());
		if ((!t || (t->row>row || (t->row==row && t->col>col)))
		&& (l->first() && l->first()->is.line))
		{
//			if (l->type==QUOTE && l->first()->is.list)
//				l=LineP(l->first());
			l->makeTree();
//console->Clear();
//c_out << "A" << l << "Z" << endL;
//console->flush();
//console->dispatchMessages();
//lpause(0);
			if (l->type==TREE)
//				l=findLine(col, row, TreeP(l->first())->tree());
				l=TreeP(l->first())->tree();
		}else
			l=t;
		i++;
		checkThrowing();
		if throwing return 0;
	}
	if (l && l->is.line && l->row==row && l->col==col)
		return l;
	return 0;
*/
//	ThreadP th=Thread::This();
/*console->Clear();
c_out << "A1" << l << "Z1" << endL;
console->flush();
console->dispatchMessages();
*/	int i=0;
	while (l && l->is.line && (l->row<row || (l->row==row && l->col<col)) && i<1000) 
	{
//console->Clear();
//c_out << "A2" << l << "Z2" << endL; console->dispatchMessages(); lpause(0);
		LineP t=LineP(l->tail());
		if (!t || (LineP(t)->row>row || (t->row==row && t->col>col)))
		{
//console->Clear();
//c_out << "A3" << l << "Z3" << endL; console->dispatchMessages(); lpause(0);
			if (l->type==QUOTE)
			{	l=LineP(QuoteP(l)->quote());
				l->makeTree();
				if (l->type==TREE)
					l=TreeP(l)->tree();
			}
			else if (l->type==TREE)
				l=TreeP(l)->tree();
			else
				l=LineP(l->first());
/*			{	l->makeTree();
				if (l->type==TREE)
					l=TreeP(l)->tree();
			}
*/
//console->Clear();
//c_out << "A4" << l << "Z4" << endL; console->dispatchMessages(); lpause(0);
		}else
			l=t;
		i++;
	}
//c_out << "A" << l << "M" << l->first() << "Z" << endL;
	if (!l) 
		return 0;
	if (!l->is.line || l->row!=row || l->col!=col)
		return 0;
	return l;
}

WX_DEFINE_LIST(ThreadList);

ThreadP Thread::main=0;
HANDLE Thread::mainHandle=0;
ThreadList Thread::list;
DispatchMutex Thread::listCS;
wxCriticalSection Thread::gui, Thread::csWaitingForGui;
int Thread::nrPaused=0,
	Thread::circcounter=1,
	Thread::waitingForGui=0;

Security::Security()
{
	dlcall=1;
	iodll=1;
	shell=1;
	filewrite=1;
	fileread=1;
	dirs=1;
	thread=1;
	keyboard=1;
	gui=1;
	erase=1;
	connect=1;
	global=1;
	buried=1;
	namespce=1;
	user=1;
	language=1;
	stacksize=-1; 
	recordsize=-1;
	memsize=-1;
	nodes=-1;
	timeout=-1;
}

bool Security::operator<(const Security &b)
{
	bool state=
			(    dlcall > b.dlcall    )
		|| (     iodll > b.iodll     )
		|| (     shell > b.shell     )
		|| ( filewrite > b.filewrite )
		|| (  fileread > b.fileread  )
		|| (      dirs > b.dirs      )
		|| (    thread > b.thread    )
		|| (  keyboard > b.keyboard  )
		|| (       gui > b.gui       )
		|| (     erase > b.erase     )
		|| (   connect > b.connect   )
		|| (    global > b.global    )
		|| (    buried > b.buried    )
		|| (  namespce > b.namespce  )
		|| (      user > b.user      )
		|| (  language > b.language  )
		|| ( stacksize > b.stacksize )
		|| (recordsize > b.recordsize)
		|| (   memsize > b.memsize   )
		|| (     nodes > b.nodes     )
		|| (   timeout > b.timeout && b.timeout>=0);
	return state;
}


void DispatchMutex::Lock()
{
	ThreadP th=Thread::This();
	while (TryLock()!=wxMUTEX_NO_ERROR)
	{	th->dispatchMessages();
		if (GC_::is_running)
		{	Thread::nrPaused++;
			while (theApp->Pending())
				th->dispatch();
			while (GC_::is_running)
			{	th->yield();
			}
			Thread::nrPaused--;
		}
		th->yield();
	}
}

DispatchMutexLocker::DispatchMutexLocker(DispatchMutex *dm_)
{
	dm=dm_;
	dm->Lock();
}

DispatchMutexLocker::~DispatchMutexLocker()
{
	dm->Unlock();
}

Thread::Thread(wxThreadKind mode):
wxThread(mode)
{
	prevFiber=this;
	nextFiber=this;
	threadFiber=this;
	startFiber=this;
	fiber=0;

	bottomStack=0;
	topStack=0;

	user=0;
	memsize=0;

	security=new Security;
	if (!security)
	{	error(OUT_OF_MEM); return;
	}
	inDispatch=false;
	inProcessIdle=false;
	processIdleInterleaving=256;
	guiOwned=0;

	stoppingFlag=RUN;

	nodeList=0;
	what=new ToDo;
	if (!what)
	{	error(OUT_OF_MEM); return;
	}
	dont_fix_ift=false;
	redefinable=false;

	ift_iff_flag=-1;
	trace_level=0;
	proccallInc=0;

	repcount=0;
	user_repcount=0;

	ifori=0;
	iforend=0;
	iforstep=0;

	fori=0;
	forend=0;
	forstep=0;

	tailcall = in_sequence;
	val_status= output_ok;

	argStack=new NodePStack;	// argument Stack
	if (!argStack)
	{	error(OUT_OF_MEM); return;
	}
	stack=new NodePStack;	// eval register stack
	if (!stack)
	{	error(OUT_OF_MEM); return;
	}
	funStack=new NodePStack;	// for the calls window
	if (!funStack)
	{	error(OUT_OF_MEM); return;
	}
	intStack=new IntStack;	// integer stack
	if (!intStack)
	{	error(OUT_OF_MEM); return;
	}
	floatStack=new FloatStack;	// float stack
	if (!floatStack)
	{	error(OUT_OF_MEM); return;
	}
	toDoStack=new ToDoStack;	// instruction stack 
	if (!toDoStack)
	{	error(OUT_OF_MEM); return;
	}
	varStack=new VarStack;	// stack for storing global objects while local vars are bound
	if (!varStack)
	{	error(OUT_OF_MEM); return;
	}
	varPStack=new IntStack;	// stack for numbers into varStack
	if (!varPStack)
	{	error(OUT_OF_MEM); return;
	}
	frameStack=new IntStack;// stack for frame pointers into varStack
	if (!frameStack)
	{	error(OUT_OF_MEM); return;
	}
	framePStack=new IntStack;// stack for numbers into frameStack
	if (!framePStack)
	{	error(OUT_OF_MEM); return;
	}
	argPStack=new IntStack;	// stack for numbers into argStack
	if (!argPStack)
	{	error(OUT_OF_MEM); return;
	}
	argNrStack=new IntStack; // nr of actual arguments given to fun
	if (!argNrStack)
	{	error(OUT_OF_MEM); return;
	}
	errorStack=new ErrorStack;	// error stack
	if (!errorStack)
	{	error(OUT_OF_MEM); return;
	}

	last_call=0;  // the last proc called
	didnt_output_name=0;  // the name of the proc that didn't OP 

	output_node=0;  // the output of the current function 

	fun=0;  // current function name 
	if (This())
		ufun=This()->ufun;
	else
		ufun=0;  // current user-defined function name
	lexufun=ufun;
	this_line=0;  // the current instruction line 
	thisobj=0;	// current LogoObject
	parents=0;	// current parents list for LogoObject constructor

	last_line=0;  // the line that called this one 
	loopcond=0;	// the loop condition list
	last_ufun=0,  // the function that called this one 
	forname=0;

	qmList=-1;  // question mark list 

	didnt_get_output=0;	// the name of the proc that wanted the OP 

	var=0;	// dynamic frame pointer into varStack
	frame=0;	// lexical frame pointer into varStack
	lastFrame=0;
	lexicalDepth=0;

	throw_node=0;
	err_msg=0;
	erract=0;
	erract_errtype=FATAL;

	inpause=false;
	instep=false;
	stepArmed=false;
	stepNr=0;

	lineInfoInTrace=true;

	interactive = true,
	backslashes = false;

	digits=0;
	precision=6;

	stringlen=0;
	rstringlen=0;
	indent=0;
	marginX=0;
	marginY=0;
	toPending=0;
	inputBlocking=0;

	currentLine=0;
	deependProcName=0;
	line=0;

	stringptr=0;
	stringstart=0;
	stringend=0;
	rstringptr=0;
	rstringstart=0;
	rstringend=0;
	textControl=TextControlNodeP(NodeP(0));

	Reader=0;
	Loader=0;
	Writer=0;
	Dribbler    =0;
	Stringbuffer=0;

	setfilename(0);
	filenames=0;
	startup=0;
	specialForms=0;
	logoLanguage=0;

	lineLen=File::lineMax;
	lineEnd=0;

	printDepthLimit=Int::max;
	printWidthLimit=Int::max;

	col=1;
	tcol=1;
	row=1;
	readnr=0;

	graph=0;
	turtleNode=0;
	gtTable=0;
	tessNormal=new DPoint(0,0,0);
	if (!tessNormal)
	{	error(OUT_OF_MEM); return;
	}
	eventFiFo=new EventFiFo(0x100);
	if (!eventFiFo)
	{	error(OUT_OF_MEM); return;
	}
	keyboardValue=0;
	keyEvent=0;
	sliderValue=0;
	intControlValue=0;
	floatControlValue=0;
	textControlValue=wxEmptyString;
	inDispatch=false;
	listBoxValue=0;
	choiceBoxValue=0;
	comboBoxValue=wxEmptyString;
	staticComboBox=0;
	listControlValue=0;
	listControlRow=0;
	listControlCol=0;
	listControlText=wxEmptyString;

	namespce=root;
	namespceobj=_Null_Word;
	loadNoisily=false;

	circcounter=1;
}

wxThreadError Thread::Create(unsigned int stacksize,
									  PairP nodeList_, ToDo what_, Graph *graph_, 
									  bool wxcreate)
{
	wxThreadError err=wxTHREAD_NO_ERROR;
	if (wxcreate)
		err=wxThread::Create(stacksize);

	nodeList=nodeList_;
	*what=what_;
	graph=graph_;

	if (wxcreate)
	{	listCS.Lock();
		list.Insert(this);
		listCS.Unlock();
	}
	return err;
}

Thread::~Thread()
{
	destroy();
}

void Thread::destroy()
{
	delete eventFiFo;
	delete what;
	delete argStack;	// argument Stack
	delete stack;	// eval register stack
	delete funStack;	// for the calls window
	delete intStack;	// integer stack
	delete floatStack;	// float stack
	delete toDoStack;	// instruction stack 
	delete varStack;	// stack for storing global objects while local vars are bound
	delete varPStack;	// stack for numbers into varStack
	delete frameStack;// stack for frame pointers into varStack
	delete framePStack;// stack for numbers into frameStack
	delete argPStack;	// stack for numbers into argStack
	delete argNrStack; // nr of actual arguments given to fun
	delete errorStack;	// error stack

	delete security;
	delete tessNormal;
	eventFiFo=0;
}

Thread::ExitCode Thread::Entry()
{
	PairP bottomvar=0;
	{
//		wxEventLoop *eventLoop = new wxEventLoop;
//		This()->m_activeLoop=eventLoop;

//		IntP thisi=0;

		if (!IsMain())
			bottomStack = NodePP(&bottomvar);
		topStack=bottomStack;

/*		if (!fiber)
			fiber=ConvertThreadToFiber(this);
		if (!fiber)
		{	c_out << _("; ConvertThreadToFiber failed with code ") 
			<< int(GetLastError()) << endL;
			return 0;
		}
*/		Reader=new File(File::conin , StringP(new String("reader")));
		Loader=new File(File::conin , StringP(new String("loader")));
		Writer=new File(File::conout, StringP(new String("writer")));
		if throwing return 0;
		Dribbler    =File::Null;
		Stringbuffer=File::Null;
		setfilename(_Unnamed->name());
		specialForms=main->specialForms;
		logoLanguage=main->logoLanguage;
//		turtleNode=graph->turtleNode;
		if (!gtTable)
			gtTable=new PtrTable(7);

		Evaluator ev;
		output_node=ev.eval(nodeList, *what, this);

		if throwing
		{	if (throw_node==_error   ) error_print();
			else if (throw_node!=_toplevel && throw_node!=_system)
			{	error(NO_CATCH_TAG, throw_node);	error_print();
			}
			inpause=false;
		}
		if (stopping || outputting)
		{	c_out << _("; You must be in a procedure to use OUTPUT or STOP.") << endL;
		}
//		File::charMode=false;	// not really correct

		GC_::run(true);

		eventDispatch();
		eventEatAll();

		GuiLeave();
		if (nextFiber!=this)
		{	if (this==startFiber)
			{	threadFiber->startFiber=nextFiber;
				ThreadP th=this;
				while (th)
				{	th->startFiber=nextFiber;
					if (th->nextFiber==this)
						break;
					else
						th=th->nextFiber;
				}
			}
			prevFiber->nextFiber=nextFiber;
			nextFiber->prevFiber=prevFiber;

			graph->leave();		
			graph->thread=0;
#ifdef WIN32
			ThreadP nf=nextFiber;
			if (this!=threadFiber)
				delete this;
			SwitchToFiber(nf->fiber);
#else
//TODO
#endif
/*			while (nextFiber!=this)
			{	if (!GC_::is_running)
					SwitchToFiber(nextFiber->fiber);
				else
					yield();
			}
*/		}
		if (!IsMain())
		{	listCS.Lock();
			list.DeleteObject(threadFiber);
			listCS.Unlock();
			if (this!=threadFiber)
				delete threadFiber;
		}
		if (fiber)
		{	//ConvertFiberToThread();
			fiber=0;
			if (!IsMain())
			{
//	destroy();
//	GC_::free(this);
			}
		}else if (!IsMain())
			graph->leave();
	}
	return 0;
}

StringP Thread::filename() {return _filename;}

void Thread::setfilename(NodeP nd) 
{	if (!nd)
		nd=nd;
	_filename=StringP(nd);  
}

void Thread::setcirccounter(int ccnt)
{
//	if (ccnt==Int::max)
//		GC_::resetAllCounters();
	circcounter=ccnt;
}

void Thread::eventDispatch()
{
	if (inDispatch)
		return;	// this should prevent any stack overflows
	inDispatch=true;
	ThreadP th=Thread::This();
	
	EventP ev;
	while (*eventFiFo)
	{	*eventFiFo >> ev;
/*
ValStatus vs=th->val_status;							\
th->val_status = no_value_allowed;					\
ObjectP lexufun=th->lexufun;							\
th->lexufun=ObjectP(*graph->d(Graph::uonMotion));		\
LogoObjectP thisobj=th->thisobj;								\
th->thisobj=LogoObjectP(*graph->d(Graph::tonMotion));	\
ControlType sf=th->stoppingFlag;
TailCall tc=th->tailcall;
Push7(th->stack, th->nodeList, th->fun, th->ufun, th->this_line,
		th->last_ufun, th->last_line, th->last_call, dummy);
Push2(th->stack, th->line, th->currentLine, dummy);
Push3(th->intStack, th->var, th->frame, th->lastFrame, dummy);
*/
		ev->process();
/*
Pop3(th->intStack, th->var, th->frame, th->lastFrame, dummy);
Pop2(th->stack, (NodeP&)th->line, (NodeP&)th->currentLine, dummy);
Pop1(th->stack, th->nodeList, dummy);
Pop1(th->stack, th->fun, dummy);
Pop1(th->stack, th->ufun, dummy);
Pop1(th->stack, th->this_line, dummy);
Pop1(th->stack, th->last_ufun, dummy);
Pop1(th->stack, th->last_line, dummy);
Pop1(th->stack, th->last_call, dummy);
th->tailcall=tc;
th->stoppingFlag=sf;
th->thisobj=thisobj;										\
th->lexufun=lexufun;										\
th->val_status=vs;										\
*/
		Float::reset_FPU();
		delete ev;
	}
	inDispatch=false;
}

void Thread::eventEatAll()
{
	EventP ev;
	while (*eventFiFo)
	{	*eventFiFo >> ev;
		delete ev;
	}
}

void Thread::GuiEnter()
{
/*	if (guiOwned)
		return;
	csWaitingForGui.Enter();
	waitingForGui++;
	csWaitingForGui.Leave();
	gui.Enter();
	csWaitingForGui.Enter();
	waitingForGui--;
	guiOwned=true;
	csWaitingForGui.Leave();
*/
}

void Thread::GuiLeave()
{
#ifdef WIN32
#else
	if (!guiOwned)
		return;
	guiOwned--;
	if (!guiOwned)
		gui.Leave();
#endif
}

bool Thread::GuiTryEnter()
{
#ifdef WIN32
	return true;
#else
	if (guiOwned)
	{	guiOwned++;
		return true;
	}
	csWaitingForGui.Enter();
	if (!waitingForGui)
	{	if (!guiOwned)
		{	waitingForGui++;
			gui.Enter();
			waitingForGui--;
			guiOwned=1;
		}else
			guiOwned++;
		csWaitingForGui.Leave();
		return true;
	}
	csWaitingForGui.Leave();
	return false;
#endif
}

#ifndef WIN32
bool Thread::TestDestroy()
{
	PairP topvar=0;
	topStack = NodePP(&topvar);
	return wxThread::TestDestroy();
}
#endif

bool Thread::checkBreak()
{
	static int count=0;
//	if (th->IsMain())
	{	count++;
		count&=0xff;	// empirical value
		if (!count)
			dispatchMessages();
		if (theApp->action==CONTROL_PAUSE) 
		{	theApp->action=NOP;
			error(STOP_ERROR);
			return true;
		}
		if (theApp->action==PAUSE)
		{	theApp->action=NOP;
			toPending=0;
			lpause(PairPP(argStack->index));
		}
		if (!IsMain() && TestDestroy())
		{	throw_node=_Stop;
			stoppingFlag=THROWING;
		}
	}
	if (GC_::is_running)
	{	nrPaused++;
		while (theApp->Pending())
			dispatch();
		while (GC_::is_running)
		{	yield();
		}
		nrPaused--;
	}
#ifdef WIN32
	if (!(count & 0x3) && nextFiber!=this && !GC_::is_running)
		SwitchToFiber(nextFiber->fiber);
#else
//	TODO
#endif
	return false;
}

bool Thread::dispatch()
{
	if	(inDispatch < 3)
	{	inDispatch++;
		bool result;
		if (GuiTryEnter())
		{	result=theApp->Dispatch();
			GuiLeave();
		}
		inDispatch--;
		return result;
	}
	return false;
}

bool Thread::processIdle()
{
	if	(!inProcessIdle)
	{	inProcessIdle=true;
		ThreadP th=Thread::This();
		bool result=false;
		if (th->IsMain() && th->GuiTryEnter())
		{	wxIdleEvent event;
			bool needMore = false;
			wxWindowList::compatibility_iterator node = wxTopLevelWindows.GetFirst();
			while (node)
			{	wxWindow* win = node->GetData();
				if (theApp->SendIdleEvents(win, event))
					needMore = true;
				node = node->GetNext();
			}
			event.SetEventObject(theApp);
			(void) theApp->ProcessEvent(event);
			if (event.MoreRequested())
				needMore = true;

			wxUpdateUIEvent::ResetUpdateTime();
			result=needMore;
			th->GuiLeave();
		}
		if (th->graph 
		&& th->graph->direct
		&& (Thread::list.GetCount() > 0 || (console && !console->idle)))
			th->graph->updateGraph();

		inProcessIdle=false;
		return result;
	}
	return false;
}

#ifdef WIN32
	#pragma optimize("", off)
#endif
void Thread::dispatchMessages()
{
	static int count=0;
	if (GuiTryEnter())
	{	//if (th->graph)
		//	th->graph->tryEnter();
		while (theApp->Pending())
		{	if (!dispatch())
				break;
		}
		count++;
		count%=processIdleInterleaving;	// empirical value
		if (!count)
		{	while (processIdle())
				;
		}
		ACTION;
		GuiLeave();
	}
} 
#ifdef WIN32
	#pragma optimize("", on)
#endif

void Thread::yield()
{
	static int count=0;
	count++;
#ifdef WIN32
	MSG msg;
	while (PeekMessage(&msg, (HWND)0, 0, 0, PM_NOREMOVE) 
	&& msg.message != WM_QUIT)
#else
	while (theApp->Pending())
#endif
	{	if (!dispatch())
			break;
	}
//	theApp->ProcessPendingEvents();
	if (!IsMain() && TestDestroy())
	{	throw_node=_Stop;
		stoppingFlag=THROWING;
	}
#ifdef WIN32
	if (!(count & 0x3) && nextFiber!=this && !GC_::is_running)
		SwitchToFiber(nextFiber->fiber);
#else
//	TODO
#endif
}

ThreadP Thread::This() 
{
	ThreadP th=0;
	if (IsMain())
	{	th=main;
#ifdef WIN32
		if (main && main->fiber)
			th=ThreadP(GetFiberData());
#else
//TODO
#endif
		return th;
	}
	th=(Thread*)wxThread::This();
#ifdef WIN32
	if (th->fiber)
		th=ThreadP(GetFiberData());
#else
//TODO
#endif
	return th;
}

ThreadP Thread::ThisThread() 
{
	ThreadP th=0;
	if (IsMain())
		return main;
	th=(Thread*)wxThread::This();
	return th;
}


NodeP lquestionmarkRest(PairPP arg)
// equivalent to:
// to ?rest [:which 1]
// output bf item :which :__template_lists
// end
{
	ThreadP th=Thread::This();
	PairP var=0;
	var=PairP(th->varStack->find(___Template_Lists));
	if (noarg)
	{	if (var 
		&& var!=Unbound
		&& var->first())
			return var->first()->butFirst();
	}else
	{	int i=arg[1]->a_int(1)-1;
		if throwing return Unbound;
		if (var
		&& var!=Unbound
		&& var->item(i))
			return PairP(var->item(i))->butFirst();
	}
	return 0;
}


#define create_name(x) #x,

const char Evaluator::commandName[][end+1] =
{	Eval_Labels(create_name)
	"null"
};

#ifdef PROC_EVAL	// for debugging & profiling
	#ifdef _DEBUG		// for use with stack frames
		#define Goto(f)	{register Do fun=__##f.instruction; __asm{mov ebx,fun __asm mov ecx,this __asm mov esp,ebp __asm pop ebp __asm jmp ebx} return 0;}
	#else				// for use without stack frames
		#define Goto(f)	{return *intP(&__##f.instruction);}
	#endif
	#define TO(x)	}	Evaluator::_##x()	{
#else	// for the optimized release version; the fastest Goto is a goto !-)
	#define Goto(f)  goto f;
	#define TO(x)	}	x:	{
#endif

extern NodeP lcallcode(PairPP) {return Unbound;}

//___________________________________________________________________
//
//		An explicit control evaluator, according to SICP, section 5.2.
//			<nodeList> is a flat list of expressions to evaluate.
//			<what> is the EvalCommand to begin with.
//			<Return value>  depends on what.
//___________________________________________________________________

Evaluator::Evaluator(PairP nodeList_, ToDo what, Thread *th)
{
	eval(nodeList_, what, th);
}

NodeP Evaluator::eval(PairP nodeList_, ToDo what, Thread *th)

#ifndef PROC_EVAL
{
#endif
				{	oldtailcall=th->tailcall;
					tracing=1;
					old_ift_iff=th->ift_iff_flag;

					val=catch_tag=0;
					exp=unev= arg= parm=formals=0;
					proc=0;
					asp=*th->argStack;
					vsp=0;
					th->var=*th->varStack;
					
					Push(th->varPStack, th->var, eval);
					Push3(th->stack, th->fun, th->ufun, th->this_line, eval);
					Push(th->toDoStack, __end, eval);

					nodeList=nodeList_;
#ifdef PROC_EVAL
 					ToDo command = what;
					while(command.instruction)  
						command.i = (this->*command.instruction)();
					return val;
#else
					Push(th->toDoStack, what, eval);
					Goto( fetch_command )
#endif

TO( fetch_command )
					ToDo __command;
					Pop1(th->toDoStack, __command, fetch_command); 
#ifdef PROC_EVAL
					Goto( command )
#else
	#define CREATE_CASE(x)	case x:	goto x;

					switch (__command.mnemonic)
					{	Eval_Labels(CREATE_CASE)
					}
#endif

TO( begin_line )
					Push(th->toDoStack, __end_line, begin_line);	Goto( begin_sequence )
TO( end_line )
					if (val != Unbound 
					&& th->val_status!=output_ok
					&& th->val_status!=value_required
					&& th->val_status!=dont_care
					&& !throwing) 
						error(DK_WHAT, val);
					if (val != Unbound 
					&& th->val_status!=output_ok
					&& th->val_status!=value_required
					&& th->val_status!=dont_care) 
						val=0;
					Goto( fetch_command )

TO( tail_dispatch )
					th->tailcall = tailcall_tail;
					Goto( dispatch )
TO( dispatch )
					switch (exp->type)
					{
					case LINE:
					case PAIR:	// procedure application
					case TREE:
									{	ObjectP obj=ObjectP(exp->first());

										if (th->tailcall==tailcall_tail)
										{	if (!obj->bit.permanent 
											&&   obj->bit.proc_macro 
											||   obj==_Goto
											||   obj==_For)	// this is not very nice
																	// but I don't know how to avoid it
											{	// tail call to user-defined macro must be treated as non-tail
												// because the expression returned by the macro
												// remains to be evaluated in the caller's context
												unev=0; Goto( non_tail_eval )
											}
										}
										th->fun=obj;
									}
									if (exp->tail()) Goto( proc_with_args )
									asp=*th->argStack;	
									// Evaluate an application of a procedure with no arguments. 
									Goto( apply_dispatch )	// apply the procedure 

					case COLON:	//val = ColonP(exp)->value();	// variable
								//	if (th->varStack->isvar(ObjectP(exp->first())))	// variable
										val = th->varStack->find(ObjectP(exp->first()));
										if (val==Unbound && !throwing) 
											error(NO_VALUE, ColonP(exp)->colon());
									break;

					case QUOTE:	val = QuoteP(exp)->quote();	break; // quoted literal
//					case ARRAY:	//val = ArrayP(exp)->deepCopy();break; // array must be copied
//									val = NodeP(exp->array());	break; 
					default:		val=exp;		// self-evaluating
					}
					Goto( fetch_command )

TO( proc_with_args )	// Evaluate an application of a procedure with arguments. 
					unev=exp->tail();
					asp=*th->argStack;
					Push3(th->intStack, th->val_status, th->tailcall, th->ift_iff_flag, proc_with_args);
					Push(th->varPStack, th->var, proc_with_args);
					Push(th->stack, th->didnt_output_name, proc_with_args);
					Goto( arg_loop )
TO( arg_loop )
	 arg_loop_again:
					if (!unev) Goto( args_done )
					exp = unev->first();
					if (!exp) {exp=_Not_Enough_node; goto arg_is_function;}
//if (!is_valid_pointer(exp)) {lpause(0); return Unbound;}
					switch (exp->type)
					{
					case LINE:
					case PAIR:
					case TREE:
								 {	ObjectP obj=ObjectP(exp->first());
									// Fix a colonless var if no proc or prim exists. 
									if (obj && obj->bit.proc)
										goto arg_is_function;
									if (th->logoLanguage==_ucblogo)
									{	error(DK_HOW, obj); 
										break;
									}
									exp = new Colon(obj);
									unev->setfirst( exp );	// now we have a COLON
								 }
					case COLON:	//val = ColonP(exp)->value();		// variable
								//	if (th->varStack->isvar(ObjectP(exp->first())))	// variable
										val = th->varStack->find(ObjectP(exp->first()));
										if (val==Unbound && !throwing)	
											error(NO_VALUE, ColonP(exp)->colon());
									break;

					case QUOTE:	val = QuoteP(exp)->quote();	break; // quoted literal
//					case ARRAY:	//val = ArrayP(exp)->deepCopy();break; // array must be copied
//									val = NodeP(exp->array());	break; 
					default:		val=exp;		// self-evaluating
					}
					Push(th->argStack, val, arg_loop);
					next(unev);
					goto arg_loop_again;
	 arg_is_function:
					if (exp==_Not_Enough_node && !throwing) 
					{	error(NOT_ENOUGH, 0); 
						th->argStack->pop_till(asp);
						Goto( args_done )
					}
					Push(th->argPStack, asp, arg_is_function);
					Push7(th->stack, unev,proc, 
						th->fun,th->ufun,th->this_line, 
						th->last_ufun,th->last_line, arg_is_function);
					PushError(th->errorStack, ObjectP(exp->first()), th->ufun, th->this_line, arg_is_function);
					th->didnt_output_name=0;

					th->var=*th->varStack;
					th->tailcall = tailcall_arg;
					th->val_status=value_required;

					Push(th->toDoStack, __accumulate_arg, arg_is_function); 
					Goto( dispatch )   // evaluate the current argument 
TO( accumulate_arg_this )
					Pop1(th->intStack, th->proccallInc, accumulate_arg);
					asp-=th->proccallInc;
					th->argStack->pop_till(asp);
					Pop1(th->stack, th->thisobj, accumulate_arg);
					Goto( accumulate_arg )
TO( accumulate_arg )	// Put the evaluated argument on the argStack.
					if (val && !throwing)
					{	if (val->type==PROCCALL)
						{	Push(th->stack, th->thisobj, accumulate_arg);
							th->thisobj=LogoObjectP(PairP(val)->first());
							proc=PairP(val)->tail();
							th->fun=ProcedureP(proc)->object();
							asp+=th->proccallInc;
							Push(th->intStack, th->proccallInc, accumulate_arg);
							val=Unbound;
							Push(th->toDoStack, __accumulate_arg_this, accumulate_arg); 
							Goto( compound_apply )
						}
						else if (val==Unbound 
						&&	(  th->val_status==value_required
							|| th->val_status==output_ok)
						&& th->lexufun
						&& th->lexufun->type==OBJECT)
							val=new LogoObject(th->lexufun);
					}
					th->varStack->pop_till(th->var);
					th->last_call=th->fun;
					Pop(th->errorStack, arg_is_function);
					Pop7(th->stack, unev, proc, 
						th->fun, th->ufun, th->this_line, 
						th->last_ufun, th->last_line, arg_is_function);
//			th->argStack->pop_till(asp);
					Pop1(th->argPStack, asp, arg_is_function);

					if (!unev)
						error(BAD_DATA, 0);
					else
						next(unev);
					if (val==Unbound && !throwing) 
					{	error(DIDNT_OUTPUT, th->fun);
						Goto( arg_loop )
					}
					if (!throwing)
						Push(th->argStack, val, accumulate_arg);
					Goto( arg_loop )
TO( args_done )
					Pop1(th->stack, th->didnt_output_name, proc_with_args);
					Pop1(th->varPStack, th->var, proc_with_args);
					Pop3(th->intStack, th->val_status, th->tailcall, th->ift_iff_flag, proc_with_args);

					th->last_call=th->fun;
					if (throwing) 
					{	val=Unbound;
						Goto( fetch_command )
					}
					Goto( apply_dispatch )

TO( apply_dispatch )	// Load in the procedure's definition and decide 
							// whether it's a compound procedure or a primitive procedure.
					if (!th->fun)
					{	error(BAD_DATA, 0); 
						// better than a direct crash, but no good error msg yet.
						lpause(PairPP(th->argStack->index));
						Goto( fetch_command )
					}
					else
					{	proc=ObjectP(th->fun)->proc_or_prim();
						if (!ObjectP(th->fun)->bit.proc)
						{	if (th->varStack->isvar(ObjectP(th->fun)))
							{	NodeP v=th->varStack->find(ObjectP(th->fun));	
								// fixing colonless var before output
								val=v;	
								Goto( fetch_command );
							}
						}
					}
					if ( ObjectP(th->fun)->bit.proc_macro )
					{	Push2(th->intStack, th->val_status, th->tailcall, apply_dispatch);
						th->val_status=value_required;
						Push(th->toDoStack, __macro_return, apply_dispatch);
					}
					if (proc->is.primitive)		// primitive_apply
					{	if (!ObjectP(th->fun)->bit.proc_traced) 
						{	val = PrimitiveP(proc)->call(
								(PairPP)&th->argStack->base[asp]);	// call the primitive
							if (!val || val->type!=PROCCALL)
								th->argStack->pop_till(asp);
						}else
						{	tracing = ObjectP(th->fun)->bit.proc_traced;
							if (th->lineInfoInTrace)
							{	c_out << '[' << th->this_line->col << th->this_line->row << ']';
							}
							for (int i=0; i < th->trace_level; i++) 
								c_out << ' ';
							c_out << "(" << th->fun << ' ';
							if (asp!=*th->argStack)
								for (NodePP arg=th->argStack->base+asp+1;  
								arg<=NodePP(th->argStack->index);  arg++)
								{	c_out << (*arg)->maybe_quote();
									if (arg+1<=NodePP(th->argStack->index))
										c_out << ' ';
								}
							c_out << ')' << endL;
						
							val = PrimitiveP(proc)->call(
								(PairPP)&th->argStack->base[asp]);	// call the primitive
							if (!val || val->type!=PROCCALL)
								th->argStack->pop_till(asp);

							if (!throwing) 
							{	for (int i=0;  i < th->trace_level;  i++) 
									c_out << ' ';
								c_out << th->fun;
								if (val==Unbound)
									c_out << _(" stops") << endL;
								else 
									c_out << _(" outputs ") << val->maybe_quote() << endL;
							}
						}
					}
					else if (proc->type==PROC_ || proc->type==INFIXPROC)
					{	if (ProcedureP(proc)->compiled())		// primitive_apply
						{	val = ProcedureP(proc)->compiled()->call(
								(PairPP)&th->argStack->base[asp]);	// call the compiled procedure
							if (!val || val->type!=PROCCALL)
								th->argStack->pop_till(asp);
						}else
							Goto( compound_apply )
					}else 
					{	//if (ufun) 
						//	untreeify_proc(ufun);
						if (!throwing) val=error(DK_HOW, th->fun);
					}
					Goto( fetch_command )

TO( compound_apply )
					if (!ObjectP(th->fun)->bit.permanent && th->thisobj)
					{	TableP t=th->thisobj->table();
						ObjectP o=t->find(ObjectP(th->fun)->name());
						if (o && o->bit.proc)
						{	proc=o->proc();
							th->fun=ProcedureP(proc)->object();							
						}
					}
					th->checkBreak();
					tracing = ObjectP(th->fun)->bit.proc_traced;
					if (tracing) 
					{	if (th->lineInfoInTrace)
						{	if (unev)
								c_out << '[' << LineP(unev)->col << ' ' << LineP(unev)->row << ']';
							else if (th->this_line && th->this_line->first())
								c_out << '[' << LineP(th->this_line->first())->col << ' '
									<< LineP(th->this_line->first())->row << ']';
						}
						for (int i=0; i < th->trace_level; i++) 
							writer << ' ';
						th->trace_level++;
						writer << "( " << th->fun << ' ';
					}
					Goto( lambda_apply )
TO( lambda_apply )					// Bind the actuals to the formals 
					vsp=*th->varStack;	// remember where we came in 

					if (th->tailcall!=tailcall_tail || th->fun!=th->ufun || !th->ufun)
					{	Push(th->intStack, th->ift_iff_flag, lambda_apply);
						Push(th->stack, th->lexufun, lambda_apply);
						Push(th->toDoStack, __compound_apply_pop, lambda_apply);
						if (th->fun->type==OBJECT && !ObjectP(th->fun)->bit.proc_dyn)
						{	Push3(th->frameStack, th->lastFrame, th->frame, vsp, lambda_apply);
							Push2(th->stack, th->ufun, th->parents, lambda_apply);
							if (!th->ufun || ObjectP(th->fun)->parent()==th->ufun)
							{	th->lastFrame=*th->frameStack-2;
								th->lexufun=ObjectP(th->fun);
							}
							th->frame=vsp;
							th->ift_iff_flag=-1;
							Push(th->toDoStack, __compound_apply_end, lambda_apply);
						}
					}
					Push(th->argPStack, asp, lambda_apply);
					formals=ProcedureP(proc)->formals();
					Goto( begin_formal_loop )
TO( begin_formal_loop )
					if (formals)
					{	parm=formals->first();
						if (type_of(parm)==INT_)	// default # args 
							Goto( after_formals )

						if (asp != *th->argStack)
						{	arg = PairP(th->argStack->base[++asp]);
							if (tracing) 
								writer << arg->maybe_quote() << ' ';
						}else
							arg = PairP(Unbound);

						switch (type_of(parm))
						{
						case OBJECT: 
							{	if (arg)
									if (arg->type==VARPARAM)
									{	error(BAD_DATA, arg); break;
									}
								ObjectP parmobj = ObjectP(parm);
								if (parmobj->not_local(vsp)) 
									PushVar(th->varStack, parmobj, arg, begin_formal_loop);
								else
									th->varStack->setVar(parmobj, arg);
								parmobj->tell_shadow();
								break;
							}
						case VARPARAM: 
							{	ObjectP parmobj = ColonP(parm)->colon();
								if (!arg)
								{	error(BAD_DATA, arg); break;
								}
								if (arg->type!=VARPARAM)
								{	error(BAD_DATA, arg); break;
								}
								ObjectP alias=ColonP(arg)->colon();
								th->varStack->push_alias(parmobj, alias);
								break;
							}
						case LINE:
						case PAIR:		// parm is optional or rest 
							{	ObjectP parm1 = ObjectP(parm->first());

								if (!parm->tail())	// parm is rest 
								{
									NodeP value=th->argStack->to_list(asp-1);	// SLOW 8-(
									if (parm1->not_local(vsp)) 
										PushVar(th->varStack, parm1, value, begin_formal_loop);
									else
										th->varStack->setVar(parm1, value);

									parm1->tell_shadow();
									if (tracing && asp!=*th->argStack) 
									{	NodePP arg=(NodePP)&th->argStack->base[asp];
										while (arg!=NodePP(th->argStack)) 
											writer << (*++arg)->maybe_quote() << ' ';
									}
									Goto( after_formals )
								}

								if (arg==Unbound)		// use default 
								{
									Push2(th->varPStack, th->var, vsp, begin_formal_loop);
									Push8(th->stack, 
										th->didnt_output_name, proc,  
										th->fun, th->ufun, th->this_line,  
										th->last_ufun, th->last_line,
										formals, begin_formal_loop);

									Push(th->argPStack, asp, begin_formal_loop);
									Push2(th->intStack, th->ift_iff_flag, th->val_status, begin_formal_loop);

									th->var=*th->varStack;
									th->tailcall = tailcall_arg;
									th->val_status=value_required;

									nodeList=parm->tail();
									if (!throwing)
									{	ObjectP olexufun=th->lexufun;
										if (ObjectP(th->fun)->bit.proc_dyn)
											th->lexufun=0;
										else
											th->lexufun=ObjectP(th->fun);
										nodeList->makeTree();
										th->lexufun=olexufun;
									}else
										nodeList=0;

									if (nodeList && nodeList->type==TREE) 
									{	unev = TreeP(nodeList)->tree();
										val=Unbound;
										Push(th->toDoStack, __set_args_continue, begin_formal_loop);
										Goto( sequence )
									}else
										val=Unbound;
									Goto( set_args_continue )
								}
								Goto( set_args_continue2 )
							}
						default: ;
						}
						Goto( end_formal_loop )
					}
					if (asp != *th->argStack)
						error(TOO_MUCH, formals);
					Goto( after_formals )
TO( set_args_continue )
					Pop1(th->varPStack, vsp, begin_formal_loop);
					Pop1(th->argPStack, asp, begin_formal_loop);
					Pop1(th->stack, formals, begin_formal_loop);
					parm=formals->first();
					th->varStack->pop_till(th->var);
					Pop2(th->intStack, th->ift_iff_flag, th->val_status, begin_formal_loop);
					Pop7(th->stack, 
						th->didnt_output_name, proc,  
						th->fun, th->ufun, th->this_line,  
						th->last_ufun, th->last_line, begin_formal_loop);
					Pop1(th->varPStack, th->var, begin_formal_loop);

					arg=PairP(val);
					Goto( set_args_continue2 )
TO( set_args_continue2 )
					ObjectP parmobj=parm->first()->intern();
					if (ObjectP(parmobj)->not_local(vsp)) 
						PushVar(th->varStack, parmobj, arg, set_args_continue2);
					else
						th->varStack->setVar(parmobj, arg);
					ObjectP(parm->first())->tell_shadow();
//					ObjectP(parm->first())->setvar( arg );
					Goto( end_formal_loop )
TO( end_formal_loop )
					next(formals);
					Goto( begin_formal_loop )
TO( after_formals )
					Pop1(th->argPStack, asp, lambda_apply);
					th->argStack->pop_till(asp);

					if (checkThrowing()) 
					{	val=Unbound;
						Goto( fetch_command )
					}
					if ((th->tailcall==in_sequence) 
					|| th->ufun!=th->last_ufun || !th->ufun)
					{	Push(th->funStack, th->fun, after_formals);
						Push2(th->argNrStack, vsp,
							th->varStack->index-th->varStack->base-th->var, after_formals);
						Push(th->toDoStack, __compound_apply_end_pop_fun, after_formals);
					}
					vsp=0;
					tracing= !th->fun->is.list;
					if (tracing && ObjectP(th->fun)->bit.proc_traced) 
					{	if (!throwing) 
							writer << ')';
						*th->Writer << endL;
						Push(th->stack, th->fun, after_formals);
						Push(th->toDoStack, __compound_apply_continue, after_formals);
					}
					val=Unbound;
					th->last_ufun=th->ufun;

			//		if (!fun->is.list)	
					// commented out to make apply in procedure text form work
					if (th->fun->type==OBJECT 
					&& !ObjectP(th->fun)->bit.proc_dyn)
						th->lexufun=th->fun->intern();
					else
						th->lexufun=0;
					th->ufun=th->fun->intern();
					
					th->last_line=th->this_line;
					th->this_line=0;
					proc = th->fun->is.list ?
						LineP(th->fun)->anonymous_function()
						: ObjectP(th->fun)->proc();

					nodeList=ProcedureP(proc)->bodylist();		// get the body ... 
					
					if (th->fun->type!=OBJECT 
					|| (th->fun->type==OBJECT && ObjectP(th->fun)->bit.proc_dyn))
					{	ObjectP olexufun=th->lexufun;
						th->lexufun=0;
						nodeList->makeTreeFromBody();
						th->lexufun=olexufun;
					}else
						nodeList->makeTreeFromBody();

					if (!nodeList || nodeList->type!=TREE 
					|| !TreeP(nodeList)->tree()) //Kludge to make empty to def work
						Goto( fetch_command )

					unev = TreeP(nodeList)->tree();
					if (!throwing) 
						th->stoppingFlag=RUN;

					th->output_node=PairP(Unbound);

					switch (th->val_status)
					{	case value_required:				th->val_status=output_ok; break;
						case value_maybe_ok_in_macro:	th->val_status=dont_care; break;
						default:								th->val_status=no_value_allowed;
					}
					Goto( sequence )
TO( begin_sequence )
					nodeList->makeTree();
					if (!nodeList  ||  nodeList->type != TREE)
					{	val=Unbound;
						Goto( fetch_command )
					}
					unev = TreeP(nodeList)->tree();
					val=Unbound;
					Goto( sequence )
TO( sequence )	// Evaluate each expression in the sequence.  
					if (!running  ||  val != Unbound) 
						Goto( fetch_command )		// Stop as soon as  val!=Unbound.

					if (unev && unev->is.line) 
					{	if (Line::the_generation != LineP(unev)->generation && th->ufun)
						{	// something redefined while we're running 
							LineP bl = LineP(th->ufun->proc()->bodylist());
							if (bl && bl->is.line)
							{	int col=LineP(unev)->col, row=LineP(unev)->row;
								LineP l = TreeP(bl)->tree(), t=0;
//c_out << l << endL;
//console->dispatchMessages();
								t=findLine(col, row, l);
//c_out << t << endL;
//console->dispatchMessages();
//c_out << '[' << col << ' ' << row << ']' << endL;
								if (t)
								{	bl->untreeify();
//c_out << 'B' << bl << 'X';
									th->setfilename(bl->filename());
									th->row=bl->row;
									th->col=bl->col;
									bl->makeTreeFromBody();
									l = TreeP(bl)->tree();
									t=findLine(col, row, l);
									if (t)
									{	unev=t;
//c_out << "A" << t << "Z" << endL;
									//	Goto( begin_sequence )
									}
									else
									{	c_out << "Bug: line not found: " << unev << endL; //lpause(0);
//										t=findLine(col, row, l);
									}
								}
								// else line[col row] not found, so we cant fix it (we are in trouble!!!)
								else
								{	c_out << "Bug: line not found: " << unev << endL; //lpause(0); 
//									t=findLine(col, row, l);
								}
							}
						}
					}
//c_out << "A" << unev << "Z" << endL;
					if (unev && unev->type==TREE) 
					{	th->this_line = TreeP(unev)->tree();

						if (th->ufun  
						&&  ObjectP(th->ufun)->bit.proc_stepped
						&&  !th->inpause) 
						{	if (tracing) 
							{	c_out << '(' << debugStates.last 
									//<< '|' << th->this_line->linenr
									<< ')';
								for (int i=1;  i < th->trace_level;  i++) 
									c_out << ' ';
							}
//							c_out << this_line;
//c_out << th->this_line->row << th->this_line << endL;
							if (!th->this_line->filename()->equal(_Unnamed))
							{	theApp->editorShow();
								if (theApp->edFrame)
								{	theApp->edFrame->unmark(1);
									int col, row;
									if (th->this_line->first() 
									&& th->this_line->first()->is.list)
									{	col=LineP(th->this_line->first())->col;
										row=LineP(th->this_line->first())->row;
									}else
									{	col=th->this_line->col;
										row=th->this_line->row;
									}
									theApp->edFrame->mark(
										th->this_line->filename()->ptr(), 
										col, row, 1);
								}
							}
							bool oldinstep=th->instep;
							th->instep=true;
							lupdateCalls(0);
							if (th->updateVarsOnStep)
							{	lupdateVars(0);
							}
							if (th->stepNr < 10)
								wxMilliSleep(200-20*th->stepNr);
							
							if (console)
							{	console->flush();
								console->updateGraph();
							}
							if (th->stepNr < 20  || (th->stepNr & 0x3)==0)
								th->dispatchMessages();
							th->instep=oldinstep;
#ifndef _DEBUG
							if (th->stepNr==0 || !th->stepArmed)
#endif
							{	oldinstep=th->instep;
								th->instep=true;
								th->stepArmed=false;
								c_in.read("");
								th->instep=oldinstep;
							}
							th->stepNr++;
							if (theApp->edFrame)
								theApp->edFrame->unmark(1);
						}
					}

					exp=unev->first();
					wxASSERT(unev->is.list || unev->type==QUOTE || unev->type==COLON);
					th->this_line=LineP(unev);

					if (th->ufun)
						if	(ObjectP(th->ufun)->bit.proc_stepped
						&&  !th->inpause) 
						{
//static NodeP t0=0;
//static NodeP t1=0;
//t0=lTimeFine(0);
							if (tracing) 
							{	if (th->this_line)
									c_out << '(' << debugStates.last 
										//<< '|' << th->this_line->linenr 
										<< ')';
								for (int i=1;  i < th->trace_level;  i++) 
									c_out << ' ';
							}
//							c_out << exp;//this_line->first();
//c_out << th->this_line->row << th->this_line << endL;
							if (th->this_line  &&  th->this_line->is.line)
								if (!th->this_line->filename()->equal(_Unnamed))
								{	if (!theApp->edFrame)
										theApp->editorShow();
									if (theApp->edFrame)
									{	theApp->edFrame->unmark(1);
										int col, row;
										if (th->this_line->first() 
										&& th->this_line->first()->is.list)
										{	col=LineP(th->this_line->first())->col;
											row=LineP(th->this_line->first())->row;
										}else
										{	col=th->this_line->col;
											row=th->this_line->row;
										}
										theApp->edFrame->mark(
											th->this_line->filename()->ptr(), 
											col, row, 1);
									}
								}
//t1=lTimeFine(0);
							bool oldinstep=th->instep;
							th->instep=true;
								
							lupdateCalls(0);
							if (th->updateVarsOnStep)
							{	lupdateVars(0);
							}
							if (th->stepNr < 10)
								wxMilliSleep(200-20*th->stepNr);

							if (console)
							{	console->flush();
								console->updateGraph();
							}
							if (th->stepNr < 20  || (th->stepNr & 0x3)==0)
								th->dispatchMessages();
							th->instep=oldinstep;
#ifndef _DEBUG
							if (th->stepNr==0 || !th->stepArmed)
#endif
							{	oldinstep=th->instep;
								th->instep=true;
								th->stepArmed=false;
								c_in.read("");
								th->instep=oldinstep;
							}
							th->stepNr++;
							if (theApp->edFrame)
								theApp->edFrame->unmark(1);
//t8=lTimeFine(0);
//c_out << t1->sub(t0) << "seconds1" << endL;
						}
					next(unev);

					if (exp->is.list
					&& ObjectP(exp->first())->proc_or_prim()->type==TAILFORM)
					{
						PrimitiveP expProc = ObjectP(exp->first())->prim();
						Priority pri = expProc->_priority;

						switch (pri)
						{
						case priority_OUTPUT: 
								PushError(th->errorStack, 
									ObjectP(exp->first()), th->ufun, th->this_line, sequence);
								th->didnt_get_output = th->errorStack->top();
								Pop(th->errorStack, sequence);	// pretty bad, this. Should be in some other places.
								th->didnt_output_name=0;

								if (!th->ufun && !throwing && th->val_status!=output_ok) 
								{	error(AT_TOPLEVEL, exp->first());
									val=Unbound; Goto( fetch_command )
								}else 
									switch (th->val_status)
									{
									case output_ok:
									case dont_care:
											th->val_status=value_required;
											if (exp->tail())
												exp = exp->second();
											else
												error(BAD_DATA, exp);
											Goto( tail_dispatch )

									case no_value_allowed:
									case value_required:
											th->val_status=value_required;
											exp = exp->second();
											unev=0;
											Goto( non_tail_eval )    // compute value then give error
									default: ;
									}
								break;

						case priority_STOP:
								if (!th->ufun && !throwing && th->val_status!=output_ok) 
								{	error(AT_TOPLEVEL, exp->first());
									val=Unbound; Goto( fetch_command )
								}else 
									switch (th->val_status)
									{
									case value_required:
									case output_ok:			th->didnt_output_name=th->fun;
									case no_value_allowed:
									case dont_care:			val=Unbound; 
																	Goto( fetch_command )
									default: ;
									}
								break;
						

						default:	// maybeoutput
								if (exp->tail())
									exp = exp->second();
								else
									error(BAD_DATA, exp);
								if (exp && !exp->first() && !exp->tail()) // new in 4.684
								{	val=Unbound;
									Goto( fetch_command )
								}
								th->val_status=value_maybe_ok_in_macro;
								Goto( tail_dispatch )
						}
					}
					if (!unev) 
					{	switch (th->val_status)
						{
						case output_ok:
						case no_value_in_macro:
								th->didnt_output_name=th->fun;
								unev = (PairP)Unbound;
								Goto( non_tail_eval )

						default: ;
						}
						Goto( tail_dispatch )
					}
					if (unev->first())
					{
						Pair &lst=*PairP(unev->first());
						if (        lst.islist()
						&&  ObjectP(lst.first())->proc_or_prim()->type==TAILFORM 
						&&  ObjectP(lst.first())->prim()->_priority==priority_STOP
						&&  th->ufun) 
						{	switch (th->val_status)
							{
							case value_required:
							case output_ok:			th->didnt_output_name=th->fun;
							case no_value_allowed:
							case dont_care:			Goto( tail_dispatch )
							default: ;
							}
						}
					}
					Goto( non_tail_eval )
TO( non_tail_eval )
					Push(th->varPStack, th->var, proc_with_args);
					Push7(th->stack, unev, proc,  
						th->fun, th->ufun, th->this_line,  
						th->last_ufun, th->last_line, proc_with_args);
					Push2(th->intStack, th->ift_iff_flag, th->val_status, proc_with_args);
					th->var = *th->varStack;
					th->tailcall = in_sequence;
					Push(th->toDoStack, __sequence_continue, non_tail_eval);	Goto( dispatch )
TO( sequence_continue_this )
					Pop1(th->intStack, th->proccallInc, sequence_continue);
					asp-=th->proccallInc;
					th->argStack->pop_till(asp);
					Pop1(th->stack, th->thisobj, sequence_continue);
					Goto( sequence_continue )
TO( sequence_continue )
					if (val)
						if (val->type==PROCCALL)
						{	Push(th->stack, th->thisobj, sequence_continue);
							th->thisobj=LogoObjectP(PairP(val)->first());
							proc=PairP(val)->tail();
							th->fun=ProcedureP(proc)->object();
							asp+=th->proccallInc;
							Push(th->intStack, th->proccallInc, sequence_continue);
							val=Unbound;
							Push(th->toDoStack, __sequence_continue_this, sequence_continue); 
							Goto( compound_apply )
						}
					th->varStack->pop_till(th->var);
					Pop1(th->varPStack, th->var, proc_with_args);
					Pop7(th->stack, unev, proc,  
						th->fun, th->ufun, th->this_line,  
						th->last_ufun, th->last_line, proc_with_args);

 					if (th->dont_fix_ift) 
					{	Pop2(th->intStack, th->dont_fix_ift, th->val_status, proc_with_args);
						th->dont_fix_ift=false;
					}else
						Pop2(th->intStack, th->ift_iff_flag, th->val_status, proc_with_args);

					if (th->stoppingFlag==MACRO_RETURN) 
					{
						if (unev==Unbound) unev=0;

						bool fromGoto=false;
						if (val)
							if (val->is.list  &&  PairP(val)->first()==NodeP(_Tag))
								fromGoto=true;
						if (fromGoto)
							unev = PairP(val)->tail();	// from goto 
						else
						{	StringP fn=th->filename();
							if (val)
								th->setfilename(LineP(val)->filename());
							if (unev)
								unev = PairP(val)->append(unev);	// slow
							else
								unev=PairP(val);
							th->setfilename(fn);
						}
						val=Unbound;
						th->stoppingFlag=RUN;

						if (!unev) Goto( fetch_command )
					}
					else 
						switch (th->val_status)
						{
						case no_value_allowed:
						case value_required:
						case output_ok:
						case dont_care:
								switch (th->stoppingFlag)
								{
								case RUN:	th->output_node=PairP(Unbound);
												break;
								case STOP:	th->output_node=PairP(Unbound);
								case OUTPUT:th->stoppingFlag=RUN;
												val=th->output_node;
												if (th->val_status==value_required  &&  !throwing)
												{	if (val==Unbound) 
														th->didnt_output_name=_Stop;
													else
														th->didnt_output_name=_Output;

													error(DIDNT_OUTPUT, _Output);
												}
												Goto( fetch_command )
								default: ;
								}
						default: ;
						}

					if (val!=Unbound && !throwing && th->val_status!=dont_care) 
					{	error(!unev ?	DK_WHAT_UP
										:  DK_WHAT,  
									val);
						val=Unbound;
					}
					if (!throwing && (!unev || unev==Unbound)) 
					{	if (val==Unbound 
						&&	(  th->val_status==value_required
							|| th->val_status==output_ok)
						&& th->lexufun)
							val=new LogoObject(th->lexufun);
						else if (th->val_status == value_required) 
							error(DIDNT_OUTPUT, th->fun);
						Goto( fetch_command )
					}
					Goto( sequence ) 

TO( compound_apply_continue )	// Only get here if tracing 
					Pop1(th->stack, th->fun, after_formals);
					--th->trace_level;
					if (!throwing) 
					{	if (th->lineInfoInTrace)
							if (th->this_line)
								c_out << '[' << th->this_line->col << ' ' << th->this_line->row << ']';
						for (int i=0; i < th->trace_level; i++) 
							writer << ' ';
						writer << th->fun;
						if (val==Unbound)
							writer << _(" stops") << endL;
						else 
							writer << _(" outputs ") << val->maybe_quote() << endL;
					}
					Goto( fetch_command )

TO( compound_apply_end_pop_fun )
					Pop(th->funStack, after_formals);
					Pop(th->argNrStack, after_formals);
					Pop(th->argNrStack, after_formals);
					Goto( fetch_command )

TO( compound_apply_end_this )
					Pop1(th->intStack, th->proccallInc, compound_apply_end_this);
					Pop1(th->stack, th->thisobj, compound_apply_end_this);
					if (th->tailcall != tailcall_tail)
					{	asp-=th->proccallInc;
						th->argStack->pop_till(asp);
					}
					Goto( compound_apply_end )

TO( compound_apply_end )
					if (!throwing)
					{	if (val && val->type==PROCCALL)
						{	//th->tailcall=in_sequence;
							//if (th->tailcall != tailcall_tail)
							{	Push(th->stack, th->thisobj, compound_apply_end_this);
								Push(th->intStack, th->proccallInc, compound_apply_end_this);
							}
							th->thisobj=LogoObjectP(PairP(val)->first());
							proc=PairP(val)->tail();
							th->fun=ProcedureP(proc)->object();
							asp+=th->proccallInc;
							val=Unbound;
							//if (th->tailcall != tailcall_tail)
								Push(th->toDoStack, __compound_apply_end_this, compound_apply_end); 
							//else
							//	Push(th->toDoStack, __compound_apply_end); 
							Goto( compound_apply )
						}
						if (val==Unbound 
						&&	(  th->val_status==value_required
							|| th->val_status==output_ok)
						&& th->lexufun
						&& th->lexufun->type==OBJECT)
							val=new LogoObject(th->lexufun);
					}
					th->varStack->pop_till(th->frame);
					Pop3(th->frameStack, th->lastFrame, th->frame, vsp, lambda_apply);
					Pop2(th->stack, th->ufun, th->parents, lambda_apply);
					Goto( fetch_command )
TO( compound_apply_pop )
					Pop1(th->intStack, th->ift_iff_flag, lambda_apply);
					Pop1(th->stack, th->lexufun, lambda_apply);
					Goto( fetch_command )	

TO( begin_apply )							// This is for _apply.
					th->fun=PairP(val)->first();
					
					if (th->fun->isnolist() 
					&& !(th->fun && (th->fun->type==OBJECT || th->fun->is.string))  
					&& !throwing)
						error(DK_HOW_UNREC, th->fun, 1);

//					if (!PairP(val)->tail() && !throwing)
//						error(NOT_ENOUGH, val, 2);
					if ((PairP(val)->tail()->isnolist() 
					&& PairP(val)->tail()->type!=ARRAY) && !throwing)
						error(APPLY_BAD_DATA, PairP(val)->tail(), 2);

					int applyArgCount=0;
					if (!throwing)
					{	asp=*th->argStack;
						if (PairP(val)->tail())
							if (PairP(val)->tail()->is.list)
								PushList(th->argStack, PairP(val)->tail(), begin_apply);
							else if (PairP(val)->tail()->type==ARRAY)
								Push(th->argStack, ArrayP(PairP(val)->tail()), begin_apply);
							else
								error(APPLY_BAD_DATA, val, 2);
						else if (!PairP(val)->first())
							error(NOT_ENOUGH, val, 2);
						applyArgCount=th->argStack->index-th->argStack->base-asp;
						val=Unbound;
					}
					if (!throwing && th->fun) 
					{	if (th->fun->islist())		    // template 
						{	PairP lst=PairP(th->fun);
							if (lst->first()->islist() && lst->tail()) 
							{	if (lst->second()->islist())		// procedure text form 
								{	proc = LineP(lst)->anonymous_function();
									tracing=0;
									Goto( lambda_apply )
								}
								formals=lst->first();		// lambda form 

								Push(th->varPStack, th->var, begin_apply);
								Push(th->intStack, th->tailcall, begin_apply);
								th->tailcall = in_sequence;
//								Push(th->argPStack, asp);
//								asp=th->argStack;
//								Push(th->argStack, formals);
//								llocal((PairPP)&th->argStack.base[asp]);	
								// bind the formals locally 
//								*th->argPStack >> asp;
								Push(th->argPStack, asp, begin_apply);
								Pop1(th->intStack, th->tailcall, begin_apply);
								
								int i=applyArgCount;
								while (formals &&  asp!=*th->argStack  && !throwing)
								{	
									if (!(i > 0))
									{	error(NOT_ENOUGH, formals, 2);
										break;
									}
//									ObjectP(formals->first())->
//										setvar( th->argStack.base[++asp] );
									PushVar(th->varStack, ObjectP(formals->first()->intern()), 
										th->argStack->base[++asp], begin_apply);
									next(formals); 
									i--;
								}
								if (i > 0)
									error(TOO_MUCH, val, 2);

								Pop1(th->argPStack, asp, begin_apply);
//						th->argStack->pop_till(asp);
								nodeList = lst->tail();
								Push(th->argPStack, th->qmList, begin_apply);

								Push(th->toDoStack, __after_lambda, begin_apply); 
								goto lambda_questionmark;
							}else		// question-mark form 
							{	Push(th->argPStack, th->qmList, begin_apply);
								th->qmList=asp;
								nodeList=lst;
	lambda_questionmark:
								Push(th->argPStack, asp, begin_apply);

//					ObjectP olexufun=th->lexufun;
//					if ((th->ufun->type==OBJECT 
//					&& ObjectP(th->ufun)->bit.proc_dyn))
//						th->lexufun=0;
								nodeList->makeTree();
//					if ((th->ufun->type==OBJECT 
//					&& ObjectP(th->ufun)->bit.proc_dyn))
//						th->lexufun=olexufun;

								if (!nodeList || nodeList->type!=TREE) 
								{	error(DK_HOW_UNREC, nodeList, 2);
									Goto( questionmark_failed )
								}							
								unev = TreeP(nodeList)->tree();

								Push(th->stack, th->didnt_output_name, lambda_questionmark);
								Push2(th->intStack, th->val_status, th->tailcall, lambda_questionmark);

								th->val_status=value_maybe_ok_in_macro;

								Push(th->toDoStack, __questionmark_continue, lambda_questionmark);	
								Goto( sequence )
							}
						}else		// name of procedure to apply 
						{	int min, max, n;

							th->fun = th->fun->intern();	// 1st) try finding th->fun in internal routines ;-)
//							if (ObjectP(th->fun)->proc_or_prim()==Unbound  &&  th->fun!=_Null_Word)
//								th->fun = th->fun->internRoot();

							proc=Unbound;
							if (ObjectP(th->fun)->proc_or_prim()==Unbound  &&  th->fun!=_Null_Word)
							{	th->fun->silent_load(environment.logolib.c_str());	// 2nd) try <logolib>/<th->fun> 
								ObjectP procobj=th->namespce->find(ObjectP(th->fun)->name());
								proc=Unbound;
								if (procobj && procobj->type==OBJECT && procobj->bit.proc)
								{	proc=procobj->proc_or_prim();
									if (proc != Unbound)
										th->fun=ProcedureP(proc)->object();
								}
							}
							if (ObjectP(th->fun)->proc_or_prim()==Unbound  &&  th->fun!=_Null_Word)
							{	th->fun->silent_load(0);	// 3rd) try ./<th->fun>.lg (the user directory)
								ObjectP procobj=th->namespce->find(ObjectP(th->fun)->name());
								proc=Unbound;
								if (procobj && procobj->type==OBJECT && procobj->bit.proc)
								{	proc=procobj->proc_or_prim();
									if (proc != Unbound)
										th->fun=ProcedureP(proc)->object();
								}
							}
							if (proc==Unbound)
								proc=ObjectP(th->fun)->proc_or_prim();

							if (proc==Unbound && !throwing)
								val=error(DK_HOW_UNREC, th->fun);
							
							if (!throwing) 
							{	if (type_of(proc) == PROC_) 
								{	min= ProcedureP(proc)->min;
									max= ProcedureP(proc)->max;
								}else 
								{	Primitive &prim= *PrimitiveP(proc);

									if (prim.std < 0)		// special form
									{	error(DK_HOW_UNREC, th->fun);	// can't apply 
										Goto( fetch_command )
									}else 
									{	min = prim.min;
										max= prim.max;
									}
								}
								n = int(th->argStack->index-th->argStack->base)-asp;

								if (n < min) 
									error(NOT_ENOUGH, 0);
								else if (n > max && max >= 0) 
									error(TOO_MUCH, 0);
								else 
									Goto( apply_dispatch )
							}
						}
					}
					Goto( fetch_command )
TO( after_lambda )
					th->varStack->pop_till(th->var);
					Pop1(th->varPStack, th->var, begin_apply);
					Goto( fetch_command )


TO( questionmark_continue )
					Pop2(th->intStack, th->val_status, th->tailcall, lambda_questionmark);
					Pop1(th->stack, th->didnt_output_name, lambda_questionmark);
					
					if (th->tailcall) 
					{	switch (th->val_status)
						{
						case no_value_allowed:
						case value_required:
						case output_ok:
						case dont_care:
								switch (th->stoppingFlag)
								{
								case RUN:	th->output_node=PairP(Unbound); break;
								case STOP:	th->output_node=PairP(Unbound);
								case OUTPUT:th->stoppingFlag=RUN;
												val=th->output_node;
												if (val != Unbound)
													switch (th->val_status)
													{
													case no_value_allowed:
													case value_required:
															error(DK_WHAT_UP, val);
													default: ;
													}
								default: ;
								}
						default: ;
						}
					}
					Goto( questionmark_failed )
TO( questionmark_failed )
					Pop2(th->argPStack, th->qmList, asp, begin_apply);
					if (asp>=0)
						th->argStack->pop_till(asp);
//					if (th->qmList>=0)
//						th->argStack->pop_till(th->qmList);// new in 4.65
//					asp=th->qmList;
					Goto( fetch_command )

TO( macro_return )	//___________________ MACROS ______________________
					Pop2(th->intStack, th->val_status, th->tailcall, apply_dispatch);

					while (!val->islist() && !throwing)
						val=error(ERR_MACRO, val);
					
					if (!throwing) 
					{	if (type_of(val)==TODO)
						{	ToDoNode &tdn = *ToDoNodeP(val);
							Push(th->toDoStack, tdn.toDo, macro_return);
							val = tdn.tail();
							Goto( fetch_command )
						}
						if (ObjectP(th->fun)->bit.permanent)
						{
							if (th->tailcall==in_sequence) 
							{	PairP(val)->makeTree();
								th->stoppingFlag=MACRO_RETURN;
								if (val->istree()) 
									val= TreeP(LineP(val))->tree();
								else
									val=0;
								Goto( fetch_command )
							}
						}else
						{	if (th->tailcall==in_sequence) 
							{//	ObjectP olexufun=th->lexufun;
							//	th->lexufun=th->last_ufun;
								PairP(val)->makeTree();
							//	th->lexufun=olexufun;
								th->stoppingFlag=MACRO_RETURN;
								if (val->istree()) 
									val= TreeP(LineP(val))->tree();
								else
									val=0;
								Goto( fetch_command )
							}
						}
						nodeList= PairP(val);
						Goto( begin_sequence )
					}
					val=Unbound;
					Goto( fetch_command )

TO( runresult_continuation )
					nodeList=PairP(val);
					th->val_status=value_maybe_ok_in_macro;
					Push(th->toDoStack, __runresult_followup, runresult_continuation);
					Goto( begin_sequence )
TO( runresult_followup )
					if (val==Unbound) val=0;
					else 
						val = new Pair(val, 0);
					Goto( fetch_command )


TO( if_continuation )	// dummies
TO( if_followup )
TO( ifElse_continuation )	// dummies
TO( ifElse_else )
TO( ifElse_followup )
TO( forever_continuation )
TO( forever_again )
TO( forever_followup )

TO( repeat_continuation )
					Push2(th->intStack, th->repcount, th->user_repcount, repeat_continuation);
					th->repcount = IntP(PairP(val)->first())->int_;
					nodeList =      PairP(val)->tail ();
					val=Unbound;
					th->user_repcount=0;
					Goto( repeat_again )
TO( repeat_again )
					th->user_repcount++;
					Push2(th->intStack, th->val_status, th->tailcall, repeat_again);
					th->val_status=no_value_in_macro;
					Push(th->stack, nodeList, repeat_again);

					Push(th->toDoStack, __repeat_followup, repeat_again);
					Goto( begin_sequence )
TO( repeat_followup )
					Pop1(th->stack, nodeList, repeat_again);
					Pop2(th->intStack, th->val_status, th->tailcall, repeat_again);


					if (val != Unbound && !throwing) error(DK_WHAT, val);

					if (th->stoppingFlag)
					{	switch (th->stoppingFlag)
						{
						case BREAK:	th->stoppingFlag=RUN;
										th->output_node=PairP(Unbound); 
										switch (th->val_status)
										{
										case value_required:
												error(DK_WHAT_UP, val);
										default: ;
										}												
										goto repeat_end;
						case CONTINUE:	th->stoppingFlag=RUN; 
										th->output_node=PairP(Unbound); 
										break;
						default: ;
						}
					}
					if (th->tailcall) 
					{
						switch (th->val_status)
						{
						case no_value_allowed:
						case value_required:
						case output_ok:
						case dont_care:
								switch (th->stoppingFlag)
								{
								case RUN:	th->output_node=PairP(Unbound); break;
								case STOP:	th->output_node=PairP(Unbound);
								case OUTPUT:th->stoppingFlag=RUN;
												val=th->output_node;
												if (val!=Unbound)
													switch (th->val_status)
													{
													case no_value_allowed:
													case value_required:
															error(DK_WHAT_UP, val);
													default: ;
													}
												goto repeat_end;
								default: ;
								}
						default:	;
						}
					}
					if (th->repcount >0) --th->repcount;	// negative means forever 
					if (th->repcount==0) goto repeat_end;

					th->checkBreak();
					if (running) Goto( repeat_again )

					val=Unbound;
	repeat_end:	Pop2(th->intStack, th->repcount, th->user_repcount, repeat_continuation);
					Goto( fetch_command )

TO( while_continuation )
					Push(th->intStack, th->user_repcount, while_continuation);
					th->user_repcount = 0;
					Push(th->stack, th->loopcond, while_continuation);
					th->loopcond = PairP(val)->first();
					 nodeList = PairP(val)->tail();
					val=Unbound;
					Goto( while_cond )
TO( while_cond )
					th->user_repcount++;
					Push2(th->intStack, th->val_status, th->tailcall, while_cond);
					th->val_status=value_required;
					Push(th->stack, nodeList, while_cond);
					nodeList=th->loopcond;
					Push(th->toDoStack, __while_again, while_cond);	Goto( begin_sequence )
TO( while_again )
					if (val==_False)
					{	Pop1(th->stack, nodeList, while_cond);
						Pop2(th->intStack, th->val_status, th->tailcall, while_cond);
						val=Unbound;
						Goto( while_end )
					}
					th->val_status=no_value_in_macro;
					Pop1(th->stack, nodeList, while_cond);	// get it again
					Push(th->stack, nodeList, while_cond);

					Push(th->toDoStack, __while_followup, while_again);
					Goto( begin_sequence )
TO( while_followup )
					Pop1(th->stack, nodeList, while_cond);
					Pop2(th->intStack, th->val_status, th->tailcall, while_cond);

					if (val != Unbound && !throwing) error(DK_WHAT, val);

					switch (th->stoppingFlag)
					{
					case BREAK:	th->stoppingFlag=RUN;
									th->output_node=PairP(Unbound); 
									th->val_status=no_value_in_macro;
									Goto( while_end );
					case CONTINUE:	th->stoppingFlag=RUN; 
									th->output_node=PairP(Unbound); 
									break;
					default: ;
					}
					if (th->tailcall) 
					{
						switch (th->val_status)
						{
						case no_value_allowed:
						case value_required:
						case output_ok:
						case dont_care:
								switch (th->stoppingFlag)
								{
								case RUN:	th->output_node=PairP(Unbound); break;
								case STOP:	th->output_node=PairP(Unbound);
								case OUTPUT:th->stoppingFlag=RUN;
												val=th->output_node;
												if (val!=Unbound)
													switch (th->val_status)
													{
													case no_value_allowed:
													case value_required:
															error(DK_WHAT_UP, val);
													default: ;
													}
												Goto( while_end );
								default: ;
								}
						default: ;
						}
					}
					th->checkBreak();
					if (running) Goto( while_cond )

					val=Unbound;
					Goto( while_end )
TO( while_end )
					Pop1(th->stack, th->loopcond, while_continuation);
					Pop1(th->intStack, th->user_repcount, while_continuation);
					Goto( fetch_command )

TO( until_continuation )
					Push(th->intStack, th->user_repcount, until_continuation);
					th->user_repcount = 0;
					Push(th->stack, th->loopcond, until_continuation);
					th->loopcond = PairP(val)->first();
					 nodeList = PairP(val)->tail();
					val=Unbound;
					Goto( until_cond )
TO( until_cond )
					th->user_repcount++;
					Push2(th->intStack, th->val_status, th->tailcall, until_cond);
					th->val_status=value_required;
					Push(th->stack, nodeList, until_cond);
					nodeList=th->loopcond;
					Push(th->toDoStack, __until_again, until_cond);	Goto( begin_sequence )
TO( until_again )
					if (val==_True)
					{	Pop1(th->stack, nodeList, until_cond);
						Pop2(th->intStack, th->val_status, th->tailcall, until_cond);
						val=Unbound;
						Goto( until_end )
					}
					th->val_status=no_value_in_macro;
					Pop1(th->stack, nodeList, until_cond);	// get it again
					Push(th->stack, nodeList, until_cond);

					Push(th->toDoStack, __until_followup, until_again);	Goto( begin_sequence )
TO( until_followup )
					Pop1(th->stack, nodeList, until_cond);
					Pop2(th->intStack, th->val_status, th->tailcall, until_cond);

					if (val != Unbound && !throwing) error(DK_WHAT, val);

					switch (th->stoppingFlag)
					{

					case BREAK:	th->stoppingFlag=RUN;
									th->output_node=PairP(Unbound); 
									th->val_status=no_value_in_macro;
									Goto( until_end );
					case CONTINUE:	th->stoppingFlag=RUN; 
									th->output_node=PairP(Unbound); 
									break;
					default: ;
					}
					if (th->tailcall) 
					{
						switch (th->val_status)
						{
						case no_value_allowed:
						case value_required:
						case output_ok:
						case dont_care:
								switch (th->stoppingFlag)
								{
								case RUN:	th->output_node=PairP(Unbound); break;
								case STOP:	th->output_node=PairP(Unbound);
								case OUTPUT:th->stoppingFlag=RUN;
												val=th->output_node;
												if (val!=Unbound)
													switch (th->val_status)
													{
													case no_value_allowed:
													case value_required:
															error(DK_WHAT_UP, val);
													default: ;
													}
												Goto( until_end );
								default: ;
								}
						default: ;
						}
					}
					th->checkBreak();
					if (running) Goto( until_cond )

					val=Unbound;
					Goto( until_end )
TO( until_end )
					Pop1(th->stack, th->loopcond, until_continuation);
					Pop1(th->intStack, th->user_repcount, until_continuation);

					Goto( fetch_command )

TO( do_while_continuation )
					Push(th->intStack, th->user_repcount, do_while_continuation);
					th->user_repcount = 0;
					Push(th->stack, th->loopcond, do_while_continuation);
					th->loopcond = PairP(val)->first();
					 nodeList = PairP(val)->tail();
					val=Unbound;
					Goto( do_while_again )
TO( do_while_again )
					th->user_repcount++;
					Push2(th->intStack, th->val_status, th->tailcall, do_while_again);
					th->val_status=no_value_in_macro;
					Push(th->stack, nodeList, do_while_again);


					Push(th->toDoStack, __do_while_followup, do_while_again);
					Goto( begin_sequence )
TO( do_while_followup )
					Pop1(th->stack, nodeList, do_while_again);
					Pop2(th->intStack, th->val_status, th->tailcall, do_while_again);

					if (val != Unbound && !throwing) error(DK_WHAT, val);

					switch (th->stoppingFlag)
					{
					case BREAK:	th->stoppingFlag=RUN;
									th->output_node=PairP(Unbound); 
									th->val_status=no_value_in_macro;
									Goto( do_while_end );
					case CONTINUE:	th->stoppingFlag=RUN; 
									th->output_node=PairP(Unbound); 
									break;
					default: ;
					}
					if (th->tailcall) 
					{
						switch (th->val_status)
						{
						case no_value_allowed:
						case value_required:
						case output_ok:
						case dont_care:
								switch (th->stoppingFlag)
								{
								case RUN:	th->output_node=PairP(Unbound); break;
								case STOP:	th->output_node=PairP(Unbound);
								case OUTPUT:th->stoppingFlag=RUN;
												val=th->output_node;
												if (val!=Unbound)


													switch (th->val_status)
													{
													case no_value_allowed:
													case value_required:
															error(DK_WHAT_UP, val);
													default: ;
													}
												Goto( do_while_end );
								default: ;
								}
						default: ;
						}
					}
					th->val_status=value_required;
					Push(th->stack, nodeList, do_while_followup);
					nodeList=th->loopcond;
					Push(th->toDoStack, __do_while_cond, do_while_followup);
					Goto( begin_sequence )
TO( do_while_cond )
					Pop1(th->stack, nodeList, do_while_followup);
					if (val==_False)
					{	val=Unbound;
						Goto( do_while_end )
					}

					th->checkBreak();
					if (running) Goto( do_while_again )

					val=Unbound;
					Goto( do_while_end )
TO( do_while_end )
					Pop1(th->stack, th->loopcond, do_while_continuation);
					Pop1(th->intStack, th->user_repcount, do_while_continuation);
					Goto( fetch_command )

TO( do_until_continuation )
					Push(th->intStack, th->user_repcount, do_until_continuation);
					th->user_repcount = 0;
					Push(th->stack, th->loopcond, do_until_continuation);
					th->loopcond = PairP(val)->first();
					 nodeList = PairP(val)->tail();
					val=Unbound;
					Goto( do_until_again )
TO( do_until_again )
					th->user_repcount++;
					Push2(th->intStack, th->val_status, th->tailcall, do_until_again);
					th->val_status=no_value_in_macro;
					Push(th->stack, nodeList, do_until_again);

					Push(th->toDoStack, __do_until_followup, do_until_again);	Goto( begin_sequence )
TO( do_until_followup )
					Pop1(th->stack, nodeList, do_until_again);
					Pop2(th->intStack, th->val_status, th->tailcall, do_until_again);

					if (val != Unbound && !throwing) error(DK_WHAT, val);

					switch (th->stoppingFlag)
					{
					case BREAK:	th->stoppingFlag=RUN;
									th->output_node=PairP(Unbound); 
									th->val_status=no_value_in_macro;
									Goto( do_until_end );
					case CONTINUE:	th->stoppingFlag=RUN; 
									th->output_node=PairP(Unbound); 
									break;
					default: ;
					}
					if (th->tailcall) 
					{
						switch (th->val_status)
						{
						case no_value_allowed:
						case value_required:
						case output_ok:
						case dont_care:
								switch (th->stoppingFlag)
								{
								case RUN:	th->output_node=PairP(Unbound); break;
								case STOP:	th->output_node=PairP(Unbound);
								case OUTPUT:th->stoppingFlag=RUN;
												val=th->output_node;
												if (val!=Unbound)
													switch (th->val_status)
													{
													case no_value_allowed:
													case value_required:
															error(DK_WHAT_UP, val);
													default: ;
													}
												Goto( do_until_end );
								default: ;

								}
						default: ;
						}
					}
					th->val_status=value_required;
					Push(th->stack, nodeList, do_until_followup);
					nodeList=th->loopcond;
					Push(th->toDoStack, __do_until_cond, do_until_followup);
					Goto( begin_sequence )
TO( do_until_cond )
					Pop1(th->stack, nodeList, do_until_followup);
					if (val==_True)
					{	val=Unbound;
						Goto( do_until_end )
					}
					th->checkBreak();
					if (running) Goto( do_until_again )

					val=Unbound;
					Goto( do_until_end )
TO( do_until_end )
					Pop1(th->stack, th->loopcond, do_until_continuation);
					Pop1(th->intStack, th->user_repcount, do_until_continuation);
					Goto( fetch_command )

TO( for_continuation )
					Push3(th->floatStack, th->fori, th->forend, th->forstep, for_continuation);
					Push(th->stack, th->forname, for_continuation);
					PairP pval=PairP(val);
					th->forname= pval->first()->intern();
					th->fori   = FloatP(pval->second())->float_;
					th->forend = FloatP(pval->third ())->float_;
					th->forstep= FloatP(pval->fourth())->float_;
					nodeList =      pval->fifth();
					PushVar(th->varStack, th->forname, new Float(th->fori), for_continuation);
					th->forname->tell_shadow();
								
					val=Unbound;
					Goto( for_again )
TO( for_again )
					Push2(th->intStack, th->val_status, th->tailcall, for_again);
					th->val_status=no_value_in_macro;
					Push(th->stack, nodeList, for_again);
					Push(th->varPStack, *th->varStack, for_again);

					Push(th->toDoStack, __for_followup, for_again);	Goto( begin_sequence )
TO( for_followup )
					Pop1(th->varPStack, vsp, for_again);
					th->varStack->pop_till(vsp);
					Pop1(th->stack, nodeList, for_again);
					Pop2(th->intStack, th->val_status, th->tailcall, for_again);

					if (val != Unbound && !throwing) error(DK_WHAT, val);

					switch (th->stoppingFlag)
					{
					case BREAK:	th->stoppingFlag=RUN;
									th->output_node=PairP(Unbound); 
									switch (th->val_status)
									{
									case value_required:
											error(DK_WHAT_UP, val);
									default: ;
									}												
									goto for_end;
					case CONTINUE:	th->stoppingFlag=RUN; 
									th->output_node=PairP(Unbound); 
									break;
					default:	;
					}
					if (th->tailcall) 
					{
						switch (th->val_status)
						{
						case no_value_allowed:
						case value_required:
						case output_ok:
						case dont_care:
								switch (th->stoppingFlag)
								{
								case RUN:	th->output_node=PairP(Unbound); break;
								case STOP:	th->output_node=PairP(Unbound);
								case OUTPUT:th->stoppingFlag=RUN;
												val=th->output_node;
												if (val!=Unbound)
													switch (th->val_status)
													{
													case no_value_allowed:
													case value_required:
															error(DK_WHAT_UP, val);
													default: ;
													}
												goto for_end;
								default: ;
								}
						default: ;
						}
					}
					{	NodeP forval=th->varStack->find(th->forname);
						if (forval->type==FLOAT_)
							th->fori = FloatP(forval)->float_;
						else if (forval->type==INT_)
							th->fori = IntP(forval)->int_;
						else
							error(BAD_DATA, forval);
					}
					th->fori+=th->forstep;
					if (th->forstep >= 0)
					{	if (th->fori > th->forend) 
							goto for_end;
					}else
						if (th->fori < th->forend) 
							goto for_end;
					th->varStack->setVar(th->forname, new Float(th->fori) );

					th->checkBreak();
					if (running) Goto( for_again )

					val=Unbound;
	for_end:
					Pop(th->varStack, for_continuation);
					Pop1(th->stack, th->forname, for_continuation);
					Pop3(th->floatStack, th->fori, th->forend, th->forstep, for_continuation);
					Goto( fetch_command )

TO( ifor_continuation )
					Push3(th->intStack, th->ifori, th->iforend, th->iforstep, ifor_continuation);
					Push(th->stack, th->forname, ifor_continuation);
					PairP pval=PairP(val);
					th->forname= pval->first()->intern();
					th->ifori   = IntP(pval->second())->int_;
					th->iforend = IntP(pval->third ())->int_;
					th->iforstep= IntP(pval->fourth())->int_;
					nodeList =      pval->fifth();
					PushVar(th->varStack, th->forname, new Int(th->ifori), ifor_continuation);
					th->forname->tell_shadow();
								
					val=Unbound;
					Goto( ifor_again )
TO( ifor_again )
					Push2(th->intStack, th->val_status, th->tailcall, ifor_again);
					th->val_status=no_value_in_macro;
					Push(th->stack, nodeList, ifor_again);
					Push(th->varPStack, *th->varStack, ifor_again);

					Push(th->toDoStack, __ifor_followup, ifor_again);
					Goto( begin_sequence )
TO( ifor_followup )
					Pop1(th->varPStack, vsp, ifor_again);
					th->varStack->pop_till(vsp);
					Pop1(th->stack, nodeList, ifor_again);
					Pop2(th->intStack, th->val_status, th->tailcall, ifor_again);

					if (val != Unbound && !throwing) error(DK_WHAT, val);

					switch (th->stoppingFlag)
					{
					case BREAK:	th->stoppingFlag=RUN;
									th->output_node=PairP(Unbound); 
									switch (th->val_status)
									{
									case value_required:
											error(DK_WHAT_UP, val);
									default: ;
									}												
									goto ifor_end;
					case CONTINUE:	th->stoppingFlag=RUN; 
									th->output_node=PairP(Unbound); 
									break;
					default:	;
					}
					if (th->tailcall) 
					{
						switch (th->val_status)
						{
						case no_value_allowed:
						case value_required:
						case output_ok:
						case dont_care:
								switch (th->stoppingFlag)
								{
								case RUN:	th->output_node=PairP(Unbound); break;
								case STOP:	th->output_node=PairP(Unbound);
								case OUTPUT:th->stoppingFlag=RUN;
												val=th->output_node;
												if (val!=Unbound)
													switch (th->val_status)
													{
													case no_value_allowed:
													case value_required:
															error(DK_WHAT_UP, val);
													default: ;

													}
												goto ifor_end;
								default: ;
								}
						default: ;
						}
					}
					{	NodeP forval=th->varStack->find(th->forname);
						if (forval->type==INT_)
							th->ifori = IntP(forval)->int_;
						else if (forval->type==FLOAT_)
							th->ifori = int(FloatP(forval)->float_);
						else
							error(BAD_DATA, forval);
					}
					th->ifori+=th->iforstep;
					if (th->iforstep >= 0)
					{	if (th->ifori > th->iforend) 
							goto ifor_end;
					}else
						if (th->ifori < th->iforend) 
							goto ifor_end;
					th->varStack->setVar(th->forname, new Int(th->ifori) );

					th->checkBreak();
					if (running) Goto( ifor_again )

					val=Unbound;
	ifor_end:	Pop(th->varStack, ifor_continuation);
					Pop1(th->stack, th->forname, ifor_continuation);
					Pop3(th->intStack, th->ifori, th->iforend, th->iforstep, ifor_continuation);
					Goto( fetch_command )

TO( foreach_continuation )
					Push(th->intStack, th->user_repcount, foreach_continuation);
					Push(th->stack, th->loopcond, foreach_continuation);
					Push(th->varPStack, th->var, foreach_continuation);
					th->var=*th->varStack;
					th->loopcond = PairP(val)->first();
					nodeList = PairP(val)->tail ();
					th->user_repcount=0;
					Goto( foreach_again )
TO( foreach_again )
					if (!th->loopcond->first() || th->loopcond->first()==NodeP(_Null_Word)) 
						Goto( foreach_end )

					th->user_repcount++;
					PushVar(th->varStack, ___Template_Lists, th->loopcond, foreach_again);
					val=new Pair(nodeList, th->loopcond->firsts());
					th->loopcond = PairP(th->loopcond->butFirsts());

					Push2(th->intStack, th->val_status, th->tailcall, foreach_again);
					Push(th->stack, nodeList, foreach_again);
					th->val_status=no_value_in_macro;

	th->fun=PairP(val)->first();
	
	while (type_of(th->fun)==ARRAY  &&  !throwing)
		th->fun=ObjectP(error(APPLY_BAD_DATA, th->fun));

	while (PairP(val)->tail()->isnolist() && !throwing)
		PairP(val)->settail( 
			error(APPLY_BAD_DATA, PairP(val)->tail()) );

	if (!throwing)
	{	asp=*th->argStack;
		PushList(th->argStack, PairP(val)->tail(), foreach_again);
		val=Unbound;
	}
	Push(th->argPStack, th->qmList, foreach_again);
	th->qmList=asp;
					
					Push(th->toDoStack, __foreach_followup, foreach_again);
					Goto( begin_sequence )
TO( foreach_followup )
					if (th->qmList>=0)
						th->argStack->pop_till(th->qmList);// new in 4.65
					Pop1(th->argPStack, th->qmList, foreach_again);
					Pop1(th->stack, nodeList, foreach_again);

					Pop2(th->intStack, th->val_status, th->tailcall, foreach_again);

					if (val != Unbound && !throwing) error(DK_WHAT, val);

					switch (th->stoppingFlag)
					{
					case BREAK:	th->stoppingFlag=RUN;
									th->output_node=PairP(Unbound); 
									switch (th->val_status)
									{
									case value_required:
											error(DK_WHAT_UP, val);
									default: ;
									}												
									Goto( foreach_end );
					case CONTINUE:	th->stoppingFlag=RUN; 
									th->output_node=PairP(Unbound); 
									break;
					default:	;

					}
					if (th->tailcall) 
					{
						switch (th->val_status)
						{
						case no_value_allowed:
						case value_required:
						case output_ok:
						case dont_care:
								switch (th->stoppingFlag)
								{
								case STOP:	th->output_node=PairP(Unbound);
								case OUTPUT:th->stoppingFlag=RUN;
												val=th->output_node;
												if (val!=Unbound)
													switch (th->val_status)
													{
													case no_value_allowed:
													case value_required:
															error(DK_WHAT_UP, val);
													default: ;
													}
												Goto( foreach_end );
								default: ;
								}
						default: ;
						}
					}
					th->checkBreak();
					if (running) Goto( foreach_again )

					val=Unbound;
					Goto( foreach_end )
TO( foreach_end )
					th->varStack->pop_till(th->var);
					Pop1(th->varPStack, th->var, foreach_continuation);
					Pop1(th->stack, th->loopcond, foreach_continuation);
					Pop1(th->intStack, th->user_repcount, foreach_continuation);
					Goto( fetch_command )

TO( catch_continuation )
					nodeList = PairP(val)->tail ();
					catch_tag= PairP(val)->first();

					th->val_status=value_maybe_ok_in_macro;

					Push3(th->stack, catch_tag, th->didnt_output_name, th->erract, catch_continuation);
					Push2(th->intStack, th->val_status, th->tailcall, catch_continuation);
					Push(th->argPStack, asp, catch_continuation);

					if (catch_tag->equal(_error)) 
					{	th->erract=Unbound;
					}
					Push(th->toDoStack, __catch_followup, catch_continuation);
					Goto( begin_sequence )
TO( catch_followup )
					Pop2(th->intStack, th->val_status, th->tailcall, catch_continuation);
					Pop3(th->stack, catch_tag, th->didnt_output_name, th->erract, catch_continuation);
					Pop1(th->argPStack, asp, catch_continuation);
					th->argStack->pop_till(asp);

					if (th->tailcall) 
					{	switch (th->val_status)
						{
						case no_value_allowed:
						case value_required:
						case output_ok:
						case dont_care:
								switch (th->stoppingFlag)
								{
								case RUN:	th->output_node=PairP(Unbound); break;
								case STOP:	th->output_node=PairP(Unbound);
								case OUTPUT:th->stoppingFlag=RUN;
												val=th->output_node;
												if (val!=Unbound)
													switch (th->val_status)
													{
													case no_value_allowed:
													case value_required:
															error(DK_WHAT_UP, val);
													default: ;

													}
								default: ;
								}
						default: ;
						}
					}
					if ( throwing 
					&& th->throw_node->equal(catch_tag)) 
					{	th->throw_node=Unbound;
						th->stoppingFlag=RUN;
						val=th->output_node;
					}
					Goto( fetch_command )

TO( goto_continuation )
					if (!throwing) 
					{	if (!th->ufun) 
						{	error(AT_TOPLEVEL, _Goto);
							val=Unbound;
							Goto( fetch_command )
						}
						    proc = ObjectP(th->ufun)->proc_or_prim();

						nodeList = ProcedureP(proc)->bodylist();
						    unev = TreeP(nodeList)->tree();

						while (unev  &&  !checkThrowing()) 
						{
							if (unev->type==TREE)
								th->this_line = TreeP(unev)->tree();
							exp=unev->first();
							next(unev);

							if (exp->islist()
							&& ObjectP(exp->first())==_Tag
							&& exp->tail()
							&& exp->second()->type==QUOTE 
							&& val->equal(QuoteP(exp->second())->quote()) ) 
							{
								val = new Pair(_Tag, unev);
								th->stoppingFlag=MACRO_RETURN;
								Goto( fetch_command )
							}
						}
						if (!throwing)
							error(BAD_DATA_UNREC, val);
					}
					val=Unbound;
					Goto( fetch_command )

TO( polygon_continuation )
					nodeList=PairP(val);
					th->val_status=no_value_allowed;
					Push(th->toDoStack, __polygon_followup, polygon_continuation);
					Goto( begin_sequence )
TO( polygon_followup )
					lPolyEnd(0);
					Goto( fetch_command )

TO( tess_continuation )
					nodeList=PairP(val);
					th->val_status=no_value_allowed;
					Push(th->toDoStack, __tess_followup, tess_continuation);
					Goto( begin_sequence )
TO( tess_followup )
					lTessEnd(0);
					Goto( fetch_command )

TO( surface_continuation )
					nodeList=PairP(val);
					th->val_status=no_value_allowed;
					Push(th->toDoStack, __surface_followup, surface_continuation);
					Goto( begin_sequence )
TO( surface_followup )
					lSurfaceEnd(0);
					Goto( fetch_command )

TO( graphic_continuation )
					nodeList=PairP(val);
					th->val_status=no_value_allowed;
					Push(th->toDoStack, __graphic_followup, graphic_continuation);
					Goto( begin_sequence )
TO( graphic_followup )
					val=lGraphicEnd(0);
					Goto( fetch_command )

TO( end )
					th->tailcall=oldtailcall;
					th->ift_iff_flag=old_ift_iff;

					Pop3(th->stack, th->fun, th->ufun, th->this_line, eval);
					th->varStack->pop_till(th->var);
					Pop1(th->varPStack, th->var, eval);
#ifdef PROC_EVAL
					return 0;
				}
#else
				}
				return val;
}
#endif
