#include "stdafx.h"
#include <malloc.h>

#ifdef WIN32
	#include <crtdbg.h>
#endif

#include "Main.h"
#include "Node.h"
#include "File.h"
#include "FiFo.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
	#define  calloc(n, m)	 _calloc_dbg((n), (m),   _NORMAL_BLOCK, __FILE__, __LINE__)
#endif

FiFo::~FiFo() {if (allocated) free(base);}

FiFo &FiFo::operator<<(const NodeP val) 
{
	if (overflow()) return *this;
	*in=val;
	if (in==max) in=base; else in++;
	if (in==out) expand();
	return *this;
}

FiFo &FiFo::operator>>(NodeP &val) 
{
	val = *out;
	if (out==max) out=base; else out++;
	return *this;
}

void FiFo::expand()	// transfer is untested!!!!
{
	NodePP newbase = (NodeP*)calloc(1, sizeof(NodeP)*(size+expand_size));

	if (newbase==NodePP(0))	// no room to increase FiFo
	{	c_out << _("; Warning: Not enough memory to run garbage collector.") << endL;
		c_out << _("; GC disabled - Save important data and exit!") << endL;
		_overflow=true;
	}
	else
	{	NodePP i=newbase;

		if (out)			// transfer old FiFo to new FiFo
		{	*this >> *i++;
			while (in!=out) 
				*this >> *i++;

		}				
		if (allocated) 
			free(base);

		allocated=true;
		size += expand_size;
		base=newbase;   max= &base[size-1];   in=i;   out= base;
	}
}
