#include "stdafx.h"
#include <wx/dir.h>
#include <wx/filename.h>
#include <wx/file.h>
#include <wx/textctrl.h>
#include <wx/process.h>

#ifdef WIN32
	#include <Winsock2.h>
#else
	//TODO
#endif

#include <wx/url.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WIN32
	#include <crtdbg.h>
	#include <io.h>
#endif
	
#include "Main.h"
#include "String.h"
#include "File.h"
#include "IntToPtr_.h"
#include "PtrToInt_.h"
#include "Pair.h"
#include "Line.h"
#include "List.h"
#include "Object.h"
#include "Int.h"
#include "Int16.h"
#include "Int8.h"
#include "UInt8.h"
#include "IntArray.h"
#include "Int16Array.h"
#include "Struct.h"
#include "TextControl.h"

#include "Environment.h"
#include "Error.h"
#include "NodePStack.h"
#include "Init.h"
#include "Color.h"
#include "Point.h"
#include "Console.h"
#include "Consolew.h"
#include "Graph.h"
#include "LogoApp.h"
#include "Security.h"
#include "Thread.h"

#ifdef WIN32
	#include "Piper.h"
#endif

extern Function lContents, lprintOut, lTextScreen;

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
	#define  malloc(m)       _malloc_dbg((m),        _NORMAL_BLOCK, __FILE__, __LINE__)
#endif

const FILEP 
	File::conin=FILEP(1),
	File::conout=FILEP(2),
	File::textcontrol=FILEP(3);

const int File::lineMax=5000;

FileP File::list=0, File::Null=0, 
		File::StdIn=0, File::StdOut=0,
		File::ConIn=0, File::ConOut=0,
		File::CIn=0, File::COut=0,
		File::TextCtrl=0;

void File::init()
{
	ThreadP th=Thread::This();

	  Null  = new File(   0    , StringP(_Null_Word)          );
	 ConIn  = new File( conin  , StringP(new String("conin" )));
	 ConOut = new File( conout , StringP(new String("conout")));
	 StdIn  = new File( stdin  , StringP(new String("stdin" )));
	 StdOut = new File( stdout , StringP(new String("stdout")));
	TextCtrl= new File(textcontrol, StringP(new String("textctrl")));

	CIn   =ConIn;
	COut  =ConOut;

	th->Reader=new File( conin  , StringP(new String("reader")));
	th->Loader=new File( conin  , StringP(new String("loader")));
	th->Writer=new File( conout , StringP(new String("conout")));
	th->Dribbler    =Null;
	th->Stringbuffer=Null;
	th->setfilename(_Unnamed->name());
}

void File::inc_gc() {fifo << name() << mode() << tail();}

int  File::youngs() 
{	return gmark(name())+gmark(mode())+gmark(tail());
}
int  File::youngsPtr(PtrToInt_ &ptrToInt) 
{	return 
		 gmarkPtr(name(), ptrToInt)
		+gmarkPtr(mode(), ptrToInt)
		+gmarkPtr(tail(), ptrToInt);
}
void File::check_oldyoungs() 
{	check_oldyoung(name()); 
	check_oldyoung(mode()); 
	check_oldyoung(tail());
}

void File::setPtrs(IntToPtr_ &intToPtr)
{	settail(FileP((  File*)intToPtr.find(int(_tail))));
	setname(StringP((String*)intToPtr.find(int(_name))));
	setmode(StringP((String*)intToPtr.find(int(_mode))));
	if (mode())
	{	setfile(fopen(name()->ptr(), mode()->ptr()));
		if (_pos)
			fseek(file(), _pos, 0);
	}
}
DataInputStream &File::read(DataInputStream &istr) 
{	istr >> (int&)_tail >> (int&)_name >> (int&)_mode >> _pos;
	int f;
	istr >> f;
	if (f==1)
		setfile(conin);
	else if (f==2)
		setfile(conout);
	else if (f==3)
		setfile(textcontrol);
	return istr;
}
wxDataOutputStream &File::write(wxDataOutputStream &ostr) 
{	if (file() && file()!=textcontrol)
		_pos=ftell(file());
	else
		_pos=0;
	ostr << type 
		<< GC_::ptrToInt->find(tail()) 
		<< GC_::ptrToInt->find(name()) 
		<< GC_::ptrToInt->find(mode())
		<< _pos;
	if (file()==conin)
		ostr << int(1);
	else if (file()==conout)
		ostr << int(2);
	else if (file()==textcontrol)
		ostr << int(3);
	else
		ostr << int(0);
	return ostr;
}

NodeP File::copy(PtrToInt_ &ptrToInt)
{
	FileP f=new File();
	if throwing return Unbound;
	f->_tail=FileP(ptrToInt.find(tail()));
	f->_name=StringP(ptrToInt.find(name()));
	f->_mode=StringP(ptrToInt.find(mode()));
	f->_file=_file;
	f->_pos=_pos;
	return f;
}

void File::print(FILEP strm, int &width, char ch) 
{
	ThreadP th=Thread::This();
	if (width > 0)
	{	width--;
		if (strm) 
		{	if (th->interactive  &&  strm==File::conout) 
			{	//switch (ch)
				//{case '\001': modeBold();	break;
				//case '\002': modePlain();	break;
				//default:
					if (console)
						console->putc_(ch, strm);
					else
						putchar(ch);
				//}
			}
			else if (strm==File::textcontrol)
			{	if (th->textControl 
				&& (th->textControl->textControl!=0))
				{	if (console)
						console->putc_(ch, strm);
					else
						putchar(ch);
				}else
				{	th->Writer=File::ConOut;
					if (console)
						console->putc_(ch, File::conout);
					else
						putchar(ch);
				}
			}
			else	    // printing to stream but not screen
				putc(ch, strm);
			
			if (dribbler)
				putc(ch, th->Dribbler->file());
		} 
		else if (ch  
		&&		 th->stringlen > 0  
		&&  --(th->stringlen) >= 0)
			*(th->stringptr)++= ch;     // printing to string
	}
}

void File::print(FILEP strm, int &width, int depth, int noBrackets, int noSpacers)
{
	name()->print(strm, width, depth, noBrackets, noSpacers);
}

void File::printBin(FILEP strm)
{
	int width=Int::max;
	name()->print(strm, width,-1);
}

int File::compare(NodeP nd)
{
	if (!nd) return Node::boolerror;
	if (this==nd) return 0;
	return name()->compare(nd);
}

int File::eof() 
{	if (file() && file()!=conin && file()!=conout && file()!=textcontrol)
		return feof(file());
	return Thread::This()->rstringlen > 0 ? 0: 1;
}

int File::    getch() 
{	if (console)
		return console->getch();
	else if (consolew)
		return consolew->getch(); 
	return 0;
}
int  File:: getchExt() 
{	if (console)
		return console->getchExt();
	else if (consolew)
		return consolew->getchExt();
	return 0;
}

#ifdef WIN32
	#pragma optimize("", off)
#endif
bool File::    kbhit() 
{	if (console)
		return console->kbhit();
	else if (consolew)
		return consolew->kbhit();
	return false;
}
#ifdef WIN32
	#pragma optimize("", on)
#endif


int File::read_getc() 
{
	int c=read_getc(file());
	if (c=='\n')
	{	Thread::This()->readnr++;
//		cout << "readnr=" << Line::readnr << endL;
	}
	return c;
}

void print(FILEP strm, int &width, char ch) 
{
	File::print(strm, width, ch);
}

void File::charModeOn() 
{	if (console)
		console->charModeOn();
	if (consolew)
		consolew->charModeOn();
}
void File::charModeOff() 
{	if (console)
		console->charModeOff();
	if (consolew)
		consolew->charModeOff();
}

int File::getc_() 
{	if (file() && file()!=conin && file()!=conout && file()!=textcontrol)
		return getc(file());
	else if (!file())
	{	if (Thread::This()->rstringlen > 0)
			return *(Thread::This()->rstringptr)++;
		else
			error(FILE_ERROR, new String
				(_("can't read after end of memory block")));	
	}
	return 0;
}

int File::ungetc(int c) 
{
	if (file() && file()!=conin && file()!=conout && file()!=textcontrol)
		return ::ungetc(c, file());
	return 0;
}

int File::read_getc(FILEP strm)
{
	ThreadP th=Thread::This();
	int c=0;
	if (strm==File::conin) 
	{	if (console)
			c=console->getc_();
		else if (consolew)
			c=consolew->getc();
		else
		{	th->throw_node=_system;
			th->stoppingFlag=THROWING;
			c=EOF;
		}
		if (Thread::This()->interactive)
		{	switch(c)
			{case 'q'-'a'+1: Thread::This()->toPending=0;		// control-q
					error(STOP_ERROR);
					return '\n';
			 case 'p'-'a'+1: logo_pause(0);	// control-p
					return read_getc(strm);
			}
		}
	}else if (strm) // reading from a file
		c=getc(strm);
	else if (Thread::This()->rstringlen > 0  &&  --(Thread::This()->rstringlen) > 0)
		c = *(Thread::This()->rstringptr)++;	// reading from string
	else
		c=EOF;
	return backslash.decode(c);
}

int File::putc_(int c) {return putc(c, file());}

int File::close() 
{	ThreadP th=Thread::This();
	int result=0;
	if (file() && file()!=conin && file()!=conout && file()!=textcontrol)
	{	result=fclose(file()); 
		if (th->Writer->file()==file())
			th->Writer=ConOut;
		if (th->Reader->file()==file())
			th->Reader=ConIn;
		setfile(0);
	}
	return result;
}
int File::pos() 
{	ThreadP th=Thread::This();
	int p=0;
	if (file() && file()!=conin && file()!=conout && file()!=textcontrol)
		p=ftell(file());
	else if (!file())		
		p=(Thread::This()->stringend - Thread::This()->stringstart) - Thread::This()->stringlen;
	else if (file()==conout)
	{	if (console)
			p=console->GetInsertionPoint();
		else
			p=0;	// TODO: improve consolew case
	}else if (file()==textcontrol)
	{	if (th->textControl)
			p=th->textControl->textControl->getInsertionPoint();	// TODO: support positioning in a TextControl
	}
	return p;
}
int File::seek(int pos) 
{	if (file())
		return fseek(file(), pos, 0);
	else
		if (pos <= Thread::This()->stringend - Thread::This()->stringstart)
		{	Thread::This()->stringptr=Thread::This()->stringstart+pos;
			Thread::This()->stringlen=Thread::This()->stringend-Thread::This()->stringptr;
			return 0;
		}
		else
			return -1;
}

size_t File::read(void *buffer, size_t size, size_t count) 
{	return fread(buffer, size, count, file());
}

void File::unblockInput() 
{	if (Thread::This()->inputBlocking) 
	{	Thread::This()->inputBlocking=0;
		longjmp(Thread::This()->inputBlockingBuffer, 1);
	}
}

bool File::exists(const char *filename)
{
	FILE *fp = fopen(filename, "r");
	if (fp==0)
	{	// That fopen failed does _not_ definitely mean the file isn't there 
		// but for now this is ok
		return false;
	}
	fclose(fp);
	return true;
}

NodeP lisFile(PairPP arg)
{
	StringP name=arg[1]->a_string(1);
	if throwing return Unbound;
	return Node::boolnode(wxFileExists(name->ptr()));
}

NodeP lisDirectory(PairPP arg)
{
	StringP name=arg[1]->a_string(1);
	if throwing return Unbound;
	return Node::boolnode(wxDirExists(name->ptr()));
}

NodeP lgetWorkingDirectory(PairPP arg)
{
	return new String(wxGetCwd());
}

NodeP lchangeDir(PairPP arg)
{
	ThreadP th=Thread::This();
	if (!th->security->dirs)
	{	error(SECURITY_ERROR, new String(_("to change the directory"))); return Unbound;
	}
	StringP path=arg[1]->a_string(1);
	if (!throwing)
	{
		path=String::make(path->ptr(), 0, path->length(), STRING, String::copy_noparity);
#ifdef WIN32
		if (_chdir(path->ptr()))
#else
		if (chdir(path->ptr()))
#endif
		{	error(FILE_ERROR, new String(new String(_("I can't change to the directory ")), path));
			return Unbound;
		}
	}
	return Unbound;
}

NodeP lmakeDirectory(PairPP arg)
{
	ThreadP th=Thread::This();
	if (!th->security->dirs)
	{	error(SECURITY_ERROR, new String(_("to make a directory"))); return Unbound;
	}
	StringP name=arg[1]->a_string(1);
	if throwing return Unbound;
	if (!wxDirExists(name->ptr()))
#ifdef WIN32
		if (_mkdir(name->ptr()))
#else
		if (mkdir(name->ptr(), S_IRWXU | S_IRWXG | S_IRWXO))
#endif
			error(FILE_ERROR, new String(
				StringP(new String(_("I can't make the directory "))), name));
	return Unbound;
}

NodeP leraseDirectory(PairPP arg)
{
	ThreadP th=Thread::This();
	if (!th->security->dirs || !th->security->erase || !th->security->filewrite)
	{	error(SECURITY_ERROR, new String(_("to erase a directory"))); return Unbound;
	}
	StringP name=arg[1]->a_string(1);
	if throwing return Unbound;
#ifdef WIN32
	if (_rmdir(name->ptr()))
#else
	if (rmdir(name->ptr()))
#endif
		error(FILE_ERROR, new String(
			StringP(new String(_("I can't erase the directory, "
				"it is not empty or does not exist "))), name));
	return Unbound;
}

NodeP lFiles(PairPP arg)
{
	ThreadP th=Thread::This();
	if (!th->security->dirs)
	{	error(SECURITY_ERROR, new String(_("to read a directory"))); return Unbound;
	}
	wxString filespec=wxEmptyString;
	if (exist(1) && arg[1])
	{	StringP fs=arg[1]->a_string(1);
		if throwing return Unbound;
		fs=String::make(fs->ptr(), 0, fs->length(), STRING, String::copy_mend);
		if throwing return Unbound;
		fs=fs->noParity();
		if throwing return Unbound;
		filespec=fs->ptr();
	}
	int flags=wxDIR_FILES;
	if (exist(2))
	{	flags=arg[2]->a_int(2);
		if throwing return Unbound;
	}
	wxDir dir(wxGetCwd());

	if (!dir.IsOpened())
	{	error(FILE_ERROR, new String(
			wxString(_("I can't read the directory "))+filespec));
		return Unbound;
	}
	wxString filename;

	bool cont = dir.GetFirst(&filename, filespec, flags);
	PairP result=0, last=0;
	while (cont)
	{	StringP str=new String(filename);
		PairP l=new Pair(str, 0);
		if throwing return Unbound;
		if (last)
			last->settail(l);
		else
			result=l;
		last=l;
		cont = dir.GetNext(&filename);
	}
	if (result)
		result=PairP(result->combSort());
	return result;
}

FILEP String::open_file(charP access) 
{
	if (this==Unbound) return 0;

	charP fnstr = charP( GC_::malloc(length()+1) );
	if (!fnstr) return 0;
	
	copy_noparity(fnstr, ptr(), length());

	FILEP tstrm=fopen(fnstr, access);
	GC_::free(fnstr); fnstr=0;
	return tstrm;
}

NodeP ldribble(PairPP arg) 
{
	if (dribbler)
		error(ALREADY_DRIBBLING, 0);
	else
	{	StringP name = arg[1]->a_string(1);
		if (!throwing)
		{	ThreadP th=Thread::This();
			if (!th->security->filewrite)
			{	error(SECURITY_ERROR, new String(_("to write files"))); return Unbound;
			}
			FILEP file = name->open_file("w+");
			if (!file) 
			{	if (!throwing)
					error(FILE_ERROR, 0);
			}else 
			{	FileP f=new File(file, 
					StringP(new String(name)), 
					StringP(new String("w+")), FileP(0));
				if throwing return Unbound;
				Thread::This()->Dribbler = f;
			}
		}
	}
	return Unbound;
}

NodeP lnoDribble(PairPP) 
{
	if (dribbler) 
	{	dribbler.close();
		Thread::This()->Dribbler=File::Null;
	}
	return Unbound;
}

FileP File::findInFilelist(bool remove)
{
	FileP fp=0;

	if (remove)
	{	FileP prev=0;

		for (fp=File::list;  fp;  next(fp))
		{
			if (FileP(this)==fp)
			{	if (remove) 
				{	if (!prev)
						File::list = tail();
					else
						prev->settail( tail() );
				}
				break;
			}
			prev=fp;
		}
	}
	return fp;
}
FileP String::findInFilelist(bool remove)
{
	FileP fp=0, prev=0;
	
	for (fp=File::list;  fp;  next(fp))
	{
		if (equal(fp->name())) 
		{	if (remove) 
			{	if (!prev)
					File::list = fp->tail();
				else
					prev->settail( fp->tail() );
			}
			break;
		}
		prev=fp;
	}
	return fp;
}

NodeP Pair::open_file_helper(charP mode) 
{
	if (!this || !is.word)
	{	error(BAD_DATA, this, 1);
		return Unbound;
	}
	StringP name=a_string(1);

	if (name->findInFilelist(false))
		error(FILE_ERROR, new String(_("File already open")));
	else
	{	FILEP file = name->open_file(mode);
		if (file) 
		{	FileP f=new File(file, StringP(new String(name)), 
				StringP(new String(mode)), File::list);
			if throwing return Unbound;
			File::list = f;
		}else
			error(FILE_ERROR, new String(
				StringP(new String(_("I can't open file "))), name));
	}
	return Unbound;
}

NodeP lopenRead     (PairPP arg) 
{	ThreadP th=Thread::This();
	if (!th->security->fileread)
	{	error(SECURITY_ERROR, new String(_("to read files"))); return Unbound;
	}
	return arg[1]->open_file_helper("r");
}
NodeP lopenReadBin  (PairPP arg) 
{	ThreadP th=Thread::This();
	if (!th->security->fileread)
	{	error(SECURITY_ERROR, new String(_("to read files"))); return Unbound;
	}
	return arg[1]->open_file_helper("rb");
}
NodeP lopenWrite    (PairPP arg) 
{	ThreadP th=Thread::This();
	if (!th->security->filewrite)
	{	error(SECURITY_ERROR, new String(_("to write files"))); return Unbound;
	}
	return arg[1]->open_file_helper("w");
}
NodeP lopenWriteBin (PairPP arg) 
{	ThreadP th=Thread::This();
	if (!th->security->filewrite)
	{	error(SECURITY_ERROR, new String(_("to write files"))); return Unbound;
	}
	return arg[1]->open_file_helper("wb");
}
NodeP lopenAppend   (PairPP arg) 
{	ThreadP th=Thread::This();
	if (!th->security->filewrite)
	{	error(SECURITY_ERROR, new String(_("to write files"))); return Unbound;
	}
	return arg[1]->open_file_helper("a");
}
NodeP lopenAppendBin(PairPP arg) 
{	ThreadP th=Thread::This();
	if (!th->security->filewrite)
	{	error(SECURITY_ERROR, new String(_("to write files"))); return Unbound;
	}
	return arg[1]->open_file_helper("ab");
}
NodeP lopenUpdate   (PairPP arg) 
{	ThreadP th=Thread::This();
	if (!th->security->filewrite)
	{	error(SECURITY_ERROR, new String(_("to write files"))); return Unbound;
	}
	return arg[1]->open_file_helper("r+");
}
NodeP lopenUpdateBin(PairPP arg) 
{	ThreadP th=Thread::This();
	if (!th->security->filewrite)
	{	error(SECURITY_ERROR, new String(_("to write files"))); return Unbound;
	}
	return arg[1]->open_file_helper("rb+");
}

NodeP lallOpen(PairPP)
{
	FileP list=File::list;
	if (!list)
		return 0;

	PairP result=0, tnode=0, lastnode=0;

	while (list) 
	{	tnode = new Pair(list->name(), 0);
		if throwing return Unbound;
		if (!result) 
		{	result=tnode;
			lastnode=tnode;
		}else 
		{	lastnode->settail( tnode );
			lastnode=tnode;
		}
		next(list);
		if (checkThrowing()) break;
	}
	return result;
}

NodeP lclose(PairPP arg) 
{
	if (!arg[1])
	{	error(FILE_ERROR, new String(_("Can't close []")));
		return Unbound;
	}
	FileP file = arg[1]->findInFilelist(true);
	if (!file)
		error(FILE_ERROR, new String(_("File not open")));
	else
		file->close();

	return Unbound;
}

NodeP lsetWriter(PairPP arg) 
{
	ThreadP th=Thread::This();
	if (noarg || !arg[1] || NodeP(arg[1])==File::ConOut) 
		 th->Writer=File::ConOut;
	else if (NodeP(arg[1])==File::StdOut 
	|| File::StdOut->name()->equal(arg[1])) 
		 th->Writer=File::StdOut;
	else if (type_of(arg[1])==INTARRAY)
	{	IntArrayP ia=IntArrayP(arg[1]);
		th->stringptr=th->stringstart=charP(ia->data());
		th->stringlen=ia->length()*sizeof(int);
		th->stringend=th->stringstart+th->stringlen;
		th->Writer=File::Null;
	}
	else if (type_of(arg[1])==INT16ARRAY)
	{	Int16ArrayP ia=Int16ArrayP(arg[1]);
		th->stringptr=th->stringstart=charP(ia->data());
		th->stringlen=ia->length()*sizeof(short);
		th->stringend=th->stringstart+th->stringlen;
		th->Writer=File::Null;
	}
	else if (type_of(arg[1])==TEXTCONTROL)
	{	th->Writer=File::TextCtrl;
		th->textControl=TextControlNodeP(arg[1]);
	}
	else 
	{	FileP file = arg[1]->findInFilelist(false);
		if (file && file->file()) 
			th->Writer=file;
		else
			error(FILE_ERROR, new String(_("File not open")));
	}
	return Unbound;
}

NodeP lsetReader(PairPP arg) 
{
	ThreadP th=Thread::This();
	if (noarg || !arg[1] || FileP(arg[1])->file()==File::conin) 
	{	FileP f=new File(File::conin, StringP(new String("reader")));
		if throwing return Unbound;
		th->Reader=f;
	}
	else if (NodeP(arg[1])==File::StdIn 
	|| File::StdIn->name()->equal(arg[1])) 
		 th->Reader=File::StdIn;
	else if (type_of(arg[1])==INTARRAY)
	{	IntArrayP ia=IntArrayP(arg[1]);
		th->rstringptr=th->rstringstart=charP(ia->data());
		th->rstringlen=ia->length()*sizeof(int);
		th->rstringend=th->rstringstart+th->rstringlen;
		th->Reader=File::Null;
	}
	else if (type_of(arg[1])==INT16ARRAY)
	{	Int16ArrayP ia=Int16ArrayP(arg[1]);
		th->rstringptr=th->rstringstart=charP(ia->data());
		th->rstringlen=ia->length()*sizeof(short);
		th->rstringend=th->rstringstart+th->rstringlen;
		th->Reader=File::Null;
	}
	else 
	{	FileP file = arg[1]->findInFilelist(false);
		if (file) 
			th->Reader=file;
		else
			error(FILE_ERROR, new String(_("File not open")));
	}
	return Unbound;
}

NodeP lReader  (PairPP)
{
	ThreadP th=Thread::This();
	FileP f=th->Reader;
	if (f->file()==File::conin)
		return 0;
	return f;
}

NodeP lWriter  (PairPP)
{
	ThreadP th=Thread::This();
	FileP f=th->Writer;
	if (f->file()==File::conout)
		return 0;
	return f;
}

NodeP lDribbler(PairPP)
{
	ThreadP th=Thread::This();
	FileP f=th->Dribbler;
	if (f==File::ConOut)
		return 0;
	return f;
}

NodeP leraseFile(PairPP arg) 
{
	ThreadP th=Thread::This();
	if (!th->security->filewrite)
	{	error(SECURITY_ERROR, new String(_("to write files"))); return Unbound;
	}
	StringP filename = arg[1]->a_string(1);
	if throwing return Unbound;
	
	charP fnstr = charP( GC_::malloc(filename->length()+1) );
	if (!fnstr) return Unbound;

	String::copy(fnstr, filename->ptr(), filename->length());
	if (::wxDirExists(fnstr))
	{	error(FILE_ERROR, new List(new String(_("eraseFile: Cannot erase a directory")), 
			filename, _ListEnd) );
	}else
		remove(fnstr);
	GC_::free(fnstr); fnstr=0;
	return Unbound;
}

NodeP lrenameFile(PairPP arg) 
{
	ThreadP th=Thread::This();
	if (!th->security->filewrite)
	{	error(SECURITY_ERROR, new String(_("to rename files"))); return Unbound;
	}
	StringP oldname = arg[1]->a_string(1), newname = arg[2]->a_string(2);
	if throwing return Unbound;
	
	charP oldstr = charP( GC_::malloc(oldname->length()+1) );
	if (!oldstr) return Unbound;
	String::copy(oldstr, oldname->ptr(), oldname->length());

	charP newstr = charP( GC_::malloc(newname->length()+1) );
	if (!newstr) return Unbound;
	String::copy(newstr, newname->ptr(), newname->length());

	int status=rename(oldstr, newstr);
	if (status!=0)
		error(FILE_ERROR, new List(new String(_("renameFile: Could not rename file to")), newname, _ListEnd) );
	GC_::free(oldstr); oldstr=0;
	GC_::free(newstr); newstr=0;
	return Unbound;
}

NodeP lsave(PairPP arg) 
{
	ThreadP th=Thread::This();
	if (!th->security->filewrite)
	{	error(SECURITY_ERROR, new String(_("to write files"))); return Unbound;
	}
	FILEP oldfile = writer.file();
	StringP str=arg[1]->a_string(1);
	writer.setfile( str->open_file("w+") );

	if (writer) 
	{	arg[1] = PairP(lContents(PairPP(Thread::This()->argStack->index)));
		lprintOut(arg);
		writer.close();
	}else
		error( FILE_ERROR, new List(new String(_("save: Could not open file")), str, _ListEnd) );

	writer.setfile(oldfile);
	return Unbound;
}

NodeP loadHelper(PairPP arg, bool local) 
{
	ThreadP th=Thread::This();

	ValStatus save_val_status = th->val_status;
	StringP str=0, old_line = th->currentLine;
	ObjectP ufun=0;
	if (local)
	{	if (!exist(2) || !arg[2])
		{	error(BAD_DATA, arg[2]);	return Unbound;
		}
		str= arg[1]->a_string(1);
		ufun=arg[2]->intern();
	}else
		str= arg[1]->a_string(1);
	if throwing return Unbound;

	FILEP old_file = loader.file();

	wxFileName fullLoadPath(str->ptr());
	fullLoadPath.Normalize();
	wxString fullPath=fullLoadPath.GetFullPath();
	str=new String(fullPath);
	if throwing return Unbound;
	loader.setfile( str->open_file("r") );

	if (loader) 
	{
		th->startup=Unbound;
		int oldreadnr=th->readnr;
		int oldcol=th->col, oldtcol=th->tcol, oldrow=th->row;
		StringP oldfn=th->filename();
		th->readnr=1;
		th->col=1;
		th->tcol=1;
		th->row=1;
		th->setfilename(Line::findFile(str));
		ObjectP olexufun=th->lexufun;
		th->lexufun=ufun;
//		cout << "_load Line::nr=1;" << endL;
		
		while (!loader.eof() && !throwing) 
		{
			th->currentLine = loader.read("");
			PairP exec_list = th->currentLine->parser(true);
			
			int row=th->row;
			th->val_status = no_value_allowed;
			if (exec_list) 
				exec_list->eval_driver();
			th->row=row;
		}
		loader.close();
		loader.setfile(old_file);
		th->readnr=oldreadnr;
		th->col=oldcol;
		th->tcol=oldtcol;
		th->row=oldrow;
		th->setfilename(oldfn);
	
		PairP st = PairP(th->startup);
		st->runstartup();
		th->val_status=save_val_status;
		th->lexufun=olexufun;
	}else
		error( FILE_ERROR, new List(new String(_("load: Could not open file")), str, _ListEnd) );

	loader.setfile(old_file);
	th->currentLine=old_line;
	return Unbound;
}

NodeP lload     (PairPP arg) {return loadHelper(arg, false);}
NodeP lloadLocal(PairPP arg) {return loadHelper(arg, true );}

NodeP lreadList(PairPP) 
{
	NodeP val=0;
	val = reader.read("")->parser(false, true);
//	if (reader.eof()) 
//		return _Null_Word;
	return val;
}

NodeP lreadListFlat(PairPP) 
{
	PairP list=0, tnode=0, lastnode=0;
	wxString word;
	char c=0;
	while (!reader.eof())
	{	c=reader.read_getc();
		while (!reader.eof() 
		&& (isalnum((unsigned char)(c)) || c=='?' || c=='.' || c=='_'))
		{	word+=c;
			c=reader.read_getc();
		}
		if (word != wxEmptyString)
		{	tnode=new Pair(new String(word), 0);
			if (!list) 
				list=tnode;
			else 
				lastnode->settail( tnode );
			lastnode=tnode;
			word=wxEmptyString;
		}
	}
	return list;
}

NodeP lreadListFlatLine(PairPP) 
{
	PairP list=0, tnode=0, lastnode=0;
	wxString word;
	char c=0;
	while (!reader.eof() && c!='\n')
	{	c=reader.read_getc();
		while (!reader.eof() && c!='\n' 
		&& (isalnum((unsigned char)(c)) || c=='?' || c=='.' || c=='_'))
		{	word+=c;
			c=reader.read_getc();
		}
		if (word != wxEmptyString)
		{	tnode=new Pair(new String(word), 0);
			if (!list) 
				list=tnode;
			else 
				lastnode->settail( tnode );
			lastnode=tnode;
			word=wxEmptyString;
		}
	}
	return list;
}

NodeP lreadListFlatRaw(PairPP) 
{
	PairP list=0, tnode=0, lastnode=0;
	wxString word;
	char c=reader.read_getc();
	while (!reader.eof())
	{	if (!reader.eof() && c!=' ' && c!='\t' && c!='\n' && c!='\r'
		&& (isalnum((unsigned char)(c)) || c=='?' || c=='.' || c=='_'))
		{	while (!reader.eof() && c!=' ' && c!='\t' && c!='\n' && c!='\r'
			&& (isalnum((unsigned char)(c)) || c=='?' || c=='.' || c=='_'))
			{	word+=c;
				c=reader.read_getc();
			}
		}else
		{	word+=c;
			c=reader.read_getc();
		}
		tnode=new Pair(new String(word), 0);
		word=wxEmptyString;
		if (!list) 
			list=tnode;
		else 
			lastnode->settail( tnode );
		lastnode=tnode;
	}
	return list;
}

NodeP lreadListFlatTags(PairPP) 
{
	PairP list=0, tnode=0, lastnode=0;
	wxString word;
	char c=reader.read_getc();
	bool intag=false;
	while (!reader.eof())
	{	if (!reader.eof() && c!=' ' && c!='\t' && c!='\n' && c!='\r'
		&& (isalnum((unsigned char)(c)) || c=='?' || c=='_' || c=='<'))
		{	while (!reader.eof() && ((c!=' ' && c!='\t' && c!='\n' && c!='\r'
			&& (isalnum((unsigned char)(c)) || c=='?' || c=='_' || c=='<')) || intag))
			{	if (c=='<')
				{	intag=true;
				}else if (c=='>')
				{	intag=false;
					break;
				}
				word+=c;
				c=reader.read_getc();
				if (c=='<')
				{	intag=true;
					break;
				}
			}
			if (c=='>')
			{	intag=false;
				word+=c;
				c=reader.read_getc();
			}
		}else
		{	word+=c;
			c=reader.read_getc();
		}
		tnode=new Pair(new String(word), 0);
		word=wxEmptyString;
		if (!list) 
			list=tnode;
		else 
			lastnode->settail( tnode );
		lastnode=tnode;
	}
	return list;
}

NodeP lreadWord(PairPP) 
{
	NodeP val=0;
	val = reader.read("RW"); // fake prompt flags no auto-continue
//	if (reader.eof())
//		return 0;
	return val;
}

NodeP lreadRawLine(PairPP) 
{
	NodeP val=0;
	val = reader.read("RAW"); // fake prompt flags no specials
//	if (reader.eof())
//		return 0;
	return val;
}

NodeP lreadChar(PairPP) 
{
	ThreadP th=Thread::This();
	int c;
	File::charModeOn();
	th->inputBlocking++;

	if (!setjmp(th->inputBlockingBuffer))
	{	
		if (th->interactive && reader.file()==File::conin)
		{
			if (!th->security->keyboard)
			{	error(SECURITY_ERROR, new String(_("to use keyboard"))); return Unbound;
			}
			c=File::getch();

			if (c=='q'-'a'+1)		// control-q
			{	th->toPending=0;
				error(STOP_ERROR,0);
			}
			if (c=='p'-'a'+1)		// control-p
			{	logo_pause(0);
				return lreadChar(PairPP(th->argStack->index));
			}
		}else
			c=reader.getc_();
	}
	th->inputBlocking=0;
	if (th->Reader->file() != File::conin && reader.eof()) return 0;

	return String::make
	(	charP(&c), 0, 1,
		backslash.is(c) ?  STRING  
						:  BACKSLASHED, 
		String::copy
	);
}

NodeP lreadCharExt(PairPP) 
{
	ThreadP th=Thread::This();
	int c;
	File::charModeOn();
	th->inputBlocking++;

	if (!setjmp(th->inputBlockingBuffer))

	{	if (th->interactive && reader.file()==File::conin)
		{	if (!th->security->keyboard)
			{	error(SECURITY_ERROR, new String(_("to use keyboard"))); return Unbound;
			}
			c=File::getchExt();
		}else
			c=reader.getc_();
	}
	th->inputBlocking=0;
	if (th->Reader->file() != File::conin && reader.eof()) return 0;

	return new Int(c);
}

NodeP lreadChars(PairPP arg) 
{
	ThreadP th=Thread::This();
	unsigned int c, i;
	NodeType type=STRING;
	String::HeadP strhead=0;
	charP strptr=0;
	
	c = arg[1]->a_pos_int(1)->int_;

	if (throwing) return Unbound;

	File::charModeOn();
	th->inputBlocking++;

	if (!setjmp(th->inputBlockingBuffer))
	{	strhead = String::HeadP( GC_::malloc(c+sizeof(int)+1) );
		if (!strhead) 
			return Unbound;

		strptr=strhead->str;
		if (th->Reader->file()==File::conin)
		{	if (!th->security->keyboard)
			{	error(SECURITY_ERROR, new String(_("to use keyboard"))); return Unbound;
			}
			for (unsigned int i=0; i<c; i++)
				strptr[i]=reader.getch();
		}else
			c=reader.read(strptr, 1, c);
		strhead->refCount=0;
	}
	th->inputBlocking=0;

	if (throwing) 
		return Unbound;
//	if (reader.eof()) 
//	{	GC_::free(strhead);
//		return 0;
//	}
	for (i=0; i < c; i++)
		if (backslash.is(strptr[i])) 
			type=BACKSLASHED;

	StringP result=String::make(strptr, strhead, (int)c, type, String::copy);
	if (result==NodeP(_Null_Word))
	{	GC_::free(strhead); strhead=0;
	}
	return result;
}

NodeP UInt8::readbin(FileP file)
{
	ThreadP th=Thread::This();
	unsigned char num;
	File::charModeOn();
	th->inputBlocking++;

	if (!setjmp(th->inputBlockingBuffer))
	{	
		if (th->interactive && file->file()==File::conin)
			num=File::getch();
		else
			if (file->file())
			{	fread(&num, sizeof(unsigned char), 1, file->file());
				if (file->eof()) return 0;
			}else
				if (th->rstringlen > 0)
				{	th->rstringlen-=sizeof(unsigned char);
					if (th->rstringlen >= 0)
					{	num = *charP(th->rstringptr);	// reading from string
						th->rstringptr+=sizeof(unsigned char);
					}else
						error(FILE_ERROR, new String
							(_("memory block too small to read UInt8")));
				}
	}
	th->inputBlocking=0;
	if (file->eof()) return 0;

	int_=num;
	return this;
}
NodeP String::readbin(FileP file)
{
	ThreadP th=Thread::This();
	charP cp=ptr();

	if (th->interactive && file->file()==File::conin)
	{	error(FILE_ERROR, new String
			(_("Can't read word binary from keyboard")));
		return Unbound;
	}
	if (file->file())
	{	fread(cp, sizeof(char), _length, file->file());
		if (file->eof()) return 0;
	}else
		if (th->rstringlen > 0)
		{	th->rstringlen-=sizeof(char)*_length;
			if (th->rstringlen >= 0)
				for (int i=_length;  i;  i--)
				{	*cp++ = *charP(th->rstringptr);	// reading from string
					th->rstringptr+=sizeof(char);
				}
			else
				error(FILE_ERROR, new String
					(_("memory block too small to read word")));
		}
	return this;
}

NodeP lreadInt8Bin(PairPP) 
{
	NodeP n=new Int8();
	if throwing return Unbound;
	return n->readbin(Thread::This()->Reader);
}

NodeP lreadUInt8Bin(PairPP) 
{
	NodeP n=new UInt8();
	if throwing return Unbound;
	return n->readbin(Thread::This()->Reader);
}

NodeP lreadInt16Bin(PairPP) 
{
	NodeP n=new Int16();
	if throwing return Unbound;
	return n->readbin(Thread::This()->Reader);
}

NodeP lreadIntBin(PairPP) 
{
	NodeP n=new Int();
	if throwing return Unbound;
	return n->readbin(Thread::This()->Reader);
}

NodeP lreadWordBin(PairPP arg) 
{
	int length=arg[1]->a_int(1);
	if throwing return Unbound;

	StringP s=new String(length);
	if (throwing || !s) return Unbound;
	return s->readbin(Thread::This()->Reader);
}

NodeP lreadIntArrayBin(PairPP arg) 
{
	int size=arg[1]->a_int(1);
	if throwing return Unbound;

	IntArrayP a=new IntArray(size);
	if (throwing || !a) return Unbound;
	return a->readbin(Thread::This()->Reader);
}

NodeP lreadInt16ArrayBin(PairPP arg) 
{
	int size=arg[1]->a_int(1);
	if throwing return Unbound;

	Int16ArrayP a=new Int16Array(size);
	if (throwing || !a) return Unbound;
	return a->readbin(Thread::This()->Reader);
}

NodeP lreadStructBin(PairPP arg) 
{
	PairP li=arg[1]->a_list(1);

	if (!li) 
		error(BAD_DATA, li);
	if throwing return Unbound;

	StructP s=new Struct(li);
	if (throwing || !s) return Unbound;
	return s->readbin(Thread::This()->Reader);
}

NodeP lisEof(PairPP) 
{
	int c=reader.getc_();
	if (c==EOF) return _True;
	reader.ungetc(c);
	return _False;
}

NodeP lReaderPos(PairPP) {return new Int(reader.pos());}
NodeP lWriterPos(PairPP) {return new Int(writer.pos());}

NodeP lsetReaderPos(PairPP arg) 
{
	IntP pos = arg[1]->a_pos_int(1);
	if (!throwing) 
		reader.seek(pos->int_);
	return Unbound;
}

NodeP lsetWriterPos(PairPP arg) 
{
	IntP pos = arg[1]->a_pos_int(1);

	if (!throwing) 
		writer.seek(pos->int_);
	return Unbound;
}

NodeP lFileSize(PairPP arg)
{
	ThreadP th=Thread::This();
	if (!th->security->dirs)
	{	error(SECURITY_ERROR, new String(_("to read directories"))); return Unbound;
	}
	StringP filename=arg[1]->a_string(1);
	if throwing return Unbound;
	FileP file = filename->findInFilelist(false);
	if (file) 
#ifdef WIN32
		return new Int(_filelength(file->file()->_file));
#else
	{	wxFile wxfile(file->name()->ptr());
		return new Int(wxfile.Length());
	}	
	//		error(NOT_YET_SUPPORTED, new String(_("FileSize")));
//		return Unbound;
#endif
	else
		error(FILE_ERROR, new String(_("File not open")));
	return Unbound;
}

NodeP lFileTime(PairPP arg)
{
	ThreadP th=Thread::This();
	if (!th->security->dirs)
	{	error(SECURITY_ERROR, new String(_("to read directories"))); return Unbound;
	}
	StringP filename=arg[1]->a_string(1);
	if throwing return Unbound;
	time_t fmt=wxFileModificationTime(filename->ptr());
	wxDateTime t(fmt);
	PairP result=new List(
		new Int(t.GetHour()), new Int(t.GetMinute()), new Int(t.GetSecond()), 
		new Int(t.GetMillisecond()), 
		new Int(t.GetWeekDay()), 
		new Int(t.GetDay()), new Int(t.GetMonth()+1), new Int(t.GetYear()), _ListEnd);
	// There's a bug in GetMonth(), so we need the +1!
	return result;
}

NodeP lLogoComspec(PairPP)
{
	return new String(environment.comspec);
}


NodeP lsetLogoComspec(PairPP arg)
{
	ThreadP th=Thread::This();
	if (!th->security->dirs)
	{	error(SECURITY_ERROR, new String(_("to set directories"))); return Unbound;
	}
	StringP dir=arg[1]->a_string(1);
	if throwing return Unbound;
	StringP d=new String(dir);
	if throwing return Unbound;
	environment.comspec = d->ptr();
	return Unbound;
}

NodeP lLogoEditor(PairPP)
{
	return new String(environment.editor);
}

NodeP lsetLogoEditor(PairPP arg)
{
	ThreadP th=Thread::This();
	if (!th->security->dirs)
	{	error(SECURITY_ERROR, new String(_("to set directories"))); return Unbound;
	}
	StringP dir=arg[1]->a_string(1);
	if throwing return Unbound;
	StringP d=new String(dir);
	if throwing return Unbound;
	environment.editor = d->ptr();
	environment.editorname = environment.editor.AfterLast(wxFileName::GetPathSeparator());
	return Unbound;
}

NodeP lLogoHelpDir(PairPP)
{
	return new String(environment.helpfiles);
}

NodeP lsetLogoHelpDir(PairPP arg)
{
	ThreadP th=Thread::This();
	if (!th->security->dirs)
	{	error(SECURITY_ERROR, new String(_("to set directories"))); return Unbound;
	}
	StringP dir=arg[1]->a_string(1);
	if throwing return Unbound;
	StringP d=new String(dir);
	if throwing return Unbound;
	environment.helpfiles = d->ptr();
	return Unbound;
}

NodeP lLogoLibDir(PairPP)
{
	return new String(environment.logolib);
}

NodeP lsetLogoLibDir(PairPP arg)
{
	ThreadP th=Thread::This();
	if (!th->security->dirs)
	{	error(SECURITY_ERROR, new String(_("to set directories"))); return Unbound;
	}
	StringP dir=arg[1]->a_string(1);
	if throwing return Unbound;
	StringP d=new String(dir);
	if throwing return Unbound;
	environment.logolib = d->ptr();
	return Unbound;
}

NodeP lLogoTempDir(PairPP)
{
	return new String(environment.tempdir);
}

NodeP lsetLogoTempDir(PairPP arg)
{
	ThreadP th=Thread::This();
	if (!th->security->dirs)
	{	error(SECURITY_ERROR, new String(_("to set directories"))); return Unbound;
	}
	StringP dir=arg[1]->a_string(1);
	if throwing return Unbound;
	StringP d=new String(dir);
	if throwing return Unbound;
	environment.tempdir = d->ptr();
	return Unbound;
}

NodeP lLogoFontsDir(PairPP)
{
	return new String(environment.fontsdir);
}

NodeP lsetLogoFontsDir(PairPP arg)
{
	ThreadP th=Thread::This();
	if (!th->security->dirs)
	{	error(SECURITY_ERROR, new String(_("to set directories"))); return Unbound;
	}
	StringP dir=arg[1]->a_string(1);
	if throwing return Unbound;
	StringP d=new String(dir);
	if throwing return Unbound;
	environment.fontsdir = d->ptr();
	return Unbound;
}

NodeP lhelp(PairPP arg) 
{
	ThreadP th=Thread::This();
	int lines;
	wxString filename, line;
	StringP str=0;
	
	if noarg
		filename = wxString(environment.helpfiles)+"/index.txt";
	else
	{	str=arg[1]->a_string(1);
		if throwing
		{	error(BAD_DATA_UNREC, arg[1]);
			return Unbound;
		}
		if (str->equalP(_Null_Word))
			filename = wxString(environment.helpfiles)+"/index.txt";
		else
		{	str=StringP(str->lower())->unspace();
			filename = wxString(environment.helpfiles)+'/'
				+String::convertQMtoP(str->ptr(), str->length())+".txt";
		}
	}
	wxFileInputStream input(filename);
	if (!input.Ok())
	{	if (arg==PairPP(th->argStack->index))
			writer << _("No help available.") << endL;
		else

			writer << _("No help available on ") << str << '.' << endL;
	}else 
	{	lTextScreen(PairPP(th->argStack->index));
		TextInputStream istr(input);
		lines=0;
		
		while (!throwing && !input.Eof())
		{	line=istr.ReadLine();
			line+='\n';
			writer << line.c_str();
			lines++;
		}
	}
	return Unbound;
}

NodeP lShellSpawn(PairPP arg) 
{
	ThreadP th=Thread::This();
	if (!th->security->shell)
	{	error(SECURITY_ERROR, new String(_("to use shell"))); return Unbound;
	}
	char doscmd[0x100];
	
	while (NodePP(arg)!=NodePP(Thread::This()->argStack->index)  
	&&  arg[1]->isnolist()  &&  !throwing) 
	{	arg[1] = error(BAD_DATA, arg[1]);
		arg++;
	}
	if (noarg) 
	{	c_out << _("Type EXIT to return to Logo.") << endL;

		if (!wxExecute(""))
		{	error
			(	FILE_ERROR, new String(
				_("Could not open shell (probably due to low memory)"))
			);
			return _False;
		}
	}else 
	{	Thread::This()->stringlen=199;
		Thread::This()->stringptr=doscmd;
		*Thread::This()->Stringbuffer << arg[1];
		*(Thread::This()->stringptr)='\0';

		if (!wxExecute(doscmd))
		{	error
			(	FILE_ERROR, new String(
				_("Could not open shell (probably due to low memory)"))
			);
			return _False;
		}
	}
	return _True;
}

class MyProcess: public wxProcess
{
public:
	MyProcess() {}

	void OnTerminate(int pid, int status)
	{	c_out << _("Shell ended. Now you're back to Logo.") << endL;
		delete this;
	}
};

NodeP lShell(PairPP arg) 
{
	ThreadP th=Thread::This();
	if (!th->security->shell)
	{	error(SECURITY_ERROR, new String(_("to use shell"))); return Unbound;
	}
	if (noarg) 
	{//	error(NOT_YET_SUPPORTED, new String("Shell"));
	//	return Unbound;

		c_out << _("Type EXIT to return to Logo.") << endL;
#ifdef WIN32
//		Piper piper(environment.comspec.c_str());
//		return piper.output;
		wxString command;
		command << environment.comspec;
		wxProcess *process=MyProcess::Open(command);
		if ( !process )
		{	error(FILE_ERROR, new String(_("Failed to launch the command.")));
			return Unbound;
		}
		wxOutputStream *out = process->GetOutputStream();
		if ( !out )
		{	error(FILE_ERROR, new String(_("Failed to connect to child stdin")));
			return Unbound;
		}
		wxInputStream *in = process->GetInputStream();
		if ( !in )
		{	error(FILE_ERROR, new String(_("Failed to connect to child stdout")));
			return Unbound;
		}
		wxInputStream *err = process->GetErrorStream();
		if ( !in )
		{	error(FILE_ERROR, new String(_("Failed to connect to child stderr")));
			return Unbound;
		}
		if (console)
		{	process->SetNextHandler(console);
			console->process=process;
		}
		while (!throwing)	
		{	while (process->IsErrorAvailable())
				while (err->CanRead())
				{	wxChar buffer[4096];
					buffer[err->Read(buffer, WXSIZEOF(buffer) - 1).LastRead()] = _T('\0');
					wxString s(buffer);
					if (!s.IsEmpty())
					{	s.Replace("\r","\r\n");
						c_out << s;
					}
				}
			while (process->IsInputAvailable())
				while ( in->CanRead() )
				{	wxChar buffer[4096];
					buffer[in->Read(buffer, WXSIZEOF(buffer)-1).LastRead()] = _T('\0');
					wxString s(buffer);
					s.Replace("\r","\r\n");
					c_out << s;
				}
			if (console)
				console->flush();

			wxString s;
			s << c_in.read("")->ptr();
			if (s.Find('>'))
				s=s.AfterFirst('>');
			if (s.Upper()==_("EXIT") || (console && !console->process))
				break;
			s+="\n";
			out->Write(s.c_str(), s.length());
		}
		if (!console || console->process)
		{	process->CloseOutput();
		}
		return Unbound;
#else
		error(NOT_YET_SUPPORTED, new String("Shell"));
		return Unbound;
#endif
	}else 
	{
		if (!arg[1])
			return 0;
		wxString command;
#ifdef WIN32
		command << environment.comspec << wxT(" /C");
#endif
		if (arg[1])
			command << arg[1]->string()->noParity()->ptr();

		wxArrayString output, errors;
		int result = wxExecute(command, output, errors);
c_out << wxGetCwd() << endL;
		PairP list=0;
		if(result != -1)
		{	bool wordmode = exist(2) ?  true : false;

			for (int i=output.GetCount()-1; i>=0; i--)
			{	if (wordmode)
				{	StringP str=new String(output[i]+'\n');
					if throwing return Unbound;
					push(list, str);
				}else
				{	StringP str=new String(output[i]);
					if throwing return Unbound;
					push(list, str->parser(false));
				}
				if throwing return Unbound;
			}
			if (errors.GetCount())
			{	c_out << _("Errors: ") << endL;
				for (unsigned int i=0; i < errors.GetCount(); i++)
					c_out << errors[i] << endL; 
			}
		}
		if (console)
			console->SetFocus();
		return list;

		//___________________here follows the old shell code___________
		char oscmd[0x100];
		Thread::This()->stringlen=0xff;
		Thread::This()->stringptr=oscmd;
		bool wordmode = exist(2) ?  true : false;

#ifdef WIN32
		*Thread::This()->Stringbuffer 
			<< environment.comspec << " /C" << arg[1];
		*(Thread::This()->stringptr)='\0';

		Piper piper(oscmd, wordmode);
		return piper.output;
#else
//		stringbuffer << environment.comspec << " " << arg[1];
		stringbuffer << arg[1];
//		*File::stringptr='\0';

		FILE *strm;
		PairP head=0, tail=0;
		NodeP this_=0;
		int len;

		strm = popen(oscmd, "r");

		if (!strm)
		{	error(FILE_ERROR, new String(_("Could not open shell pipe")));
			return Unbound;
		}
		fgets(oscmd, 0x100, strm);
		while (!feof(strm))
		{	len = strlen(oscmd);
			if (oscmd[len-1] == '\n')
				oscmd[--len] = '\0';
			if (wordmode)
				this_ = String::make(oscmd, 0, len, STRING, String::copy);
			else
				this_ = (new String(oscmd))->parser(false);
			if (!head)
			{	tail = head = new Pair(this_, 0);
			} else
			{	tail->settail(new Pair(this_, 0));
				next(tail);
			}

			fgets(oscmd, 0x100, strm);
		}
		pclose(strm);
		return head;
#endif
	}
}

NodeP lreadURL(PairPP arg)
{
	enum Paras {_url=1, _header};
	StringP urlnd=arg[_url]->a_string(_url);
//	StringP header=_Null_Word;
//	if (exist(_header))
//		header=arg[_header]->a_string(_header);
	if throwing return Unbound;
	urlnd=urlnd->noParity();
	if throwing return Unbound;
	wxURL url(urlnd->ptr());
	wxInputStream *pInput = url.GetInputStream();
	if (!pInput)
	{	error(FILE_ERROR, new String(new String(wxT( "No file found at " )), urlnd));
		return Unbound;
	}
	wxProtocol *pProtocol = &url.GetProtocol() ;
	wxString sType = pProtocol->GetContentType() ;
//	header=header->noParity();
//	if throwing return Unbound;
//	pProtocol->Write(header->ptr(), header->length());

	int iMax = pInput->GetSize();
	if (iMax < 0)
	{	error(FILE_ERROR, new String(new String(wxT( "No file found at " )), urlnd));
		return Unbound;
	}
	StringP result=new String(iMax);
	if throwing return Unbound;
	wxDataInputStream dis(*pInput);    
	pInput->Read(result->ptr(), iMax);
	return result;
}