//___________________________________________________________________
//
//                         FloatControl Header
//___________________________________________________________________

#ifndef WINDOWNODE
	#include "Window.h"
#endif

extern Function 
	lFloatControl, lFloatControlDestroy,
	lFloatControlValue, lFloatControlSetValue, 
	lFloatControlSetRange, lFloatControlOnChange,
	lFloatControlEnable;

class wxStaticText;

class FloatControl: public wxSpinCtrlDbl
{
	public:
		int format;
		enum Data
		{	WINDOW_DATA,
			onChange, uonChange, tonChange,
			dataCount
		};
		NodeP data[dataCount];

		static int vmt;

		virtual NodePP d(int i) {return &data[i];}

		FloatControl(wxWindow *parent);
		FloatControl(FloatControlNodeP floatControlNode_, int style);
		FloatControl(FloatControlNodeP floatControlNode_,
			wxWindow* parent, wxWindowID id, 
			double value, double minValue, double maxValue, double increment,
			int digits = -1, int format_ = lg_fmt,
			PairP onScroll_=PairP(0),
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = wxSP_ARROW_KEYS, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = _("FloatControl"));
		~FloatControl();

		void 
			OnClose(wxCloseEvent &event),
			OnChange(wxSpinEvent &event);

		wxString wxstring();
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		DECLARE_EVENT_TABLE()
};
typedef FloatControl *FloatControlP;

class FloatControlNode: public WindowNode
{
	public:
		FloatControlP &floatControl;

		static const FloatControlNode aFloatControlNode;

		operator_new;
		PairP onChange();
		void setonChange(NodeP function);

		FloatControlNode();
		FloatControlNode(WindowNodeP parent_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();
		
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs(IntToPtr_ &intToPtr);
		void recreate();

		StringP string();
		wxString wxstring();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		StringP _typeof();
};
