//___________________________________________________________________
//
//                         Gauge Header
//___________________________________________________________________

#ifndef WINDOWNODE
	#include "Window.h"
#endif

extern Function 
	lGauge, lGaugeDestroy,
	lGaugeValue, lGaugeSetValue, lGaugeSetRange,
	lGaugeSetColor, lGaugeSetBackgroundColor;

class wxStaticText;
class MyGauge;

class Gauge: public wxControl
{
	public:
		wxStaticText *label;
		MyGauge *gauge;
		wxSize bestSize;

		enum Data
		{	WINDOW_DATA,
			dataCount
		};
		NodeP data[dataCount];

		static int vmt;

		virtual NodePP d(int i) {return &data[i];}

		Gauge(wxWindow *parent);
		Gauge(GaugeNodeP gaugeNode_, int style);
		Gauge(GaugeNodeP gaugeNode_,
			wxWindow* parent, wxWindowID id, 
			int range, 
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = 0, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = _("Gauge"));

		bool create(wxWindow* parent, wxWindowID id, 
			int range, 
			const wxPoint& pos, 
			const wxSize& size, 
			long style, 
			const wxValidator& validator, 
			const wxString& name);

		~Gauge();

		virtual void DoSetSize(int x, int y, int width, int height,
						   int sizeFlags = wxSIZE_AUTO);

		virtual wxSize DoGetBestSize();

		virtual bool SetBackgroundColour(const wxColour& colour);
		virtual bool SetForegroundColour(const wxColour& colour);

		void 
			OnClose(wxCloseEvent &event);

		wxString wxstring();
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
};
typedef Gauge *GaugeP;

class GaugeNode: public WindowNode
{
	public:
		GaugeP &gauge;

		static const GaugeNode aGaugeNode;

		operator_new;

		GaugeNode();
		GaugeNode(WindowNodeP parent_);

		void free();

		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs(IntToPtr_ &intToPtr);
		void recreate();

		StringP string();
		wxString wxstring();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		StringP _typeof();
};
