#ifndef Node_included
	#include "Node.h"
#endif

#ifndef Int_included

class Int: public Node
{
	public: 
		int int_;
		static const int digits;
		static const int min;
		static const int max;
		static const int umax;
		static const __int64 i64max;
		static const Int aInt;
		static volatile int genSymNr;

		operator_new;
		Int():      Node(INT_), int_(0) {}
		Int(int i): Node(INT_), int_(i) {}

		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);

		StringP   string();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		void printBin(FILEP strm);

		   int   numberP() {return 1;}
		double getnumber() {return int_;}
		 NodeP    number() {return this;}

		OPERATORS_DECL
		int compare(NodeP nd);
		int _sizeof();
		StringP _typeof();
		double _min(double d);
		double _max(double d);
		NodeP Norm();
		NodeP maxNorm();
		NodeP saturateAbove(double limit);
		NodeP saturateBelow(double limit);
		NodeP item(NodeP index, NodeP result);
		NodeP bititem(NodeP index);
		NodeP setitem(NodeP index, NodeP newitem, bool safe);
		NodeP memberP(NodeP subobj, bool notp=false, bool substr=false);
		NodeP reverse();
		NodeP readbin(FileP file);
		NodeP upper();
		NodeP lower();
		PairP list();
		void setPixelXY(NodeP yin, NodeP color);
		void setPixelXYZ(NodeP yin, NodeP zin, NodeP color);
		void setXYZ(NodeP ynode, NodeP znode);

		static void init();
		static void seedMT(unsigned long seed);
		static unsigned long reloadMT();
		static unsigned long randomMT();
		static int Remainder(int x, int d);
		static int mod(int x, int d);
		static int random(int max);
		static int gcd(int a, int b);
		static int clip(double d);
};

	#define Int_included
#endif
