//___________________________________________________________________
//
//                         IntControl Header
//___________________________________________________________________

#ifndef WINDOWNODE
	#include "Window.h"
#endif

extern Function 
	lIntControl, lIntControlDestroy,
	lIntControlValue, lIntControlSetValue, 
	lIntControlSetRange, lIntControlOnChange,
	lIntControlEnable;

class wxStaticText;

class IntControl: public wxSpinCtrlInt
{
	public:
		enum Data
		{	WINDOW_DATA,
			onChange, uonChange, tonChange,
			dataCount
		};
		NodeP data[dataCount];

		static int vmt;

		virtual NodePP d(int i) {return &data[i];}

		IntControl(wxWindow *parent);
		IntControl(IntControlNodeP intControlNode_, int style);
		IntControl(IntControlNodeP intControlNode_,
			wxWindow* parent, wxWindowID id, 
			int value , int minValue, int maxValue, 
			PairP onScroll_=PairP(0),
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = wxSP_ARROW_KEYS, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = _("IntControl"));
		~IntControl();

		void 
			OnClose(wxCloseEvent &event),
			OnChange(wxSpinEvent &event);

		wxString wxstring();
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		DECLARE_EVENT_TABLE()
};
typedef IntControl *IntControlP;

class IntControlNode: public WindowNode
{
	public:
		IntControlP &intControl;
		int style;

		static const IntControlNode aIntControlNode;

		operator_new;
		PairP onChange();
		void setonChange(NodeP function);

		IntControlNode();
		IntControlNode(WindowNodeP parent_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();
		
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs(IntToPtr_ &intToPtr);
		void recreate();

		StringP string();
		wxString wxstring();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);

		StringP _typeof();
};
