#ifndef Pair_included
	#include "Pair.h"
#endif

#ifndef Line_included

class Line: public Pair
{
	public:
		StringP _filename;
		int col, tcol, row, generation;

		static int the_generation;
		static const Line aLine;
		operator_new;

		StringP filename();
		void setfilename(NodeP nd);

		Line();
		Line(NodeP first_, NodeP tail_);
		Line(NodeP first_, NodeP tail_, NodeType type_);
		Line(const charP str);
		Line(const wxChar *str);

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();
		
		void setPtrs(IntToPtr_ &intToPtr);
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);

		StringP _typeof();
		NodeP deepCopy();
		NodeP deepCopyLine();

		static LineP paren_expr(LinePP expr, bool inparen, int oldPriority);
		LineP paren_line(); // Fully parenthesize a complete line, 
								 // i.e. transform it from a flat list to a tree.

		ProcedureP define_helper(bool macroFlag=false, 
										 bool dynFlag=false, 
										 PairP name=NIL,
										 StringP left=0);
		ProcedureP anonymous_function();

		static void init();
		static StringP findFile(StringP filename_);
};

#define Line_included
#endif
