//___________________________________________________________________
//
//                         ListBox Header
//___________________________________________________________________

#ifndef WINDOWNODE
	#include "Window.h"
#endif

extern Function 
	lListBox, lListBoxDestroy,
	lListBoxSelections, lListBoxSetSelections,
	lListBoxSetChoices, 
	lListBoxAppend, 
	lListBoxSetItem, lListBoxRemoveItem, 
	lListBoxCount,
	lListBoxSetBackgroundColor, lListBoxSetColor,
	lListBoxSetFontSize, lListBoxSetFontName,
	lListBoxSetFontStyle, lListBoxSetFontWeight,
	lListBoxOnChar, lListBoxOnKeyDown, lListBoxOnKeyUp,
	lListBoxOnSelect, lListBoxOnDClick,
	lListBoxEnable;

class wxStaticText;
class MyListBox;

class ListBox_: public wxControl
{
	public:
		wxStaticText *label;
		MyListBox *listBox;
		wxSize bestSize;
		wxArrayString choices;
		enum Data
		{	WINDOW_DATA,
			onSelect, uonSelect, tonSelect, 
			onDClick, uonDClick, tonDClick,  
			dataCount
		};
		NodeP data[dataCount];

		static int vmt;

		virtual NodePP d(int i) {return &data[i];}

		ListBox_(wxWindow *parent);
		ListBox_(ListBoxNodeP listBoxNode_, int style);
		ListBox_(ListBoxNodeP listBoxNode_,
			wxWindow* parent, wxWindowID id, 
			const wxArrayString& choices_, 
			PairP onSelect_=PairP(0),
			PairP onDClick_=PairP(0),
			const wxPoint& pos=wxDefaultPosition, 
			const wxSize& size=wxDefaultSize, 
			long style = 0, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = _("ListBox"));

		bool create(wxWindow* parent, wxWindowID id, 
			const wxArrayString& choices_, 
			const wxPoint& pos, 
			const wxSize& size, 
			long style, 
			const wxValidator& validator, 
			const wxString& name);

		~ListBox_();

		virtual void DoSetSize(int x, int y, int width, int height,
						   int sizeFlags = wxSIZE_AUTO);

		virtual wxSize DoGetBestSize();

		virtual void Set(wxArrayString &choices);

		virtual void 
			OnSelect	(wxCommandEvent &event),
			OnDClick	(wxCommandEvent &event),
			OnChar	(wxKeyEvent &event),
			OnKeyDown(wxKeyEvent &event),
			OnKeyUp	(wxKeyEvent &event);

		virtual wxString wxstring();
		virtual DataInputStream &read(DataInputStream &istr);
		virtual wxDataOutputStream &write(wxDataOutputStream &ostr);

		virtual bool SetBackgroundColour(const wxColour& colour);
		virtual bool SetForegroundColour(const wxColour& colour);
		virtual bool SetFont(const wxFont& font);

		DECLARE_EVENT_TABLE()
};
typedef ListBox_ *ListBoxP;

class ListBoxNode: public WindowNode
{
	public:
		int style;
		ListBoxP &listBox;

		static const ListBoxNode aListBoxNode;

		operator_new;
		PairP onSelect();
		PairP onDClick();
		void setonSelect	(NodeP function);
		void setonDClick	(NodeP function);

		ListBoxNode();
		ListBoxNode(WindowNodeP parent_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();
		
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs(IntToPtr_ &intToPtr);
		void recreate();

		StringP string();
		wxString wxstring();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		StringP _typeof();
};
