#include "stdafx.h"
#include <math.h>

#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <stdio.h>

#include <wx/app.h>
#include <wx/list.h>
#include <wx/thread.h>

#include "Main.h"

#include "String.h"
#include "File.h"
#include "Pair.h"
#include "Line.h"
#include "List.h"
#include "WindowPair.h"
#include "Object.h"
#include "Int.h"
#include "Int16.h"
#include "Int8.h"
#include "UInt8.h"
#include "Float.h"
#include "Point.h"
#include "Array.h"
#include "IntArray.h"
#include "Int16Array.h"
#include "FloatArray.h"
#include "Table.h"
#include "Struct.h"
#include "Bitmap.h"
#include "Texture.h"
#include "TurtleNode.h"
//#include "Runparsed.h"
//#include "Tree.h"
#include "Quote.h"
#include "Colon.h"
#include "Procedure.h"
#include "GraphicNode.h"

#include "Color.h"
#include "Error.h"
#include "Stack.h"
#include "NodePStack.h"
#include "Init.h"
#include "Coms.h"
#include "Security.h"
#include "Thread.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
	#define  malloc(m)       _malloc_dbg((m),        _NORMAL_BLOCK, __FILE__, __LINE__)
#endif

/*
void Table::deepCopy()
{
	TableP tab2=new Table(size);
	if throwing return;
	ObjectPP itemptr=base;
	for (int i=size;  i;  i--)
		for (ObjectP obj = *itemptr++;  obj;  next(obj))
		{	ObjectP obj2=tab2->insert(obj->name());
				obj2->setvar(obj->var());
				obj2->settable(obj->table());
			}
		}
}*/
// TODO: Table::deepCopy(), Struct::deepCopy()
NodeP ldeepCopy(PairPP arg) 
{
	if (!arg[1])
		return 0;
	return arg[1]->deepCopy();
}

NodeP lfirst(PairPP arg) 
{
	if (!arg[1]) 
	{	error(BAD_DATA, arg[1]); return Unbound;
	}
	return arg[1]->first_();
}

NodeP lbutFirst(PairPP arg) 
{
	NodeP nd=arg[1]->a_bfable(1);
	nd=nd;
	if throwing return Unbound;
	return arg[1]->butFirst();
}

NodeP l_setFirst(PairPP arg) 
{
	PairP	  list=arg[1];
	NodeP newval=arg[2];

	if (!list || !list->is.list) 
		list = error(BAD_DATA, list);

	if (!throwing) list->setfirst(newval);
	return Unbound;
}


NodeP l_setButFirst(PairPP arg) 
{
	PairP   list=arg[1];
	NodeP newval=arg[2];

	if (!list || !list->is.list)
		list = error(BAD_DATA,list);

	if (!throwing) list->settail(newval);
	return Unbound;
}

NodeP llast(PairPP arg) 
{
	NodeP nd = arg[1];
	if (!nd)
		return 0;
	return nd->last();
}

NodeP lbutLast(PairPP arg) 
{
	if (arg[1])
		return arg[1]->butLast();
	error(BAD_DATA, arg[1]);
	return Unbound;
}

NodeP lfirsts(PairPP arg) 
{
	if (!arg[1]) 
	{	error(BAD_DATA, arg[1]); return Unbound;
	}
	return arg[1]->firsts();
}

NodeP lbutFirsts(PairPP arg) 
{
	if (!arg[1]) 
		return 0;
	return arg[1]->butFirsts();
}

NodeP lfPut(PairPP arg) 
{
	if (!arg[2]) 
	{	return new Pair(arg[1], 0);
	}
	return arg[2]->fPut(arg[1]);
}

NodeP llPut(PairPP arg) 
{
	if (!arg[2]) 
	{	return new Pair(arg[1], 0);
	}
	return arg[2]->lPut(arg[1]);
}

WindowPairP WindowPair::wlPut(NodeP nd)
{	WindowPairP lst=this, val=0, lastnode=0, tnode=0;
	while (lst) 
	{	tnode = new WindowPair(lst->first(), 0);
		if throwing return this;
		if (!val) 
			val=tnode;
		else 
			lastnode->settail( tnode );
		lastnode=tnode;
		lst=WindowPairP(lst->tail());
		if (checkThrowing()) break;
	}
	if (!val)
		return new WindowPair(nd, 0);
	else
	{	lastnode->settail( new WindowPair(nd, 0) );
		return val;
	}
}

NodeP lList(PairPP arg) {return Thread::This()->argStack->to_list(arg);}

NodeP lisempty(PairPP arg) 
{
	return Node::boolnode( !arg[1]  
		||  arg[1]==NodeP(_Null_Word) 
		||  arg[1]->count()==0);
}

NodeP lASCII(PairPP arg) 
{
	StringP str = arg[1]->a_char(1);
	if (!throwing) 
	{	unsigned char i = backslash.decode(*str->ptr());
		return new Int(i);
	}
	return Unbound;
}

NodeP lrawASCII(PairPP arg) 
{
	StringP str = arg[1]->a_char(1);
	if (!throwing) 
	{	unsigned char i = *str->ptr();
		return new Int(i);
	}
	return Unbound;
}

NodeP lisbackslashed(PairPP arg) 
{
	StringP str = arg[1]->a_char(1);
	if (!throwing) 
	{	char i = *str->ptr();
		return Node::boolnode(backslash.is(backslash.encode(i)));
	}
	return Unbound;
}

NodeP lBackslashEncode(PairPP arg) 
{
	if (!arg[1])
		return 0;
	StringP str = arg[1]->a_string(1);
	if throwing return Unbound;
	int len=str->length();
	StringP result=new String(len);
	if throwing return Unbound;
	charP out=result->ptr();
	charP cp=str->ptr();
	for (int i=len; i>0; i--)
		*out++=backslash.encode(*cp++);
	result->type=BACKSLASHED;
	return result;
}

NodeP lexpandBackslashes(PairPP arg) 
{
	if (!arg[1])
		return 0;
	StringP str = arg[1]->a_string(1);
	if throwing return Unbound;
	return str->expandSlash();
}

NodeP lsetExpandBackslashes(PairPP arg)
{
	int state=arg[1]->a_bool(1);
	ThreadP th=Thread::This();
	if (!th->security->gui)
	{	error(SECURITY_ERROR, new String(_("to set backslash expand flag"))); 
		return Unbound;
	}
	th->backslashes=(state!=0);
	return Unbound;
}

NodeP lChar(PairPP arg) 
{
	IntP i = arg[1]->a_pos_int(1);
	if (!throwing) 
	{	char c = char(i->int_);
		return new String(&c, 0, 1, STRING, String::copy);
	}
	return Unbound;
}

NodeP lisChar(PairPP arg) 
{
	if ((type_of(arg[1])==OBJECT 
		&& ObjectP(arg[1])->name()->length()==1)
	|| (arg[1]->isstring() 
		&& StringP(arg[1])->length()==1))
		return _True;
	return _False;
}

NodeP lisAlNum(PairPP arg) 
{
	if ((type_of(arg[1])==OBJECT 
	&& ObjectP(arg[1])->name()->length()==1))
		return Node::boolnode( isalnum(*ObjectP(arg[1])->name()->ptr())!=0 );

	if ((arg[1]->isstring() 
	&& StringP(arg[1])->length()==1))
		return Node::boolnode( isalnum(*StringP(arg[1])->ptr())!=0 );

	return _False;
}

NodeP lisAlpha(PairPP arg) 
{
	if ((type_of(arg[1])==OBJECT 
	&& ObjectP(arg[1])->name()->length()==1))
		return Node::boolnode( isalpha(*ObjectP(arg[1])->name()->ptr())!=0 );

	if ((arg[1]->isstring() 
	&& StringP(arg[1])->length()==1))
		return Node::boolnode( isalpha(*StringP(arg[1])->ptr())!=0 );

	return _False;
}

NodeP lisASCII(PairPP arg) 
{
	if ((type_of(arg[1])==OBJECT 
	&& ObjectP(arg[1])->name()->length()==1))
		return Node::boolnode( isascii(*ObjectP(arg[1])->name()->ptr())!=0 );

	if ((arg[1]->isstring() 
	&& StringP(arg[1])->length()==1))
		return Node::boolnode( isascii(*StringP(arg[1])->ptr())!=0 );

	return _False;
}

NodeP lisCntrl(PairPP arg) 
{
	if ((type_of(arg[1])==OBJECT 
	&& ObjectP(arg[1])->name()->length()==1))
		return Node::boolnode( iscntrl(*ObjectP(arg[1])->name()->ptr())!=0 );

	if ((arg[1]->isstring() 
	&& StringP(arg[1])->length()==1))
		return Node::boolnode( iscntrl(*StringP(arg[1])->ptr())!=0 );

	return _False;
}

NodeP lisCSym(PairPP arg) 
{
#ifdef WIN32
	if ((type_of(arg[1])==OBJECT 
	&& ObjectP(arg[1])->name()->length()==1))
		return Node::boolnode( iscsym(*ObjectP(arg[1])->name()->ptr())!=0 );

	if ((arg[1]->isstring() 
	&& StringP(arg[1])->length()==1))
		return Node::boolnode( iscsym(*StringP(arg[1])->ptr())!=0 );

	return _False;
#else
	error(NOT_YET_SUPPORTED, new String("CSym?"));
	return Unbound;
#endif
}

NodeP lisDigit(PairPP arg) 
{
	if ((type_of(arg[1])==OBJECT 
	&& ObjectP(arg[1])->name()->length()==1))
		return Node::boolnode( isdigit(*ObjectP(arg[1])->name()->ptr())!=0 );

	if ((arg[1]->isstring() 
	&& StringP(arg[1])->length()==1))
		return Node::boolnode( isdigit(*StringP(arg[1])->ptr())!=0 );

	return _False;
}

NodeP lisGraph(PairPP arg) 
{
	if ((type_of(arg[1])==OBJECT 
	&& ObjectP(arg[1])->name()->length()==1))
		return Node::boolnode( isgraph(*ObjectP(arg[1])->name()->ptr())!=0 );

	if ((arg[1]->isstring() 
	&& StringP(arg[1])->length()==1))
		return Node::boolnode( isgraph(*StringP(arg[1])->ptr())!=0 );

	return _False;
}

NodeP lisLower(PairPP arg) 
{
	if ((type_of(arg[1])==OBJECT 
	&& ObjectP(arg[1])->name()->length()==1))
		return Node::boolnode( islower(*ObjectP(arg[1])->name()->ptr())!=0 );

	if ((arg[1]->isstring() 
	&& StringP(arg[1])->length()==1))
		return Node::boolnode( islower(*StringP(arg[1])->ptr())!=0 );

	return _False;
}

NodeP lisPrint(PairPP arg) 
{
	if ((type_of(arg[1])==OBJECT 
	&& ObjectP(arg[1])->name()->length()==1))
		return Node::boolnode( isprint(*ObjectP(arg[1])->name()->ptr())!=0 );

	if ((arg[1]->isstring() 
	&& StringP(arg[1])->length()==1))
		return Node::boolnode( isprint(*StringP(arg[1])->ptr())!=0 );

	return _False;
}

NodeP lisPunct(PairPP arg) 
{
	if ((type_of(arg[1])==OBJECT 
	&& ObjectP(arg[1])->name()->length()==1))
		return Node::boolnode( ispunct(*ObjectP(arg[1])->name()->ptr())!=0 );

	if ((arg[1]->isstring() 
	&& StringP(arg[1])->length()==1))
		return Node::boolnode( ispunct(*StringP(arg[1])->ptr())!=0 );

	return _False;
}

NodeP lisSpace(PairPP arg) 
{
	if ((type_of(arg[1])==OBJECT 
	&& ObjectP(arg[1])->name()->length()==1))
		return Node::boolnode( isspace(*ObjectP(arg[1])->name()->ptr())!=0 );

	if ((arg[1]->isstring() 
	&& StringP(arg[1])->length()==1))
		return Node::boolnode( isspace(*StringP(arg[1])->ptr())!=0 );

	return _False;
}

NodeP lisUpper(PairPP arg) 
{
	if ((type_of(arg[1])==OBJECT 
	&& ObjectP(arg[1])->name()->length()==1))
		return Node::boolnode( wxIsupper(*ObjectP(arg[1])->name()->ptr())!=0 );

	if ((arg[1]->isstring() 
	&& StringP(arg[1])->length()==1))
		return Node::boolnode( wxIsupper(*StringP(arg[1])->ptr())!=0 );

	return _False;
}

NodeP lisxDigit(PairPP arg) 
{
	if ((type_of(arg[1])==OBJECT 

	&& ObjectP(arg[1])->name()->length()==1))
		return Node::boolnode( isxdigit(*ObjectP(arg[1])->name()->ptr())!=0 );

	if ((arg[1]->isstring() 
	&& StringP(arg[1])->length()==1))
		return Node::boolnode( isxdigit(*StringP(arg[1])->ptr())!=0 );

	return _False;
}

NodeP lupperCase(PairPP arg) 
{
	NodeP thing=arg[1];
	if (!thing)
		return 0;
	return thing->upper();
}

NodeP llowerCase(PairPP arg) 
{
	NodeP thing=arg[1];
	if (!thing)
		return 0;
	return thing->lower();
}

NodeP lcount(PairPP arg) {return new Int(arg[1]?  arg[1]->count() : 0);}

int UInt8 ::_sizeof() {return sizeof(unsigned char);}

NodeP lSizeOf(PairPP arg) {return new Int(arg[1]?  arg[1]->_sizeof() : 0);}

NodeP lTypeOf(PairPP arg) {return arg[1]?  arg[1]->_typeof() : new String(_("List"));}


NodeP lpush(PairPP arg)
{
	ThreadP th=Thread::This();
	NodeP stackname=arg[1]->a_name(1);

	if (!throwing)
	{	ObjectP obj=stackname->intern();
		NodeP var=th->varStack->find(obj);
		if (var==Unbound)
		{	PairP p=new Pair(arg[2], 0);
			if throwing return Unbound;
			th->varStack->setVar(obj, p);
		}else
		{	PairP p=new Pair(arg[2], var);
			if throwing return Unbound;
			th->varStack->setVar(obj, p);
		}
	}
	return Unbound;
}

NodeP lpop(PairPP arg)
{
	ThreadP th=Thread::This();
	NodeP stackname=arg[1]->a_name(1);

	if (!throwing)
	{	ObjectP obj=stackname->intern();
		NodeP var=th->varStack->find(obj);
		if (!var || var==Unbound || var->isnolist())
		{	error(BAD_DATA, stackname);
			return Unbound;
		}
		NodeP result=PairP(var)->first();
		th->varStack->setVar(obj, PairP(var)->tail());
		return result;
	}
	return Unbound;
}

NodeP lqueue(PairPP arg)
{
	ThreadP th=Thread::This();
	NodeP queuename=arg[1]->a_name(1);

	if (!throwing)
	{	ObjectP obj=queuename->intern();
		NodeP var=0;
		var=th->varStack->find(obj);
		if (!var || var==Unbound)
			th->varStack->setVar(obj, new Pair(arg[2], 0));
		else if (var->isnolist())
		{	error(BAD_DATA, queuename);
			return Unbound;
		}else
		{	PairP list=PairP(var);
			while (list)
			{	if (!list->tail())
				{	list->settail(new Pair(arg[2], 0));
					return Unbound;
				}
				next(list);
			}
		}
	}
	return Unbound;
}

NodeP lWord(PairPP arg) 
{
	if (noarg)	return _Null_Word;
	int nr=1, count=0;
	StringP str=0;
	NodeType str_type=STRING;
	PairPP sp=arg;  

	while (sp!=PairPP(Thread::This()->argStack->index)  &&  !throwing) 
	{	if (!sp[1])
		{	sp++;
			continue;
		}
		str = (*++sp)->a_string(nr);
		if (!throwing) 
		{	if (str->is.backslashed)
				str_type=VBAR_STRING;
			count += str->length();
		}
		nr++;
	}
	if (!throwing)
		str = String::fromList(arg, count, str_type, String::copy_word);
	else
		str = StringP(Unbound);
	return str;
}

NodeP lStringBuffer(PairPP arg)
{
	int length=arg[1]->a_int(1);
	if throwing return Unbound;
	return new String(length);
}

NodeP lStringBufferToWord(PairPP arg)
{
	StringP s=arg[1]->a_string(1);
	if throwing return Unbound;
	return new String(s->ptr());
}

NodeP lcombine(PairPP arg)
{
	ThreadP th=Thread::This();
	if (!arg[2])
		return new Pair(arg[1], 0);
	else if (arg[2]->is.word)
		return lWord(arg);
	else if (arg[2]->islist())
		return lfPut(arg);
	else
	{	NodeType t;
		if (arg[1])
			t=arg[1]->type;
		else
			t=PAIR;
		NodePP a=NodePP(arg);
		int i=1;
		while (a!=th->argStack->index)
		{	if (a[1] && a[1]->type!=t)
			{	error(BAD_DATA, arg[i], i); return Unbound;
			}
			a++;
			i++;
		}
		if (t==FLOATARRAY)
		{	NodePP sp=NodePP(arg);
			int l=0;
			while (sp!=th->argStack->index)
			{	l+=FloatArrayP(sp[1])->length();
				sp++;
			}
			FloatArrayP result=new FloatArray(l);
			if throwing return Unbound;
			doubleP dr=result->data();
			sp=NodePP(arg);
			while (sp!=th->argStack->index)
			{	FloatArrayP a=FloatArrayP(sp[1]);
				doubleP da=a->data();
				int la=a->length();
				while (la--)
				{	*dr++=*da++;
				}
				sp++;
			}
			return result;
		}
		else if (t==INTARRAY)
		{	NodePP sp=NodePP(arg);
			int l=0;
			while (sp!=th->argStack->index)
			{	l+=IntArrayP(sp[1])->length();
				sp++;
			}
			IntArrayP result=new IntArray(l);
			if throwing return Unbound;
			intP dr=result->data();
			sp=NodePP(arg);
			while (sp!=th->argStack->index)
			{	IntArrayP a=IntArrayP(sp[1]);
				intP da=a->data();
				int la=a->length();
				while (la--)
				{	*dr++=*da++;
				}
				sp++;
			}
			return result;
		}
		else if (t==INT16ARRAY)
		{	NodePP sp=NodePP(arg);
			int l=0;
			while (sp!=th->argStack->index)
			{	l+=Int16ArrayP(sp[1])->length();
				sp++;
			}
			Int16ArrayP result=new Int16Array(l);
			if throwing return Unbound;
			shortP dr=result->data();
			sp=NodePP(arg);
			while (sp!=th->argStack->index)
			{	Int16ArrayP a=Int16ArrayP(sp[1]);
				shortP da=a->data();
				int la=a->length();
				while (la--)
				{	*dr++=*da++;
				}
				sp++;
			}
			return result;
		}
		else if (t==ARRAY)
		{	NodePP sp=NodePP(arg);
			int l=0;
			while (sp!=th->argStack->index)
			{	l+=ArrayP(sp[1])->length();
				sp++;
			}
			ArrayP result=new Array(l);
			if throwing return Unbound;
			NodePP dr=result->data();
			sp=NodePP(arg);
			while (sp!=th->argStack->index)
			{	ArrayP a=ArrayP(sp[1]);
				NodePP da=a->data();
				int la=a->length();
				while (la--)
				{	*dr++=*da++;
				}
				sp++;
			}
			return result;
		}
	}
	error(BAD_DATA, arg[2], 2);
	return Unbound;
}

NodeP lSentence(PairPP arg) 
{
	NodeP val=0;
	PairP tnode=0, lastnode=0;

	while (NodePP(arg)!=Thread::This()->argStack->index && !throwing) 
	{
		PairP thing= *++arg;

		if (thing->islist()) 
		{	for (PairP lst=thing;  lst && !throwing;  next(lst))
			{
				tnode = new Pair(lst->first(), 0);
				if (!val) 
					val=tnode;
				else 
					lastnode->settail( tnode );
				lastnode=tnode;
			}
		}else 
		{	tnode=new Pair(thing, 0);
			if (!val) 
				val=tnode;
			else 
				lastnode->settail( tnode );
			lastnode=tnode;
		}
	}
	if (throwing) return Unbound;
	return val;
}

NodeP lisList   (PairPP arg) {return Node::boolnode(arg[1]->islist());}
NodeP lisArray  (PairPP arg) {return Node::boolnode(type_of(arg[1])==ARRAY  );}
NodeP lisIntArray(PairPP arg) {return Node::boolnode(type_of(arg[1])==INTARRAY);}
NodeP lisInt16Array(PairPP arg) {return Node::boolnode(type_of(arg[1])==INT16ARRAY);}
NodeP lisFloatArray(PairPP arg) {return Node::boolnode(type_of(arg[1])==FLOATARRAY);}
NodeP lisTable  (PairPP arg) {return Node::boolnode(type_of(arg[1])==TABLE  );}
NodeP lisInt    (PairPP arg) {return Node::boolnode(type_of(arg[1])==INT_   );}
NodeP lisInt16  (PairPP arg) {return Node::boolnode(type_of(arg[1])==NINT16  );}
NodeP lisInt8   (PairPP arg) {return Node::boolnode(type_of(arg[1])==NINT8   );}
NodeP lisUInt8  (PairPP arg) {return Node::boolnode(type_of(arg[1])==NUINT8  );}
NodeP lisFloat  (PairPP arg) {return Node::boolnode(type_of(arg[1])==FLOAT_ );}
NodeP lisBigFloat(PairPP arg) {return Node::boolnode(type_of(arg[1])==BIGFLOAT);}
NodeP lisComplex_(PairPP arg) {return Node::boolnode(type_of(arg[1])==COMPLEX);}

NodeP lisNumber(PairPP arg) 
{
	if (!arg[1])
		return _False;
	arg[1] = PairP(arg[1]->number());
	return Node::boolnode( arg[1] != Unbound );
}

NodeP lisWord(PairPP arg) 
{
	return Node::boolnode( 
		arg[1]!=Unbound  &&  arg[1]  &&  !arg[1]->isaggregate() );
}

NodeP UInt8::memberP(NodeP subobj, bool notp, bool substr)
{	return string()->memberP(subobj, notp, substr);
}
NodeP lisMember   (PairPP arg)
{	return arg[2]? 
		arg[2]->memberP(arg[1], false, false) 
		: _False;
}
NodeP lisSubstring(PairPP arg)
{	return arg[2]? 
		arg[2]->memberP(arg[1], false,  true)
		: _False;
}
NodeP lMember     (PairPP arg)
{	return arg[2]? 
		arg[2]->memberP(arg[1], true, false)
		: _False;
}

NodeP lMemberCount(PairPP arg)
{	if (arg[2] && arg[2]->memberP(arg[1], false, false)==_True)
		return new Int(1);
	return new Int(0);
}

NodeP lSubStringCount(PairPP arg)
{	if (arg[2] && arg[2]->memberP(arg[1], false, true)==_True)
		return new Int(1);
	return new Int(0);
}

NodeP isSubList(PairP sublist, PairP list)
{
	if (!sublist)
		return _True;

	if (!sublist->is.list)
	{	error(BAD_DATA, sublist, 2);
		return Unbound;
	}
	while (list && !throwing) 
	{
		PairP sub=sublist, savelist=list;
		while (list && sub)
		{	NodeP f=list->first();
			NodeP sf=sub->first();
			if (!f && sf)
				break;
			if (f && !f->equalP(sf))
				break;
			next(list);
			next(sub);
			if (checkThrowing()) break;
		}
		if (checkThrowing()) break;
		if (!list || !sub)
			return _True;
		list=savelist;
		next(list);
	}
	return _False;
}

NodeP lisSubList(PairPP arg)
{	return arg[2]? 
		isSubList(arg[1], arg[2])
		: _False;
}

NodeP lreplace(PairPP arg)
{
	StringP 
		substrp=arg[1]->a_string(1),
		newstrp=arg[2]->a_string(2),
		strp=arg[3]->a_string(3);

	if (!throwing)
	{
/*		std::string str(strp->ptr()),
			substr(substrp->ptr()),
			newstr(newstrp->ptr());

		std::string::size_type pos=0;
		do 
		{	pos=str.find(substr, pos);
			if (pos!=std::string::npos)
			{	if (pos)
				{	str.erase(pos, substr.length());
					str.insert(pos, newstr);

					pos+=newstr.length();
				}
				else
					pos++;
			}
		} while (pos!=std::string::npos);

*/		substrp=new String(substrp->ptr(), 0, substrp->count(), STRING, String::copy);
		newstrp=new String(newstrp->ptr(), 0, newstrp->count(), STRING, String::copy);
		   strp=new String(   strp->ptr(), 0,    strp->count(), STRING, String::copy);
		if throwing return Unbound;
		wxString str(strp->ptr());
		str.Replace(substrp->ptr(), newstrp->ptr(), true);
	   strp=String::make(charP(str.c_str()), 0, strlen(str), STRING, String::copy);
		return strp;
	}
	return Unbound;
}

NodeP liscircular(PairPP arg)
{
	if (exist(2))
		return Node::boolnode(arg[1]->circular(arg[2]));
	else
		return Node::boolnode(arg[1]->circular());
}

#define ITEM_if_index_islist							\
	if (index->islist() && result->islist())		 \
	{	PairP i=PairP(index), r=PairP(result);		  \
		while (i && r)										   \
		{	NodeP ret=item(i->first(), r->first());    \
			if (!throwing) r->setfirst( ret );		     \
			next(i);											      \
			next(r);											       \
		}														        \
		if (!i && !r && !throwing) return result;	         \
	}

NodeP   UInt8::item(NodeP index, NodeP result)
{	return string()->item(index,result);
}
NodeP   String::item(NodeP index, NodeP result)
{	ITEM_if_index_islist
	else if (index->type==INT_)
		return item(IntP(index)->int_);
	error(BAD_DATA, index); return Unbound;
}
NodeP IntArray::item(NodeP index, NodeP result)
{	if (index->type==INT_)
	{	int i=IntP(index)->int_-_origin;
		if (i >= 0  &&  i < _length) 
			return new Int(_data[i]);
	}
	else if (index->type==INTARRAY)
	{	IntArrayP idx=IntArrayP(index);
		int l=idx->length();
		IntArrayP r=new IntArray(l);
		if throwing return Unbound;
		intP d=r->data();
		intP i=idx->data();
		for (;  l;  l--)
		{	*d++=_data[(*i++)-1];
		}
		return r;
	}
	else ITEM_if_index_islist
	error(BAD_DATA, index); return Unbound;
}
NodeP Int16Array::item(NodeP index, NodeP result)
{	ITEM_if_index_islist
	else if (index->type==INT_)
	{	int i=IntP(index)->int_-_origin;
		if (i >= 0  &&  i < _length) 
			return new Int16(_data[i]);
	}
	error(BAD_DATA, index); return Unbound;
}
NodeP FloatArray::item(NodeP index, NodeP result)
{
	if (index->type==INT_)
	{	int i=IntP(index)->int_-_origin;
		if (i >= 0  &&  i < _length) 
			return new Float(_data[i]);
	}
	else if (index->type==INTARRAY)
	{	IntArrayP idx=IntArrayP(index);
		int l=idx->length();
		FloatArrayP r=new FloatArray(l);
		if throwing return Unbound;
		doubleP d=r->data();
		intP i=idx->data();
		for (;  l;  l--)
		{	if (*i > length() || *i < origin())
			{	error(BAD_DATA, index, 2); return Unbound;
			}
			*d++=_data[(*i++)-origin()];
		}
		return r;
	}
	else if (index->type==ARRAY)
	{	ArrayP idx=ArrayP(index);
		int l=idx->length();
		FloatArrayP r=new FloatArray(l);
		if throwing return Unbound;
		doubleP d=r->data();
		NodePP i=idx->data();
		for (;  l;  l--)
		{	*d++=item(*i++, 0)->getnumber();
		}
		return r;
	}
	else ITEM_if_index_islist
	else if (index->is.string)
		return item(StringP(index)->number(), 0);
	error(BAD_DATA, index); return Unbound;
}
NodeP lItem(PairPP arg) // _item index obj 
{
	NodeP index=arg[1], obj=arg[2], result=0;
	if (!index)
	{	error(BAD_DATA, arg[1], 1);
		return Unbound;
	}
	if (index->isstring()) index=arg[1]->a_number(1);
//	if (exist(3)) result = arg[3];

	if ((!obj || obj==_Null_Word) && !throwing) 
		error(BAD_DATA, obj);

	if (!throwing) return obj->item(index, result);
	return Unbound;
}


NodeP lisNameInTable(PairPP arg) // NameInTable? name table
{
	NodeP index=arg[1];
	TableP table=arg[2]->a_table(2);
	if throwing return Unbound;
	ObjectP obj=table->find(index->string());
	return Node::boolnode(obj != NodeP(0));
}

NodeP ldot(PairPP arg) // _dot( obj, index )
{
//	PairP obj=arg[1];	arg[1] = arg[2];	arg[2]=obj;
//	return _Item(arg);
	NodeP obj=arg[1], index=arg[2], result=0;
//	if (index->isstring() && index->numberP()) index=index->a_number();
	if (!index)
	{	//error(BAD_DATA, arg[1], 1);
		return 0;//Unbound;
	}
	if (exist(3)) result = arg[3];

	while ((!obj || obj==_Null_Word) && !throwing) 
		obj=error(BAD_DATA, obj);

	if (obj && !throwing) 
		return obj->item(index, result);
	return Unbound;
}

NodeP lpick(PairPP arg)
{
	NodeP obj=arg[1];
	if (!obj) 
		return 0;

	int c=obj->count();
	if (obj->islist() || obj->isarray())
		return obj->item(Int::random(c));
	else if (obj->isstring())
		return obj->item(Int::random(c)+1);
	else if (obj->type==OBJECT)
		return ObjectP(obj)->name()->item(Int::random(c)+1);
	return Unbound;
}

NodeP lmdItem(PairPP arg) // mdItem( indexlist, mdobj )
{
	PairP index=arg[1]->a_list(1);
	NodeP obj=arg[2];
	if throwing return Unbound;

	if (!index)
		return obj;
	if (!obj)
	{	error(BAD_DATA, obj, 2);
		return Unbound;
	}
	return obj->mdItem(index);
}

NodeP    UInt8::bititem(NodeP index)
{	int i=index->a_int(1);
	if throwing return Unbound;
	if (i<0 || i >= int(sizeof(unsigned char))<<3)
	{	error(BAD_DATA, index);

		return Unbound;
	}
	return boolnode((int_>>i) & 1);
}

NodeP lBitItem(PairPP arg) // _item( index, obj )
{
	NodeP index=arg[1], obj=arg[2];
	if (index->isstring()) index=arg[1]->a_number(1);

	while ((!obj || obj==_Null_Word) && !throwing) 
		obj=error(BAD_DATA, obj, 2);

	if (!throwing) return obj->bititem(index);
	return Unbound;
}

NodeP lItems(PairPP arg) // _item( index, obj )
{
	NodeP start=arg[1], end=arg[2], obj=arg[3];
	if (start->isstring()) start=start->a_number(1);
	if (end  ->isstring()) end  =end  ->a_number(2);

	while ((!start || !end || !obj || obj==_Null_Word) && !throwing) 
		obj=error(BAD_DATA, obj, 3);

	if (!throwing) return obj->items(start, end);
	return Unbound;
}

NodeP UInt8::setitem(NodeP index, NodeP newitem, bool safe)
{	int i=index->a_int(1);
	if throwing return Unbound;
	if (newitem && newitem->type==OBJECT)
	{	int bit=newitem->a_bool(3);
		if (!throwing)
		{	if (i<0 || i >= int(sizeof(unsigned char))<<3)
			{	error(BAD_DATA, index);
				return Unbound;
			}
			if (bit)
				int_|=(1<<i);
			else
				int_&=~(1<<i);
		}
	}
	else
	{	StringP num=string();
		num->setitem(index, newitem, safe);
		int_=int(num->getnumber());
	}
	return Unbound;
}
NodeP setItemHelper(PairPP arg, bool safe) 
{
	NodeP  index =arg[1];
	NodeP   obj  =arg[2];
	NodeP newitem=arg[3];

	if (!index)
		error(BAD_DATA, index);
	else
	{	if (obj)
		{	NodeP i=obj->setitem(index, newitem, safe);
			if (!throwing)
				return i;
		}else
			error(BAD_DATA, obj, 2);
	}
	return Unbound;
}

NodeP lsetItem(PairPP arg) {return setItemHelper(arg, true);}
NodeP l_setItem(PairPP arg) {return setItemHelper(arg, false);}

NodeP lmdSetItem(PairPP arg) 
{
	NodeP indexlist=arg[1];
	NodeP   obj  =arg[2];
	NodeP newitem=arg[3];

	if (!indexlist)
		error(BAD_DATA, indexlist);
	else
	{	if (obj)
		{	obj=obj->mdItem(indexlist->butLast());
			if (!obj)
			{	error(BAD_DATA, obj, 2); return Unbound;
			}
			NodeP i=obj->setitem(indexlist->last(), newitem, false);
			if (!throwing)
				return i;
		}else
			error(BAD_DATA, obj, 2);
	}
	return Unbound;
}

NodeP lsetItems(PairPP arg) 
{
	NodeP  start  =arg[1];
	NodeP   obj   =arg[2];
	NodeP newitems=arg[3];

	if (!start)
		error(BAD_DATA, start);
	else
	{	if (obj)
		{	NodeP i=obj->setitems(start, newitems);
			if (!throwing)
				return i;
		}else
			error(BAD_DATA, obj, 2);
	}
	return Unbound;
}

NodeP lremoveItem(PairPP arg) 
{
	NodeP index =arg[1];
	NodeP  obj  =arg[2];

	if (!index)
		error(BAD_DATA, index);
	else
	{	if (!obj)
			error(BAD_DATA, obj, 2);
		else
			obj->removeitem(index);
	}
	return Unbound;
}

NodeP lreverse(PairPP arg)
{
	if (!arg[1])
		return 0;

	return arg[1]->reverse();
}

NodeP lrotate(PairPP arg) 
{
	IntP places=arg[2]->a_integer(2);
	if (throwing) return Unbound;
	if (!arg[1]) return 0;
	return arg[1]->rotate( places->int_ );
}

NodeP lshuffle(PairPP arg)
{
	NodeP thing=arg[1];
	if (thing)
		return thing->shuffle();
	return 0;
}

NodeP lremove(PairPP arg)
{
	NodeP thing=arg[1], from=arg[2];
	if (!from)
		return 0;
	return from->remove(thing);
}

NodeP WindowPair::destructiveRemove(NodeP thing)
{
	WindowPairP list=this, last=0, result=list;
	while (list)
	{	while (list && (list->first()==thing || !list->first()))
		{	if (last)
				last->settail(list->tail());
			else
				result=WindowPairP(list->tail());
			list=WindowPairP(list->tail());
		}
		last=list;
		if (list)
			list=WindowPairP(list->tail());
	}
	return result;
}
NodeP ldestructiveRemove(PairPP arg)
{
	NodeP thing=arg[1], from=arg[2];
	if (!from)
		return 0;
	return from->destructiveRemove(thing);
}

NodeP lremdup(PairPP arg)
{
	if (!arg[1])
		return 0;
	return arg[1]->remdup();
}

PairP UInt8::list() {return string()->list();}

NodeP ltoList(PairPP arg) {return arg[1]->list();}

NodeP lArray(PairPP arg) 
{
	IntP length=0;
	int origin;

	if (exist(2))
		origin = arg[2]->a_int(2);
	else 
		origin=1;
	
	if (!throwing) 
	{	if (!arg[1])
		{	return new Array(1, origin);
		}
		if (arg[1]->number() != Unbound)
		{	length = arg[1]->a_pos_int(1);
			ArrayP array = new Array(length->int_, origin);
			return array;
		}else
			 return arg[1]->array(origin);
	}
	return Unbound;
}

NodeP lIntArray(PairPP arg) 
{
	IntP length=0;
	int origin;

	if (exist(2))
		origin = arg[2]->a_int(2);
	else 
		origin=1;
	
	if (!throwing) 
	{	if (arg[1]->number() != Unbound)
		{	length = arg[1]->a_pos_int(1);
			IntArrayP array = new IntArray(length->int_, origin);
			return array;

		}else
			return arg[1]->intarray(origin);
	}
	return Unbound;
}


NodeP lInt16Array(PairPP arg) 
{
	IntP length=0;
	int origin;

	if (exist(2))
		origin = arg[2]->a_int(2);
	else 
		origin=1;
	
	if (!throwing) 
	{	if (arg[1]->number() != Unbound)
		{	length = arg[1]->a_pos_int(1);
			Int16ArrayP array = new Int16Array(length->int_, origin);
			return array;
		}else
			return arg[1]->int16array(origin);
	}
	return Unbound;
}

NodeP lFloatArray(PairPP arg) 
{
	IntP length=0;
	int origin;

	if (exist(2))
		origin = arg[2]->a_int(2);
	else 
		origin=1;
	
	if (!throwing) 
	{	if (arg[1]->number() != Unbound)
		{	length = arg[1]->a_pos_int(1);
			FloatArrayP array = new FloatArray(length->int_, origin);
			return array;
		}else
			return arg[1]->floatarray(origin);
	}
	return Unbound;
}

NodeP lBitmap(PairPP arg)
{
	NodeP data=arg[1];
	IntP width=arg[2]->a_pos_int(2);
	if (data && !throwing)
	{	return data->bitmap(width->int_);
	}
	return Unbound;
}

NodeP lTable(PairPP arg)
{
	if (!arg[1])
		return new Table(31);
	if (arg[1]->number() != Unbound)
	{	int size=arg[1]->a_int(1);
		if throwing return Unbound;
		return new Table(size);
	}
	return arg[1]->table();
}

NodeP lStruct(PairPP arg)
{
	PairP data=arg[1]->a_list(1);
	if throwing return Unbound;
	return new Struct(data);
}

NodeP lmerge(PairPP arg)
{
	if ((arg[1] && arg[1]->type==TABLE)
	 && (arg[2] && arg[2]->type==TABLE))
	{	TableP a=TableP(arg[1]), b=TableP(arg[2]);
		return a->merge(b);
	}
	PairP 
		a=arg[1]->a_list(1),
		b=arg[2]->a_list(2);
	if throwing return Unbound;
	if (a && b && (a->circular() || b->circular() || a->circular(b)))
	{	error(BAD_DATA, a);
	}
	return a->merge(b);
}

NodeP lmergePairs(PairPP arg)
{
	PairP a=arg[1]->a_list(1);
	if throwing return Unbound;
	a->mergePairs();
	return a;
}

NodeP ltoListList(PairPP arg)
{
	PairP a=arg[1]->a_list(1);
	if throwing return Unbound;
	a->toListList();
	return a;
}

NodeP lmergeSort(PairPP arg)
{
	PairP a=arg[1]->a_list(1);
	if throwing return Unbound;
	return a->mergeSort();
}

NodeP lmergeSortInPlace(PairPP arg)
{
	PairP a=arg[1]->a_list(1);
	if throwing return Unbound;
	a->mergeSortInPlace();
	return Unbound;
}

NodeP lcombSortInPlace(PairPP arg)
{
	enum Params {_array=1};
	if (!arg[_array])
		return 0;
	NodeP a=arg[_array];
	a->combSortInPlace();
	return Unbound;
}

NodeP lcombSort(PairPP arg)
{
	enum Params {_node=1};
	if (!arg[_node])
		return 0;
	return arg[_node]->combSort();
}

NodeP lgenSym(PairPP)
{
	char sym[256];
	Int::genSymNr++;
	sprintf(sym, "g%d", Int::genSymNr);
	return new String(sym, 0, strlen(sym), STRING, String::copy);
}

NodeP lsetGenSym(PairPP arg)
{
	int i=arg[1]->a_int(1);
	if throwing return Unbound;
	Int::genSymNr=i;
	return Unbound;
}

NodeP lForm(PairPP arg) 
{
	enum Params {_num=1, _width, _precision, _alignment=_precision};
	int  width=arg[_width]->a_int(_width), precision=0;
	if (!arg[_num])
		error(BAD_DATA, arg[_num]);
	if throwing return Unbound;
	if (arg[_num]->numberP())
	{	double num=arg[_num]->a_float(_num);
		if throwing return Unbound;
		wxString result;
		if (exist(_precision))
			precision = arg[_precision]->a_int(_precision);
		if (width >= 1000000) width=999999;
		if (width >= 0)
			result.Printf("%*.*f", width, precision, num);

		return String::make(charP(result.c_str()), 0, result.Length(), STRING, String::copy);
	}else
	{	StringP str=new String(arg[_num]->string());
		int alignment=0;
		if (exist(_alignment))
			alignment=arg[_alignment]->a_int(_alignment);
		if throwing return Unbound;
		wxString s=str->ptr();
		s.Truncate(width);
		int n=width-s.length();
		if (n > 0)
			s.Append(' ', n);
		return new String(s);
	}
}

NodeP ltoInt(PairPP arg)
{
	StringP str=arg[1]->a_string(1);
	if throwing return Unbound;
	int base=arg[2]->a_int(2);
	if throwing return Unbound;
	if (base > 35 || base < 2)
	{	error(BAD_DATA, arg[2], 2); return Unbound;
	}
	wxString s(str->ptr());
	long i;
	if (s.ToLong(&i, base))
		return new Int(i);
	error(BAD_DATA, arg[1], 1); return Unbound;
}

NodeP lLineColumn(PairPP arg)
{
	if (!arg[1])
		return new Int(0);
	LineP line=arg[1]->a_line(1);
	if throwing return Unbound;
	return new Int(line->col);
}

NodeP lLineTColumn(PairPP arg)
{
	if (!arg[1])
		return new Int(0);
	LineP line=arg[1]->a_line(1);
	if throwing return Unbound;
	return new Int(line->tcol);
}

NodeP lLineRow(PairPP arg)
{
	if (!arg[1])
		return new Int(0);
	LineP line=arg[1]->a_line(1);
	if throwing return Unbound;
	return new Int(line->row);
}

