//___________________________________________________________________
//
//                         Class LogoApp
//___________________________________________________________________

extern Function 
	lhideLogoMainFrame, lshowLogoMainFrame,
	lhideLogoConsolew, lshowLogoConsolew,
	lrecreateGUI, lLogoInstance, 
	lyield, lcountThreads, lThreads, lkillThread, 
	lsetErallOnRun, lsetFocusOnRun, lsetShowGuiOnError,
	lwait, lwaitMS, lwaituS,
	lTimeFine, lTimeMilli, lTimeu, lTimeuRes, lTimerFreq, lTime,
	lMIPS, 
	lSound, lSounds, lSoundsStop, lSoundsFinished, 
	lTone , lTones , lTonesStop , lTonesFinished ,
	lplayWave, lplayWaveFast;

class History;
class ConsoleFrame;
class Consolew;
class Graph;
class StackVars;
class Vars;
class Calls;
class MainFrame;
class wxHelpController;
class wxConfig;
class wxNotebook;
class EdFrame;
class MemoryWindow;
class MemoryFrame;
class Server;
class Aui;
class wxAuiManager;

enum AppAction
{	NOP,
	EXIT_LOGO,
	EXIT_DELAYED,
	RECREATE_GUI,
	HIDE_MAIN,
	ON_RUN,
	ON_STEP,
	ON_STEP_OVER,
	ON_REVERSE_STEP,
	ON_REVERSE_STEP_OVER,
	ON_LOAD,
	PAUSE,
	CONTROL_PAUSE,
	LOAD_NODES,
	SAVE_NODES,
};

class LogoApp : public wxApp
{
	public:
		AppAction action;
		bool saved, 
			mainShown, graphShown, consoleShown, 
			stackvarsShown, varsShown, 
			callsShown, editorShown, memoryShown, 
			doubleBuffer, 
			playOnSwap, erallOnRun, setFocusOnRun, autoloadEdit,
			consoleAutosave, pictureAutosave, nodesAutosave,
			showGuiOnError;
		int caretpos, 
			memblockx, memblocky, memborder,
			memposx, memposy, memsizex, memsizey, 
			ringBufferSize, editFontSize,
			consoleHSCROLL;
		wxPoint max;

		charP heapReserve;
		Aui *aui;
		History *history;
		MainFrame *mainFrame;
		Graph *graph;
		GraphNodeP graphNode;
		ConsoleFrame *consoleFrame;
		Console *console;
		StackVars *stackvars;
		Vars *vars;
		Calls *calls;
		EdFrame *edFrame;
		wxHelpController *help;
		MemoryWindow *memoryWindow;
		MemoryFrame *memoryFrame;

		wxConfig *config;
		bool backup;
		wxString auiPerspective, 
			runDirectory, helpFileName, aUCBLogo, 
			consoleFileName, historyFileName,
			pictureFileName, nodesFileName;
		
		Server *server;

		wxLocale *locale;
		int language;
		wxString langdir;

		int osVersion, osMajor, osMinor;
		wxString osDescription;
		wxPlatformInfo *platformInfo;

		bool OnInit();
		void createGUI();
		int OnExit();
		virtual bool OnExceptionInMainLoop();
		int MainLoop();
		void destroyGUI();
		bool killThread(int id);
		void doAction();
		void prepareToDraw(void);
		void 
			mainShow(), mainHide(), saveMainConfig(),
			editorShow(), editorHide(), loadEditorFiles(), saveEditorConfig(),
			varsShow(), varsHide(),
			stackvarsShow(), stackvarsHide(),
			callsShow(), callsHide(),
			memoryShow(), memoryHide();

		bool loadLocale(int language);
		void getInstalledLanguages(wxArrayString &dirs, wxArrayString &names, wxArrayLong &identifiers);
		bool askUserForLanguage(wxArrayString &dirs, wxArrayString &names, wxArrayLong & identifiers);
		void waituS(int n);
		void Sound(double frequency, double duration);
		void Tone(double pitch, double duration);

		static void (__cdecl *callback)();
};

extern LogoApp *theApp;

#ifndef WIN32
	#define _LARGE_INTEGER long long
#endif

union TimeUnion {_LARGE_INTEGER i; __int64 u;};

#ifdef WIN32
	#define ACTION					\
		int ibx,icx,idi,isi;		\
		__asm{ mov ibx,ebx }		\
		__asm{ mov icx,ecx }		\
		__asm{ mov idi,edi }		\
		__asm{ mov isi,esi }		\
	   theApp->doAction();		\
		__asm{ mov ebx,ibx }		\
		__asm{ mov ecx,icx }		\
		__asm{ mov edi,idi }		\
		__asm{ mov esi,isi }
#else
	#define ACTION								\
		int ibx,icx,idi,isi;					\
	   asm("mov %%ebx,%0":"=m"(ibx));	\
	   asm("mov %%ecx,%0":"=m"(icx));	\
	   asm("mov %%edi,%0":"=m"(idi));	\
	   asm("mov %%esi,%0":"=m"(isi));	\
	   theApp->doAction();					\
	   asm("mov %0,%%ebx": :"m"(ibx));\
	   asm("mov %0,%%ecx": :"m"(icx));\
	   asm("mov %0,%%edi": :"m"(idi));\
	   asm("mov %0,%%esi": :"m"(isi));
#endif
