#include "stdafx.h"
#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <wx/thread.h>
#include <wx/datstrm.h>

#include "Main.h"
#include "File.h"
#include "IntToPtr_.h"
#include "PtrToInt_.h"
#include "String.h"
#include "Int.h"
#include "Object.h"
#include "Table.h"
#include "LogoObject.h"
#include "Pair.h"
#include "Procedure.h"
#include "Table.h"
#include "Mem.h"
#include "Error.h"
#include "Init.h"
#include "Thread.h"
#include "Stack.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
#else
	static char THIS_FILE[]= __FILE__;
#endif

int LogoObject::maxStringLength=65536;

void LogoObject::setname(StringP nd) {_name = nd;  check_oldyoung(nd);}
void LogoObject::setproc(ProcedureP nd) {_proc = nd;  check_oldyoung(nd);}
void LogoObject::settable(TableP nd) 
{	_table= nd;  check_oldyoung(nd);
	bit.val=(_table!=Unbound);
}
void LogoObject::setparents(PairP nd) 
{	wxASSERT(!nd || nd->islist());	
	_parents = nd;
	check_oldyoung(nd);
}

LogoObject::LogoObject(): 
Node(LOGOOBJECT), 
_name(0), _proc(0), _table(0), _parents(0)
{	flag=ObjectType(TABLE_OBJECT);
}

LogoObject::LogoObject(ObjectP proc_): 
Node(LOGOOBJECT), _parents(0)
{
	flag=ObjectType(TABLE_OBJECT);
	ThreadP th=Thread::This();
	setname(proc_->name());
	setproc(proc_->proc()); 
	setparents(th->parents);
	VarStack::ItemP var=th->varStack->base+th->frame+1;
	TableP tab=new Table(7);//(th->varStack.index-var+2)*3);
	if throwing return;
	PairP par=parents();
	while (par)
	{	TableP pt=LogoObjectP(par->first())->table();
		if (pt!=Unbound)
		{	ObjectPP itemptr=pt->base;
			for (int i=pt->size;  i;  i--)
			{	for (ObjectP obj = *itemptr++;  obj;  next(obj))
				{	ObjectP o=tab->find(obj->name());
					if (!o)
						o=tab->insert(obj->name(), THIS_FILE, __LINE__);
					if (o)
					{	o->setvar(obj->var());
						o->settable(obj->table());
						o->setparent(obj->parent());
						o->bit=obj->bit;
					}
				}
			}
		}
		next(par);
	}
	TableP pt=proc_->table();
	ObjectPP itemptr=pt->base;
	for (int i=pt->size;  i;  i--)
	{	for (ObjectP obj = *itemptr++;  obj;  next(obj))
		{	ObjectP o=tab->find(obj->name());
			if (!o)
				o=tab->insert(obj->name(), THIS_FILE, __LINE__);
			if (o)
			{	o->setvar(obj->var());
				o->settable(obj->table());
				o->setparent(obj->parent());
				o->bit=obj->bit;
			}
		}
	}	
	while (var <= th->varStack->index)
	{	ObjectP obj=tab->find(var->i.object->name());
		if (!obj)
			obj=tab->insert(var->i.object->name(), THIS_FILE, __LINE__);
		if (obj)
		{	obj->setvar(var->i.val);
			obj->settable(var->i.object->table());
			obj->setparent(var->i.object->parent());
			obj->flag=VAL_OBJECT;
		}
		var++;
	}
	settable(tab);
}

void LogoObject::inc_gc() 
{	fifo << name() << proc() << table() << parents();
}
int LogoObject::youngs() 
{	return gmark(name())+gmark(proc())+gmark(table())+gmark(parents());
}
int LogoObject::youngsPtr(PtrToInt_ &ptrToInt) 
{	return 
		gmarkPtr(name(), ptrToInt)
		+gmarkPtr(proc(), ptrToInt)
		+gmarkPtr(table(), ptrToInt)
		+gmarkPtr(parents(), ptrToInt);
}
void LogoObject::check_oldyoungs() 
{	check_oldyoung(name()); 
	check_oldyoung(proc()); 
	check_oldyoung(table()); 
	check_oldyoung(parents());
}

void LogoObject::setPtrs(IntToPtr_ &intToPtr)
{	setname   (StringP((String*)intToPtr.find(int(_name   ))));
	setproc   (ProcedureP((Procedure*)intToPtr.find(int(_proc   ))));
	settable  (TableP((Table*)intToPtr.find(int(_table  ))));
	setparents( PairP(( Pair*)intToPtr.find(int(_parents))));
}
DataInputStream &LogoObject::read(DataInputStream &istr) 
{	return istr 
		>> (int&)_name >> (int&)_proc 
		>> (int&)_table  >> (int&)_parents;
}
wxDataOutputStream &LogoObject::write(wxDataOutputStream &ostr) 
{	return ostr << type 
		<< GC_::ptrToInt->find(_name)
		<< GC_::ptrToInt->find(_proc)
		<< GC_::ptrToInt->find(_table)
		<< GC_::ptrToInt->find(_parents);
}

NodeP LogoObject::copy(PtrToInt_ &ptrToInt)
{
	LogoObjectP obj=new LogoObject();
	if throwing return Unbound;
	obj->_name=StringP(ptrToInt.find(name()));
	obj->_proc=NodeP(ptrToInt.find(proc()));
	obj->_table=TableP(ptrToInt.find(table()));
	obj->_parents=PairP(ptrToInt.find(parents()));
	obj->bit=bit;
	return obj;
}

int LogoObject::_sizeof() {return _table->_sizeof();}

StringP LogoObject::string()
{
	char textbuf[65536];
	ThreadP th=Thread::This();
	th->stringptr=textbuf;
	th->stringlen=maxStringLength-1;
	NodeP(this)->print(stringbuffer.file(), maxStringLength, 0, 0, Int::max);
	*th->stringptr='\0';
	return new String(textbuf);
}

void LogoObject::print(FILEP strm, int &width, int depth, int noBrackets, int noSpacers)
{
	table()->print(strm, width, depth-1, noBrackets-1, noSpacers-1);
}

void LogoObject::printBin(FILEP strm)
{
	int width=Int::max;
	table()->print(strm, width, -1);
}

int LogoObject::compare(NodeP nd) 
{
	if (!nd) return Node::boolerror;
	if (this==nd) return 0;
	else return table()->compare(nd);
}

NodeP LogoObject::item(int i) {error(BAD_DATA, this, 2); return Unbound;}

NodeP LogoObject::item(NodeP index, NodeP result) 
{	NodeP nd=table()->item(index, result);
	if (nd && nd->type==PROC_)
	{	ThreadP th=Thread::This();
		th->proccallInc=2;	// add 2 to asp
		return new Pair(this, nd, PROCCALL);
	}else
		return nd;
}

NodeP LogoObject::memberP(NodeP subobj, bool notp, bool substr)
{	return table()->memberP(subobj, notp, substr);
}

NodeP LogoObject::setitem(NodeP index, NodeP newitem, bool safe)
{	return table()->setitem(index, newitem, safe);
}

void LogoObject::removeitem(NodeP index)
{	table()->removeitem(index);
}

PairP LogoObject::list() {return table()->list();}

PairP LogoObject::contents(ObjectType want, ObjectType dont)
{
	return table()->contents(want, dont);
}

PairP LogoObject::contentsNameVar(ObjectType want)
{
	return table()->contentsNameVar(want);
}

NodeP LogoObject::contentsTree(	wxArrayString &namearr, 
											wxArrayString &valarr, 
											wxArrayPtrVoid &objarr, 
											ObjectType want, 
											ObjectType dont, 
											ObjectType must, 
											int &count, int level)
{
	objarr[count]=this;
	PairP contentsList=0;
	NodeP tab=Unbound;

	if (bit.table)
	{	if (bit.table_expand)
			tab=table()->contentsTree(
				namearr, valarr, objarr, want, dont, must, count, level);
		else
		{	tab=table();
			StringP str=table()->string();
			if (str  &&  str->is.string)
			{	valarr[count]=str->noFormat()->ptr();
				incContentsArrays(namearr, valarr, objarr, count);
			}
		}
	}
	if (!tab || tab==Unbound)
		return 0;
	return this;
}

bool LogoObject::expanded() 
{
	return bit.table_expand;
}

void LogoObject::setExpanded(bool state) 
{
	bit.table_expand=state;
	if (table())
		ObjectP(table())->setExpanded(state);
}

void LogoObject::setflag(ObjectType want, ObjectType flag)
{
	table()->setflag(want, flag);
}

void LogoObject::clearflag(ObjectType want, ObjectType flag)
{
	table()->clearflag(want, flag);
}

NodeP linherit(PairPP arg)
{
	if (!arg[1] || arg[1]->type!=LOGOOBJECT)
	{	error(BAD_DATA, arg[1]);	return Unbound;
	}
	LogoObjectP obj=LogoObjectP(arg[1]);
	if throwing return Unbound;
	ThreadP th=Thread::This();
	if (!th->lexufun)
	{	error(BAD_DATA, arg[1]);	return Unbound;
	}
	PairP parents=th->parents;
	if (!parents)
		parents=new Pair(obj, 0);
	else
		parents=PairP(parents->lPut(obj));
	th->parents=parents;
	return Unbound;
}

NodeP lthis(PairPP arg)
{
	ThreadP th=Thread::This();
	return th->thisobj;
}

