#ifndef LogoObject_included

#ifndef Node_included
	#include "Node.h"
#endif

class LogoObject: public Node
{
	StringP _name;
	NodeP _proc;
	TableP _table;
	PairP _parents;

	public:
		union {ObjectType flag; ObjectBits bit; int tint;};

		static int maxStringLength;
		static const LogoObject aLogoObject;

		operator_new;

			StringP name()   {return _name;}
		ProcedureP proc()   {return ProcedureP(_proc);}
		    TableP table()  {return _table;}
		     PairP parents(){return _parents;}

		void setname   (   StringP nd);
		void setproc   (ProcedureP nd);
		void settable  (    TableP nd);
		void setparents(     PairP nd);

		LogoObject();
		LogoObject(ObjectP proc_);

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();

		void setPtrs(IntToPtr_ &intToPtr);
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);

		StringP string();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		void printBin(FILEP strm);
		NodeP contentsTree(	wxArrayString &namearr, 
									wxArrayString &valarr, 
									wxArrayPtrVoid &objarr, 
									ObjectType want, 
									ObjectType dont, 
									ObjectType must, 
									int &count, int level);
		bool expandable() {return true;}
		bool expanded();
		void setExpanded(bool state);

//		OPERATORS_DECL
		int compare(NodeP nd);
		int _sizeof();
		StringP _typeof();
		NodeP item(int i);
		NodeP item(NodeP index, NodeP result);
		NodeP memberP(NodeP subobj, bool notp=false, bool substr=false);
		NodeP setitem(NodeP index, NodeP newitem, bool safe);
		void removeitem(NodeP index);
//		NodeP remove(NodeP thing);
		PairP list();
//		ArrayP array(int origin);
		PairP contents(ObjectType want, ObjectType dont);
		PairP contentsNameVar(ObjectType want);
		void setflag(ObjectType want, ObjectType newflag);
		void clearflag(ObjectType want, ObjectType newflag);

		void print();
};

#endif

#define LogoObject_included
