//___________________________________________________________________
//
//                        Class MainFrame
//___________________________________________________________________

extern Function 
	lTextScreen, lsplitScreen, lfullScreen, 
	lsetVarsSplitter, lsetCallsSplitter,
	lallFullScreen, lnotFullScreen,
	lloadLayout, lsaveLayout;

enum
{	ID_MAINFRAME,
	ID_CONSOLEFRAME,
	ID_CONSOLE,
	ID_GRAPH,
	ID_STACKVARS,
	ID_VARS,
	ID_CALLS,
	ID_EDITOR,
	ID_MEMORY,

	ID_CONSOLE_OPEN,
	ID_CONSOLE_SAVE,
	ID_CONSOLE_AUTOSAVE,

	ID_PICTURE_OPEN,
	ID_PICTURE_SAVE,
	ID_PICTURE_TEXT_OPEN,
	ID_PICTURE_TEXT_SAVE,
	ID_PICTURE_AUTOSAVE,

	ID_NODES_OPEN,
	ID_NODES_SAVE,
	ID_NODES_AUTOSAVE,

	ID_PAGE_SETUP,
	ID_EDIT_REPEAT,
	ID_EDIT_RESET,
	ID_EDIT_GOTO_CURSOR_LINE,
	ID_EDIT_WRAP_LINES,
	ID_EDIT_LANGUAGE,

	ID_VIEW_EDITOR,
	ID_VIEW_GRAPH,
	ID_VIEW_CONSOLE,
	ID_VIEW_STACKVARS,
	ID_VIEW_VARS,
	ID_VIEW_CALLS,
	ID_VIEW_MEMORY,

	ID_LAYOUT_LOAD1,
	ID_LAYOUT_LOAD2,
	ID_LAYOUT_LOAD3,
	ID_LAYOUT_LOAD4,
	ID_LAYOUT_LOAD5,
	ID_LAYOUT_LOAD6,
	ID_LAYOUT_LOAD7,
	ID_LAYOUT_LOAD8,
	ID_LAYOUT_LOAD9,

	ID_LAYOUT_SAVE1,
	ID_LAYOUT_SAVE2,
	ID_LAYOUT_SAVE3,
	ID_LAYOUT_SAVE4,
	ID_LAYOUT_SAVE5,
	ID_LAYOUT_SAVE6,
	ID_LAYOUT_SAVE7,
	ID_LAYOUT_SAVE8,
	ID_LAYOUT_SAVE9,
	
	ID_GOTO_LINE,
	ID_OPEN_FILE_AT_CURSOR,

	ID_MEMORY_CHANGE_BLOCK_SIZE,
	ID_MEMORY_CHANGE_BLOCK_BORDER,

	ID_CONSOLE_INSERT_MENU,
	ID_CONSOLE_INSERT,
	ID_CONSOLE_INSERT_MAX=ID_CONSOLE_INSERT+5000,
};

class Graph;
class Console;
class StackVars;
class Vars;
class Calls;
class Splitter;
class wxPrintData;
class wxPageSetupData;
class wxFlatMenu;
class wxFlatMenuBar;
class wxFlatMenuItem;

class MainFrame: public wxFrame
{
	public:
		bool initialized, inGraphicsMode, inSplitScreen, 
			graphAutosave, nodesAutosave;
		Splitter *splitter, *splitter2, *splitter3, *splitter4;
		wxFlatMenuItem *viewMenuConsole, *viewMenuEditor, *viewMenuGraph,
			*viewMenuStackVars, *viewMenuVars, *viewMenuCalls, *viewMenuMemory;
		wxFlatMenu *viewMenu, *layoutMenu;
		wxFlatMenuBar *menuBar;
		wxPanel *menu;

		MainFrame(wxWindow* parent, wxWindowID id, 
			const wxString& title, 
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = wxDEFAULT_FRAME_STYLE, 
			const wxString& name = "MainFrame",
			bool consoleAutosave = true, int caretpos = 0,
			bool pictureAutosave = true,
			bool nodesAutosave_ = true);

		~MainFrame();

		int getHeight(), getHeight2();
		double getSplitterRatio();
		void setSplitter(double y), 
			loadLayout(wxString name), 
			saveLayout(wxString name),
			fullScreen(), splitScreen(), TextScreen(),
			allFullScreen(), notFullScreen(),
			printPrompt(charP str);

		wxPrintData *printData;
		wxPageSetupData *pageSetupData;

		void 
			OnClose				(wxCloseEvent   &event),
			OnChar				(wxKeyEvent   &event),
			OnKeyDown			(wxKeyEvent   &event),
			OnExit				(wxCommandEvent &event),
			OnMove				(wxMoveEvent    &event),
			OnErase				(wxEraseEvent   &event),
			OnSetFocus			(wxFocusEvent   &event),
			OnAppAbout			(wxCommandEvent &event), 
			OnFileNew			(wxCommandEvent &event), 
			OnFileOpen			(wxCommandEvent &event),
			OnFileSave			(wxCommandEvent &event),
			OnConsoleOpen		(wxCommandEvent &event),
			OnConsoleSave		(wxCommandEvent &event),
			OnConsoleAutoSave	(wxCommandEvent &event),
			OnPictureOpen		(wxCommandEvent &event),
			OnPictureSave		(wxCommandEvent &event),
			OnPictureTextOpen	(wxCommandEvent &event),
			OnPictureTextSave	(wxCommandEvent &event),
			OnPictureAutoSave	(wxCommandEvent &event),
			OnNodesOpen			(wxCommandEvent &event),
			OnNodesSave			(wxCommandEvent &event),
			OnNodesAutoSave	(wxCommandEvent &event),
			OnEditRepeat		(wxCommandEvent &event),
			OnEditReset			(wxCommandEvent &event),
			OnEditGotoCursorLine(wxCommandEvent &event),
			OnEditWrapLines	(wxCommandEvent &event),
			OnEditChooseLanguage(wxCommandEvent &event),
			OnViewConsole		(wxCommandEvent &event),
			OnViewEditor		(wxCommandEvent &event),
			OnViewGraph			(wxCommandEvent &event), 
			OnViewStackVars	(wxCommandEvent &event),
			OnViewVars			(wxCommandEvent &event), 
			OnViewCalls			(wxCommandEvent &event),
			OnViewMemory		(wxCommandEvent &event),
			OnLayoutLoad		(wxCommandEvent &event),
			OnLayoutSave		(wxCommandEvent &event),
			OnHelp				(wxCommandEvent &event),

			OnPrint				(wxCommandEvent& event),
			OnPrintPreview		(wxCommandEvent& event),
			OnPrintSetup		(wxCommandEvent& event),
			OnPageSetup			(wxCommandEvent& event);
		DECLARE_EVENT_TABLE()
};
