#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

#ifdef WIN32
	#include <crtdbg.h>
	#include <windows.h>
#endif

#include <wx/string.h>
#include <wx/thread.h>
#include <wx/list.h>

#include <m_apm.h>

#include "Main.h"
#include "String.h"
#include "Object.h"
//#include "LogoObject.h"
#include "Line.h"
#include "List.h"
#include "Int.h"
#include "Int16.h"
#include "Int8.h"
#include "UInt8.h"
#include "Float.h"
#include "BigFloat.h"
#include "Complex.h"
#include "Array.h"
#include "IntArray.h"
#include "Int16Array.h"
#include "FloatArray.h"
#include "Bitmap.h"
#include "File.h"
#include "Table.h"
#include "Tree.h"
#include "Colon.h"
#include "Color.h"
#include "Error.h"
#include "NodePStack.h"
#include "Stack.h"
#include "Init.h"
#include "Point.h"
#include "Eval.h"
#include "Thread.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
	#define  malloc(m)       _malloc_dbg((m),        _NORMAL_BLOCK, __FILE__, __LINE__)
#endif

NodeP lBigFloatSetPrecision(PairPP arg)
{
	int precision=arg[1]->a_int(1);
	m_apm_cpp_precision(precision);
	BigFloat::deg2rad=MAPM(MM_PI)/180;
	return Unbound;
}

unsigned char UInt8::clip(double d)
{
	if (d > UInt8::max) return UInt8::max;
	if (d < 0         ) return 0;
	return (unsigned char)(d);
}

unsigned char UInt8::clip(int d)
{
	if (d > UInt8::max) return UInt8::max;
	if (d < 0         ) return 0;
	return (unsigned char)(d);
}

int Int::compare(NodeP nd)
{
	if (!nd) return Node::boolerror;
	if (this==nd) return 0;

	if (nd->type==INT_) 
	{	int i=int_- IntP(nd)->int_;
		return i==0 ?  0  :  (i > 0 ?  1 : -1);
	}
	else if (nd->type==FLOAT_) 
	{	double f = int_- FloatP(nd)->float_;
		return f==0.0 ?  0  :  (f > 0.0 ?  1 : -1);
	}
	else if (nd->type==COMPLEX) 
	{	double f = int_- ComplexdP(nd)->Norm()->getnumber();
		return f==0.0 ?  0  :  (f > 0.0 ?  1 : -1);
	}
	else if (nd->type==NINT16) 
	{	int i=int_- Int16P(nd)->int_;
		return i==0 ?  0  :  (i > 0 ?  1 : -1);
	}
	else if (nd->type==NINT8) 
	{	int i=int_- Int8P(nd)->int_;
		return i==0 ?  0  :  (i > 0 ?  1 : -1);
	}
	else if (nd->type==NUINT8) 
	{	int i=int_- UInt8P(nd)->int_;
		return i==0 ?  0  :  (i > 0 ?  1 : -1);
	}
	else if (nd->type==BIGFLOAT) 
	{	MAPM f = int_- BigFloatP(nd)->float_;

		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	NodeP b=0;
	if (nd->type==OBJECT)
		b = ObjectP(nd)->name()->number();
	else
		b = nd->number();

	if (b != Unbound) 
		return compare(b);
	else
		return string()->compare(nd);
}
int Int16::compare(NodeP nd)
{
	if (!nd) return Node::boolerror;
	if (this==nd) return 0;

	if (nd->type==INT_) 
	{	int i=int_- IntP(nd)->int_;
		return i==0 ?  0  :  (i > 0 ?  1 : -1);
	}
	else if (nd->type==FLOAT_) 
	{	double f = int_- FloatP(nd)->float_;
		return f==0.0 ?  0  :  (f > 0.0 ?  1 : -1);
	}
	else if (nd->type==COMPLEX) 
	{	double f = int_- ComplexdP(nd)->Norm()->getnumber();
		return f==0.0 ?  0  :  (f > 0.0 ?  1 : -1);
	}
	else if (nd->type==NINT16) 
	{	int i=int_- Int16P(nd)->int_;
		return i==0 ?  0  :  (i > 0 ?  1 : -1);
	}
	else if (nd->type==NINT8) 
	{	int i=int_- Int8P(nd)->int_;
		return i==0 ?  0  :  (i > 0 ?  1 : -1);
	}
	else if (nd->type==NUINT8) 
	{	int i=int_- UInt8P(nd)->int_;
		return i==0 ?  0  :  (i > 0 ?  1 : -1);
	}
	else if (nd->type==BIGFLOAT) 
	{	MAPM f = int_- BigFloatP(nd)->float_;
		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	NodeP b=0;
	if (nd->type==OBJECT)
		b = ObjectP(nd)->name()->number();
	else
		b = nd->number();

	if (b != Unbound) 
		return compare(b);
	else
		return string()->compare(nd);
}

int Int8::compare(NodeP nd)
{
	if (!nd) return Node::boolerror;
	if (this==nd) return 0;

	if (nd->type==INT_) 
	{	int i=int_- IntP(nd)->int_;
		return i==0 ?  0  :  (i > 0 ?  1 : -1);
	}


	else if (nd->type==FLOAT_) 
	{	double f = int_- FloatP(nd)->float_;
		return f==0.0 ?  0  :  (f > 0.0 ?  1 : -1);
	}
	else if (nd->type==COMPLEX) 
	{	double f = int_- ComplexdP(nd)->Norm()->getnumber();
		return f==0.0 ?  0  :  (f > 0.0 ?  1 : -1);
	}
	else if (nd->type==NINT16) 
	{	int i=int_- Int16P(nd)->int_;
		return i==0 ?  0  :  (i > 0 ?  1 : -1);
	}
	else if (nd->type==NINT8) 
	{	int i=int_- Int8P(nd)->int_;
		return i==0 ?  0  :  (i > 0 ?  1 : -1);
	}
	else if (nd->type==NUINT8) 
	{	int i=int_- UInt8P(nd)->int_;
		return i==0 ?  0  :  (i > 0 ?  1 : -1);
	}
	else if (nd->type==BIGFLOAT) 
	{	MAPM f = int_- BigFloatP(nd)->float_;
		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	NodeP b=0;
	if (nd->type==OBJECT)
		b = ObjectP(nd)->name()->number();
	else
		b = nd->number();

	if (b != Unbound) 
		return compare(b);
	else
		return string()->compare(nd);
}
int UInt8::compare(NodeP nd)
{
	if (!nd) return Node::boolerror;
	if (this==nd) return 0;

	if (nd->type==INT_) 
	{	int i=int_- IntP(nd)->int_;
		return i==0 ?  0  :  (i > 0 ?  1 : -1);
	}
	else if (nd->type==FLOAT_) 
	{	double f = int_- FloatP(nd)->float_;
		return f==0.0 ?  0  :  (f > 0.0 ?  1 : -1);
	}
	else if (nd->type==COMPLEX) 
	{	double f = int_- ComplexdP(nd)->Norm()->getnumber();
		return f==0.0 ?  0  :  (f > 0.0 ?  1 : -1);
	}
	else if (nd->type==NINT16) 
	{	int i=int_- Int16P(nd)->int_;
		return i==0 ?  0  :  (i > 0 ?  1 : -1);

	}
	else if (nd->type==NINT8) 
	{	int i=int_- Int8P(nd)->int_;
		return i==0 ?  0  :  (i > 0 ?  1 : -1);
	}
	else if (nd->type==NUINT8) 
	{	int i=int_- UInt8P(nd)->int_;
		return i==0 ?  0  :  (i > 0 ?  1 : -1);
	}
	else if (nd->type==BIGFLOAT) 
	{	MAPM f = int_- BigFloatP(nd)->float_;
		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	NodeP b=0;
	if (nd->type==OBJECT)
		b = ObjectP(nd)->name()->number();
	else
		b = nd->number();

	if (b != Unbound) 
		return compare(b);
	else
		return string()->compare(nd);
}
int Float::compare(NodeP nd)
{
	if (!nd) return Node::boolerror;
	if (this==nd) return 0;

	if (nd->type==INT_) 
	{	double f = float_- IntP(nd)->int_;
		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	else if (nd->type==FLOAT_) 
	{	double f = float_- FloatP(nd)->float_;
		return f==0.0 ?  0  :  (f > 0.0 ?  1 : -1);
	}
	else if (nd->type==COMPLEX) 
	{	double f = float_- ComplexdP(nd)->Norm()->getnumber();
		return f==0.0 ?  0  :  (f > 0.0 ?  1 : -1);
	}
	else if (nd->type==NINT16) 
	{	double f = float_- Int16P(nd)->int_;
		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	else if (nd->type==NINT8) 
	{	double f = float_- Int8P(nd)->int_;
		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	else if (nd->type==NUINT8) 
	{	double f = float_- UInt8P(nd)->int_;
		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	else if (nd->type==BIGFLOAT) 
	{	MAPM f = float_- BigFloatP(nd)->float_;
		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	NodeP b;
	if (nd->type==OBJECT)

		b = ObjectP(nd)->name()->number();
	else
		b = nd->number();

	if (b != Unbound) 
		return compare(b);
	else
		return string()->compare(nd);
}
int Complexd::compare(NodeP nd)
{
	if (!nd) return Node::boolerror;
	if (this==nd) return 0;

	if (nd->type==INT_) 
	{	double f = Norm()->getnumber()- IntP(nd)->int_;
		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	else if (nd->type==FLOAT_) 
	{	double f = Norm()->getnumber()- FloatP(nd)->float_;
		return f==0.0 ?  0  :  (f > 0.0 ?  1 : -1);
	}
	else if (nd->type==COMPLEX) 
	{	double f = Norm()->getnumber()-ComplexdP(nd)->Norm()->getnumber();
		return f==0.0 ?  0  :  (f > 0.0 ?  1 : -1);
	}
	else if (nd->type==NINT16) 
	{	double f = Norm()->getnumber()- Int16P(nd)->int_;
		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	else if (nd->type==NINT8) 
	{	double f = Norm()->getnumber()- Int8P(nd)->int_;
		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	else if (nd->type==NUINT8) 
	{	double f = Norm()->getnumber()- UInt8P(nd)->int_;
		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	else if (nd->type==BIGFLOAT) 
	{	return Node::boolerror;
	}
	NodeP b=0;
	if (nd->type==OBJECT)
		b = ObjectP(nd)->name()->number();
	else
		b = nd->number();

	if (b != Unbound) 
		return compare(b);
	else
		return Node::boolerror;
}
int BigFloat::compare(NodeP nd)
{
	if (!nd) return Node::boolerror;
	if (this==nd) return 0;

	if (nd->type==INT_) 
	{	MAPM f = float_- IntP(nd)->int_;
		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	else if (nd->type==FLOAT_) 
	{	MAPM f = float_- FloatP(nd)->float_;
		return f==0.0 ?  0  :  (f > 0.0 ?  1 : -1);
	}
	else if (nd->type==COMPLEX) 
		return Node::boolerror;
	else if (nd->type==NINT16) 
	{	MAPM f = float_- Int16P(nd)->int_;
		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	else if (nd->type==NINT8) 
	{	MAPM f = float_- Int8P(nd)->int_;
		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	else if (nd->type==NUINT8) 
	{	MAPM f = float_- UInt8P(nd)->int_;
		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	else if (nd->type==BIGFLOAT) 
	{	MAPM f = float_- BigFloatP(nd)->float_;
		return f==0 ?  0  :  (f > 0 ?  1 : -1);
	}
	NodeP b;
	if (nd->type==OBJECT)

		b = ObjectP(nd)->name()->number();
	else
		b = nd->number();

	if (b != Unbound) 
		return compare(b);
	else
		return string()->compare(nd);
}

NodeP lisbefore(PairPP arg) 
{
	StringP 
		a = arg[1]->a_string(1),
		b = arg[2]->a_string(2);
	if (!a)
		return Unbound;
	return Node::boolnode( a->compare(b) < 0 );
}

NodeP lisless(PairPP arg) 
{
	NodeP 
		a=arg[1],
		b=arg[2];
	if (!b)
	{	error(BAD_DATA, b, 2);
		return Unbound;
	}
	if (b->is.number)
	{	int tf=b->compare(a);
		Node::checkboolerror(tf,a,b);
		if (!throwing)
			return Node::boolnode( tf > 0 );
		return Unbound;
	}
	if (!a)
		return Unbound;
	int tf=a->compare(b);
	Node::checkboolerror(tf,a,b);
	if (!throwing)
		return Node::boolnode( tf < 0 );
	return Unbound;
}

NodeP lisgreater(PairPP arg) 
{
	NodeP 
		a=arg[1],
		b=arg[2];
	if (!b)
	{	error(BAD_DATA, b, 2);
		return Unbound;
	}
	if (b->is.number)
	{	int tf=b->compare(a);
		Node::checkboolerror(tf,a,b);
		if (!throwing)
			return Node::boolnode( tf < 0 );
		return Unbound;
	}
	if (!a)
		return Unbound;
	int tf=a->compare(b);
	Node::checkboolerror(tf,a,b);
	if (!throwing)
		return Node::boolnode( tf > 0 );
	return Unbound;
}

NodeP lislessEqual(PairPP arg) 
{
	NodeP 
		a=arg[1],
		b=arg[2];
	if (!b)
	{	error(BAD_DATA, b, 2);
		return Unbound;
	}
	if (b->is.number)
	{	int tf=b->compare(a);
		Node::checkboolerror(tf,a,b);
		if (!throwing)
			return Node::boolnode( tf >= 0 );
		return Unbound;
	}
	if (!a)
		return Unbound;
	int tf=a->compare(b);
	Node::checkboolerror(tf,a,b);
	if (!throwing)
		return Node::boolnode( tf <= 0 );
	return Unbound;
}

NodeP lisgreaterEqual(PairPP arg) 
{
	NodeP 
		a=arg[1],
		b=arg[2];
	if (!b)
	{	error(BAD_DATA, b, 2);
		return Unbound;
	}
	if (b->is.number)
	{	int tf=b->compare(a);
		Node::checkboolerror(tf,a,b);
		if (!throwing)
			return Node::boolnode( tf <= 0 );
		return Unbound;
	}
	if (!a)
		return Unbound;
	int tf=a->compare(b);
	Node::checkboolerror(tf,a,b);
	if (!throwing)
		return Node::boolnode( tf >= 0 );
	return Unbound;
}

NodeP l_eq    (PairPP arg) {return Node::boolnode(arg[1]==arg[2]);}
NodeP lisequal(PairPP arg) 
{	return 
		arg[1]? Node::boolnode( arg[1]->equalP(arg[2])) 
			:	(arg[2]?  _False 
					:	_True);
}
NodeP lisunequal(PairPP arg) 
{	return 
		arg[1] ?  Node::boolnode(!arg[1]->equalP(arg[2]))
			:	(arg[2] ?  _True 
					:	_False);
}


NodeP lnot(PairPP arg) 
{
	int b = arg[1]->a_bool(1);
	if (!throwing) 
	{	if (b) return _False;
		else   return _True;
	}
	return Unbound;
}

NodeP land(PairPP arg) 
{
	int nr=1;
	ThreadP th=Thread::This();
	while (NodePP(arg)!=th->argStack->index && !throwing) 
	{	arg++;
		if ((*arg) && (*arg)->is.list)
		{	PairP list=(*arg)->a_runnable(nr);
			if throwing return Unbound;
			th->val_status=value_required;
			Evaluator e;
			NodeP result=e.eval(list, __begin_line, th);
			int b=result->a_bool(nr);
			if throwing return Unbound;
			if (b==0)
				return _False;
			nr++;
		}else if ((*arg)->a_bool(nr++)==0) 
			return _False;
	}
	if throwing return Unbound;
	return _True;
}

NodeP lor(PairPP arg) 
{
	int nr=1;
	ThreadP th=Thread::This();
	while (NodePP(arg)!=th->argStack->index && !throwing) 
	{	arg++;
		if ((*arg) && (*arg)->is.list)
		{	PairP list=(*arg)->a_runnable(nr);
			if throwing return Unbound;
			th->val_status=value_required;
			Evaluator e;
			NodeP result=e.eval(list, __begin_line, th);
			int b=result->a_bool(nr);
			if throwing return Unbound;
			if (b==1)
				return _True;
			nr++;
		}else if ((*arg)->a_bool(nr++)==1) 
			return _True;
	}
	if throwing return Unbound;
	return _False;
}

NodeP lFaculty(PairPP arg)
{
	IntP num = arg[1]->a_pos_int(1);
	int n=num->int_;
	if (n < 13)
	{	int f=1;
		for (int i=n;  i>0;  i--)
			f*=i;
		return new Int(f);
	}
	else if (n <21)
	{	__int64 f=1;
		for (int i=n;  i>0;  i--)
			f*=i;
		return new Float(double(f));	// rounding may occur here
	}
	else
	{	MAPM f=1;
		for (int i=n;  i>0;  i--)
			f*=i;
		return new BigFloat(f);
	}
	return Unbound;
}

NodeP lisPrime(PairPP arg)
{
	NodeP num = arg[1]->a_number(1);
	if (num->type==BIGFLOAT)
	{	MAPM n=BigFloatP(num)->float_;
		if (n==0 || n==1)
			return _False;
		MAPM maxi=sqrt(n);

		if (n % 2 == 0)
			return _False;

		for (MAPM i=3;  i <= maxi;  i+=2)
		{	if (n % i == 0)
				return _False;
			if (checkThrowing())
				return _False;
		}
		return _True;
	}
	double d=num->getnumber();
	if (d==0 || d==1)
		return _False;

	if (d < 0) d=-d;

	if (d < 4) return _True;
	
	if (d < Int::max)
	{	unsigned n=unsigned(d);
		unsigned maxi=unsigned(sqrt(double(n)));

		if (n % 2 == 0)
			return _False;

		for (unsigned i=3;  i <= maxi;  i+=2)
			if (n % i == 0)
				return _False;
	}
	else if (d < Int::i64max)
	{	__int64 n=(__int64)(num->getnumber());	// don`t wanna loose precision
		unsigned maxi=unsigned(sqrt(double(n)));

		if (n % 2 == 0)
			return _False;

		for (unsigned i=3;  i <= maxi;  i+=2)
			if (n % i == 0)
				return _False;
	}else
		error(BAD_DATA, num); // number too big for exact representation
	
	return _True;
}

NodeP lgcd(PairPP arg)
{
	int 
		a=arg[1]->a_int(1),
		b=arg[2]->a_int(2);

	if (!throwing)
	{	if (!b) return new Int(a);
		return new Int(Int::gcd(b, a % b));
	}
	return Unbound;
}

NodeP lfactorize(PairPP arg)
{
	NodeP num = arg[1]->a_number(1);
	PairP list=0;
	if (num->type==BIGFLOAT)
	{	MAPM d=BigFloatP(num)->float_;
		if (d<0) 
		{	push(list, new Int(-1));	
			if (d==-1) return list;
			d=-d;
		}
		if (d < 4)
		{	push(list, new Int(d.to_int()));
		}
		else
		{
	factorizeBig:
			MAPM maxi=ceil(sqrt(d));

			if (d % 2 == 0)
			{	push(list, new Int(2));
				if throwing return Unbound;
				d/=2;  goto factorizeBig;
			}
			for (MAPM i=3;  i <= maxi;  i+=2)
			{	if (checkThrowing())
					return Unbound;
				if (d % i == 0)
				{	push(list, new BigFloat(i));
					if throwing return Unbound;
					d/=i;  goto factorizeBig;
				}	
			}
			if (d!=1)
				push(list, new BigFloat(d));
			return list;
		}
	}
	double d = num->getnumber();

	if (d<0) 
	{	push(list, new Int(-1));	
		if throwing return Unbound;
		if (d==-1) return list;
		d=-d;
	}
	if (d < 4)
	{	push(list, new Int(int(d)));
		if throwing return Unbound;
	}
	else if (d < Int::max)
	{	int n=int(d);
factorize:
		int maxi=int(sqrt(double(n)));

		if (n % 2 == 0)
		{	push(list, new Int(2));
			if throwing return Unbound;
			n/=2;  goto factorize;
		}
		for (int i=3;  i <= maxi;  i+=2)
			if (n % i == 0)
			{	push(list, new Int(i));
				if throwing return Unbound;
				n/=i;  goto factorize;
			}	
		if (n!=1)
			push(list, new Int(n));
	}
	else if (d < Int::i64max/2)
	{	__int64 n=(__int64)(num->getnumber());	// don`t wanna loose precision
		if (n<0) 
			n=-n;
factorize64:
		int maxi=int(sqrt(double(n)));

		if ((n & 1) == 0)
		{	push(list, new Int(2));
			if throwing return Unbound;
			n/=2;  goto factorize64;
		}
		for (int i=3;  i <= maxi;  i+=2)
		{	if (n % i == 0)
			{	push(list, new Int(i));
				if throwing return Unbound;
				n/=i;  goto factorize64;
			}	
		}
		if (n!=1)
		{	if (n <= Int::max)
				  push(list, new Int(int(n)));
			else push(list, new Float(double(n)));
		}
	}else
		error(BAD_DATA, num); // number too big for exact representation
	return list;
}

double UInt8::_min(double d) {return int_ < d ?  int_ : d;}
NodeP lmin(PairPP arg)
{
	if (exist(1) && !exist(2)) 
		return new Float(arg[1]->_min(Float::max_));
	double d=Float::max_;
	ThreadP th=Thread::This();
	while (NodePP(arg)!=th->argStack->index)
	{	d = (*++arg)->_min(d);
		if throwing return Unbound;
	}
	return new Float(d);
}

double UInt8::_max(double d) {return int_ > d ?  int_ : d;}
NodeP lmax(PairPP arg)
{
	if (exist(1) && !exist(2)) 
		return new Float(arg[1]->_max(-Float::max_));
	double d=-Float::max_;
	ThreadP th=Thread::This();
	while (NodePP(arg)!=th->argStack->index)
	{	if (!*++arg)
		{	error(BAD_DATA, *arg ); return Unbound;
		}
		d = (*arg)->_max(d);
		if throwing return Unbound;
	}
	return new Float(d);
}

NodeP UInt8::Norm() {return this;}

NodeP lNorm(PairPP arg)
{
	if (!arg[1]) return 0;
	if (exist(1) && !exist(2)) 
		return arg[1]->Norm();
	double d=0;
	ThreadP th=Thread::This();
	while (NodePP(arg)!=th->argStack->index)
	{	double h = (*++arg)->Norm()->getnumber();
		if (throwing) 
			return Unbound;
		d+= h*h;
	}
	return new Float(sqrt(d));
}

NodeP lNorm3(PairPP arg)
{
	if (!arg[1]) return 0;
	if (exist(1) && !exist(2)) 
		return arg[1]->Norm3();
	double d=0;
	ThreadP th=Thread::This();
	while (NodePP(arg)!=th->argStack->index)
	{	double h = (*++arg)->Norm3()->getnumber();
		if (throwing) 
			return Unbound;
		d+= h*h;
	}
	return new Float(sqrt(d));
}

NodeP UInt8::maxNorm() {return this;}

NodeP lmaxNorm(PairPP arg)
{
	if (exist(1) && !exist(2)) 
		return arg[1]->maxNorm();
	double d=0;
	ThreadP th=Thread::This();
	while (NodePP(arg)!=th->argStack->index)
	{	double h = (*++arg)->maxNorm()->getnumber();
		if (throwing) return Unbound;
		double ha=Float::abs(h);
		if (ha > d) d = ha;

	}
	return new Float(d);
}

NodeP lresize(PairPP arg)	// test:  resize {1 2 3} 7
{
	NodeP what=arg[1];
	IntP newsize= arg[2]->a_pos_int(2);
	if (throwing) return Unbound;
	if (what) return what->resize(newsize->int_);
	else return NIL;
}

NodeP llowPassFilter(PairPP arg)
{
	NodeP what=arg[1];
	double weight=arg[2]->a_float(2);
	if (throwing) return Unbound;
	if (what) return what->lowPassFilter(weight);
	else return NIL;
}

NodeP llowPassFilter2(PairPP arg)
{
	NodeP what=arg[1];
	double weight=arg[2]->a_float(2);
	if (throwing) return Unbound;
	if (what) return what->lowPassFilter2(weight);
	else return NIL;
}

NodeP lsaturateAbove(PairPP arg)
{
	double limit=arg[1]->a_float(2);
	NodeP what=arg[2];
	if (throwing) return Unbound;
	if (what) return what->saturateAbove(limit);
	else return NIL;
}

NodeP lsaturateBelow(PairPP arg)
{
	double limit=arg[1]->a_float(2);
	NodeP what=arg[2];
	if (throwing) return Unbound;
	if (what) return what->saturateBelow(limit);
	else return NIL;
}


NodeP lreRandom(PairPP arg) 
{
	int seed=1;
	if (exist(1)) seed = arg[1]->a_int(1);
	if (!throwing) Int::seedMT(seed);
	return Unbound;
}

int Int::random(int max) 
{
	return max?  randomMT() % max  :  randomMT();
}


NodeP lrnd(PairPP) {return new Float(Float::rnd());}

NodeP liSeq(PairPP arg)
{
	int
		a=arg[1]->a_int(1),
		b=arg[2]->a_int(2);

	if (!throwing)
	{	PairP list=0;
		if (a <= b)
			for (int i=b; i>=a; i--)
				list=new Pair(new Int(i), list);
		else
			for (int i=b; i<=a; i++)
				list=new Pair(new Int(i), list);
		
		return list;
	}
	return Unbound;
}

NodeP lrSeq(PairPP arg)
{
	NodeP
		a=arg[1]->a_number(1),
		b=arg[2]->a_number(2);
	int c=arg[3]->a_int(3);

	if (!throwing)

	{	if (!c)
			return 0;

		PairP list=0;

		bool iscomplex=false;
		complexd ac,bc;

		if (a->type==INT_)
			ac=IntP(a)->int_;
		if (a->type==FLOAT_)
			ac=FloatP(a)->float_;
		if (a->type==COMPLEX)
		{	ac=ComplexdP(a)->complex_;
			iscomplex=true;
		}
		if (b->type==INT_)
			bc=IntP(b)->int_;
		if (b->type==FLOAT_)
			bc=FloatP(b)->float_;
		if (b->type==COMPLEX)
		{	bc=ComplexdP(b)->complex_;
			iscomplex=true;
		}

		if (iscomplex)
		{	complexd v=bc, d;
			if (c-1)
				d=(v-ac)/complexd(c-1);
			else
				d=1;

			for (int i=1; i<=c; i++)
			{	list=new Pair(new Complexd(v), list);
				if throwing return Unbound;
				v-=d;
			}
		}else
		{	double v=bc.real(), d;
			if (c-1)
				d=(v-ac.real())/(c-1);
			else
				d=1;

			for (int i=1; i<=c; i++)
			{	list=new Pair(new Float(v), list);
				if throwing return Unbound;
				v-=d;
			}
		}
		return list;
	}
	return Unbound;
}

NodeP lrSeqFloatArray(PairPP arg)
{
	NodeP
		a=arg[1]->a_number(1),
		b=arg[2]->a_number(2);
	int c=arg[3]->a_int(3);

	if (!throwing)
	{	if (!c || c==1)
			return 0;

		double ac=0, bc=0;

		if (a->type==INT_)
			ac=IntP(a)->int_;
		if (a->type==FLOAT_)
			ac=FloatP(a)->float_;
		if (b->type==INT_)
			bc=IntP(b)->int_;
		if (b->type==FLOAT_)
			bc=FloatP(b)->float_;
		double v=ac, d=(v-bc)/(c-1);

		FloatArrayP result=new FloatArray(c);
		if throwing return Unbound;
		doubleP rd=result->data();

		for (int i=1; i<=c; i++)
		{	*rd++=v;
			v-=d;
		}
		return result;
	}
	return Unbound;
}

NodeP liSeqIntArray(PairPP arg)
{
	enum Paras {_from=1, _to, _nr};
	int
		from=arg[_from]->a_int(_from),
		to=arg[_to]->a_int(_to),
		nr=arg[_nr]->a_int(_nr);

	if (!throwing)
	{	if (!nr || nr==1)
			return 0;

		double v=from, d=(v-to)/(nr-1);

		IntArrayP result=new IntArray(nr);
		if throwing return Unbound;
		intP rd=result->data();

		for (int i=1; i<=nr; i++)
		{	*rd++=int(v);
			v-=d;
		}
		return result;
	}
	return Unbound;
}

NodeP lintForm(PairPP arg) 
{
	NodeP nd=arg[1]->a_number(1);
	if (nd->type==BIGFLOAT)
	{	wxString s('\0', MM_cpp_min_precision+20);
		BigFloatP(nd)->float_.toIntegerString(charP(s.c_str()));
		return new String(s);
	}
	unsigned int num=(unsigned int)nd->getnumber();
	int width=arg[2]->a_int(2),
		  base=arg[3]->a_int(3);

	if throwing return Unbound;

	if (width > 255 || width < 0)
	{	error(BAD_DATA, arg[2], 2);
		return Unbound;
	}
	if (base > 35 || base < 2)
	{	error(BAD_DATA, arg[3], 3);
		return Unbound;
	}
	const int maxlength=256;
	char numstr[maxlength+1];
	for (int i=0; i<maxlength; i++)
		numstr[i]=' ';
	numstr[maxlength]='\0';

	charP ciphers="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";

	charP str=&numstr[maxlength-1];
	int cipher;
	while (num)
	{	cipher = num % base;
		*str-- = ciphers[cipher];
		num/=base;
		width--;
	}
	while (width>0)
	{	str--;
		width--;
	}
	str++;
	return String::make(str, 0, strlen(str), STRING, String::copy);
}

NodeP lmandelIterate(PairPP arg)
{
	int maxi=arg[3]->a_int(3);
	if throwing return Unbound;

	if (type_of(arg[1])==COMPLEX && type_of(arg[2])==COMPLEX)
	{	complexd 
			z=ComplexdP(arg[1])->complex_, 
			c=ComplexdP(arg[2])->complex_;
		int i=1;
		while (i < maxi)
		{	z*=z;
			z+=c;
			if (Float::sqr(z.real())+Float::sqr(z.imag()) > 4) break;
			i++;
		}
		return new Int(i);
	}
	else if (type_of(arg[1])==ARRAY && type_of(arg[2])==ARRAY)
	{	ArrayP za=ArrayP(arg[1]), ca=ArrayP(arg[2]);
		int l=za->length();
		if (l != ca->length())
		{	error(BAD_DATA, arg[2], 2);
			return Unbound;
		}
		NodePP zd=za->data(), cd=ca->data();
		IntArrayP result=new IntArray(l);
		if throwing return Unbound;
		intP r=result->data();
		while (l--)
		{	if (type_of(*zd)!=COMPLEX)
			{	error(BAD_DATA, arg[2], 2);
				return Unbound;
			}				
			if (type_of(*cd)!=COMPLEX)
			{	error(BAD_DATA, arg[3], 3);
				return Unbound;
			}				
			complexd 
				z=ComplexdP(*zd++)->complex_, 
				c=ComplexdP(*cd++)->complex_;
			int i=1;
			while (i < maxi)
			{	z*=z;
				z+=c;
				if (Float::sqr(z.real())+Float::sqr(z.imag()) > 4) break;
				i++;
			}
			*r++=i;
		}
		return result;
	}
	else
		error(BAD_DATA, arg[1], 1);
	return Unbound;
}

complexd sine(complexd z)
{
	double x,y;
	x=real(z); y=imag(z); 
	return complexd(sin(x)*cosh(y), cos(x)*sinh(y));
}

NodeP lmandelIterateSine(PairPP arg)
{
	ComplexdP znd=arg[1]->a_complexOrReal(1),
		cnd=arg[2]->a_complexOrReal(2);
	int maxiter=arg[3]->a_int(3);
	if throwing return Unbound;
	complexd z=znd->complex_, c=cnd->complex_;
	int i;
	for (i=1;  i< maxiter;  i++)
	{	z=sine(z)+z*z+c;
		if (Float::abs(real(z)) > 10 
		||  Float::abs(imag(z)) > 10)
			break;
	}
	IntP result=new Int(i);
	return result;
}

NodeP lCross(PairPP arg)
{
	if (!arg[1])
	{	error(BAD_DATA, arg[1], 1); return Unbound;
	}
	if (!arg[2])
	{	error(BAD_DATA, arg[2], 2); return Unbound;
	}
	if (arg[1]->islist())
	{	PairP 
			a=arg[1]->a_list(1),
			b=arg[2]->a_list(2);
		if (!throwing)
		{	if (a->count() != 3)
			{	error(BAD_DATA,a);
				return Unbound;
			}
			if (b->count() != 3)
			{	error(BAD_DATA, b, 2);
				return Unbound;
			}
			Point ap,bp;
			for (int i=0; i<3; i++, next(a), next(b))
			{	double 
					ad=a->first()->a_float(1),
					bd=b->first()->a_float(2);
				if (throwing)
				{	error(BAD_DATA, b, 2);
					return Unbound;
				}
				ap.a[i]=ad;
				bp.a[i]=bd;
			}
			Point cp=ap.X(bp);

			PairP o=0;
			o=new Pair(new Float(cp.z), o);
			o=new Pair(new Float(cp.y), o);
			o=new Pair(new Float(cp.x), o);
			return o;
		}
	}
	else if (arg[1]->type==ARRAY)
	{	ArrayP 
			a=arg[1]->a_array(1),
			b=arg[2]->a_array(2);

		if (!throwing)
		{	if (a->length() != 3)
			{	error(BAD_DATA,a);
				return Unbound;
			}
			if (b->length() != 3)
			{	error(BAD_DATA, b, 2);
				return Unbound;
			}
			Point ap,bp;
			for (int i=0; i<3; i++)
			{	double 
					ad=a->data()[i]->a_float(1),
					bd=b->data()[i]->a_float(2);
				if (throwing)
				{	error(BAD_DATA, b, 2);
					return Unbound;
				}
				ap.a[i]=ad;
				bp.a[i]=bd;
			}
			Point cp=ap.X(bp);

			ArrayP o=new Array(3);
			if throwing return Unbound;
			NodePP od=o->data();
			*od++=new Float(cp.x);
			*od++=new Float(cp.y);
			*od++=new Float(cp.z);
			return o;
		}
	}
	else if (arg[1]->type==FLOATARRAY)
	{	FloatArrayP 
			a=arg[1]->a_floatarray(1),
			b=arg[2]->a_floatarray(2);

		if (!throwing)
		{	if (a->length() != 3)
			{	error(BAD_DATA,a);
				return Unbound;
			}
			if (b->length() != 3)
			{	error(BAD_DATA, b, 2);
				return Unbound;
			}
			DPoint 
				ap=*(DPoint*)a->data(),
				bp=*(DPoint*)b->data();
			DPoint cp=ap.X(bp);

			FloatArrayP o=new FloatArray(3);
			if throwing return Unbound;
			doubleP od=o->data();
			*od++=cp.x;
			*od++=cp.y;
			*od++=cp.z;
			return o;
		}
	}
	return Unbound;
}

double *invertMatrix(double *m, int n, NodeP arg)
{
	double 
		*imb=(double*)GC_::malloc(n*n*sizeof(double)), *im=imb;
	if (!imb)
		return 0;
	double det;

	switch (n)
	{	case 1:	det=*m;
					if (det==0)
					{	error(BAD_DATA, arg);
						break;
					}
					*im=1/det;
					_Determinant->setvar(new Float(det));
					break;

		case 2:	det=m[0+0]*m[1*2+1]-m[0+1]*m[1*2+0];
					if (det==0)
					{	error(BAD_DATA, arg);
						break;
					}
					*im++= m[1*2+1]/det;
					*im++=-m[0  +1]/det;
					*im++=-m[1*2+0]/det;
					*im++= m[0  +0]/det;
					_Determinant->setvar(new Float(det));
					break;
					
		case 3:
			{	double 
					d1=m[1*3+1]*m[2*3+2]-m[2*3+1]*m[1*3+2],
					d2=m[1*3+2]*m[2*3+0]-m[2*3+2]*m[1*3+0],
					d3=m[1*3+0]*m[2*3+1]-m[2*3+0]*m[1*3+1];

				det=m[0+0]*d1+m[0+1]*d2+m[0+2]*d3;
				if (det==0)
				{	error(BAD_DATA, arg);
					break;
				}
				*im++=d1/det;
				*im++=(m[2*3+1]*m[0*3+2]-m[0*3+1]*m[2*3+2])/det;
				*im++=(m[0*3+1]*m[1*3+2]-m[1*3+1]*m[0*3+2])/det;				
				*im++=d2/det;
				*im++=(m[2*3+2]*m[0*3+0]-m[0*3+2]*m[2*3+0])/det;
				*im++=(m[0*3+2]*m[1*3+0]-m[1*3+2]*m[0*3+0])/det;				
				*im++=d3/det;
				*im++=(m[2*3+0]*m[0*3+1]-m[0*3+0]*m[2*3+1])/det;
				*im++=(m[0*3+0]*m[1*3+1]-m[1*3+0]*m[0*3+1])/det;
				_Determinant->setvar(new Float(det));
				break;
			}
		default:
			{	int i;
				for (i=n*n; i>0; i--)
					*im++=*m++;	// copy the matrix (the original maybe used afterwards)
				im=imb;

				det=1;
				for (int l=0; l<n; l++)
				{	int ln=l*n;
					double x=im[ln+l];
					det*=x;
					if (det==0)
					{	error(BAD_DATA, arg);
						return imb;
					}
					im[ln+l]=1;
					for (i=0; i<n; i++)
						im[ln+i]=im[ln+i]/x;
					for (i=0; i<n; i++)
						if (i != l)
						{	int in=i*n;
							x=im[in+l];
							im[in+l]=0;
							for (int j=0; j<n; j++)
								im[in+j]=im[in+j]-x*im[ln+j];
						}
				}
			}				
	}
	return imb;
}

NodeP linvertMatrix(PairPP arg)
{
	ArrayP a=arg[1]->a_array(1);
	if (!throwing)
	{	int x=a->length();
		double 
			*mb=(double*)GC_::malloc(x*x*sizeof(double)), *m=mb;
		if (!mb)
			return Unbound;

		NodePP ad=a->data(), d=ad, de=ad+x-1;
		while (unsigned(d) <= unsigned(de))
		{	ArrayP b=(*d)->a_array(1);
			if (throwing) 
				return Unbound;
			if (b->length() != x) 
			{	error(BAD_DATA, a);
				return Unbound;
			}
			NodePP bd=b->data(), bde=bd+x-1;
			while (unsigned(bd) <= unsigned(bde))
			{	*m=(*bd)->a_float(1);	// argument checking first
				if (throwing)
					return Unbound;
				m++;
				bd++;
			}
			d++;
		}
		double *im=invertMatrix(mb,x,a);
		GC_::free(mb); mb=0;

		if (throwing) 
			return Unbound;

		m=im;
		ArrayP o=new Array(x);
		if throwing return Unbound;
		NodePP od=o->data();
		for (int i=x; i>0; i--)
		{	*od=new Array(x);
			if throwing return Unbound;
			NodePP odd=ArrayP(*od)->data();
			for (int j=x; j>0; j--)
			{	*odd=new Float(*m++);
				if throwing return Unbound;
				odd++;
			}
			od++;
		}
		GC_::free(im); im=0;
		return o;
	}
	return Unbound;
}

#ifdef WIN32
	#define FLOAT_ASM																		\
		_asm																					\
		{	_asm fnstsw ax																	\
			_asm fnclex																		\
			_asm test ax,Float::x87_overflow_mask									\
			_asm jnz float_overflow														\
		}
#else
	#define FLOAT_ASM																		\
		int of;																				\
		asm("	fnstsw %%ax				\n													\
				fnclex					\n													\
				test %1,%%ax			\n													\
				jnz 1f; mov $0,%0; jmp 2f; 1: mov $1,%0; 2:"						\
				 : "=r" (of) : "g" (Float::x87_overflow_mask));					\
		if (of) goto float_overflow;
#endif

#ifdef WIN32
	#define COMPLEX_ASM																	\
		_asm																					\
		{	_asm fnstsw ax _asm fnclex													\
			_asm test ax, Float::x87_overflow_mask									\
			_asm jnz complex_overflow													\
		}
#else
	#define COMPLEX_ASM																	\
		int of;																				\
		asm("	fnstsw %%ax				\n													\
				fnclex					\n													\
				test %1,%%ax			\n													\
				jnz 1f; mov $0,%0; jmp 2f; 1: mov $1,%0; 2:"						\
				 : "=r" (of) : "g" (Float::x87_overflow_mask));					\
		if (of) goto complex_overflow;
#endif

#ifdef WIN32
	#define INT_ASM	\
		_asm{_asm jo int_overflow}
#else
	#define INT_ASM	\
		int of;			\
		asm("jo 1f; mov $0,%0; jmp 2f; 1: mov $1,%0; 2:": "=r" (of));	\
		if (of) goto int_overflow;
#endif

#ifdef WIN32
	#define INT_ASM2	\
		_asm{_asm jo int_overflow2}
#else
	#define INT_ASM2	\
		int of;			\
		asm("jo 1f; mov $0,%0; jmp 2f; 1: mov $1,%0; 2:": "=r" (of));	\
		if (of) goto int_overflow2;
#endif

#ifdef WIN32
	#define INT_ASM3	\
		_asm{_asm jo int_overflow3}
#else
	#define INT_ASM3	\
		int of;			\
		asm("jo 1f; mov $0,%0; jmp 2f; 1: mov $1,%0; 2:": "=r" (of));	\
		if (of) goto int_overflow3;
#endif

#ifdef WIN32
	#define INT_ASM4	\
		_asm{_asm jo int_overflow4}
#else
	#define INT_ASM4	\
		int of;			\
		asm("jo 1f; mov $0,%0; jmp 2f; 1: mov $1,%0; 2:": "=r" (of));	\
		if (of) goto int_overflow4;
#endif

#ifdef WIN32
	#define INT16_ASM	\
		_asm{_asm jo int16_overflow}
#else
	#define INT16_ASM	\
		int of;			\
		asm("jo 1f; mov $0,%0; jmp 2f; 1: mov $1,%0; 2:": "=r" (of));	\
		if (of) goto int16_overflow;
#endif

#ifdef WIN32
	#define INT16_ASM2	\
		_asm{_asm jo int16_overflow2}
#else
	#define INT16_ASM2	\
		int of;			\
		asm("jo 1f; mov $0,%0; jmp 2f; 1: mov $1,%0; 2:": "=r" (of));	\
		if (of) goto int16_overflow2;
#endif

#ifdef WIN32
	#define INT16_ASM3	\
		_asm{_asm jo int16_overflow3}
#else
	#define INT16_ASM3	\
		int of;			\
		asm("jo 1f; mov $0,%0; jmp 2f; 1: mov $1,%0; 2:": "=r" (of));	\
		if (of) goto int16_overflow3;
#endif

#ifdef WIN32
	#define INT8_ASM	\
		_asm{_asm jo int8_overflow}
#else
	#define INT8_ASM	\
		int of;			\
		asm("jo 1f; mov $0,%0; jmp 2f; 1: mov $1,%0; 2:": "=r" (of));	\
		if (of) goto int8_overflow;
#endif

#ifdef WIN32
	#define INT8_ASM2	\
		_asm{_asm jo int8_overflow2}
#else
	#define INT8_ASM2	\
		int of;			\
		asm("jo 1f; mov $0,%0; jmp 2f; 1: mov $1,%0; 2:": "=r" (of));	\
		if (of) goto int8_overflow2;
#endif

#define TRY_FUNC(NAME, NUMBER)														\
{	double v;																				\
	if (true)																				\
	{	FUNC_##NAME(NUMBER);																\
		FLOAT_ASM																			\
	}else float_overflow:																\
	{	Float::reset_FPU();																\
		error(BAD_DATA, this);															\
		return Unbound;																	\
	}																							\
	return new Float(v);																	\
}

#define TRY_FUNCI(NAME, NUMBER)														\
{	int v;																					\
	if (true)																				\
	{	FUNC_i##NAME(NUMBER);															\
		INT_ASM																				\
	}else int_overflow:																	\
		TRY_FUNC(NAME, double(int_))													\
	return new Int(v);																	\
}

#define TRY_FUNCI16(NAME, NUMBER)													\
{	short v;																					\
	if (true)																				\
	{	FUNC_i16##NAME(NUMBER);															\
		INT16_ASM																			\
	}else int16_overflow:																\
		TRY_FUNCI(NAME, int(int_))														\
	return new Int(v);																	\
}

#define TRY_FUNCC(NAME, NUMBER)														\
{	complexd v;																				\
	if (true)																				\
	{	FUNC_c##NAME(NUMBER);															\
		FLOAT_ASM																			\
	}else float_overflow:																\
	{	Float::reset_FPU();																\
		error(BAD_DATA, this);															\
		return Unbound;																	\
	}																							\
	return new Complexd(v);																\
}

#define UNARY_OP(NAME, SYMBOLNODE)													\
NodeP Node::NAME() {error(BAD_DATA, this); return Unbound;}					\
NodeP Object::NAME()				 														\
{	NodeP n=number();																		\
	if (n != Unbound)																		\
		return n->NAME();																	\
	else																						\
		return new Tree(SYMBOLNODE, new Pair(new Colon(this), 0));			\
	error(BAD_DATA, this); return Unbound;											\
}																								\
NodeP String::NAME()																		\
{	NodeP n=number();																		\
	if (n != Unbound) return n->NAME();												\
	error(BAD_DATA, this); return Unbound;											\
}																								\
NodeP Int::NAME()																			\
{	int v;																					\
	FUNC_i##NAME(int_);																	\
	INT_ASM																					\
	return new Int(v);																	\
int_overflow:																				\
	TRY_FUNC(NAME, double(int_))														\
}																								\
NodeP Int16::NAME()																		\
{	short v;																					\
	FUNC_i16##NAME(int_);																\
	INT16_ASM																				\
	return new Int16(v);																	\
int16_overflow:																			\
	TRY_FUNCI(NAME, int(int_))															\
}																								\
NodeP Int8::NAME()																		\
{	char v;																					\
	FUNC_i8##NAME(int_);																	\
	INT8_ASM																					\
	return new Int8(v);																	\
int8_overflow:																				\
	TRY_FUNCI16(NAME, short(int_))													\
}																								\
NodeP UInt8::NAME()																		\
{	char v;																					\
	FUNC_i8##NAME(int_);																	\
	INT8_ASM																					\
	return new UInt8(v);																	\
int8_overflow:																				\
	TRY_FUNCI16(NAME, short(int_))													\
}																								\
NodeP Float::NAME() {TRY_FUNC(NAME, float_);}									\
NodeP BigFloat::NAME()																	\
{	MAPM v;																					\
	if (true)																				\
	{	FUNC_b##NAME(float_);															\
		if (m_apm_error)																	\
			goto bigfloat_overflow;														\
	}else bigfloat_overflow:															\
	{	m_apm_reset_error();																\
		error(BAD_DATA, this);															\
		return Unbound;																	\
	}																							\
	return new BigFloat(v);																\
}																								\
NodeP Complexd::NAME() {TRY_FUNCC(NAME, complex_);}							\
NodeP Pair::NAME()																		\
{																								\
	ThreadP th=Thread::This();															\
	if (this && circcounter()==th->circcounter)									\
		return 0;																			\
	PairP a=this, result=0, lastnode=0, tnode=0;									\
	if (a->type==TREE)																	\
	{	return new Tree(																	\
			SYMBOLNODE, new Pair(this, 0));											\
	}																							\
	while (a)																				\
	{	if (a->circcounter()==th->circcounter)										\
			break;																			\
		else																					\
			a->setcirccounter(th->circcounter);										\
		tnode = new Pair(a->first()->NAME(), 0);									\
		if (throwing) return Unbound;													\
		if (result)																			\
			lastnode->settail( tnode );												\
		else																					\
			result=tnode;																	\
		lastnode=tnode;																	\
		next(a);																				\
	}																							\
	th->setcirccounter(th->circcounter+1);											\
	if (!a) return result;																\
	error(BAD_DATA, this); return Unbound;											\
}																								\
NodeP Array::NAME()																		\
{																								\
	ThreadP th=Thread::This();															\
	if (this && circcounter()==th->circcounter)									\
		return 0;																			\
	else																						\
		setcirccounter(th->circcounter);												\
	NodePP d=data();																		\
	int i=length();																		\
	ArrayP result = new Array(i, origin());										\
	if throwing return Unbound;														\
	NodePP rd=result->data();															\
	while (i--)																				\
	{	if (*d)																				\
			*rd = (*d)->NAME();															\
		else																					\
		{	error(BAD_DATA, this);														\
			return Unbound;																\
		}																						\
		*d++;																					\
		result->check_oldyoung(*rd++);												\
		if (throwing) return Unbound;													\
	}																							\
	th->setcirccounter(th->circcounter+1);											\
	return result;																			\
}																								\
NodeP IntArray::NAME()																	\
{																								\
	intP d=_data;																			\
	int i=length();																		\
	IntArrayP result = new IntArray(i, origin());								\
	if throwing return Unbound;														\
	intP rd=result->_data;																\
	IntP element=new Int(0);															\
	if throwing return Unbound;														\
	NodeP res=0;																			\
	while (i--)																				\
	{	element->int_=(*d++);															\
		res = element->NAME();															\
		if (type_of(res) != INT_)														\
		{	error(BAD_DATA, this);														\
			return Unbound;																\
		}																						\
		(*rd++) = IntP(res)->int_;														\
		if (throwing) return Unbound;													\
	}																							\
	return result;																			\
}																								\
NodeP Int16Array::NAME()																\
{																								\
	shortP d=_data;																		\
	int i=length();																		\
	Int16ArrayP result = new Int16Array(i, origin());							\
	if throwing return Unbound;														\
	shortP rd=result->_data;															\
	Int16P element=new Int16(0);														\
	if throwing return Unbound;														\
	NodeP res=0;																			\
	while (i--)																				\
	{	element->int_=(*d++);															\
		res = element->NAME();															\
		if (type_of(res) != NINT16)													\
		{	error(BAD_DATA, this);														\
			return Unbound;																\
		}																						\
		(*rd++) = Int16P(res)->int_;													\
		if (throwing) return Unbound;													\
	}																							\
	return result;																			\
}																								\
NodeP FloatArray::NAME()																\
{																								\
	doubleP d=_data;																		\
	int i=length();																		\
	FloatArrayP result = new FloatArray(i, origin());							\
	if throwing return Unbound;														\
	doubleP rd=result->_data;															\
	NodeP res=0;																			\
	while (i--)																				\
	{	double a=(*d++), v;																\
		if (true)																			\
		{	FUNC_##NAME(a);																\
			FLOAT_ASM																		\
		}else float_overflow:															\
		{	Float::reset_FPU();															\
			error(BAD_DATA, this);														\
			return Unbound;																\
		}																						\
		(*rd++) = v;																		\
		if (throwing) return Unbound;													\
	}																							\
	return result;																			\
}																								\
NodeP Bitmap::NAME()																		\
{																								\
	ColorP rpixels=ColorP(malloc(winx*winy*sizeof(Color)));					\
	BitmapP result=new Bitmap(width, height, winx, winy, rpixels);			\
	if throwing return Unbound;														\
	for (int i=winx*winy-1; i>=0; i--)												\
	{	Color c=pixels[i];																\
		double a,v;																			\
		if (true)																			\
		{	{	a=c.r/255;																	\
				FUNC_##NAME(a);															\
				FLOAT_ASM																	\
				rpixels[i].r=int(v*255);												\
			}{	a=c.g/255;																	\
				FUNC_##NAME(a);															\
				FLOAT_ASM																	\
				rpixels[i].g=int(v*255);												\
			}{	a=c.b/255;																	\
				FUNC_##NAME(a);															\
				FLOAT_ASM																	\
				rpixels[i].b=int(v*255);												\
			}																					\
		}else																					\
		{float_overflow:																	\
			Float::reset_FPU();															\
			error(BAD_DATA, this); return Unbound;									\
		}																						\
	}																							\
	return result;																			\
}																								\
NodeP l##NAME(PairPP arg) {return arg[1]?  arg[1]->NAME() : 0;}

#define FUNC_negate(a)		v=-a
#define FUNC_bnegate(a)		v=-a
#define FUNC_cnegate(a)		v=-a
#define FUNC_inegate(a)		v=-a
#define FUNC_i16negate(a)	v=-a
#define FUNC_i8negate(a)	v=-a

#define FUNC_reciprocal(a)		v=1/a
#define FUNC_breciprocal(a)	v=1/a
#define FUNC_creciprocal(a)	v=complexd(1)/a
#define FUNC_ireciprocal(a)	goto int_overflow
#define FUNC_i16reciprocal(a)	goto int_overflow
#define FUNC_i8reciprocal(a)	goto int_overflow

#define FUNC_BitNot(a)		v=int(~(unsigned int)(a))
#define FUNC_bBitNot(a)		goto bigfloat_overflow
#define FUNC_cBitNot(a)		goto float_overflow
#define FUNC_iBitNot(a)		v=~a
#define FUNC_i16BitNot(a)	v=~a
#define FUNC_i8BitNot(a)	v=~a

#define FUNC_random(a)		goto float_overflow
#define FUNC_brandom(a)		random()
#define FUNC_crandom(a)		goto float_overflow
#define FUNC_irandom(a)		v=Int::random(a)
#define FUNC_i16random(a)	v=short(Int::random(a))
#define FUNC_i8random(a)	v=char(Int::random(a))

#define FUNC_truncate(a)	if (a >= Int::min && a <= Int::max)	\
	v=int(a); else v=floor(a)
#define FUNC_btruncate(a)	v=floor(a)
#define FUNC_ctruncate(a)										\
	if (a.imag()==0 && Complexd::abs(a) <= Int::max)	\
		return new Int(int(a.real()));						\
	else v=complexd(floor(a.real()), floor(a.imag()))
#define FUNC_itruncate(a)		return this
#define FUNC_i16truncate(a)	return this
#define FUNC_i8truncate(a)		return this

#define FUNC__int(a)		if (a >= Int::min && a <= Int::max)	\
	return new Int(int(a)); else goto float_overflow
#define FUNC_b_int(a)	if (a >= Int::min && a <= Int::max)	\
	return new Int(a.to_int()); else goto bigfloat_overflow
#define FUNC_c_int(a)	if (Complexd::abs(a) <= Int::max)	\
	return new Int(int(abs(a))); else goto float_overflow
#define FUNC_i_int(a)	v=a
#define FUNC_i16_int(a)	return new Int(a)
#define FUNC_i8_int(a)	return new Int(a)

#define FUNC_toint16(a)		if (a >= Int16::min && a <= Int16::max)	\
	return new Int16(short(a)); else goto float_overflow
#define FUNC_btoint16(a)	if (a >= Int16::min && a <= Int16::max)	\
	return new Int16(a.to_int()); else goto bigfloat_overflow
#define FUNC_ctoint16(a)	if (Complexd::abs(a) <= Int16::max)	\
	return new Int16(short(abs(a))); else goto float_overflow
#define FUNC_itoint16(a)	if (a >= Int16::min && a <= Int16::max)	\
	return new Int16(short(a)); else goto int_overflow
#define FUNC_i16toint16(a)	v=a
#define FUNC_i8toint16(a)	return new Int16(a)

#define FUNC_toint8(a)	if (a >= Int8::min && a <= Int8::max)	\
	return new Int8(char(a)); else goto float_overflow
#define FUNC_btoint8(a)	if (a >= Int8::min && a <= Int8::max)	\
	return new Int8(a.to_int()); else goto bigfloat_overflow
#define FUNC_ctoint8(a)	if (Complexd::abs(a) <= Int8::max)	\
	return new Int8(char(abs(a))); else goto float_overflow
#define FUNC_itoint8(a)	if (a >= Int8::min && a <= Int8::max)	\
	return new Int8(char(a)); else goto int_overflow
#define FUNC_i16toint8(a)	if (a >= Int8::min && a <= Int8::max)	\
	return new Int8(char(a)); else goto int16_overflow
#define FUNC_i8toint8(a)	v=a

#define FUNC_touint8(a)	if (a >= 0 && a <= UInt8::max)	\
	return new UInt8((unsigned char)(a)); else goto float_overflow
#define FUNC_btouint8(a)	if (a >= 0 && a <= UInt8::max)	\
	return new UInt8(a.to_int()); else goto bigfloat_overflow
#define FUNC_ctouint8(a)	if (Complexd::abs(a) <= UInt8::max)	\
	return new UInt8((unsigned char)(abs(a))); else goto float_overflow
#define FUNC_itouint8(a)	if (a >= 0 && a <= UInt8::max)	\
	return new UInt8((unsigned char)(a)); else goto int_overflow
#define FUNC_i16touint8(a)	if (a >= 0 && a <= UInt8::max)	\
	return new UInt8((unsigned char)(a)); else goto int16_overflow
#define FUNC_i8touint8(a)	v=a


#define FUNC_round(a)		if (Float::abs(a) <= Int::max)	\
	return new Int(int(floor(a+0.5))); else v=floor(a+0.5)
#define FUNC_bround(a)		v=floor(a+0.5)
#define FUNC_cround(a)										\
	if (a.imag()==0 && Complexd::abs(a) <= Int::max)	\
		return new Int(int(floor(a.real()+0.5)));				\
	else v=complexd(floor(a.real()+0.5),floor(a.real()+0.5))
#define FUNC_iround(a)		return this
#define FUNC_i16round(a)	return this
#define FUNC_i8round(a)		return this

#define FUNC__float(a)		v=a;
#define FUNC_b_float(a)		return new Float(a.to_double());
#define FUNC_c_float(a)		return new Float(abs(a));
#define FUNC_i_float(a)		return new Float(a);
#define FUNC_i16_float(a)	return new Float(a);
#define FUNC_i8_float(a)	return new Float(a);

#define FUNC__bigfloat(a)		return new BigFloat(a);
#define FUNC_b_bigfloat(a)		return new BigFloat(a);
#define FUNC_c_bigfloat(a)		goto float_overflow;
#define FUNC_i_bigfloat(a)		return new BigFloat(a);
#define FUNC_i16_bigfloat(a)	return new BigFloat(a);
#define FUNC_i8_bigfloat(a)	return new BigFloat(a);

#define FUNC_tocomplex(a)		return new Complexd(a);
#define FUNC_btocomplex(a)		return new Complexd(a.to_double());
#define FUNC_ctocomplex(a)		v=a;
#define FUNC_itocomplex(a)		return new Complexd(a);
#define FUNC_i16tocomplex(a)	return new Complexd(a);
#define FUNC_i8tocomplex(a)	return new Complexd(a);

#define FUNC_Sin(a)		v=::sin(Float::Remainder(a,360)*Float::deg2rad)
#define FUNC_bSin(a)		v=::sin(BigFloat::Remainder(a,360)*BigFloat::deg2rad)
#define FUNC_cSin(a)		v=std::sin(Complexd::Remainder(a,360)*Float::deg2rad)
#define FUNC_iSin(a)		goto int_overflow
#define FUNC_i16Sin(a)	goto int_overflow
#define FUNC_i8Sin(a)	goto int_overflow
#define FUNC_Cos(a)		v=::cos(Float::Remainder(a,360)*Float::deg2rad)
#define FUNC_bCos(a)		v=::cos(BigFloat::Remainder(a,360)*BigFloat::deg2rad)
#define FUNC_cCos(a)		v=std::cos(Complexd::Remainder(a,360)*Float::deg2rad)
#define FUNC_iCos(a)		goto int_overflow
#define FUNC_i16Cos(a)	goto int_overflow
#define FUNC_i8Cos(a)	goto int_overflow
#define FUNC_Tan(a)		v=::tan(Float::Remainder(a,360)*Float::deg2rad)
#define FUNC_bTan(a)		v=::tan(BigFloat::Remainder(a,360)*BigFloat::deg2rad)
#define FUNC_cTan(a)		complexd c=Complexd::Remainder(a,360)*Float::deg2rad; \
	v=std::sin(c)/std::cos(c)
#define FUNC_iTan(a)		goto int_overflow
#define FUNC_i16Tan(a)	goto int_overflow
#define FUNC_i8Tan(a)	goto int_overflow

#define FUNC_ArcSin(a)		v=::asin(a)/Float::deg2rad
#define FUNC_bArcSin(a)		v=::asin(a)/BigFloat::deg2rad
#define FUNC_cArcSin(a)		goto float_overflow
#define FUNC_iArcSin(a)		goto int_overflow
#define FUNC_i16ArcSin(a)	goto int_overflow
#define FUNC_i8ArcSin(a)	goto int_overflow
#define FUNC_ArcCos(a)		v=::acos(a)/Float::deg2rad
#define FUNC_bArcCos(a)		v=::acos(a)/BigFloat::deg2rad
#define FUNC_cArcCos(a)		goto float_overflow
#define FUNC_iArcCos(a)		goto int_overflow
#define FUNC_i16ArcCos(a)	goto int_overflow
#define FUNC_i8ArcCos(a)	goto int_overflow

#define FUNC_radSin(a)		v=::sin(a)
#define FUNC_bradSin(a)		v=::sin(a)
#define FUNC_cradSin(a)		v=std::sin(a)
#define FUNC_iradSin(a)		goto int_overflow
#define FUNC_i16radSin(a)	goto int_overflow
#define FUNC_i8radSin(a)	goto int_overflow
#define FUNC_radCos(a)		v=::cos(a)
#define FUNC_bradCos(a)		v=::cos(a)
#define FUNC_cradCos(a)		v=std::cos(a)
#define FUNC_iradCos(a)		goto int_overflow
#define FUNC_i16radCos(a)	goto int_overflow
#define FUNC_i8radCos(a)	goto int_overflow
#define FUNC_radTan(a)		v=::tan(a)
#define FUNC_bradTan(a)		v=::tan(a)
#define FUNC_cradTan(a)		v=std::sin(a)/std::cos(a)
#define FUNC_iradTan(a)		goto int_overflow
#define FUNC_i16radTan(a)	goto int_overflow
#define FUNC_i8radTan(a)	goto int_overflow

#define FUNC_radArcSin(a)		v=::asin(a)
#define FUNC_bradArcSin(a)		v=::asin(a)
#define FUNC_cradArcSin(a)		goto float_overflow
#define FUNC_iradArcSin(a)		goto int_overflow
#define FUNC_i16radArcSin(a)	goto int_overflow
#define FUNC_i8radArcSin(a)	goto int_overflow
#define FUNC_radArcCos(a)		v=::acos(a)
#define FUNC_bradArcCos(a)		v=::acos(a)
#define FUNC_cradArcCos(a)		goto float_overflow
#define FUNC_iradArcCos(a)		goto int_overflow
#define FUNC_i16radArcCos(a)	goto int_overflow
#define FUNC_i8radArcCos(a)	goto int_overflow

#define FUNC_abs(a)		v=fabs(a)
#define FUNC_babs(a)		v=fabs(a)
#define FUNC_cabs(a)		return new Float(abs(a))
#define FUNC_iabs(a)		v=::abs(a)
#define FUNC_i16abs(a)	v=::abs(a)
#define FUNC_i8abs(a)	v=::abs(a)
#define FUNC_Sqr(a)		v=a*a
#define FUNC_bSqr(a)		v=a*a
#define FUNC_cSqr(a)		v=a*a
#define FUNC_iSqr(a)		v=a*a
#define FUNC_i16Sqr(a)	v=a*a
#define FUNC_i8Sqr(a)	v=a*a
#define FUNC_Sqrt(a)		if (a >= 0) v=::sqrt(a); \
	else return new Complexd(std::sqrt(complexd(a)));
#define FUNC_bSqrt(a)	if (a >= 0) v=::sqrt(a); else goto bigfloat_overflow
#define FUNC_cSqrt(a)	v=std::sqrt(a)
#define FUNC_iSqrt(a)	goto int_overflow
#define FUNC_i16Sqrt(a)	goto int_overflow
#define FUNC_i8Sqrt(a)	goto int_overflow
#define FUNC_exp(a)		v=::exp(a)
#define FUNC_bexp(a)		v=::exp(a)
#define FUNC_cexp(a)		v=std::exp(a)
#define FUNC_iexp(a)		goto int_overflow
#define FUNC_i16exp(a)	goto int_overflow
#define FUNC_i8exp(a)	goto int_overflow

#define FUNC_LN(a)		v=log(a)
#define FUNC_bLN(a)		v=log(a)
#define FUNC_cLN(a)		v=std::log(a)
#define FUNC_iLN(a)		goto int_overflow
#define FUNC_i16LN(a)	goto int_overflow
#define FUNC_i8LN(a)		goto int_overflow
#define FUNC_Log10(a)		v=::log10(a)
#define FUNC_bLog10(a)		v=::log10(a)
#define FUNC_cLog10(a)		v=std::log10(a)
#define FUNC_iLog10(a)		goto int_overflow

#define FUNC_i16Log10(a)	goto int_overflow
#define FUNC_i8Log10(a)		goto int_overflow

#define FUNC_real(a)		v=a
#define FUNC_breal(a)	v=a
#define FUNC_creal(a)	return new Float(a.real())
#define FUNC_ireal(a)	v=a
#define FUNC_i16real(a)	v=a
#define FUNC_i8real(a)	v=a
#define FUNC_imag(a)		v=0
#define FUNC_bimag(a)	v=0
#define FUNC_cimag(a)	return new Float(a.imag())
#define FUNC_iimag(a)	v=0
#define FUNC_i16imag(a)	v=0
#define FUNC_i8imag(a)	v=0
#define FUNC_conjugate(a)		v=a
#define FUNC_bconjugate(a)		v=a
#define FUNC_cconjugate(a)		v=complexd(a.real(),-a.imag())
#define FUNC_iconjugate(a)		v=a
#define FUNC_i16conjugate(a)	v=a
#define FUNC_i8conjugate(a)	v=a

#define FUNC_Signum(a)	if (a>0) return new Int(1); \
								else if (a<0) return new Int(-1); \
								else return new Int(0)
#define FUNC_bSignum(a)	FUNC_Signum(a)
#define FUNC_cSignum(a)	if (a.imag()!=0) goto float_overflow; \
								else if (a.real()>0) return new Int(1); \
								else if (a.real()<0) return new Int(-1); \
								else return new Int(0)
#define FUNC_iSignum(a)	a>0? v=1 \
									: a<0? v=-1 \
										: v=0
#define FUNC_i16Signum(a)	FUNC_iSignum(a)
#define FUNC_i8Signum(a)	FUNC_iSignum(a)


UNARY_OP(negate, _Negate)
UNARY_OP(reciprocal, _Reciprocal)
UNARY_OP(BitNot, _BitNot)
UNARY_OP(random, _Random)
UNARY_OP(_int, _Int)
UNARY_OP(toint16, _Int16)
UNARY_OP(toint8, _Int8)
UNARY_OP(touint8, _UInt8)
UNARY_OP(truncate, _Truncate)
UNARY_OP(round, _Round)
UNARY_OP(_float, _Float)
UNARY_OP(_bigfloat, _BigFloat)
UNARY_OP(tocomplex, _Complex_)
UNARY_OP(Sin, _SIn)
UNARY_OP(Cos, _COs)
UNARY_OP(Tan, _Tan)
UNARY_OP(ArcSin, _ArcSin)
UNARY_OP(ArcCos, _ArcCos)
UNARY_OP(radSin, _radSin)
UNARY_OP(radCos, _radCos)
UNARY_OP(radTan, _radTan)
UNARY_OP(radArcSin, _radArcSin)
UNARY_OP(radArcCos, _radArcCos)
UNARY_OP(abs, _Abs)
UNARY_OP(Sqr, _Sqr)
UNARY_OP(Sqrt, _Sqrt)
UNARY_OP(exp, _EXp)
UNARY_OP(LN, _LN)
UNARY_OP(Log10, _Log10)
UNARY_OP(real, _Real)
UNARY_OP(imag, _Imag)
UNARY_OP(conjugate, _Conjugate)
UNARY_OP(Signum, _Signum)

#ifdef WIN32
	#define BINARY_FLOAT_ASM(TYPE)													\
		_asm																					\
		{	_asm fnstsw ax _asm fnclex													\
			_asm test ax,Float::x87_overflow_mask									\
			_asm jnz float_overflow##TYPE												\
		}
#else
	#define BINARY_FLOAT_ASM(TYPE)													\
		int of;																				\
		asm("	fnstsw %%ax				\n													\
				fnclex					\n													\
				test %1,%%ax			\n													\
				jnz 1f; mov $0,%0; jmp 2f; 1: mov $1,%0; 2:"						\
				 : "=r" (of) : "g" (Float::x87_overflow_mask));					\
		if (of) goto float_overflow##TYPE;
#endif

#ifdef WIN32
	#define BINARY_COMPLEX_ASM(TYPE)													\
		_asm																					\
		{	_asm fnstsw ax _asm fnclex													\
			_asm test ax, Float::x87_overflow_mask									\
			_asm jnz complex_overflow##TYPE											\
		}
#else
	#define BINARY_COMPLEX_ASM(TYPE)													\
		int of;																				\
		asm("	fnstsw %%ax				\n													\
				fnclex					\n													\
				test %1,%%ax			\n													\
				jnz 1f; mov $0,%0; jmp 2f; 1: mov $1,%0; 2:"						\
				 : "=r" (of) : "g" (Float::x87_overflow_mask));					\
		if (of) goto complex_overflow##TYPE;
#endif

#define NR_if_(TYPE, NAME, NUMBER, ARG)											\
	if (arg->type==TYPE)																	\
	{	double f;																			\
		if (true)																			\
		{	f = FUNC_##NAME(NUMBER, ARG);												\
			BINARY_FLOAT_ASM(TYPE)														\
		}else float_overflow##TYPE:													\
		{	Float::reset_FPU();															\
			error(BAD_DATA, arg, 2);													\
			return Unbound;																\
		}																						\
		return new Float(f);																\
	}																							\

#define BNR_if_(TYPE, NAME, NUMBER, ARG)											\
	if (arg->type==TYPE)																	\
	{	MAPM f;																				\
		if (true)																			\
		{	f = FUNC_b##NAME(NUMBER, ARG);											\
			if (m_apm_error)																\
				goto bigfloat_overflow##TYPE;											\
		}else bigfloat_overflow##TYPE:												\
		{	m_apm_reset_error();															\
			error(BAD_DATA, arg, 2);													\
			return Unbound;																\
		}																						\
		return new BigFloat(f);															\
	}																							\

#define CNR_if_(TYPE, NAME, NUMBER, ARG)											\
	if (arg->type==TYPE)																	\
	{	complexd c;																			\
		if (true)																			\
		{	c = FUNC_c##NAME(NUMBER, ARG);											\
			BINARY_COMPLEX_ASM(TYPE)													\
		}else complex_overflow##TYPE:													\
		{	Float::reset_FPU();															\
			error(BAD_DATA, arg, 2);													\
			return Unbound;																\
		}																						\
		return new Complexd(c);															\
	}																							\

#define else_if_STRING(NAME, SYMBOLNODE)											\
	else if (arg->is.string)															\
	{	ThreadP th=Thread::This();														\
		NodeP n=0;  n=arg->number();													\
		th->setcirccounter(th->circcounter+1);										\
		if (n != Unbound) return NAME(n);											\
		error(BAD_DATA, this); return Unbound;										\
	}

#define else_if_OBJECT(NAME, SYMBOLNODE)											\
	else if (arg->type==OBJECT)														\
	{	ThreadP th=Thread::This();														\
		ObjectP obj=ObjectP(arg);														\
		NodeP n=0;  n=arg->number();													\
		th->setcirccounter(th->circcounter+1);										\
		if (n != Unbound) return NAME(n);											\
		return new Tree(																	\
			SYMBOLNODE,																		\
			new Pair(this,																	\
			new Pair(new Colon(arg), 0)));											\
	}

#define else_if_LIST(NAME)																\
	else if (arg->is.list)																\
	{	ThreadP th=Thread::This();														\
		NodeP a=this;																		\
		PairP b = PairP(arg);															\
		while (b)																			\
		{	if (b->circcounter()==th->circcounter)									\
				break;																		\
			else																				\
				b->setcirccounter(th->circcounter);									\
			a = a->NAME( b->first() );													\
			if (throwing) return Unbound;												\
			next(b);																			\
		}																						\
		th->setcirccounter(th->circcounter+1);										\
		if (!b) return a;																	\
		error(BAD_DATA, arg, 2); return Unbound;									\
	}

#define else_if_ARRAY(NAME)															\
	else if (arg->type==ARRAY && ArrayP(arg)->length())						\
	{	ThreadP th=Thread::This();														\
		NodeP a=this;																		\
		NodePP d = ArrayP(arg)->data();												\
		int i=ArrayP(arg)->length();													\
		while (i--)																			\
		{	if (a->circcounter()==th->circcounter)									\
				break;																		\
			else																				\
				a->setcirccounter(th->circcounter);									\
			a = a->NAME(*d++);															\
			if (throwing) return Unbound;												\
		}																						\
		th->setcirccounter(th->circcounter+1);										\
		return a;																			\
	}

#define else_if_FLOATARRAY(NAME)														\
	else if (arg->type==FLOATARRAY && FloatArrayP(arg)->length())			\
	{	double f=getnumber();															\
		doubleP d = FloatArrayP(arg)->data();										\
		int i=FloatArrayP(arg)->length();											\
		while (i--)																			\
		{	if (true)																		\
			{	f = FUNC_##NAME(f, (*d++));											\
				BINARY_FLOAT_ASM(FloatArray)											\
			}else float_overflowFloatArray:											\
			{	Float::reset_FPU();														\
				error(BAD_DATA, arg, 2);												\
				return Unbound;															\
			}																					\
		}																						\
		return new Float(f);																\
	}

#define else_if_INTARRAY(NAME)														\
	else if (arg->type==INTARRAY && IntArrayP(arg)->length())				\
	{	int f=int(getnumber());															\
		intP d = IntArrayP(arg)->data();												\
		int i=IntArrayP(arg)->length();												\
		while (i--)																			\
		{	if (true)																		\
			{	f = FUNC_i##NAME(f, (*d++));											\
				BINARY_FLOAT_ASM(IntArray)												\
			}else float_overflowIntArray:												\
			{	Float::reset_FPU();														\
				error(BAD_DATA, arg, 2);												\
				return Unbound;															\
			}																					\
		}																						\
		return new Float(f);																\
	}

#define BINARY_OP(NAME, SYMBOLNODE, NEUTRAL)										\
NodeP Node::NAME(NodeP arg) {error(BAD_DATA, this); return Unbound;}		\
NodeP Object::NAME(NodeP arg) 														\
{	NodeP n=number();																		\
	if (n != Unbound) return n->NAME(arg);											\
	else return new Tree(SYMBOLNODE,													\
		new Pair(new Colon(this), new Pair(arg, 0)));							\
}																								\
NodeP String::NAME(NodeP arg)															\
{	NodeP n=number();																		\
	if (n != Unbound) return n->NAME(arg);											\
	error(BAD_DATA, this); return Unbound;											\
}																								\
NodeP Int::NAME(NodeP arg)																\
{	if (arg)																					\
	{	if (arg->type==INT_)																\
		{	int iarg=IntP(arg)->int_;													\
			if (true)																		\
			{	int nval = FUNC_i##NAME(int_, iarg);								\
				INT_ASM																		\
				return new Int(nval);													\
			}else																				\
	int_overflow:																			\
				NR_if_(INT_, NAME, double(int_), iarg)								\
		}																						\
		 NR_if_( FLOAT_, NAME,        int_ ,    FloatP(arg)->float_  )		\
		CNR_if_(COMPLEX, NAME, double(int_), ComplexdP(arg)->complex_)		\
		BNR_if_(BIGFLOAT,NAME,   MAPM(int_), BigFloatP(arg)->float_)		\
		else if (arg->type==NINT16)													\
		{	short iarg=Int16P(arg)->int_;												\
			if (true)																		\
			{	int nval = FUNC_i##NAME(int_, iarg);								\
				INT_ASM2																		\
				return new Int(nval);													\
			}else																				\
	int_overflow2:																			\
				NR_if_(NINT16, NAME, double(int_), iarg)							\
		}																						\
		else if (arg->type==NINT8)														\
		{	char iarg=Int8P(arg)->int_;												\
			if (true)																		\
			{	int nval = FUNC_i##NAME(int_, iarg);								\
				INT_ASM3																		\
				return new Int(nval);													\
			}else																				\
	int_overflow3:																			\
				NR_if_(NINT8, NAME, double(int_), iarg)							\
		}																						\
		else if (arg->type==NUINT8)													\
		{	unsigned char iarg=UInt8P(arg)->int_;									\
			if (true)																		\
			{	int nval = FUNC_i##NAME(int_, iarg);								\
				INT_ASM4																		\
				return new Int(nval);													\
			}else																				\
	int_overflow4:																			\
				NR_if_(NUINT8, NAME, double(int_), iarg)							\
		}																						\
		else_if_STRING(NAME, SYMBOLNODE)												\
		else_if_OBJECT(NAME, SYMBOLNODE)												\
		else_if_LIST  (NAME)																\
		else_if_ARRAY (NAME)																\
		else_if_FLOATARRAY (NAME)														\
		else_if_INTARRAY   (NAME)														\
	}																							\
	error(BAD_DATA, this); return Unbound;											\
}																								\
NodeP Int16::NAME(NodeP arg)															\
{	if (arg)																					\
	{	if (arg->type==INT_)																\
		{	int iarg=IntP(arg)->int_;													\
			if (true)																		\
			{	int nval = FUNC_i##NAME(int_, iarg);								\
				INT_ASM																		\
				return new Int(nval);													\
			}else																				\
	int_overflow:																			\
				NR_if_(INT_, NAME, double(int_), iarg)								\
		}																						\
		 NR_if_( FLOAT_, NAME,        int_ ,   FloatP(arg)->float_  )		\
		CNR_if_(COMPLEX, NAME, double(int_), ComplexdP(arg)->complex_)		\
		BNR_if_(BIGFLOAT,NAME,   MAPM(int_), BigFloatP(arg)->float_)		\
		else if (arg->type==NINT16)													\
		{	short iarg=Int16P(arg)->int_;												\
			if (true)																		\
			{	short nval = FUNC_i16##NAME(int_, iarg);							\
				INT16_ASM																	\
				return new Int16(nval);													\
			}else																				\
	int16_overflow:																		\
			{	int iarg=Int16P(arg)->int_;											\
				if (true)																	\
				{	int nval = FUNC_i##NAME(int_, iarg);							\
					INT_ASM2																	\
					return new Int(nval);												\
				}else																			\
	int_overflow2:																			\
					NR_if_(NINT16, NAME, double(int_), iarg)						\
			}																					\
		}																						\
		else if (arg->type==NINT8)														\
		{	char iarg=Int8P(arg)->int_;												\
			if (true)																		\
			{	short nval = FUNC_i16##NAME(int_, iarg);							\
				INT16_ASM2																	\
				return new Int16(nval);													\
			}else																				\
	int16_overflow2:																		\
			{	int iarg=Int8P(arg)->int_;												\
				if (true)																	\
				{	int nval = FUNC_i##NAME(int_, iarg);							\
					INT_ASM3																	\
					return new Int(nval);												\
				}else																			\
	int_overflow3:																			\
					NR_if_(NINT8, NAME, double(int_), iarg)						\
			}																					\
		}																						\
		else if (arg->type==NUINT8)													\
		{	unsigned char iarg=UInt8P(arg)->int_;									\
			if (true)																		\
			{	short nval = FUNC_i16##NAME(int_, iarg);							\
				INT16_ASM3																	\
				return new Int16(nval);													\
			}else																				\
	int16_overflow3:																		\
			{	int iarg=UInt8P(arg)->int_;											\
				if (true)																	\
				{	int nval = FUNC_i##NAME(int_, iarg);							\
					INT_ASM4																	\
					return new Int(nval);												\
				}else																			\
	int_overflow4:																			\
					NR_if_(NUINT8, NAME, double(int_), iarg)						\
			}																					\
		}																						\
		else_if_STRING(NAME, SYMBOLNODE)												\
		else_if_OBJECT(NAME, SYMBOLNODE)												\
		else_if_LIST  (NAME)																\
		else_if_ARRAY (NAME)																\
		else_if_FLOATARRAY (NAME)														\
	}																							\
	error(BAD_DATA, this); return Unbound;											\
}																								\
NodeP Int8::NAME(NodeP arg)															\
{	if (arg)																					\
	{	if (arg->type==INT_)																\
		{	int iarg=IntP(arg)->int_;													\
			if (true)																		\
			{	int nval = FUNC_i##NAME(int_, iarg);								\
				INT_ASM																		\
				return new Int(nval);													\
			}else																				\
	int_overflow:																			\
				NR_if_(INT_, NAME, double(int_), iarg)								\
		}																						\
		 NR_if_( FLOAT_, NAME,        int_ ,   FloatP(arg)->float_  )		\
		CNR_if_(COMPLEX, NAME, double(int_), ComplexdP(arg)->complex_)		\
		BNR_if_(BIGFLOAT,NAME,   MAPM(int_), BigFloatP(arg)->float_)		\
		else if (arg->type==NINT16)													\
		{	short iarg=Int16P(arg)->int_;												\
			if (true)																		\
			{	short nval = FUNC_i16##NAME(int_, iarg);							\
				INT16_ASM																	\
				return new Int16(nval);													\
			}else																				\
	int16_overflow:																		\
			{	int iarg=Int16P(arg)->int_;											\
				if (true)																	\
				{	int nval = FUNC_i##NAME(int_, iarg);							\
					INT_ASM2																	\
					return new Int(nval);												\
				}else																			\
	int_overflow2:																			\
					NR_if_(NINT16, NAME, double(int_), iarg)						\
			}																					\
		}																						\
		else if (arg->type==NINT8)														\
		{	char iarg=Int8P(arg)->int_;												\
			if (true)																		\
			{	char nval = FUNC_i8##NAME(int_, iarg);								\
				INT8_ASM																		\
				return new Int8(nval);													\
			}else																				\
	int8_overflow:																			\
			{	short iarg=Int8P(arg)->int_;											\
				if (true)																	\
				{	short nval = FUNC_i16##NAME(int_, iarg);						\
					INT16_ASM2																\
					return new Int16(nval);												\
				}else																			\
	int16_overflow2:																		\
				{	int iarg=Int8P(arg)->int_;											\
					if (true)																\
					{	int nval = FUNC_i##NAME(int_, iarg);						\
						INT_ASM3																\
						return new Int(nval);											\
					}else																		\
		int_overflow3:																		\
						NR_if_(NINT8, NAME, double(int_), iarg)					\
				}																				\
			}																					\
		}																						\
		else if (arg->type==NUINT8)													\
		{	unsigned char iarg=UInt8P(arg)->int_;									\
			if (true)																		\
			{	unsigned char nval = FUNC_i8##NAME(int_, iarg);					\
				INT8_ASM2																	\
				return new UInt8(nval);													\
			}else																				\
	int8_overflow2:																		\
			{	short iarg=UInt8P(arg)->int_;											\
				if (true)																	\
				{	short nval = FUNC_i16##NAME(int_, iarg);						\
					INT16_ASM3																\
					return new Int16(nval);												\
				}else																			\
	int16_overflow3:																		\
				{	int iarg=UInt8P(arg)->int_;										\
					if (true)																\
					{	int nval = FUNC_i##NAME(int_, iarg);						\
						INT_ASM4																\
						return new Int(nval);											\
					}else																		\
		int_overflow4:																		\
						NR_if_(NUINT8, NAME, double(int_), iarg)					\
				}																				\
			}																					\
		}																						\
		else_if_STRING(NAME, SYMBOLNODE)												\
		else_if_OBJECT(NAME, SYMBOLNODE)												\
		else_if_LIST  (NAME)																\
		else_if_ARRAY (NAME)																\
		else_if_FLOATARRAY (NAME)														\
	}																							\
	error(BAD_DATA, this); return Unbound;											\
}																								\
NodeP UInt8::NAME(NodeP arg)															\
{	if (arg)																					\
	{	if (arg->type==INT_)																\
		{	int iarg=IntP(arg)->int_;													\
			if (true)																		\
			{	int nval = FUNC_i##NAME(int_, iarg);								\
				INT_ASM																		\
				return new Int(nval);													\
			}else																				\
	int_overflow:																			\
				NR_if_(INT_, NAME, double(int_), iarg)								\
		}																						\
		 NR_if_( FLOAT_, NAME,        int_ ,   FloatP(arg)->float_  )		\
		CNR_if_(COMPLEX, NAME, double(int_), ComplexdP(arg)->complex_)		\
		BNR_if_(BIGFLOAT,NAME,   MAPM(int_), BigFloatP(arg)->float_)		\
		else if (arg->type==NINT16)													\
		{	short iarg=Int16P(arg)->int_;												\
			if (true)																		\
			{	short nval = FUNC_i16##NAME(int_, iarg);							\
				INT16_ASM																	\
				return new Int16(nval);													\
			}else																				\
	int16_overflow:																		\
			{	int iarg=Int16P(arg)->int_;											\
				if (true)																	\
				{	int nval = FUNC_i##NAME(int_, iarg);							\
					INT_ASM2																	\
					return new Int(nval);												\
				}else																			\
	int_overflow2:																			\
					NR_if_(NINT16, NAME, double(int_), iarg)						\
			}																					\
		}																						\
		else if (arg->type==NINT8)														\
		{	char iarg=Int8P(arg)->int_;												\
			if (true)																		\
			{	char nval = FUNC_i8##NAME(int_, iarg);								\
				INT8_ASM																		\
				return new Int8(nval);													\
			}else																				\
	int8_overflow:																			\
			{	short iarg=Int8P(arg)->int_;											\
				if (true)																	\
				{	short nval = FUNC_i16##NAME(int_, iarg);						\
					INT16_ASM2																\
					return new Int16(nval);												\
				}else																			\
	int16_overflow2:																		\
				{	int iarg=Int8P(arg)->int_;											\
					if (true)																\
					{	int nval = FUNC_i##NAME(int_, iarg);						\
						INT_ASM3																\
						return new Int(nval);											\
					}else																		\
		int_overflow3:																		\
						NR_if_(NINT8, NAME, double(int_), iarg)					\
				}																				\
			}																					\
		}																						\
		else if (arg->type==NUINT8)													\
		{	unsigned char iarg=UInt8P(arg)->int_;									\
			if (true)																		\
			{	unsigned char nval = FUNC_i8##NAME(int_, iarg);					\
				INT8_ASM2																	\
				return new UInt8(nval);													\
			}else																				\
	int8_overflow2:																		\
			{	short iarg=UInt8P(arg)->int_;											\
				if (true)																	\
				{	short nval = FUNC_i16##NAME(int_, iarg);						\
					INT16_ASM3																\
					return new Int16(nval);												\
				}else																			\
	int16_overflow3:																		\
				{	int iarg=UInt8P(arg)->int_;										\
					if (true)																\
					{	int nval = FUNC_i##NAME(int_, iarg);						\
						INT_ASM4																\
						return new Int(nval);											\
					}else																		\
		int_overflow4:																		\
						NR_if_(NUINT8, NAME, double(int_), iarg)					\
				}																				\
			}																					\
		}																						\
		else_if_STRING(NAME, SYMBOLNODE)												\
		else_if_OBJECT(NAME, SYMBOLNODE)												\
		else_if_LIST  (NAME)																\
		else_if_ARRAY (NAME)																\
		else_if_FLOATARRAY (NAME)														\
	}																							\
	error(BAD_DATA, this); return Unbound;											\
}																								\
NodeP Float::NAME(NodeP arg)															\
{	if (arg)																					\
	{	 NR_if_( INT_  , NAME, float_,     IntP(arg)->int_  )					\
		 NR_if_( FLOAT_, NAME, float_,   FloatP(arg)->float_)					\
		CNR_if_(COMPLEX, NAME, float_, ComplexdP(arg)->complex_)				\
		 NR_if_( NINT16 , NAME, float_,   Int16P(arg)->int_  )				\
		 NR_if_( NINT8  , NAME, float_,    Int8P(arg)->int_  )				\
		 NR_if_( NUINT8 , NAME, float_,   UInt8P(arg)->int_  )				\
		BNR_if_(BIGFLOAT,NAME, float_,BigFloatP(arg)->float_)					\
		else_if_STRING(NAME, SYMBOLNODE)												\
		else_if_OBJECT(NAME, SYMBOLNODE)												\
		else_if_LIST  (NAME)																\
		else_if_ARRAY (NAME)																\
		else_if_FLOATARRAY (NAME)														\
	}																							\
	error(BAD_DATA, this); return Unbound;											\
}																								\
NodeP BigFloat::NAME(NodeP arg)														\
{	if (arg)																					\
	{	BNR_if_( INT_  , NAME, float_,     IntP(arg)->int_  )					\
		BNR_if_( FLOAT_, NAME, float_,MAPM(FloatP(arg)->float_))				\
		BNR_if_(BIGFLOAT,NAME, float_,BigFloatP(arg)->float_)					\
		BNR_if_( NINT16 , NAME, float_,   Int16P(arg)->int_  )				\
		BNR_if_( NINT8  , NAME, float_,    Int8P(arg)->int_  )				\
		BNR_if_( NUINT8 , NAME, float_,   UInt8P(arg)->int_  )				\
		else_if_STRING(NAME, SYMBOLNODE)												\
		else_if_OBJECT(NAME, SYMBOLNODE)												\
		else_if_LIST  (NAME)																\
		else_if_ARRAY (NAME)																\
		else_if_FLOATARRAY (NAME)														\
	}																							\
	error(BAD_DATA, this); return Unbound;											\
}																								\
NodeP Complexd::NAME(NodeP arg)														\
{	if (arg)																					\
	{	CNR_if_(  INT_ , NAME, complex_,   double(IntP(arg)->int_)   )		\
		CNR_if_( FLOAT_, NAME, complex_,        FloatP(arg)->float_  )		\
		CNR_if_(COMPLEX, NAME, complex_,     ComplexdP(arg)->complex_)		\
		CNR_if_( NINT16 , NAME, complex_, double(Int16P(arg)->int_)   )	\
		CNR_if_( NINT8  , NAME, complex_,  double(Int8P(arg)->int_)   )	\
		CNR_if_( NUINT8 , NAME, complex_, double(UInt8P(arg)->int_)   )	\
		else_if_STRING(NAME, SYMBOLNODE)												\
		else_if_OBJECT(NAME, SYMBOLNODE)												\
		else_if_LIST  (NAME)																\
		else_if_ARRAY (NAME)																\
		else_if_FLOATARRAY (NAME)														\
	}																							\
	error(BAD_DATA, this); return Unbound;											\
}																								\
NodeP Pair::NAME(NodeP arg)															\
{	ThreadP th=Thread::This();															\
	if (this && circcounter()==th->circcounter)									\
		return 0;																			\
	PairP a=this, result=0, lastnode=0, tnode=0;									\
	if (a->type==TREE)																	\
	{	return new Tree(																	\
			SYMBOLNODE, new Pair(this, new Pair(arg, 0)));						\
	}																							\
	if (arg->islist())																	\
	{	PairP b = PairP(arg);															\
		if (depth() > b->depth())														\
		{	while (a)																		\
			{	if (a->circcounter()==th->circcounter)								\
					break;																	\
				else																			\
					a->setcirccounter(th->circcounter);								\
				tnode = new Pair(a->first()->NAME(arg), 0);						\
				if (throwing) return Unbound;											\
				if (result)																	\
					lastnode->settail( tnode );										\
				else																			\
					result=tnode;															\
				lastnode=tnode;															\
				next(a);																		\
			}																					\
			th->setcirccounter(th->circcounter+1);									\
			if (!a) return result;														\
		}else																					\
		{	while (a && b)																	\
			{	if (a->circcounter()==th->circcounter)								\
					break;																	\
				else																			\
					a->setcirccounter(th->circcounter);								\
				tnode = new Pair(a->first()->NAME( b->first() ), 0);			\
				if (throwing) return Unbound;											\
				if (result)																	\
					lastnode->settail( tnode );										\
				else																			\
					result=tnode;															\
				lastnode=tnode;															\
				next(a);																		\
				next(b);																		\
			}																					\
			th->setcirccounter(th->circcounter+1);									\
			if (!a && !b) return result;												\
		}																						\
	}																							\
	else if (arg->type==ARRAY)															\
	{	NodePP bd = ArrayP(arg)->data();												\
		int ai = 0, bi = ArrayP(arg)->length();									\
		while (a)																			\
		{	if (a->circcounter()==th->circcounter)									\
				break;																		\
			else																				\
				a->setcirccounter(th->circcounter);									\
			NodeP r = a->first();														\
			int i = bi;																		\
			NodePP b=bd;																	\
			while (i--)																		\
			{	if ((*b)->islist())														\
					r = r->NAME((*b++)->item(ai));									\
				else error(BAD_DATA, this);											\
				if (throwing) return Unbound;											\
			}																					\
			tnode = new Pair(r, 0);														\
			if (throwing) return Unbound;												\
			if (result)																		\
				lastnode->settail( tnode );											\
			else																				\
				result=tnode;																\
			lastnode=tnode;																\
			next(a);	ai++;																	\
		}																						\
		th->setcirccounter(th->circcounter+1);										\
		 if (!a) return result;															\
	}																							\
	else if (arg->type==INT_ || arg->type==FLOAT_ || arg->type==COMPLEX	\
			|| arg->type==NINT16|| arg->type==NINT8 || arg->type==NUINT8)	\
	{	while (a)																			\
		{	if (a->circcounter()==th->circcounter)									\
				break;																		\
			else																				\
				a->setcirccounter(th->circcounter);									\
			tnode = new Pair(a->first()->NAME(arg), 0);							\
			if (throwing) return Unbound;												\
			if (result)																		\
				lastnode->settail( tnode );											\
			else																				\
				result=tnode;																\
			lastnode=tnode;																\
			next(a);																			\
		}																						\
		th->setcirccounter(th->circcounter+1);										\
		if (!a) return result;															\
	}																							\
	else_if_STRING(NAME, SYMBOLNODE)													\
	else_if_OBJECT(NAME, SYMBOLNODE)													\
	error(BAD_DATA, this); return Unbound;											\
}																								\
NodeP Array::NAME(NodeP arg)															\
{	ThreadP th=Thread::This();															\
	if (this && circcounter()==th->circcounter)									\
		return 0;																			\
	else																						\
		setcirccounter(th->circcounter);												\
	if (!arg)																				\
	{	error(BAD_DATA, this); return Unbound;										\
	}																							\
	NodePP a=data();																		\
	if (arg->type==ARRAY)																\
	{	NodePP b = ArrayP(arg)->data();												\
		int i=length();																	\
		if (i==ArrayP(arg)->length())													\
		{	ArrayP result=0;  result = new Array(length(), origin());		\
			if throwing return Unbound;												\
			NodePP c=result->data();													\
			while (i--)																		\
			{	if (*a)																		\
					*c = (*a)->NAME(*b);													\
				else																			\
				{	error(BAD_DATA, this);												\
					return Unbound;														\
				}																				\
				a++, b++;																	\
				result->check_oldyoung(*c++);											\
				if (throwing) return Unbound;											\
			}																					\
			th->setcirccounter(th->circcounter+1);									\
			return result;																	\
		}																						\
	}																							\
	else if (arg->is.list																\
			|| arg->type==INT_ || arg->type==FLOAT_ || arg->type==COMPLEX	\
			|| arg->type==NINT16|| arg->type==NINT8 || arg->type==NINT8)	\
	{	ArrayP result=0;  result = new Array(length(), origin());			\
		if throwing return Unbound;													\
		NodePP c=result->data();														\
		int i=length();																	\
		while (i--)																			\
		{	if (*a)																			\
				*c = (*a)->NAME(arg);													\
			else																				\
			{	error(BAD_DATA, this);													\
				return Unbound;															\
			}																					\
			a++;																				\
			result->check_oldyoung(*c++);												\
			if (throwing) return Unbound;												\
		}																						\
		th->setcirccounter(th->circcounter+1);										\
		return result;																		\
	}																							\
	else_if_STRING(NAME, SYMBOLNODE)													\
	else_if_OBJECT(NAME, SYMBOLNODE)													\
	error(BAD_DATA, this); return Unbound;											\
}																								\
NodeP IntArray::NAME(NodeP arg)														\
{	if (!arg)																				\
	{	error(BAD_DATA, this); return Unbound;										\
	}																							\
	intP a=_data;																			\
	if (arg->type==INTARRAY)															\
	{	intP b = IntArrayP(arg)->_data;												\
		int l=length(), l2=IntArrayP(arg)->length();								\
		if (l2 < l) l=l2;																	\
		IntArrayP result=0;  result = new IntArray(length(), origin());	\
		if throwing return Unbound;													\
		intP c=result->_data;															\
		while (l--)																			\
			(*c++) = Int::clip(FUNC_i##NAME((*a++), (*b++)));					\
		return result;																		\
	}																							\
	else if (arg->type==INT_)															\
	{	IntArrayP result=0;  result = new IntArray(length(), origin());	\
		if throwing return Unbound;													\
		intP c=result->_data;															\
		int l=length(), i=IntP(arg)->int_;											\
		while (l--)																			\
			(*c++) = Int::clip(FUNC_i##NAME((*a++), i));							\
		return result;																		\
	}																							\
	else_if_STRING(NAME, SYMBOLNODE)													\
	else_if_OBJECT(NAME, SYMBOLNODE)													\
	error(BAD_DATA, this); return Unbound;											\
}																								\
NodeP Int16Array::NAME(NodeP arg)													\
{	if (!arg)																				\
	{	error(BAD_DATA, this); return Unbound;										\
	}																							\
	shortP a=_data;																		\
	if (arg->type==INT16ARRAY)															\
	{	shortP b = Int16ArrayP(arg)->_data;											\
		int l=length(), l2=Int16ArrayP(arg)->length();							\
		if (l2 < l) l=l2;																	\
		Int16ArrayP result=0;															\
		result = new Int16Array(l, origin());										\
		if throwing return Unbound;													\
		shortP c=result->_data;															\
		while (l--)																			\
			(*c++) = Int16::clip(FUNC_i16##NAME((*a++), (*b++)));				\
		return result;																		\
	}																							\
	else if (arg->type==INT_)															\
	{	Int16ArrayP result=0;															\
		result = new Int16Array(length(), origin());								\
		if throwing return Unbound;													\
		shortP c=result->_data;															\
		int l=length(), i=IntP(arg)->int_;											\
		while (l--)																			\
			(*c++) = Int16::clip(FUNC_i##NAME((*a++), i));						\
		return result;																		\
	}																							\
	else if (arg->type==FLOAT_)														\
	{	FloatArrayP result=0;															\
		result = new FloatArray(length(), origin());								\
		if throwing return Unbound;													\
		doubleP c=result->data();														\
		int l=length();																	\
		double d=FloatP(arg)->float_;													\
		while (l--)																			\
		{	double f = FUNC_##NAME((*a++), d);										\
			(*c++) = f;																		\
		}																						\
		return result;																		\
	}																							\
	else_if_STRING(NAME, SYMBOLNODE)													\
	else_if_OBJECT(NAME, SYMBOLNODE)													\
	error(BAD_DATA, this); return Unbound;											\
}																								\
NodeP FloatArray::NAME(NodeP arg)													\
{	if (!arg)																				\
	{	error(BAD_DATA, this); return Unbound;										\
	}																							\
	doubleP a=_data;																		\
	if (arg->type==FLOATARRAY)															\
	{	doubleP b = FloatArrayP(arg)->_data;										\
		int l=length(), l2=FloatArrayP(arg)->length();							\
		if (l2 < l) l=l2;																	\
		FloatArrayP result=0;															\
		result = new FloatArray(length(), origin());								\
		if throwing return Unbound;													\
		doubleP c=result->_data;														\
		while (l--)																			\
		{	double f = FUNC_##NAME((*a++), (*b++));								\
			(*c++) = f;																		\
		}																						\
		return result;																		\
	}																							\
	else if (arg->type==FLOAT_)														\
	{	FloatArrayP result=0;															\
		result = new FloatArray(length(), origin());								\
		if throwing return Unbound;													\
		doubleP c=result->_data;														\
		int l=length();																	\
		double d=FloatP(arg)->float_;													\
		while (l--)																			\
		{	double aa=*a++;																\
			{	double a=aa;																\
				double f = FUNC_##NAME(a, d);											\
				(*c++) = f;																	\
			}																					\
		}																						\
		return result;																		\
	}																							\
	else if (arg->type==INT_)															\
	{	FloatArrayP result=0;															\
		result = new FloatArray(length(), origin());								\
		if throwing return Unbound;													\
		doubleP c=result->_data;														\
		int l=length(), i=IntP(arg)->int_;											\
		while (l--)																			\
		{	double f = FUNC_##NAME((*a++), i);										\
			(*c++) = f;																		\
		}																						\
		return result;																		\
	}																							\
	else if (arg->type==NINT16)														\
	{	FloatArrayP result=0;															\
		result = new FloatArray(length(), origin());								\
		if throwing return Unbound;													\
		doubleP c=result->_data;														\
		int l=length(), i=Int16P(arg)->int_;										\
		while (l--)																			\
		{	double f = FUNC_##NAME((*a++), i);										\
			(*c++) = f;																		\
		}																						\
		return result;																		\
	}																							\
	else_if_STRING(NAME, SYMBOLNODE)													\
	else_if_OBJECT(NAME, SYMBOLNODE)													\
	error(BAD_DATA, this); return Unbound;											\
}																								\
NodeP Bitmap::NAME(NodeP arg)															\
{																								\
	if (arg)																					\
	{	if (arg->type==FLOAT_)															\
		{	double b=FloatP(arg)->float_;												\
			if throwing return Unbound;												\
			ColorP rpixels=ColorP(malloc(winx*winy*sizeof(Color)));			\
			BitmapP result=new Bitmap(width, height, winx, winy, rpixels);	\
			if throwing return Unbound;												\
			for (int i=winx*winy-1; i>=0; i--)										\
			{	Color c=pixels[i];														\
				double a,f;																	\
				if (true)																	\
				{	{	a=double(c.r)/255;												\
						f = FUNC_##NAME(a, b);											\
						BINARY_FLOAT_ASM(float)											\
						rpixels[i].r=(unsigned char)(f*255);						\
					}{	a=double(c.g)/255;												\
						f = FUNC_##NAME(a, b);											\
						BINARY_FLOAT_ASM(float)											\
						rpixels[i].g=(unsigned char)(f*255);						\
					}{	a=double(c.b)/255;												\
						f = FUNC_##NAME(a, b);											\
						BINARY_FLOAT_ASM(float)											\
						rpixels[i].b=(unsigned char)(f*255);						\
					}																			\
				}else																			\
				{float_overflowfloat:													\
					Float::reset_FPU();													\
					error(BAD_DATA, this); return Unbound;							\
				}																				\
			}																					\
			return result;																	\
		}																						\
	}																							\
	error(BAD_DATA, this); return Unbound;											\
}																								\
NodeP l##NAME(PairPP arg)																\
{	if (!exist(3))																			\
		if (exist(2) && arg[1])															\
			return arg[1]->NAME(arg[2]);												\
		else if (exist(1))																\
		{	if (arg[1])																		\
				return arg[1]->NAME(NEUTRAL->var());/* not really correct!!! */\
			else																				\
				return 0;																	\
		}else																					\
			return NEUTRAL->var();														\
	if (!arg[1])																			\
	{	error(BAD_DATA, arg[1], 1); return Unbound;								\
	}																							\
	int nr=1;																				\
	NodeP a = (*++arg)->a_number(nr++);												\
	NodeType type=type_of(a);   														\
	char i8;	short i16;	int i;   double f;   complexd c;						\
	enum Mode {I8MODE, I16MODE, IMODE, FMODE, CMODE};							\
	Mode imode;																				\
																								\
	     if (type== NINT16 ) {i16=  Int16P(a)->    int_; imode=I16MODE;}	\
	else if (type== NINT8  ) {i8 =   Int8P(a)->    int_; imode= I8MODE;}	\
	else if (type== INT_  ) {i =     IntP(a)->    int_; imode=  IMODE;}	\
	else if (type== FLOAT_) {f =   FloatP(a)->  float_; imode=  FMODE;}	\
	else if (type==COMPLEX) {c =ComplexdP(a)->complex_; imode=  CMODE;}	\
	else {error(BAD_DATA, a); return Unbound;}									\
																								\
	ThreadP th=Thread::This();															\
	while (NodePP(arg)!=th->argStack->index  &&  !throwing) 					\
	{																							\
		a = (*++arg)->a_number(nr++);													\
		if (throwing) return Unbound;													\
		char i8arg; short i16arg; int iarg; double farg; complexd carg;	\
																								\
		if (type_of(a)==NINT8) 															\
		{	switch (imode)																	\
			{	case  I8MODE:  i8arg=IntP(a)->int_; break;						\
				case I16MODE: i16arg=IntP(a)->int_; break;						\
				case   IMODE: iarg = IntP(a)->int_; break;						\
				case   FMODE: farg = IntP(a)->int_; break;						\
				case   CMODE: carg = IntP(a)->int_; break;						\
			}																					\
		}																						\
		if (type_of(a)==NINT16) 														\
		{	switch (imode)																	\
			{	case  I8MODE: i16=i8; imode=I16MODE; break;						\
				case I16MODE: i16arg=IntP(a)->int_; break;						\
				case   IMODE: iarg = IntP(a)->int_; break;						\
				case   FMODE: farg = IntP(a)->int_; break;						\
				case   CMODE: carg = IntP(a)->int_; break;						\
			}																					\
		}																						\
		else if (type_of(a)==INT_) 													\
		{	switch (imode)																	\
			{	case  I8MODE: i=i8;	imode=IMODE; break;							\
				case I16MODE: i=i16;	imode=IMODE; break;							\
				case   IMODE: iarg = IntP(a)->int_; break;						\
				case   FMODE: farg = IntP(a)->int_; break;						\
				case   CMODE: carg = IntP(a)->int_; break;						\
			}																					\
		}else if (type_of(a)==FLOAT_)													\
		{	switch (imode)																	\
			{	case  I8MODE: f=i8;	imode=FMODE; break;							\
				case I16MODE: f=i16;	imode=FMODE; break;							\
				case   IMODE: f=i;	imode=FMODE; break;							\
				default: ;																	\
			}																					\
			farg = FloatP(a)->float_;													\
		}																						\
		else if (type_of(a)==COMPLEX)													\
		{	switch (imode)																	\
			{	case  I8MODE: c=i8;	imode=CMODE; break;							\
				case I16MODE: c=i16;	imode=CMODE; break;							\
				case   IMODE: c=i;	imode=CMODE; break;							\
				case   FMODE: c=f;	imode=CMODE; break;							\
				default: ;																	\
			}																					\
			carg = ComplexdP(a)->complex_;											\
		}																						\
		switch (imode)																		\
		{	case I8MODE:																	\
				if (true) 																	\
				{	char nval = FUNC_i8##NAME(i8, i8arg);							\
					INT8_ASM	i8=nval;														\
				}else																			\
	int8_overflow:																			\
					if (true)																\
					{	imode=I16MODE;														\
						short nval = FUNC_i16##NAME(short(i8), short(i8arg));	\
						INT16_ASM	i16=nval;											\
					}else																		\
	int16_overflow:																		\
						if (true)															\
						{	imode=IMODE;													\
							int nval = FUNC_i##NAME(int(i8), int(i8arg));		\
							INT_ASM	i=nval;												\
						}else																	\
	int_overflow:	{imode=FMODE;  f = FUNC_##NAME(double(i8), i8arg);}	\
				break;																		\
																								\
			case I16MODE:																	\
				if (true) 																	\
				{	short nval = FUNC_i16##NAME(i16, i16arg);						\
					INT16_ASM2	i16=nval;												\
				}else																			\
	int16_overflow2:																		\
					if (true)																\
					{	imode=IMODE;														\
						int nval = FUNC_i##NAME(int(i16), int(i16arg));			\
						INT_ASM2	i=nval;													\
					}else																		\
	int_overflow2: {imode=FMODE;  f = FUNC_##NAME(double(i16), i16arg);}	\
				break;																		\
																								\
			case IMODE:																		\
				if (true) 																	\
				{	int nval = FUNC_i##NAME(i, iarg);								\
					INT_ASM3	i=nval;														\
				}else																			\
	int_overflow3: {imode=FMODE;  f = FUNC_##NAME(double(i), iarg);}		\
				break;																		\
																								\
			case FMODE:																		\
				if (true)																	\
				{	f = FUNC_##NAME(f, farg);											\
					FLOAT_ASM																\
				}else																			\
	float_overflow: {Float::reset_FPU();  error(BAD_DATA, a, nr-1);}		\
				break;																		\
																								\
			case CMODE:																		\
				if (true)																	\
				{	c = FUNC_c##NAME(c, carg);											\
					COMPLEX_ASM																\
				}else																			\
	complex_overflow: {Float::reset_FPU();  error(BAD_DATA, a, nr-1);}	\
				break;																		\
		}																						\
	}																							\
	if (!throwing) 																		\
	{	switch (imode)																		\
		{	case  I8MODE: return new     Int8(i);									\
			case I16MODE: return new    Int16(i);									\
			case   IMODE: return new      Int(i);									\
			case   FMODE: return new    Float(f);									\
			case   CMODE: return new Complexd(c);									\
		}																						\
	}																							\
	return Unbound;																		\
}

#define FUNC_add(a,b)		a+b
#define FUNC_badd(a,b)		a+b
#define FUNC_cadd(a,b)		a+b
#define FUNC_iadd(a,b)		a+b
#define FUNC_i16add(a,b)	a+b
#define FUNC_i8add(a,b)		a+b
#define FUNC_sub(a,b)		a-b
#define FUNC_csub(a,b)		a-b
#define FUNC_bsub(a,b)		a-b
#define FUNC_isub(a,b)		a-b
#define FUNC_i16sub(a,b)	a-b
#define FUNC_i8sub(a,b)		a-b
#define FUNC_mul(a,b)		a*b
#define FUNC_bmul(a,b)		a*b
#define FUNC_cmul(a,b)		a*b
#define FUNC_imul(a,b)		a*b
#define FUNC_i16mul(a,b)	a*b > Int16::max ? Int::max+1 : a*b
#define FUNC_i8mul(a,b)		a*b > Int8::max ? Int::max+1 : a*b
#define FUNC_div(a,b)		a/b
#define FUNC_bdiv(a,b)		a/b
#define FUNC_cdiv(a,b)		a/b
#define FUNC_idiv(a,b)		b? (a%b? Int::max+1 : a/b) : Int::max+1
#define FUNC_i16div(a,b)	b? (a%b? Int::max+1 : a/b) : Int::max+1
#define FUNC_i8div(a,b)		b? (a%b? Int::max+1 : a/b) : Int::max+1

#define FUNC_mod(a,b)		Float::mod(a, b)
#define FUNC_bmod(a,b)		BigFloat::mod(a, b)
#define FUNC_cmod(a,b)		Complexd::mod(a, b)
#define FUNC_imod(a,b)		Int::mod(a, b)
#define FUNC_i16mod(a,b)	Int::mod(a, b)
#define FUNC_i8mod(a,b)		Int::mod(a, b)
#define FUNC_Remainder(a,b)		Float::Remainder(a, b)
#define FUNC_bRemainder(a,b)		BigFloat::Remainder(a, b)
#define FUNC_cRemainder(a,b)		Complexd::Remainder(a, b)
#define FUNC_iRemainder(a,b)		Int::Remainder(a, b)
#define FUNC_i16Remainder(a,b)	Int::Remainder(a, b)
#define FUNC_i8Remainder(a,b)		Int::Remainder(a, b)

#define FUNC_aShift(a,b)		int(a)*pow(2.0, b)
#define FUNC_baShift(a,b)		a*pow(2.0, b)
#define FUNC_caShift(a,b)		a*std::pow(double(2), complexd(b))
#define FUNC_iaShift(a,b)		b>=0? a<<b : int(unsigned(a)>>-b)
#define FUNC_i16aShift(a,b)		b>=0? a<<b : short(unsigned(a)>>-b)
#define FUNC_i8aShift(a,b)		b>=0? a<<b : char(unsigned(a)>>-b)
#define FUNC_lShift(a,b)	fabs(double(unsigned(a)))*pow(2.0, b)
#define FUNC_blShift(a,b)	fabs(a)*pow(2.0, b)
#define FUNC_clShift(a,b)										\
	complexd(Float::abs(complexd(a).real()),				\
				Float::abs(complexd(a).imag()))*std::pow(double(2), complexd(b))
#define FUNC_ilShift(a,b)  b>=0? int(((unsigned)a)<<b) : int(((unsigned)a)>>-b)
#define FUNC_i16lShift(a,b)	b>=0? a<<b : a>>-b
#define FUNC_i8lShift(a,b)	b>=0? a<<b : a>>-b

#define FUNC_BitOr(a,b)			0; return new Int((unsigned int)(a) | (unsigned int)(b));
#define FUNC_bBitOr(a,b)		Float::NaN
#define FUNC_cBitOr(a,b)		Float::NaN
#define FUNC_iBitOr(a,b)		a|b
#define FUNC_i16BitOr(a,b)		a|b
#define FUNC_i8BitOr(a,b)		a|b
#define FUNC_BitAnd(a,b)		0; return new Int((unsigned int)(a) & (unsigned int)(b));
#define FUNC_bBitAnd(a,b)		Float::NaN
#define FUNC_cBitAnd(a,b)		Float::NaN
#define FUNC_iBitAnd(a,b)		a&b
#define FUNC_i16BitAnd(a,b)		a&b
#define FUNC_i8BitAnd(a,b)		a&b
#define FUNC_BitXOr(a,b)		0; return new Int((unsigned int)(a) ^ (unsigned int)(b));
#define FUNC_bBitXOr(a,b)		Float::NaN
#define FUNC_cBitXOr(a,b)		Float::NaN
#define FUNC_iBitXOr(a,b)		a^b
#define FUNC_i16BitXOr(a,b)	a^b
#define FUNC_i8BitXOr(a,b)		a^b

#define FUNC_Power(a,b)		0; {if (a==0.0 && b==0.0) f=Float::NaN; \
	else if (a<0) return new Complexd(std::pow(complexd(a), complexd(b))); \
	else f=pow(a, b);}
#define FUNC_bPower(a,b)	0; f=pow(a,b);//{if (a >= 0.0) f=pow(a, b); else f=BigFloat::NaN;}
#define FUNC_cPower(a,b)	std::pow(a, complexd(b))
#define FUNC_iPower(a,b)	Int::max+1
#define FUNC_i16Power(a,b)	Int::max+1
#define FUNC_i8Power(a,b)	Int::max+1
#define FUNC_ArcTan(a,b)	atan2(b, a)/Float::deg2rad
#define FUNC_bArcTan(a,b)	atan2(b, a)/BigFloat::deg2rad
#define FUNC_cArcTan(a,b)	Float::NaN
#define FUNC_iArcTan(a,b)	Int::max+1
#define FUNC_i16ArcTan(a,b)	Int::max+1
#define FUNC_i8ArcTan(a,b)	Int::max+1
#define FUNC_radArcTan(a,b)	atan2(b, a)
#define FUNC_bradArcTan(a,b)	atan2(b, a)
#define FUNC_cradArcTan(a,b)	Float::NaN
#define FUNC_iradArcTan(a,b)	Int::max+1
#define FUNC_i16radArcTan(a,b)	Int::max+1
#define FUNC_i8radArcTan(a,b)	Int::max+1

BINARY_OP(add,  _Plus_Sign, _Zeroo)
BINARY_OP(sub, _Minus_Sign, _Zeroo)

BINARY_OP(mul,   _Mul_Sign, _One)
BINARY_OP(div,   _Div_Sign, _One)
BINARY_OP(mod,   _Mod_Sign, _Zeroo)
BINARY_OP(Remainder, _Remainder_, _Zeroo)

BINARY_OP(aShift, _AShift, _One)
BINARY_OP(lShift, _LShift, _One)
BINARY_OP(BitOr,   _BitOr, _Zeroo)
BINARY_OP(BitAnd, _BitAnd, _Minus_One)
BINARY_OP(BitXOr, _BitXOr, _Zeroo)

BINARY_OP(Power, _Power_, _One)
BINARY_OP(ArcTan,    _ArcTan_, _Zeroo)
BINARY_OP(radArcTan, _RadArcTan_, _Zeroo)

#define _XFUNC_virtuals(NAME)															\
void Node::NAME(NodeP arg) {error(BAD_DATA, this);}							\
void String::NAME(NodeP arg) {error(BAD_DATA, this);}							\
void Object::NAME(NodeP arg) {var()->NAME(arg);}								\
void Int::NAME(NodeP arg)																\
{	if (type_of(arg)==INT_)	FUNC_i##NAME(int_, IntP(arg)->int_);			\
	else error(BAD_DATA, this);														\
}																								\
void Int16::NAME(NodeP arg)															\
{	if (type_of(arg)==NINT16)	FUNC_i##NAME(int_, Int16P(arg)->int_);		\
	else error(BAD_DATA, this);														\
}																								\
void Int8::NAME(NodeP arg)																\
{	if (type_of(arg)==NINT8)	FUNC_i##NAME(int_, Int8P(arg)->int_);		\
	else error(BAD_DATA, this);														\
}																								\
void UInt8::NAME(NodeP arg)															\
{	if (type_of(arg)==NUINT8)	FUNC_i##NAME(int_, UInt8P(arg)->int_);		\
	else error(BAD_DATA, this);														\
}																								\
void Float::NAME(NodeP arg)															\
{	if (type_of(arg)==FLOAT_)															\
		FUNC_##NAME(float_, FloatP(arg)->float_);									\
	else if (type_of(arg)==INT_)														\
		FUNC_##NAME(float_, IntP(arg)->int_);										\
	else error(BAD_DATA, this);														\
}																								\
void BigFloat::NAME(NodeP arg)														\
{	if (type_of(arg)==FLOAT_)															\
		FUNC_b##NAME(float_, FloatP(arg)->float_);								\
	else if (type_of(arg)==INT_)														\
		FUNC_b##NAME(float_, IntP(arg)->int_);										\
	else if (type_of(arg)==BIGFLOAT)													\
		FUNC_b##NAME(float_, BigFloatP(arg)->float_);							\
	else error(BAD_DATA, this);														\
}																								\
void Complexd::NAME(NodeP arg)														\
{	if (type_of(arg)==COMPLEX)															\
		FUNC_c##NAME(complex_, ComplexdP(arg)->complex_);						\
	else if (type_of(arg)==FLOAT_)													\
		FUNC_c##NAME(complex_, FloatP(arg)->float_);								\
	else if (type_of(arg)==INT_)														\
		FUNC_c##NAME(complex_, IntP(arg)->int_);									\
	else error(BAD_DATA, this);														\
}																								\
void Pair::NAME(NodeP arg)																\
{	ThreadP th=Thread::This();															\
	if (this && circcounter()==th->circcounter)									\
		return;																				\
	PairP a=this;																			\
	if (arg->islist())																	\
	{	PairP b=PairP(arg);																\
		while (a && b)																		\
		{	if (a->circcounter()==th->circcounter)									\
				break;																		\
			else																				\
				a->setcirccounter(th->circcounter);									\
			if (a->first())																\
				a->first()->NAME( b->first() );										\
			if (throwing) return;														\
			next(a); next(b);																\
		}																						\
		th->setcirccounter(th->circcounter+1);										\
		if (!a && !b) return;															\
	}																							\
	else																						\
	{	while (a)																			\
		{	if (a->circcounter()==th->circcounter)									\
				break;																		\
			else																				\
				a->setcirccounter(th->circcounter);									\
			if (a->first())																\
				a->first()->NAME(arg);													\
			if (throwing) return;														\
			next(a);																			\
		}																						\
		th->setcirccounter(th->circcounter+1);										\
		if (!a) return;																	\
	}																							\
	error(BAD_DATA, this);																\
}																								\
void Array::NAME(NodeP arg)															\
{	ThreadP th=Thread::This();															\
	if (this && circcounter()==th->circcounter)									\
		return;																				\
	else																						\
		setcirccounter(th->circcounter);												\
	if (type_of(arg)==ARRAY)															\
	{	int i=length();																	\
		if (i==ArrayP(arg)->length())													\
		{	NodePP a=data(), b=ArrayP(arg)->data();								\
			while (i>0 && *a)																\
			{	(*a++)->NAME(*b++);														\
				i--;																			\
				if (throwing) return;													\
			}																					\
		}																						\
		else																					\
			error(BAD_DATA, arg, 2);													\
	}																							\
	else																						\
	{	int i=length();																	\
		NodePP a=data();																	\
		while (i>0 && *a && !throwing)												\
		{	(*a++)->NAME(arg);															\
			i--;																				\
			if (throwing) return;														\
		}																						\
	}																							\
	th->setcirccounter(th->circcounter+1);											\
	return;																					\
}																								\
void IntArray::NAME(NodeP arg)														\
{	if (type_of(arg)==INTARRAY)														\
	{	int i=length();																	\
		if (i==IntArrayP(arg)->length())												\
		{	intP a=_data, b=IntArrayP(arg)->_data;									\
			while (i-- && *a)																\
				FUNC_i##NAME((*a++), (*b++));											\
		}																						\
		else																					\
			error(BAD_DATA, arg, 2);													\
	}																							\
	else																						\
	{	if (type_of(arg)!=INT_)															\
		{	error(BAD_DATA, arg, 2);													\
			return;																			\
		}																						\
		int i=IntP(arg)->int_, l=length();											\
		intP a=_data;																		\
		while (l-- && *a)																	\
			FUNC_i##NAME((*a++), i);													\
	}																							\
	return;																					\
}																								\
void Int16Array::NAME(NodeP arg)														\
{	if (type_of(arg)==INT16ARRAY)														\
	{	int i=length();																	\
		if (i==Int16ArrayP(arg)->length())											\
		{	shortP a=_data, b=Int16ArrayP(arg)->_data;							\
			while (i-- && *a)																\
				FUNC_i##NAME((*a++), (*b++));											\
		}																						\
		else																					\
			error(BAD_DATA, arg, 2);													\
	}																							\
	else																						\
	{	if (type_of(arg)!=NINT16)														\
		{	error(BAD_DATA, arg, 2);													\
			return;																			\
		}																						\
		short i=Int16P(arg)->int_, l=length();										\
		shortP a=_data;																	\
		while (l-- && *a)																	\
			FUNC_i##NAME((*a++), i);													\
	}																							\
	return;																					\
}																								\
void FloatArray::NAME(NodeP arg)														\
{	if (type_of(arg)==FLOATARRAY)														\
	{	int i=length();																	\
		if (i==FloatArrayP(arg)->length())											\
		{	doubleP a=_data, b=FloatArrayP(arg)->_data;							\
			while (i-- && *a)																\
				FUNC_##NAME((*a++), (*b++));											\
		}																						\
		else																					\
			error(BAD_DATA, arg, 2);													\
	}																							\
	else																						\
	{	if (type_of(arg)!=FLOAT_)														\
		{	error(BAD_DATA, arg, 2);													\
			return;																			\
		}																						\
		double i=FloatP(arg)->float_, l=length();									\
		doubleP a=_data;																	\
		while (l-- && *a)																	\
				FUNC_##NAME((*a++), i);													\
	}																							\
	return;																					\
}																								\
void Bitmap::NAME(NodeP arg)															\
{																								\
	double b=arg->a_float(2);															\
	if throwing return;																	\
	for (int i=winx*winy-1; i>=0; i--)												\
	{	Color c=pixels[i];																\
		double a;																			\
		a=double(c.r)/255;																\
		FUNC_##NAME(a, b);																\
		pixels[i].r=(unsigned char)(a*255);											\
		a=double(c.g)/255;																\
		FUNC_##NAME(a, b);																\
		pixels[i].g=(unsigned char)(a*255);											\
		a=double(c.b)/255;																\
		FUNC_##NAME(a, b);																\
		pixels[i].b=(unsigned char)(a*255);											\
	}																							\
}																								\
//*
#define _XFUNC_primitive(NAME)														\
NodeP l##NAME(PairPP arg)																\
{	ThreadP th=Thread::This();															\
	NodeP val = th->varStack->find(arg[1]->intern());							\
	val->NAME(arg[2]);																	\
	return Unbound;																		\
}
/*/
template <class NAME> NodeP _NAME(PairPP arg)									\
{	((ObjectP)(arg[1]))->var()->NAME( arg[2] );									
	return Unbound;																		
}
//*/

#define _XFUNC(NAME)	_XFUNC_virtuals(NAME)	_XFUNC_primitive(NAME)

#define FUNC_xCopy(a,b)	a=b
#define FUNC_bxCopy(a,b) a=b
#define FUNC_cxCopy(a,b) a=b
#define FUNC_ixCopy(a,b) a=b
#define FUNC_xAdd(a,b)	a+=b
#define FUNC_bxAdd(a,b)	a+=b
#define FUNC_cxAdd(a,b)	a+=b
#define FUNC_ixAdd(a,b)	a+=b
#define FUNC_xSub(a,b)	a-=b
#define FUNC_bxSub(a,b)	a-=b
#define FUNC_cxSub(a,b)	a-=b
#define FUNC_ixSub(a,b)	a-=b
#define FUNC_xMul(a,b)	a*=b
#define FUNC_bxMul(a,b)	a*=b
#define FUNC_cxMul(a,b)	a*=b
#define FUNC_ixMul(a,b)	a*=b
#define FUNC_xDiv(a,b)	a/=b
#define FUNC_bxDiv(a,b)	a/=b
#define FUNC_cxDiv(a,b)	a/=b
#define FUNC_ixDiv(a,b)	a/=b
#define FUNC_xMod(a,b)	a=Float::mod(a,b)
#define FUNC_bxMod(a,b)	a=BigFloat::mod(a,b)
#define FUNC_cxMod(a,b)	a=Complexd::mod(a,b)
#define FUNC_ixMod(a,b)	a=Int::mod(a,b)

_XFUNC(xAdd)	_XFUNC(xSub)  _XFUNC(xMul)  _XFUNC(xDiv)  _XFUNC(xMod)

//_XFUNC_virtuals(xCopy)

void Node::xCopy(NodeP arg) {error(BAD_DATA, this);}
void String::xCopy(NodeP arg)
{	if (arg->isstring())
	{	free();
		StringP a=StringP(arg);
		_length = a->length();
			_ptr = a->ptr();
		  _head = a->head();
		_head->refCount++;
	}
	else error(BAD_DATA, arg, 2);
}
void Object::xCopy(NodeP arg){var()->xCopy(arg);}
void Int::xCopy(NodeP arg)
{	if (type_of(arg) == INT_) int_ = IntP(arg)->int_;
	else error(BAD_DATA, this);
}
void Int16::xCopy(NodeP arg)
{	if (type_of(arg) == NINT16) int_ = Int16P(arg)->int_;
	else error(BAD_DATA, this);
}
void Int8::xCopy(NodeP arg)
{	if (type_of(arg) == NINT8) int_ = Int8P(arg)->int_;
	else error(BAD_DATA, this);
}
void UInt8::xCopy(NodeP arg)
{	if (type_of(arg) == NUINT8) int_ = UInt8P(arg)->int_;
	else error(BAD_DATA, this);
}
void Float::xCopy(NodeP arg)
{	if (type_of(arg) == FLOAT_) float_ = FloatP(arg)->float_;
	else error(BAD_DATA, this);
}
void BigFloat::xCopy(NodeP arg)
{	if (type_of(arg) == BIGFLOAT) float_ = BigFloatP(arg)->float_;
	else error(BAD_DATA, this);
}
void Complexd::xCopy(NodeP arg)
{	if (type_of(arg) == COMPLEX) complex_ = ComplexdP(arg)->complex_;
	else error(BAD_DATA, this);
}
void Pair::xCopy(NodeP arg)
{	ThreadP th=Thread::This();
	if (this && circcounter()==th->circcounter)
		return;
	PairP a = this;
	if (arg->islist())
	{	PairP b = PairP(arg);
		while (a && b)
		{	if (a->circcounter()==th->circcounter)
				break;
			else
				a->setcirccounter(th->circcounter);
			if (a->first())
				a->first()->xCopy(b->first());
			if (throwing) return;
			next(a);
			next(b);
		}
		th->setcirccounter(th->circcounter+1);
		if (!a && !b) return;
	}else
	{	while (a)
		{	if (a->circcounter()==th->circcounter)
				break;
			else
				a->setcirccounter(th->circcounter);
			if (a->first())
				a->first()->xCopy(arg);
			if (throwing) return;
			next(a);
		}
		th->setcirccounter(th->circcounter+1);
		if (!a) return;
	}
	error(BAD_DATA, this);
}
void Array::xCopy(NodeP arg)
{	ThreadP th=Thread::This();
	if (this && circcounter()==th->circcounter)
		return;
	else
		setcirccounter(th->circcounter);
	if (type_of(arg) == ARRAY)
	{	int i = length();
		if (i == ArrayP(arg)->length())
		{	NodePP a = data(), b = ArrayP(arg)->data();
			while (i-- && *a)
			{	(*a++)->xCopy(*b++);
				if (throwing) return;
			}
		}
		else
			error(BAD_DATA, arg, 2);
	}else
	{	int i = length();
		NodePP a = data();
		while (i-- && *a && !throwing)
		{	(*a++)->xCopy(arg);
			if (throwing) return;
		}
	}
	th->setcirccounter(th->circcounter+1);
	return;
}
void IntArray::xCopy(NodeP arg)
{	if (type_of(arg) == INTARRAY)
	{	int l = length();
		if (l == IntArrayP(arg)->length())
		{	intP a = _data, b = IntArrayP(arg)->_data;
			while (l-- && *a)
			{	(*a++) = (*b++);
				if (throwing) return;
			}
		}
		else
			error(BAD_DATA, arg, 2);
	}else
	{	if (type_of(arg)!=INT_)
		{	error(BAD_DATA, arg, 2);
			return;
		}
		int i=IntP(arg)->int_, l=length();
		intP a=_data;
		while (l-- && *a && !throwing)
			(*a++)=i;
	}
	return;
}
void Int16Array::xCopy(NodeP arg)
{	if (type_of(arg) == INT16ARRAY)
	{	int l = length();
		if (l == Int16ArrayP(arg)->length())
		{	shortP a = _data, b = Int16ArrayP(arg)->_data;
			while (l-- && *a)
			{	(*a++) = (*b++);
				if (throwing) return;
			}
		}
		else
			error(BAD_DATA, arg, 2);
	}else
	{	if (type_of(arg)!=NINT16)
		{	error(BAD_DATA, arg, 2);
			return;
		}
		short i=Int16P(arg)->int_, l=length();
		shortP a=_data;
		while (l-- && *a && !throwing)
			(*a++)=i;
	}
	return;
}
void FloatArray::xCopy(NodeP arg)
{	if (type_of(arg) == FLOATARRAY)
	{	int l = length();
		if (l == FloatArrayP(arg)->length())
		{	doubleP a = _data, b = FloatArrayP(arg)->_data;
			while (l-- && *a)
			{	(*a++) = (*b++);
				if (throwing) return;
			}
		}
		else
			error(BAD_DATA, arg, 2);
	}else
	{	if (type_of(arg)!=FLOAT_)
		{	error(BAD_DATA, arg, 2);
			return;
		}
		double i=FloatP(arg)->float_, l=length();
		doubleP a=_data;
		while (l-- && *a && !throwing)
			(*a++)=i;
	}
	return;
}
void Bitmap::xCopy(NodeP arg)															
{																								
	BitmapP b=arg->a_bitmap(2);															
	if throwing return;																	
	if (b->winx != winx || b->winy != winy)
		error(BAD_DATA, b, 2);
	if throwing return;																	
	for (int i=winx*winy-1; i>=0; i--)
	{	pixels[i]=b->pixels[i];																
	}																							
}																								
NodeP lxCopy(PairPP arg)
{	NodeP name = arg[1]->a_name(1);
	if (!throwing) 
	{	ThreadP th=Thread::This();
		NodeP val = th->varStack->find(name->intern());
		val->xCopy(arg[2]);
	}
	return Unbound;
}
