#include "stdafx.h"
#include <math.h>

#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <wx/thread.h>
#include <wx/datstrm.h>
#include <wx/slider.h>
#include <wx/button.h>
#include <wx/radiobut.h>
#include <wx/checkbox.h>
#include <wx/tglbtn.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/frame.h>
#include <wx/sizer.h>
#include <wx/filename.h>

#include <m_apm.h>

#include "spinctld.h"
#include "spinctli.h"

#include "Main.h"
#include "File.h"
#include "IntToPtr_.h"
#include "PtrToInt_.h"
#include "String.h"
#include "Float.h"
#include "BigFloat.h"
#include "Complex.h"
#include "Pair.h"
#include "Procedure.h"
#include "Compiled.h"
#include "Object.h"
#include "LogoObject.h"
#include "Table.h"
#include "Struct.h"
#include "Line.h"
#include "List.h"
#include "Quote.h"
#include "Colon.h"
#include "Tree.h"
#include "WindowPair.h"
#include "Int.h"
#include "Int16.h"
#include "Int8.h"
#include "UInt8.h"
#include "Array.h"
#include "IntArray.h"
#include "Int16Array.h"
#include "FloatArray.h"
#include "Window.h"
#include "Frame.h"
#include "Slider.h"
#include "Gauge.h"
#include "IntControl.h"
#include "FloatControl.h"
#include "Button.h"
#include "ToggleButton.h"
#include "CheckBox.h"
#include "RadioButton.h"
#include "StaticText.h"
#include "TextControl.h"
#include "ListBox.h"
#include "ChoiceBox.h"
#include "ComboBox.h"
#include "ListControl.h"
#include "BoxSizer.h"
#include "StaticBoxSizer.h"

#include "Point.h"
#include "Color.h"
#include "Pen.h"
#include "Bitmap.h"
#include "Texture.h"
#include "TurtleNode.h"
#include "GraphicNode.h"
#include "DL.h"
#include "Graph.h"

#include "Init.h"
#include "Error.h"
#include "Console.h"
#include "Consolew.h"
#include "Thread.h"
#include "Security.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
#else
	static char THIS_FILE[]= __FILE__;
#endif

const int Node::boolerror=-99999999;

void Node::mark_all_but_objects() 
{
}

DataInputStream &Node::read(DataInputStream &istr) 
{	return istr;
}
wxDataOutputStream &Node::write(wxDataOutputStream &ostr) 
{	return ostr << type;
}

void Node::setPtrs(IntToPtr_ &intToPtr)
{
}

void Node::aftersetPtrs(){}
void Node::recreate(){}

void Node::aftersetPtrs2(){}
void Node::aftersetPtrs3(){}

NodeP Node::copy(PtrToInt_ &ptrToInt)
{	return new Node(type);
}

StringP Node::string() {return _Null_Word->name();}

void Node::print(FILEP strm, int &width, int depth, int noBrackets, int noSpacers) 
{
	if (this==Unbound) 
		::print(strm, width, _("Unbound"));
	else if (type == NTFREE)
		::print(strm, width, _("NTFREE"));
	else
		error(BAD_DATA, this);
}

void Node::printBin(FILEP strm) 
{
	int width=Int::max;
	if (this==Unbound) 
		::print(strm, width, _("Unbound"));
	else if (type == NTFREE)
		::print(strm, width, _("NTFREE"));
	else 
		error(BAD_DATA, this);
}

NodeP  Node::   number() {return Unbound;}
double Node::getnumber() {return Float::quietNaN;}

int Node::compare(NodeP nd) 
{
	if (!nd) return boolerror;

	if (NodeP(this)==nd) return 0;
	if (!is.word  ||  !nd->is.word)
		return boolerror;

	error(FATAL, this);	// should never be reached
	return 0;
}

static DispatchMutex internMutex;

ObjectP Node::intern() 
{
	DispatchMutexLocker dml(&internMutex);

	ThreadP th=Thread::This();
	StringP str=0;	str=string();
	if (String::caseIgnored)
		str=str->noparity_lower();
	str=String::make(str->ptr(), 0, str->length(), 
						str->type, String::copy);
//if (console)	c_out << str << endL;
	if (ObjectP(str)==_Null_Word)
		return _Null_Word;
	if throwing return _Null_Word;

	ObjectP obj=0;
	TableP table=th->namespce;
	charP 
		start=str->ptr(),
		  end=str->ptr()+str->length(),
		  pos=0, 
		  cp=start;
	if (start)
		pos=strstr(start, "::");
//if (str->memberP(new String("("), false, true)==_True)
//	str=str;
	if (!th->lexufun && !pos)
	{	obj=table->find(str);
		if (!obj)
		{	if (table!=root)
			{	obj=root->find(str);
				if (!(obj && (obj->bit.permanent || obj->bit.permanentobj)))
				{	obj=table->insert(str, THIS_FILE, __LINE__);
					obj->setparent(th->namespceobj);
				}
			}else
			{	obj=table->insert(str, THIS_FILE, __LINE__);
				obj->setparent(th->namespceobj);
			}
		}
//if (obj->name()->equalP(new String("singleshot")))
//	c_out << "XXXXXXXXXXXXXXXXXX";
	}else	if (!th->lexufun || pos)
	{
		if (pos==start)
		{
			if (!th->security->global)
			{	error(SECURITY_ERROR, new String(_("to use global scope"))); 
				return _Null_Word;
			}
			pos+=2;
			start+=2;
			cp=pos;
			while (cp <= end)	// search from root to inner tables
			{	if (cp==end || (*cp==':' && cp+1 < end && cp[1]==':'))
				{	StringP substr=String::make(start, 0, cp-start, 
						STRING, String::copy);
					if (table==Unbound)
					{	table=new Table(31);
						if throwing return _Null_Word;
						obj->settable(table);
					}
					ObjectP lastobj=obj;
					obj=table->find(substr);
					if (!obj)
					{	obj=table->insert(substr, THIS_FILE, __LINE__);
						obj->setparent(lastobj);
					}
					table=obj->table();
					start=cp+2;
					cp+=2;
				}
				cp++;
			}
			return obj;
		}
		ObjectP parent=th->lexufun;	// search from lexufun outwards
		while (!obj)
		{	if (parent)
				table=parent->table();
			else
				table=th->namespce;
			if (table!=Unbound)
			{	start=str->ptr();
				if (pos)
					cp=pos;
				else
					cp=start;
				while (cp <= end)
				{	if (cp==end || (*cp==':' && cp+1 < end && cp[1]==':'))
					{	StringP substr=String::make(start, 0, cp-start, 
							STRING, String::copy);
						if (table==Unbound)
						{	table=new Table(31);
							if throwing return _Null_Word;
							obj->settable(table);
						}
						ObjectP lastobj=obj;
						obj=table->find(substr);
						if (obj)
							table=obj->table();
						else
						{	if (start==str->ptr())
								break;
							else
								goto insert_it;
						}
						start=cp+2;
						cp+=2;
					}
					cp++;
				}
			}
			if (parent)
				parent=parent->parent();
			else
				break;
		}
		parent=th->lexufun;	// search from ufun outwards
insert_it:
		while (!obj)
		{	if (parent)
				table=parent->table();
			else
				table=th->namespce;
			if (table!=Unbound)
			{	start=str->ptr();
				if (pos)
					cp=pos;
				else
					cp=start;
				while (cp <= end)	// search to inner tables
				{	if (cp==end || (*cp==':' && cp+1 < end && cp[1]==':'))
					{	StringP substr=String::make(start, 0, cp-start, 
							STRING, String::copy);
						if (table==Unbound)
						{	table=new Table(31);
							if throwing return _Null_Word;
							obj->settable(table);
						}
						ObjectP lastobj=obj;
						obj=table->find(substr);
						if (!obj)
						{	obj=table->insert(substr, THIS_FILE, __LINE__);
							obj->setparent(lastobj);
						}
						table=obj->table();
						start=cp+2;
						cp+=2;
					}
					cp++;
				}
			}
			if (parent)
				parent=parent->parent();
			else
				break;
		}
	}else	// search from lexufun outwards
	{	ObjectP parent=th->lexufun;
		while (parent && !obj)
		{	table=parent->table();
			if (table!=Unbound)
				obj=table->find(str);
			parent=parent->parent();
		}
		if (!parent && !obj)
		{	obj=th->namespce->find(str);	// if not found in inner tables try th->namespce
			if (!obj)
				obj=root->find(str);	// if not found in inner tables try root
			if (obj && obj->var()==Unbound && !obj->bit.permanent && !obj->bit.permanentobj)
				obj=0;
		}
		if (!obj)	// if still not found create obj in lexufun
		{	parent=th->lexufun;
			table=parent->table();
			if (table==Unbound)
			{	table=new Table(31);
				if throwing return _Null_Word;
				parent->settable(table);
			}
			obj=table->find(str);
			if (!obj)
			{	obj=table->insert(str, THIS_FILE, __LINE__);
				obj->setparent(parent);
			}
		}
	}
//if (GC_::initialized) {c_out << obj->fullName() << endL; if (console) console->flush();}
//if (obj->name()->equalP(new String("singleshot")))
//	c_out << "XXX";
	return obj;
}

ObjectP Node::internRoot()
{
	ThreadP th=Thread::This();
	TableP namespce=th->namespce;
	th->namespce=root;
	ObjectP obj=intern();
	th->namespce=namespce;
	return obj;
}

int Node::count() {return string()->length();}

int Node::_sizeof() {error(BAD_DATA, this); return 0;}

bool Node::equalP(NodeP b) {return equal(b);}

NodeP Node::deepCopy() 
{	NodeType t=type;
	return this;
}

NodeP Node::deepCopyLine() 
{	NodeType t=type;
	return this;
}

NodeP Node::first_()
{	return string()->first();
}

NodeP Node::butFirst()
{	return string()->butFirst();
}

NodeP Node::firsts() {error(BAD_DATA, this); return Unbound;}

NodeP Node::butFirsts() {error(BAD_DATA, this); return Unbound;}

NodeP Node::last() 
{	StringP s=string();
	if (s!=Unbound)
		return s->last();
	error(BAD_DATA, this); return Unbound;
}

NodeP Node::butLast() 
{	StringP s=string();
	if (s!=Unbound && s!=_Null_Word->name())
		return s->butLast();
	error(BAD_DATA, this); return Unbound;
}

NodeP Node::fPut(NodeP nd) 
{	return string()->fPut(nd);
}

NodeP Node::lPut(NodeP nd) 
{	return string()->lPut(nd);
}

double Node ::_min(double d) {error(BAD_DATA, this); return 0;}

double Node ::_max(double d) {error(BAD_DATA, this); return 0;}

NodeP Node::Norm() {error(BAD_DATA, this); return Unbound;}

NodeP Node::Norm3() {error(BAD_DATA, this); return Unbound;}

NodeP Node::maxNorm() {error(BAD_DATA, this); return Unbound;}

NodeP Node::resize(int newsize) {error(BAD_DATA, this); return Unbound;}

NodeP Node::lowPassFilter(double weight) 
{	error(BAD_DATA, this); return Unbound;
}

NodeP Node::lowPassFilter2(double weight) 
{	error(BAD_DATA, this); return Unbound;
}

NodeP Node::saturateAbove(double limit) 
{	error(BAD_DATA, this); return Unbound;
}

NodeP Node::saturateBelow(double limit) 
{	error(BAD_DATA, this); return Unbound;
}

NodeP Node::item(int i) {error(BAD_DATA, this, 2); return Unbound;}

NodeP Node::item(NodeP index, NodeP result) {return item(0);}

NodeP   Node::items(NodeP start, NodeP end) 
{	error(BAD_DATA, this, 3); return Unbound;
}

NodeP Node::mdItem(NodeP index)
{	error(BAD_DATA, this); return Unbound;
}

NodeP Node::bititem(NodeP index) 
{	error(BAD_DATA, this, 2); return Unbound;
}

NodeP Node::setitem(int index, NodeP newitem) 
{	error(BAD_DATA, this, 2); 
	return Unbound;
}

NodeP Node::setitem(NodeP index, NodeP newitem, bool safe) 
{	error(BAD_DATA, this, 2); 
	return Unbound;
}

NodeP Node::setitems(NodeP start, NodeP newitems) 
{	error(BAD_DATA, this, 2); 
	return Unbound;
}

NodeP   Node::memberP(NodeP subobj, bool notp, bool substr)
{
	if (subobj->is.aggregate) 
		return notp ?   _Null_Word  :  _False;
	else if (NodeP(this)==subobj)
		return _True;
	else
		return _False;
}

void Node::removeitem(NodeP index) 
{	error(BAD_DATA, this, 2); 
}

NodeP Node::reverse()
{
	error(BAD_DATA, this); 
	return Unbound;
}

NodeP Node::rotate(int places) {error(BAD_DATA, this); return Unbound;}

NodeP Node::shuffle() {error(BAD_DATA, this); return Unbound;}

NodeP Node::remove(NodeP) {error(BAD_DATA, this, 2); return Unbound;}

NodeP Node::destructiveRemove(NodeP thing)
{
	error(BAD_DATA, this);
	return Unbound;
}

NodeP Node::remdup() {error(BAD_DATA, this); return Unbound;}

NodeP Node::upper() {return error(BAD_DATA, this);}
NodeP Node::lower() {return error(BAD_DATA, this);}

PairP Node::list() {error(BAD_DATA, this); return PairP(Unbound);}

ArrayP Node::array(int origin) {error(BAD_DATA, this); return ArrayP(Unbound);}

IntArrayP Node::intarray(int origin) 
{	error(BAD_DATA, this); return IntArrayP(Unbound);
}

Int16ArrayP Node::int16array(int origin) 
{	error(BAD_DATA, this); return Int16ArrayP(Unbound);
} 

FloatArrayP Node::floatarray(int origin) 
{	error(BAD_DATA, this); return FloatArrayP(Unbound);
}

BitmapP Node::bitmap(int width)
{	error(BAD_DATA, this); return BitmapP(Unbound);
}

TableP Node::table() {return TableP(Unbound);}

void Node::combSortInPlace()
{	error(BAD_DATA, this);
}

NodeP Node::combSort()
{	return this;
}

void Node::untreeify()
{
//	error(BAD_DATA, this);
}

FileP Node::findInFilelist(bool remove) 
{
	return string()->findInFilelist(remove);
}

Priority Node::priority() {return priority_STOP;}

Priority Node::infixPriority() {return priority_STOP;}

LineP Node::gather_args(LinePP args, bool inparen, int oldPriority, ObjectPP ifnode)
{	error(BAD_DATA/*FATAL*/, this); return 0;
}

NodeP Node::readbin(FileP file) {error(BAD_DATA, this); return Unbound;}

void Node::setflag(ObjectType want, ObjectType newflag){}
void Node::clearflag(ObjectType want, ObjectType clrflag) {}

PairP Node::contents(ObjectType want, ObjectType dont)
{
	return 0;
}

NodeP Node::contentsTree(	wxArrayString &namearr, 
									wxArrayString &valarr, 
									wxArrayPtrVoid &objarr, 
									ObjectType want,
									ObjectType dont, 
									ObjectType must, 
									int &count, int level)
{
	objarr[count]=this;
	valarr[count]=string()->ptr();
	incContentsArrays(namearr, valarr, objarr, count);
	return this;
}

void Node::incContentsArrays(	wxArrayString &namearr, 
								wxArrayString &valarr, 
								wxArrayPtrVoid &objarr, 
								int &count)
{
	static const int dcount=256;
	if (count % dcount==0)
	{	namearr.Add(wxEmptyString, dcount);
		 valarr.Add(wxEmptyString, dcount);
		 objarr.Add(0, dcount);
	}
	count++;
}

wxWindow *Node::wxwindow()
{
	if (console)
		return console;
	else
		return consolew;
}

PairP Node::maybe_quote() 
{
	if (!this  
	||  PairP(this)==Unbound  
	||  is.aggregate  
	||  type==VARPARAM 
	||  numberP()) 
		return PairP(this);

	return new Quote(this);
}

void Node::silent_load(const char *prefix) 
{
	// This procedure is called three ways:
	//	  silent_load(0, *argv)         loads *argv
	//	  silent_load(proc, logolib)    loads logolib/proc
	//	  silent_load(proc, 0)          loads proc.lg
	// The "/" or ".lg" is supplied by this procedure as needed.
	// In the case that this procedure is called to load a procedure from the
	// logo library, it must first truncate the name of the procedure to
	// eight characters, to find the filename (so as to be compatible with MS-DOS)

	if (throwing || (!prefix && !this)) return;

	ThreadP th=Thread::This();

	wxString loadPath;
	if (prefix)
		if (!this)
			loadPath=prefix;
		else
			loadPath=wxString(prefix)+wxFileName::GetPathSeparator();

	ValStatus save_val_status = th->val_status;
	StringP str=0;

	if (this) 
	{	str = string();
		if (str==Unbound) 
			return;
		if (!strncmp(str->ptr(), ".", str->length())) 
			return;
		str=str->noparity_lower();
		if throwing return;
		loadPath+=str->ptr();
		loadPath+=".lg";
	}
	wxFileName fullLoadPath(loadPath);
	fullLoadPath.Normalize();
	wxString fullPath=fullLoadPath.GetFullPath();
	loadPath=fullPath;

	FILEP old_file = loader.file();
	StringP old_line=th->currentLine, oldFilename=th->filename();
	loader.setfile( fopen(loadPath, "r") );

	if (loader) 
	{	int col=th->col, tcol=th->tcol, row=th->row;
		StringP fn=th->filename();

		th->startup=Unbound;
		th->readnr=1;
		th->col=1;
		th->tcol=1;
		th->row=1;
		th->setfilename(Line::findFile(StringP(new String(loadPath))));
		ObjectP lexufun=th->lexufun;

		if (!throwing)
		{	th->lexufun=0;

//			cout << "silent_load Line::nr=1;" << endL;

			while (!loader.eof() && !throwing) 
			{
				th->currentLine = loader.read("");
				PairP exec_list = th->currentLine->parser(true);

				th->val_status=no_value_allowed;
				if (exec_list) 
					exec_list->eval_driver();
			}
		}
		loader.close();
		loader.setfile(old_file);

		PairP st = PairP(th->startup);
		st->runstartup();
		th->val_status=save_val_status;
		th->lexufun=lexufun;

		th->col=col;
		th->tcol=tcol;
		th->row=row;
		th->setfilename(fn);
	}else 
		if (!str) 
			c_out << _("File not found: ") << prefix << endL;

	loader.setfile(old_file);
	th->currentLine=old_line;
	th->setfilename(oldFilename);
}

NodeP Node::boolnode(bool tf) {return tf ?  _True : _False;}

void Node::checkboolerror(int tf, NodeP a, NodeP b) 
{
	if (tf==Node::boolerror)
		error(BAD_DATA, new List(a, b, _ListEnd));
}

bool Node::circular() 
{
	ThreadP th=Thread::This();
	bool circ=circular2();
	th->setcirccounter(th->circcounter+1);
	return circ;
}

bool Node::circular(NodeP b) 
{
	ThreadP th=Thread::This();
	bool circ=circular2();
	if (b && b->circcounter()==th->circcounter)
		circ=true;
	th->setcirccounter(th->circcounter+1);
	return circ;
}

//___________________________________________________________________
//
// Argument Type Checking Functions
// Proposal: toggle argument checking by turning a_xxx into function pointers

int Node::a_bool(int nr) 
{
	if (this)
	{	if (equal(_False)) return 0;
		if (equal(_True )) return 1;
	}
	error(BAD_DATA, this, nr);
	return -1;
}

IntP Node::a_integer(int nr) 
{
	if (!this)
	{	error(BAD_DATA, this, nr);
		return IntP(Unbound);
	}
	NodeP a=this, val;
	val = a->number();

	if (val->type==INT_) return IntP(val);
	if (val->type==FLOAT_)
	{	double f = FloatP(val)->float_;

		if (f==int(f)) return new Int(int(f));
	}
	if (val->type==NINT16)
		return new Int(int(Int16P(val)->int_));
	if (val->type==NINT8)
		return new Int(int(Int8P(val)->int_));
	if (val->type==NUINT8)
		return new Int(int(UInt8P(val)->int_));
	
	error(BAD_DATA, this, nr); return IntP(Unbound);
}

int Node::a_int(int nr)
{
	IntP i = a_integer(nr);
	if (!throwing) 
		return i->int_;
	else
		return boolerror;
}

Int16P Node::a_integer16(int nr) 
{
	if (!this)
	{	error(BAD_DATA, this, nr);
		return Int16P(Unbound);
	}
	NodeP a=this, val;
	val = a->number();

	if (val->type==NINT16) return Int16P(val);
	if (val->type==INT_)

	{	int i = IntP(val)->int_;
		if (i==short(i)) return new Int16(short(i));
	}
	if (val->type==FLOAT_)
	{	double f = FloatP(val)->float_;

		if (f==short(f)) return new Int16(short(f));
	}
	if (val->type==NINT8)
		return new Int16(int(Int8P(val)->int_));
	if (val->type==NUINT8)
		return new Int16(int(UInt8P(val)->int_));
	
	error(BAD_DATA, this, nr); return Int16P(Unbound);
}

short Node::a_int16(int nr)
{
	Int16P i = a_integer16(nr);
	if (!throwing) 
		return i->int_;
	else
		return short(boolerror);
}

Int8P Node::a_integer8(int nr) 
{
	if (!this)
	{	error(BAD_DATA, this, nr);
		return Int8P(Unbound);
	}
	NodeP a=this, val;
	val = a->number();

	if (val->type==NINT8) return Int8P(val);
	if (val->type==INT_)
	{	int i = IntP(val)->int_;
		if (i==char(i)) return new Int8(char(i));
	}
	if (val->type==FLOAT_)
	{	double f = FloatP(val)->float_;

		if (f==char(f)) return new Int8(char(f));
	}
	if (val->type==NINT16)
	{	short i = Int16P(val)->int_;
		if (i==char(i)) return new Int8(char(i));
	}
	if (val->type==NUINT8)
	{	unsigned char i = UInt8P(val)->int_;
		if (i==char(i)) return new Int8(char(i));
	}
	error(BAD_DATA, this, nr); return Int8P(Unbound);
}

char Node::a_int8(int nr)
{
	Int8P i = a_integer8(nr);
	if (!throwing) 
		return i->int_;
	else
		return char(boolerror);
}

IntP Node::a_pos_int(int nr)
{
	if (!this)
	{	error(BAD_DATA, this, nr);
		return IntP(Unbound);
	}
	NodeP val = number();

	if (val->type==INT_ && IntP(val)->int_ >= 0) return IntP(val);
	if (val->type==FLOAT_)
	{	double f = FloatP(val)->float_;

		if (f==int(f)  &&  int(f) >= 0)
			return new Int(int(f));
	}
	if (val->type==NINT16)
	{	short i = Int16P(val)->int_;

		if (i >= 0)
			return new Int(int(i));
	}
	if (val->type==NINT8)
	{	char i = Int8P(val)->int_;

		if (i >= 0)
			return new Int(int(i));
	}
	if (val->type==NUINT8)
	{	unsigned char i = UInt8P(val)->int_;
		return new Int(int(i));
	}
	error(BAD_DATA, this, nr); return IntP(Unbound);
}

double Node::a_float(int nr) 
{
	if (this)
	{	NodeP val=number();

		if (val->type==FLOAT_) return FloatP(val)->float_;
		if (val->type==INT_  ) return   IntP(val)->int_;
		if (val->type==NINT16 ) return Int16P(val)->int_;
		if (val->type==NINT8  ) return Int8P(val)->int_;
		if (val->type==NUINT8 ) return UInt8P(val)->int_;
		if (val->type==BIGFLOAT) return BigFloatP(val)->float_.to_double();
	}
	error(BAD_DATA, this, nr);
	return Float::quietNaN;
}

NodeP Node::a_number(int nr) 
{
	if (!this)
	{	error(BAD_DATA, this, nr);
		return Unbound;
	}
	NodeP val = number();
	if (val==Unbound && !throwing) error(BAD_DATA, this, nr);
	return val;
}

ComplexdP Node::a_complex(int nr) 
{
	if (!this)
	{	error(BAD_DATA, this, nr);
		return ComplexdP(Unbound);
	}
	NodeP val = number();
	if ((val==Unbound || val->type!=COMPLEX) && !throwing) 
		error(BAD_DATA, this, nr);

	return ComplexdP(val);
}

ComplexdP Node::a_complexOrReal(int nr) 
{
	if (this)
	{	NodeP val=number();

		if (val->type==COMPLEX) return ComplexdP(val);
		if (val->type==FLOAT_) return new Complexd(FloatP(val)->float_);
		if (val->type==INT_  ) return new Complexd(IntP(val)->int_);
		if (val->type==NINT16 ) return new Complexd(Int16P(val)->int_);
		if (val->type==NINT8  ) return new Complexd(Int8P(val)->int_);
		if (val->type==NUINT8 ) return new Complexd(UInt8P(val)->int_);
		if (val->type==BIGFLOAT) return new Complexd(BigFloatP(val)->float_.to_double());
	}
	error(BAD_DATA, this, nr);
	return new Complexd(Float::quietNaN);
}

BigFloatP Node::a_bigfloat(int nr) 
{
	if (!this)
	{	error(BAD_DATA, this, nr);
		return BigFloatP(Unbound);
	}
	NodeP val = number();
	if ((val==Unbound || val->type!=BIGFLOAT) && !throwing) 
		error(BAD_DATA, this, nr);

	return BigFloatP(val);
}

StringP Node::a_char(int nr) 
{
	if (!this)
	{	error(BAD_DATA, this, nr);
		return StringP(Unbound);
	}
	StringP str = string();
	NodeP a = this;
	while ( (str==Unbound  ||  str->length() != 1) && !throwing ) 
	{	a = error(BAD_DATA, a, nr);
		str = a->string();
	}
	return str;
}

StringP Node::a_string(int nr) 
{
	if (!this)
	{	error(BAD_DATA, this, nr);
		return StringP(Unbound);
	}
	StringP str = string();
	  NodeP a=this;

	while (str==Unbound && !throwing) 
	{	a = error(BAD_DATA, a, nr);
		str = a->string();
	}
	return str;
}

NodeP Node::a_name(int nr) 
{
	if (isaggregate())
		error(BAD_DATA, this, nr);
	return this;
}

NodeP Node::a_bfable(int nr)
{
	NodeP a=this;
	if ((!a 
		|| a==Unbound 
		|| a==_Null_Word
		|| (a->type==     ARRAY && !     ArrayP(a)->length())
		|| (a->type==FLOATARRAY && !FloatArrayP(a)->length())
		|| (a->type==  INTARRAY && !  IntArrayP(a)->length())
		|| (a->type==INT16ARRAY && !Int16ArrayP(a)->length()))  &&  !throwing) 
	{	error(BAD_DATA, a, nr); return Unbound;
	}
	return a;
}

PairP Node::a_list(int nr) 
{
	NodeP a=this;
	if (a && a->type==PROC_)
		return ProcedureP(a)->bodywords();
	if (a && a->type==COMPILED)
		return CompiledP(a)->assembly();
	if (a->isnolist() && !throwing) 
		error(BAD_DATA, a, nr);
	return PairP(a);
}

PairP Node::a_runnable(int nr) 
{
	if (this && is.string) 
		return StringP(this)->parser(true);
	else if (this && type==OBJECT) 
		return ObjectP(this)->name()->parser(true);

	if (islist()) return PairP(this);
	
	error(BAD_DATA, this, nr); return PairP(Unbound);
}

LineP Node::a_line(int nr) 
{
	NodeP a=this;
	if (a && a->type==PROC_)
		return LineP(ProcedureP(a)->bodywords());
	if ((!a || (a->type!=LINE && a->type!=TREE)) && !throwing) 
		error(BAD_DATA, a, nr);
	return LineP(a);
}


BitmapP Node::a_bitmap(int nr)
{
	if (this && type==BITMAP_)
		return BitmapP(this);
	error(BAD_DATA, this, nr); return BitmapP(Unbound);
}

TableP Node::a_table(int nr)
{
	if (this && type==TABLE)
		return TableP(this);
	error(BAD_DATA, this, nr); return TableP(Unbound);
}

ArrayP Node::a_array(int nr)
{
	if (this && type==ARRAY)
		return ArrayP(this);
	error(BAD_DATA, this, nr); return ArrayP(Unbound);
}

IntArrayP Node::a_intarray(int nr)
{
	if (this && type==INTARRAY)
		return IntArrayP(this);
	error(BAD_DATA, this, nr); return IntArrayP(Unbound);
}

Int16ArrayP Node::a_int16array(int nr)
{
	if (this && type==INT16ARRAY)
		return Int16ArrayP(this);
	error(BAD_DATA, this, nr); return Int16ArrayP(Unbound);
}

FloatArrayP Node::a_floatarray(int nr)
{
	if (this && type==FLOATARRAY)
		return FloatArrayP(this);
	error(BAD_DATA, this, nr); return FloatArrayP(Unbound);
}

Point Node::a_3darray(int nr)
{
	if (this && type==ARRAY)
	{	if (ArrayP(this)->length()==3)
		{	NodePP n=ArrayP(this)->data();

			Point p=Point(
				n[0]->a_float(nr), 
				n[1]->a_float(nr),
				n[2]->a_float(nr));
			if (!throwing)
				return p;
		}
	}
	error(BAD_DATA, this, nr); return Point(0,0,0);
}

PairP Node::a_vector_helper(bool floatok, bool three, bool neg, int nr) 
{
	NodeP a=this;

	while (!throwing) 
	{	if (a->islist())
		{	PairP l=PairP(a);

			if (l
			&&  l->tail()
			&&  (three?  l->tail()->tail() && !l->tail()->tail()->tail()  
						 : !l->tail()->tail()))

			{	NodeP 
					val1 = l-> first()->number(),
					val2 = l->second()->number(),
					val3 = 0;

				if (three)
					val3 = l->third()->number();

				if ( val1 != Unbound  &&  val2 != Unbound 
				&& (floatok 
					|| (   val1->type==INT_  && (neg || IntP(val1)->int_>= 0) 
						&&  val2->type==INT_  && (neg || IntP(val2)->int_>= 0) 
						&& (!three 
							 || (val3->type==INT_ && (neg || IntP(val3)->int_>= 0)))))) 
				{
					l->setfirst (val1);
					l->setsecond(val2);
					if (three) 
						l->setthird(val3);

					return l;
				}
			}
		}
		a = error(BAD_DATA, a, nr);
	}
	return PairP(Unbound);
}

PairP Node::a_vector        (int nr) 
{	return a_vector_helper( true, false, true, nr);
}

PairP Node::a_3dvector      (int nr) 
{	return a_vector_helper( true,  true, true, nr);
}

PairP Node::a_int_vector(int nr) 
{	return a_vector_helper(false, false, true, nr);
}

PairP Node::a_pos_int_vector(int nr) 
{	return a_vector_helper(false, false, false, nr);
}

PairP Node::a_rgb           (int nr) 
{	return a_vector_helper( true,  true, false, nr);
}

PairP Node::a_rgba(int nr) 
{
	NodeP a=this;
	if (a->isnolist())
	{	error(BAD_DATA, a, nr);
		return PairP(Unbound);
	}
	PairP l=PairP(a);
	int i;
	for (i=4; i && l && l->first();  i--) 
	{	NodeP val=l->first()->number();
		if (val==Unbound)
			error(BAD_DATA, a, nr);

		l->setfirst(val);
		next(l);
	}
	if (i!=0)
		error(BAD_DATA, a, nr);
	return PairP(this);
}

Color Node::a_color(int nr)
{	if (!this)
		error(BAD_DATA, this, nr);
	else if (numberP())
	{	IntP i = a_integer(nr);
		if (!throwing) 
			return Pen::realcolor(i->int_);
	}
	else if (is.string)
	{	StringP name=StringP(StringP(this)->upper())->noParity();
		wxColour wxc=(name->ptr());
		if (wxc.Ok())
			return Color(wxc.Red(), wxc.Green(), wxc.Blue());
		else
			error(BAD_DATA, this, nr);
	}
	else if (type==OBJECT)

	{	StringP name=StringP(ObjectP(this)->upper());
		wxColour wxc(name->ptr());
		if (wxc.Ok())
			return Color(wxc.Red(), wxc.Green(), wxc.Blue());
		else
			error(BAD_DATA, this, nr);
	}
	else if (is.list)
	{	int n=count();
		if (n==3)
		{	PairP rgb=a_rgb(nr);
			if throwing return 0;
			return Color(
				rgb->first ()->getnumber(), 
				rgb->second()->getnumber(), 
				rgb->third ()->getnumber());
		}
		else if (n==4)
		{	PairP rgba=a_rgba(nr);
			if throwing return 0;
			return Color(
				rgba->first ()->getnumber(), 
				rgba->second()->getnumber(), 
				rgba->third ()->getnumber(),
				rgba->fourth()->getnumber());
		}else
			error(BAD_DATA, this, nr);
	}
	else
		error(BAD_DATA, this, nr);
	return 0;
}

TurtleNodeP Node::a_turtleNode(int nr)
{
	if (this && type==TURTLE_)
		return TurtleNodeP(this);

	error(BAD_DATA, this, nr); return TurtleNodeP(Unbound);
}

GraphicNodeP Node::a_graphicNode(int nr)
{
	if (this && type==GRAPHIC)
		return GraphicNodeP(this);

	error(BAD_DATA, this, nr); return GraphicNodeP(Unbound);
}

wxDynamicLibrary *Node::a_dynamicLibrary(int nr)
{
	if (this && type==DYNAMIC_LIB)
		return DynamicLibraryP(this)->module;

	error(BAD_DATA, this, nr); return 0;
}

SliderNodeP Node::a_slider(int nr)
{
	if (this && type==SLIDER)
	{	SliderP slider=SliderNodeP(this)->slider;
		if (slider)
			return SliderNodeP(this);
	}
	error(BAD_DATA, this, nr); return 0;
}

GaugeNodeP Node::a_gauge(int nr)
{
	if (this && type==GAUGE)
	{	WindowP window=GaugeNodeP(this)->window;
		if (window)
			return GaugeNodeP(this);
	}
	error(BAD_DATA, this, nr); return 0;
}

IntControlNodeP Node::a_intControl(int nr)
{
	if (this && type==INTCONTROL)
	{	WindowP window=IntControlNodeP(this)->window;
		if (window)
			return IntControlNodeP(this);
	}
	error(BAD_DATA, this, nr); return 0;
}

FloatControlNodeP Node::a_floatControl(int nr)
{
	if (this && type==FLOATCONTROL)
	{	FloatControlP floatControl=FloatControlNodeP(this)->floatControl;
		if (floatControl)
			return FloatControlNodeP(this);
	}
	error(BAD_DATA, this, nr); return 0;
}

ButtonNodeP Node::a_button(int nr)
{
	if (this && type==BUTTON)
	{	ButtonP button=ButtonNodeP(this)->button;
		if (button)
			return ButtonNodeP(this);
	}
	error(BAD_DATA, this, nr); return 0;
}

ToggleButtonNodeP Node::a_toggleButton(int nr)
{
	if (this && type==TOGGLEBUTTON)
	{	ToggleButtonP toggleButton=ToggleButtonNodeP(this)->toggleButton;
		if (toggleButton)
			return ToggleButtonNodeP(this);
	}
	error(BAD_DATA, this, nr); return 0;
}

CheckBoxNodeP Node::a_checkBox(int nr)
{
	if (this && type==CHECKBOX)
	{	CheckBoxP checkBox=CheckBoxNodeP(this)->checkBox;
		if (checkBox)
			return CheckBoxNodeP(this);
	}
	error(BAD_DATA, this, nr); return 0;
}

RadioButtonNodeP Node::a_radioButton(int nr)
{
	if (this && type==RADIOBUTTON)
	{	RadioButtonP radioButton=RadioButtonNodeP(this)->radioButton;
		if (radioButton)
			return RadioButtonNodeP(this);
	}
	error(BAD_DATA, this, nr); return 0;
}

StaticTextNodeP Node::a_staticText(int nr)
{
	if (this && type==STATICTEXT)
	{	StaticTextP staticText=StaticTextNodeP(this)->staticText;
		if (staticText)
			return StaticTextNodeP(this);
	}
	error(BAD_DATA, this, nr); return 0;
}

TextControlNodeP Node::a_textControl(int nr)
{
	if (this && type==TEXTCONTROL)
	{	TextControlP textControl=TextControlNodeP(this)->textControl;
		if (textControl)
			return TextControlNodeP(this);
	}
	error(BAD_DATA, this, nr); return 0;
}

ListBoxNodeP Node::a_listBox(int nr)
{
	if (this && type==LISTBOX)
	{	WindowP window=ListBoxNodeP(this)->window;
		if (window)
			return ListBoxNodeP(this);
	}
	error(BAD_DATA, this, nr); return 0;
}

ChoiceBoxNodeP Node::a_choiceBox(int nr)
{
	if (this && type==CHOICEBOX)
	{	WindowP window=ChoiceBoxNodeP(this)->window;
		if (window)
			return ChoiceBoxNodeP(this);
	}
	error(BAD_DATA, this, nr); return 0;
}

ComboBoxNodeP Node::a_comboBox(int nr)
{
	if (this && type==COMBOBOX)
	{	WindowP window=ComboBoxNodeP(this)->window;
		if (window)
			return ComboBoxNodeP(this);
	}
	error(BAD_DATA, this, nr); return 0;
}

ListControlNodeP Node::a_listControl(int nr)
{
	if (this && type==LISTCONTROL)
	{	WindowP window=ListControlNodeP(this)->window;
		if (window)
			return ListControlNodeP(this);
	}
	error(BAD_DATA, this, nr); return 0;
}

WindowNodeP Node::a_window(int nr)
{
	if (this && is.window)
	{	WindowP window=WindowNodeP(this)->window;
		if (window)
			return WindowNodeP(this);
	}else if (!this)
	{	GraphP graph=Thread::This()->graph;
		if (graph)
			return WindowNodeP(*graph->d(Graph::windowNode));
	}
	error(BAD_DATA, this, nr); return 0;
}

FrameNodeP Node::a_frame(int nr)
{
	if (this && type==FRAME)
	{	WindowP window=FrameNodeP(this)->window;
		if (window)
			return FrameNodeP(this);
	}
	error(BAD_DATA, this, nr); return 0;
}

GraphNodeP Node::a_graph(int nr)
{
	if (this && type==GRAPH)
	{	WindowP window=GraphNodeP(this)->window;
		if (window)
			return GraphNodeP(this);
	}
	error(BAD_DATA, this, nr); return 0;
}

BoxSizerNodeP Node::a_boxSizer(int nr)
{
	if (this && type==BOXSIZER)
	{	BoxSizerP boxSizer=BoxSizerNodeP(this)->boxSizer;
		if (boxSizer)
			return BoxSizerNodeP(this);
	}else if (this && type==STATICBOXSIZER)
	{	StaticBoxSizerP boxSizer=StaticBoxSizerP(StaticBoxSizerNodeP(this)->boxSizer);
		if (boxSizer)
			return StaticBoxSizerNodeP(this);
	}
	error(BAD_DATA, this, nr); return 0;
}

wxWindow *Node::a_wxwindow(int nr)
{
	ThreadP th=Thread::This();
	if (!th->security->gui)
	{	error(SECURITY_ERROR, new String(_("to use GUI"))); return 0;
	}
	if (this)
		return wxwindow();
	else if (console)
		return console;
	else
		return consolew;
}
