#ifndef Node_included
	#include "Node.h"
#endif

#include "PtrIntTable.h"

class Object: public Node
{
	public:
		ObjectP _tail;
		StringP _name;
		NodeP _var;
		TableP _table;
		ObjectP _parent;
		ObjectP _owner;

		charP creationFile;
		int creationLine;
		int dummy;
		int dummy2;

		union {ObjectType flag; ObjectBits bit; int tint;};
		static const Object aObject;

		operator_new;

		   ObjectP tail() {return _tail;}
		   StringP name() {return _name;}
		NodeP proc_or_prim() {return _var;}
		ProcedureP proc() {return ProcedureP(_var);}
		PrimitiveP prim() {return PrimitiveP(_var);}
		     NodeP var()  {return _var;}
		    TableP table(){return _table;}
		  ObjectP parent(){return _parent;}
		  ObjectP owner() {return _owner;}

		void settail (ObjectP    nd) {_tail = nd;  check_oldyoung(nd);}
		void setname (StringP    nd);
		void setproc_or_prim(NodeP nd);
		void setproc (ProcedureP nd);
		void setprim (PrimitiveP nd);
		void setvar  (NodeP      nd);
		void setvarPermanent(NodeP nd);
		void settable(TableP     nd);
		void setparent(ObjectP   nd);
		void setowner (ObjectP   nd);

		Object();
		Object(StringP name_, ObjectP tail_);
		void free();

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();

		void setPtrs(IntToPtr_ &intToPtr);
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);

		ObjectP intern() {return this;}
		StringP string() {return name();}
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		void printBin(FILEP strm);
		NodeP contentsTree(	wxArrayString &namearr, 
									wxArrayString &valarr, 
									wxArrayPtrVoid &objarr, 
									ObjectType want, 
									ObjectType dont, 
									ObjectType must,
									int &count, int level);
		bool expandable() {return true;}
		bool expanded();
		void setExpanded(bool state);

		int   numberP(); 
		double getnumber(); 
		NodeP     number();
		OPERATORS_DECL
		int compare(NodeP nd);
		int _sizeof();
		StringP _typeof();
		NodeP fPut(NodeP nd);
		NodeP lPut(NodeP nd);
		NodeP item(int i);
		NodeP item(NodeP index, NodeP result);
		NodeP items(NodeP start, NodeP end);
		NodeP bititem(NodeP index);
		NodeP memberP(NodeP subobj, bool notp=false, bool substr=false);
		NodeP setitem(NodeP index, NodeP newitem, bool safe);
		void removeitem(NodeP index);
		NodeP reverse();
		NodeP remove(NodeP thing);
		NodeP remdup();
		NodeP upper();
		NodeP lower();
		PairP list();
		ArrayP array(int origin);

		StringP longName();
		StringP fullName();
		bool inNamespace(ObjectP namespce);
		void   setflag(int f) {tint  |=   f;}
		void clearflag(int f) {tint &= ~f;}
		void setflag(ObjectType want, ObjectType newflag);
		void clearflag(ObjectType want, ObjectType newflag);

		void mark_all_but_objects();
		Priority infixPriority();
		void tell_shadow();
		bool not_local(int stackPtr);

		int find_limit();
		void print();
		PairP contents(ObjectType want, ObjectType dont);
		PairP contentsNameVar(ObjectType want);

	friend class Evaluator;
};

#define Object_included
