#ifndef PtrIntTable_included

class PtrIntTable
{
	public:
		class PtrIntPair;
		typedef PtrIntPair *PtrIntPairP;

		class PtrIntPair
		{
		public:
			int i;
			void *p;
			PtrIntPairP tail;

			PtrIntPair(void *p_, int i_, PtrIntPairP tail_):
				i(i_), p(p_), tail(tail_)
			{}

			~PtrIntPair() {if (tail) delete tail;}
		};

		int size;
		PtrIntPairP *data;

		PtrIntTable() {}
		PtrIntTable(int size_);
		virtual ~PtrIntTable();

		int hash(void *p);
		PtrIntPairP find(void *p);
		PtrIntPairP insert(void *p, int i);

		int item(void *index);
		void setitem(void *index, int newitem);
		void removeitem(void *index);
};
typedef PtrIntTable *PtrIntTableP;

	#define PtrIntTable_included
#endif
