//___________________________________________________________________
//
//                         Class PtrToString
//
//                           Definitions
//___________________________________________________________________

#include "stdafx.h"
#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <stdio.h>
#include <malloc.h>

#include <wx/string.h>

#include "Main.h"
#include "GC.h"
#include "Primitive.h"
#include "PtrToString.h"
#include "Error.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;

	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)

	#define  calloc(n, m)	 _calloc_dbg((n), (m),   _NORMAL_BLOCK, __FILE__, __LINE__)
#endif

PtrToString::PtrStringPair::PtrStringPair(void *p_, 
														wxString &s_, 
														PtrStringPairP tail_):
	s(s_), p(p_), nxt(0), tail(tail_)
{}

PtrToString::PtrToString(int size_):
	size(0), nr(0), start(0), last(0)
{
	data = (PtrStringPairP*)(GC_::calloc(size_, sizeof(PtrStringPairP)));
	if (data)
		size=size_;
}

PtrToString::PtrToString(int size_, PrimType primitives[]):
	size(0), nr(0), start(0), last(0)
{
	data = (PtrStringPairP*)(GC_::calloc(size_, sizeof(PtrStringPairP)));
	if (!data)
		return;
	size=size_;
	PrimType *prim=primitives;
	while (prim->name)
	{	insert((void*)prim->function, prim->name);
		prim++;
	}
}

PtrToString::~PtrToString()
{
	for (int i=0; i < size; i++)
	{	if (data[i])
			delete data[i];
	}
	if (data)
	{	GC_::free(data); data=0;
	}
}

int PtrToString::hash(void *p)
{
	unsigned int index = (unsigned int)p;
	if (size)
		index %= size;
	else
		index=0;
	return index;
}

wxString PtrToString::find(void *p)
{
	PtrStringPairP obj;
	for (obj=data[hash(p)];  obj;  obj=obj->tail)
		if (obj->p==p)
			return obj->s;
	return wxEmptyString;
}

void PtrToString::insert(void *p, wxString s)
{
	nr++;
	PtrStringPairP &obj=data[hash(p)];
	obj = new PtrStringPair(p, s, obj);
	if (!obj)
		error(OUT_OF_MEM);
}
