#include "stdafx.h"
#include <malloc.h>

#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <wx/app.h>
#include <wx/frame.h>
#include <wx/scrolwin.h>
#include <wxflatmenu/flat_menu.h>
#include <wxflatmenu/flat_menu_bar.h>

#include <m_apm.h>

#include "Main.h"
#include "Segment.h"
#include "GC.h"
#include "Object.h"
#include "Color.h"
#include "MemoryWindow.h"
#include "MainFrame.h"
#include "LogoApp.h"
#include "Error.h"
#include "DebugState.h"
#include "Security.h"
#include "Thread.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
	#define  calloc(n, m)	 _calloc_dbg((n), (m),   _NORMAL_BLOCK, __FILE__, __LINE__)
#endif

SegmentP Segment::list=0, Segment::start=0;

Segment::Segment()
{
	base = (Object*)::calloc(GC_::segment_size, sizeof(Object));
}

Segment::~Segment()
{
	free((Node*)base);
}
/*
Segment::Segment()
{
	unsigned int num=GC_::segment_size, size=sizeof(Object);
	ThreadP th=Thread::This();
	int realsize=(num*size ? ((num*size-1) & GC_::MemBlockMask)+GC_::MemBlockSize : GC_::MemBlockSize);
	if (num)
		size=realsize/num;
//if (size > 1000000 || realsize < MemBlockSize)
//{	c_out << "bogus!" << int(size) << endL;
//	return 0;
//}
	if (th)
	{	if (th->security->memsize < th->memsize+num*size && !throwing)
		{	error(SECURITY_MEMSIZE); return;
		}
	}
	void *mem=::calloc(num, size);
	if (!mem)
		error(OUT_OF_MEM, 0);
	if (mem && th)
		th->memsize+=realsize;
	base=ObjectP(mem);
}

Segment::~Segment()
{
	GC_::free((Node*)base);
}
*/
bool Segment::add()
{
	SegmentP newseg = new Segment;
	if ((newseg!=0) && newseg->base) 
	{	newseg->baseu=unsigned(newseg->base);
		newseg->maxu=unsigned(&newseg->base[GC_::segment_size-1]);

		newseg->_tail = list;
		if (list)
			list->prev = newseg;
		newseg->prev = 0;
		list=newseg;
		if (!start)
			start=newseg;

		for (int p=GC_::segment_size-1;  p >=0;  p--)
		{	newseg->base[p]._next = GC_::free_node;
			GC_::free_node = &newseg->base[p];
			GC_::free_node->type = NTFREE;
			*intP((Node*)GC_::free_node) = Node::vmtNode;
		}
		GC_::mem_free += GC_::segment_size;
		if (memoryWindow)
		{	wxPaintEvent pev;
			memoryWindow->OnPaint(pev);
		}
		return true;
	}else
		return false;
}

#ifdef WIN32
extern void WaveInfoDestroy();
#endif

void Segment::freeAll()
{
	debugStates.switchToLast();
	if (theApp->mainFrame)
		theApp->mainFrame->initialized=false;
#ifdef WIN32
	WaveInfoDestroy();
#endif
	SegmentP seg=list;
	while (seg)
	{	for (int p=0;  p < GC_::segment_size;  p++)
		{	NodeP n = &seg->base[p];
			if (n)
				n->free();
		}
		next(seg);
	}
	seg=list;
	while (seg)
	{	SegmentP s=seg;
		next(seg);
		delete s;
	}
	m_apm_free_all_mem();
	debugStates.free();
}
