#include "stdafx.h"

#include <wx/ipc.h>

#ifdef WIN32
	#include <wx/dde.h>
#else
	#include <wx/ipc.h>
#endif

#include "Main.h"
#include "File.h"
#include "Pair.h"
#include "Eval.h"
#include "String.h"
#include "Object.h"
#include "Init.h"
#include "Error.h"
#include "Security.h"
#include "Thread.h"
#include "Server.h"
#include "Color.h"
#include "Console.h"
#include "Consolew.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
#endif

Connection::Connection():
#ifdef WIN32
	wxDDEConnection()
#else
	wxConnection()
#endif
{
}

Connection::~Connection()
{
}

bool Connection::OnPoke(const wxString& topic, 
								const wxString& item, 
								char* data, int size, wxIPCFormat format)
{
	ThreadP th=Thread::This();
	if (!th->security->connect)
		return 0;
	wxSetEnv(item, data);
	return true;
}

char *Connection::OnRequest(const wxString& topic, 
									 const wxString& item, 
									 int *size, wxIPCFormat format)
{
	ThreadP th=Thread::This();
	if (!th->security->connect)
		return 0;
	bool oldCharMode;
	if (console)
		oldCharMode=console->charMode;
	else
		oldCharMode=consolew->charMode;
	th->currentLine=new String(item);
	if throwing return 0;
	PairP execList = th->currentLine->parser(true);
	NodeP result=0;
	if throwing return 0;
	
	ValStatus vs=th->val_status;
	th->val_status = output_ok;
	*th->what=__begin_sequence;
	Evaluator e;
	result=e.eval(execList, __begin_sequence, th);
	th->val_status=vs;
	
	if throwing
	{	     if (th->throw_node==_error   ) error_print();
		else if (th->throw_node!=_toplevel)
		{	error(NO_CATCH_TAG, th->throw_node);	error_print();
		}
	}
	if (console)
		console->charMode=oldCharMode;
	if (consolew)
		consolew->charMode=oldCharMode;
	StringP str=0;
	if (result)
	{	str=result->string();
		if throwing return 0;
		*size=str->length();
		str=String::make(str->ptr(), 0, str->length(), STRING, String::copy_noparity);
		return str->ptr();
	}
	return 0;
}


Server::~Server()
{
}

wxConnectionBase *Server::OnAcceptConnection(const wxString& topic)
{
	ThreadP th=Thread::This();
#ifdef WIN32
	if (!GetConnections().IsEmpty() || !th->security->connect)
		return 0;
#else
// TODO
#endif
	Connection *con=new Connection();
	return con;
}
