//___________________________________________________________________
//
//                         Slider Header
//___________________________________________________________________

#ifndef WINDOWNODE
	#include "Window.h"
#endif

extern Function 
	lSlider, 
	lSliderDestroy, 
	lSliderEnable, 
	lSliderOnScroll, 
	lSliderSetLineSize, 
	lSliderSetPageSize, 
	lSliderSetRange, 
	lSliderSetValue, 
	lSliderValue;

class wxStaticText;
class MySlider;

class Slider: public wxControl
{
	public:
		wxStaticText *label;
		MySlider *slider;
		wxSize bestSize;
		int value, minValue, maxValue;
		enum Data
		{	WINDOW_DATA,
			onScroll, uonScroll, tonScroll,
			dataCount
		};
		NodeP data[dataCount];

		static int vmt;

		virtual NodePP d(int i) {return &data[i];}

		Slider(wxWindow *parent);
		Slider(SliderNodeP sliderNode_, int style);
		Slider(SliderNodeP sliderNode_,
			wxWindow* parent, wxWindowID id, 
			int value , int minValue, int maxValue, 
			PairP onScroll_=PairP(0),
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = wxSL_HORIZONTAL, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = _("Slider"));
		~Slider();

		bool create(wxWindow* parent, wxWindowID id, 
			int value_, int minValue_, int maxValue_, 
			const wxPoint& pos, 
			const wxSize& size, 
			long style, 
			const wxValidator& validator, 
			const wxString& name);

		virtual void DoSetSize(int x, int y, int width, int height,
						   int sizeFlags = wxSIZE_AUTO);

		virtual wxSize DoGetBestSize();

		virtual void 
			OnChar			(wxKeyEvent &event),
			OnKeyDown		(wxKeyEvent &event),
			OnKeyUp			(wxKeyEvent &event),
			OnLeftDown		(wxMouseEvent &event),
			OnRightDown		(wxMouseEvent &event),
			OnMiddleDown	(wxMouseEvent &event),
			OnLeftUp  		(wxMouseEvent &event),
			OnRightUp  		(wxMouseEvent &event),
			OnMiddleUp  	(wxMouseEvent &event),
			OnLeftDClick	(wxMouseEvent &event),
			OnRightDClick	(wxMouseEvent &event),
			OnMiddleDClick	(wxMouseEvent &event),
			OnMotion			(wxMouseEvent &event),
			OnEnterWindow	(wxMouseEvent &event),
			OnLeaveWindow	(wxMouseEvent &event),
			OnMouseWheel	(wxMouseEvent &event),
			OnMouse			(wxMouseEvent &event),
			OnScroll       (wxScrollEvent &event);

		int GetValue() const;

		wxString wxstring();
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		static int defaultStyle;

		DECLARE_EVENT_TABLE()
};
typedef Slider *SliderP;

class SliderNode: public WindowNode
{
	public:
		SliderP &slider;

		static const SliderNode aSliderNode;

		operator_new;
		PairP onScroll();
		ObjectP uonScroll();
		LogoObjectP tonScroll();
		void setonScroll(NodeP function);

		SliderNode();
		SliderNode(WindowNodeP parent_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();
		
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs(IntToPtr_ &intToPtr);
		void recreate();

		StringP string();
		wxString wxstring();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		StringP _typeof();
};
