#ifndef Node_included
	#include "Node.h"
#endif

class Backslash
{	public:
		char size, begin;
		charP chars;
		char array[0x100], 
		   unarray[0x100];
		bool   _is[0x100];

		Backslash();
		bool     is(char c) {return     _is[(unsigned char)(c)];}
		char encode(char c) {return   array[(unsigned char)(c)];}
		char decode(char c) {return unarray[(unsigned char)(c)];}
};
extern Backslash backslash;

class wxString;

class String: public Node
{
	public:
		struct Head
		{	unsigned int refCount;
			char str[1];	    // This array will be of variable length really
		};
		typedef Head* HeadP;

	private:
		int _length;
		charP _ptr;
		HeadP _head;

	public:
		union {ObjectType flag; ObjectBits bit; int tint;};

		static const int digits;	// max number of digits in a number
		static bool caseIgnored;
		static int tabSize;
		static const String aString;

		typedef charP     CopyRoutine(charP s1,  charP s2, int n);
		typedef charP PairCopyRoutine(charP s1, PairPP s2, int n);
		typedef  int   CompareRoutine(charP s1,  charP s2, int n);

		typedef CopyRoutine *CopyRoutineP;
		typedef PairCopyRoutine *PairCopyRoutineP;

		operator_new;
		String():             Node(STRING), _length(0), _ptr(0), _head(0) {}
		String(int length);
		String(StringP sp);
		String(StringP sp, StringP sp2);
		String(NodeType typ): Node(typ),    _length(0), _ptr(0), _head(0) {}
		String(charP str);
		String(wxString str);

		String(charP strptr, HeadP strhead, int length, NodeType typ, 
				CopyRoutineP copy);	// use only if not empty; else use String::make

		String(PairPP arg, int length, NodeType typ, 
				PairCopyRoutineP copy);	// dito

		static StringP 
			make(charP ptr, HeadP head, int length, NodeType type, CopyRoutineP copy);
		static StringP 
			fromList(PairPP arg,        int length, NodeType type, PairCopyRoutineP copy);

		int length() {return _length;}
		charP  ptr() {return _ptr;}
		HeadP head() {return _head;}

		void free();

		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);

		StringP   string() {return this;}
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		void printBin(FILEP strm);
		NodeP contentsTree(	wxArrayString &namearr, 
									wxArrayString &valarr, 
									wxArrayPtrVoid &objarr, 
									ObjectType want, 
									ObjectType dont, 
									ObjectType must, 
									int &count, int level);
		bool expanded() {return bit.table_expand;}
		bool expandable() {return true;}
		void setExpanded(bool state) {bit.table_expand=state;}

		int	    numberP(); 
		double getnumber(); 
		NodeP     number();

		OPERATORS_DECL
		int compare(NodeP nd);
		double _max(double d);
		double _min(double d);
		NodeP Norm();
		NodeP maxNorm();

		int count();
		int _sizeof();
		StringP _typeof();

		StringP first();
		NodeP first_();
		NodeP butFirst();
		NodeP last();
		NodeP butLast();
		NodeP fPut(NodeP nd);
		NodeP lPut(NodeP nd);

		NodeP item(int index);
		NodeP item(NodeP index, NodeP result);
		NodeP items(NodeP start, NodeP end);
		NodeP bititem(NodeP index);
		NodeP memberP(NodeP subobj, bool notp=false, bool substr=false);
		NodeP setitem(NodeP index, NodeP newitem, bool safe);
		void removeitem(NodeP index);
		NodeP reverse();
		NodeP remove(NodeP thing);
		NodeP remdup();

		void setXYZ(NodeP ynode, NodeP znode);

//		void untreeify();
		FileP findInFilelist(bool remove);
		FILEP open_file(charP access);

		NodeP upper();
		NodeP lower();

		PairP list();
		ArrayP array(int origin);
		NodeP readbin(FileP file);

		StringP noparity_lower();
		StringP unspace();
		charP expand_slash();
		StringP expandSlash();
		StringP expandFormat();
		StringP noFormat();
		StringP noParity();
		StringP mend();

		LineP runparse_node(PairPP ndsptr, 
			bool &was_assignment, bool &was_dot);
		PairP parser(bool semi, bool inparen=false);

		static bool is_digit(char ch) {return '0' <= ch && ch <= '9';}
		static charP addSeparator(const char *path);
		static wxString convertQMtoP(charP ptr, int len);
		static CopyRoutine copy;
		static CopyRoutine copy_quote;
		static CopyRoutine copy_colon;
		static CopyRoutine copy_noparity;
		static CopyRoutine copy_cap;
		static CopyRoutine copy_low;
		static CopyRoutine copy_unspace;
		static CopyRoutine copy_noformat;
		static CopyRoutine copy_noparitylow;
		static CopyRoutine copy_expand_format;
		static CopyRoutine copy_vbar;
		static CopyRoutine copy_mend;
		static CopyRoutine copy_mend_nosemi;
		static CopyRoutine copy_reverse;

		static PairCopyRoutine copy_word;

		static CompareRoutine comp_noparity;
		static CompareRoutine comp_case;
		static CompareRoutine comp_low;
		static CompareRoutine comp_noparitylow;
};

#define String_included
