//___________________________________________________________________
//
//                         Class PtrToInt_
//
//                           Definitions
//___________________________________________________________________

#include "stdafx.h"
#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <stdio.h>

#include <wx/string.h>

#include "Main.h"
#include "GC.h"
#include "Primitive.h"
#include "Error.h"
#include "StringToPtr.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)

	#define  calloc(n, m)	 _calloc_dbg((n), (m),   _NORMAL_BLOCK, __FILE__, __LINE__)
#endif

StringToPtr::StringToPtr(int size_):
	size(0), nr(0)
{
	data = (PtrStringPairP*)(GC_::calloc(size_, sizeof(PtrStringPairP)));
	if (data)
		size=size_;
}

StringToPtr::StringToPtr(int size_, PrimType primitives[]):
	size(0), nr(0)
{
	data = (PtrStringPairP*)(GC_::calloc(size_, sizeof(PtrStringPairP)));
	if (!data)
		return;
	size=size_;
	PrimType *prim=primitives;
	while (prim->name)
	{	insert(prim->name, (void*)prim->function);
		prim++;
	}
}

StringToPtr::~StringToPtr()
{
	for (int i=0; i < size; i++)
	{	if (data[i])
			delete data[i];
	}
	if (data)
	{	GC_::free(data); data=0;
	}
}

int StringToPtr::hash(wxString &s)
{
	unsigned int *i= (unsigned int*) s.c_str(),   index=0;

	for (char len=char(s.Length());  len>0;  len-=sizeof(int))
	{	switch (len)
		{	case 0:	break;
			case 1:	index^= *i & 0x000000ff;	break;
			case 2:	index^= *i & 0x0000ffff;	break;
			case 3:	index^= *i & 0x00ffffff;	break;
			case 4:	index^= *i;	break;
			default:	index^= *i++ << 5;
		}
	};
	if (size)
		index %= size;
	else
		return 0;
	return index;
}

void *StringToPtr::find(wxString &s)
{
	PtrStringPairP obj;
	for (obj=data[hash(s)];  obj;  obj=obj->tail)
		if (obj->s==s)
			return obj->p;
	return 0;
}

void StringToPtr::insert(wxString s, void *p)
{
	nr++;
	PtrStringPairP &obj=data[hash(s)];
	obj = new PtrStringPair(p, s, obj);
	if (!obj)
	{	error(OUT_OF_MEM);
	}
}
