#include "stdafx.h"
#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <wx/app.h>
//#include <wx/listctrl.h>
#include <wx/treectrl.h>

#include "Main.h"
#include "File.h"
#include "Pair.h"
#include "Object.h"
#include "Table.h"
#include "String.h"

#include "Vars.h"
#include "LogoApp.h"
#include "Eval.h"
#include "Stack.h"
#include "Init.h"
#include "Thread.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
#endif

bool updateVarsOnStep=true;

Vars::Vars(wxWindow* parent, wxWindowID id, 
			  const wxPoint& pos, 
			  const wxSize& size, 
			  long style, 
			  const wxValidator& validator, 
			  const wxString& name):
wxTreeCtrl(parent, id, pos, size, style, validator, name)
{
	inupdate=false;
//	InsertColumn(0,  "Name", wxLIST_FORMAT_RIGHT, 100);
//	InsertColumn(1, "Value", wxLIST_FORMAT_LEFT , 500);

	theApp->vars=this;
	return;
}

wxString Vars::OnGetItemText(long item, long column) const
{
	if (!column)
		return namearr[item];
	return valarr[item];
}

void Vars::update()
{
	if (inupdate)
		return;

	inupdate=true;

	ThreadP th=Thread::This();

	charP reserve=new char[100000];
	if (!reserve)
		return;
	delete reserve;

	PairP namesStart=root->contents(VALS, NORMAL_OBJECT),
		names=namesStart;

	if (names)
		count=names->count();
	else
		count=0;
	int stacksize=th->varStack.index-th->varStack.base;
	if (stacksize)
		stacksize++;
	count+=stacksize;
	int y=stacksize;

	if (!th->IsMain())
		wxMutexGuiEnter();

//	namearr.Clear(); namearr.Alloc(count); namearr.Add(wxEmptyString, count);
//	 valarr.Clear();  valarr.Alloc(count);  valarr.Add(wxEmptyString, count);
	DeleteAllItems();
	wxTreeItemId rootItem;
	rootItem=AddRoot("root");
	wxTreeItemId lastItem=rootItem;

	while (names)
	{
		StringP name=StringP(names->first());
		ObjectP obj=name->intern();
		if (obj)
		{	
if (y >= count)
{	c_out << "Vars::update error " << count << namesStart << endL;
	break;
}
			NodeP var=obj->var();
			StringP shortname=new String(obj->fullName());
		
			wxString itemText=shortname->ptr();
			if (var)
			{	StringP varstr=var->string();
				if (varstr  &&  varstr->is.string)
				{	StringP shortvar=new String(
						varstr->ptr(), 0, varstr->length(), STRING, 
						String::copy_noformat);
					if (shortvar->ptr())
						itemText+=wxString(" = ")+shortvar->ptr();
				}
			}
			lastItem=AppendItem(rootItem, itemText);
			y++;
		}
		next(names);
	}
	y=0;
	VarP base=th->varStack.base;
	for (VarP i=th->varStack.index;  i>base;  i--)
	{	StringP name=i->object->fullName();
		wxString itemText=name->ptr();
		StringP val=0;
		if (i->val)
		{	StringP valstr=_Null_Word->name();
			if (i->alias==-1)
			{	ObjectP obj=ObjectP(i->val);
				if (obj->var())
					valstr=obj->var()->string();
				StringP shortval=new String(
						valstr->ptr(), 0, valstr->length(), STRING, 
						String::copy_noformat);
				valstr=new String(wxString('&')+shortval->ptr());
			}
			else if (i->alias>0)	
			{	VarP j=th->varStack.base+i->alias;
				if (j->val)
					valstr=j->val->string();
				StringP shortval=new String(
						valstr->ptr(), 0, valstr->length(), STRING, 
						String::copy_noformat);
				valstr=new String(wxString('&')+shortval->ptr());
			}
			else
				valstr=i->val->string();

			if (valstr  &&  valstr->is.string)
			{	StringP shortval=new String(
					valstr->ptr(), 0, valstr->length(), STRING, 
					String::copy_noformat);
				if (shortval->ptr())
					itemText+=wxString(" = ")+shortval->ptr();
				lastItem=AppendItem(rootItem, itemText);
			}
		}//else
		//	valarr[y]=wxEmptyString;
		y++;
	}
	if (stacksize)
	{//	namearr[y]=wxEmptyString;
	//	valarr[y]=wxEmptyString;
	}
//	SetItemCount(count);
//	if (count >= 1)
//		RefreshItems(0, count-1);

	if (!th->IsMain())
		wxMutexGuiLeave();

	inupdate=false;
}

NodeP lupdateVars(PairPP)
{
	if (theApp->vars) 
		theApp->vars->update();
	return Unbound;
}

NodeP lupdateVarsOnStep(PairPP arg)
{
	int update=arg[1]->a_bool(1);
	if (!throwing)
		updateVarsOnStep=(update==1);
	return Unbound;
}
